
(* DO NOT EDIT THIS FILE *) 

(* init.m  for Automata *)

(*
*   set
*       $AutomataMessages = False; $AutomataExperimental = True;
*   to turn off load messages and load experimental code
*)

BeginPackage["Automata`Kernel`init`"]
EndPackage[]


Initfile::begin = "****  Automata init.m ";

If[TrueQ[$AutomataMessages],Message[Initfile::begin]];


(***********************  modified built-ins  ***********************)

Unprotect[NonCommutativeMultiply,ToString];

ToString[Automata`automata`Eps|"Eps"] = "";

Attributes[NonCommutativeMultiply]={OneIdentity,Listable};

Protect[NonCommutativeMultiply,ToString];



DeclarePackage["Automata`dimath`",{

"DC", 
"GEN", 
"Graph", 
"SG", 
"T", 
"AccCoaccGraph", 
"AccessibleGraph", 
"AlgebraicForm", 
"AllTimes", 
"AlternatingGroupSG", 
"AnalyzeOrbit", 
"AperiodicQSG", 
"AperiodicQT", 
"AperiodicSG", 
"AssignFunction", 
"BlocksToDClass", 
"BooleanComplement", 
"BooleanComposition", 
"BooleanConverse", 
"BooleanIntersection", 
"BooleanPower", 
"BooleanUnion", 
"CartesianProduct", 
"CirculantGraph", 
"ClosureSearch", 
"Closure", 
"CollapseT", 
"ColorQ", 
"CompCycles", 
"Concatenate", 
"ConsT", 
"Curry", 
"CycleDecompositionT", 
"CycleToT", 
"CyclicQGraph", 
"DClassDecomposition", 
"DClassDimensions", 
"DClassSize", 
"DClassToBlocks", 
"DClassT", 
"DegreeGraph", 
"Dependency", 
"DisjointQ", 
"DoShow", 
"EdgeQ", 
"Edges", 
"EnumForm", 
"EquationsToWitnesses", 
"FastPowerSet", 
"FlattenOne", 
"Frequencies", 
"FromBitVector", 
"FromEps", 
"FromIdentityString", 
"GenerateCSM", 
"GenerateSG", 
"GreenHQT", 
"GreenJQT", 
"GreenLQT", 
"GreenRQT", 
"GridLine", 
"GridPoints", 
"HClassSize", 
"HClassT", 
"HTrivialQSG", 
"HueRasterColors", 
"IdealT", 
"IdemQT", 
"IdemSG", 
"ImageT", 
"IndToWitnesses", 
"InGroupQT", 
"InGroupSG", 
"InverseT", 
"IrreducibleQ", 
"JTrivialQSG", 
"JTrivialSG", 
"KernelImageToT", 
"KernelT", 
"KPermutationsR", 
"LabelEdgeList", 
"LeftIdealT", 
"LeftNullQT", 
"LeftNullSG", 
"LeftOneQT", 
"LeftOneSG", 
"LocallyCommQSG", 
"LocallyIdemQSG", 
"LongestPath", 
"LShiftT", 
"MakeAlphabet", 
"MakeFullAlphabet", 
"MakeIndex", 
"MakeMonoidSG", 
"MakePlotRange", 
"Merge12T", 
"MonoidQSG", 
"NilpotentQSG", 
"NonDecreasing", 
"NonTransientGraph", 
"NormalizeGraph", 
"NullQT", 
"NullSG", 
"NumEdges", 
"NumVertices", 
"OneQT", 
"OneSG", 
"OneT", 
"OrderT", 
"PairsToRules", 
"Pairs", 
"PartitionCumRest", 
"Partitions", 
"PathGraph", 
"PermuteGraph", 
"PlotFunction", 
"PlotMatrix", 
"PlotRelation", 
"PlotTDGraph", 
"PlotT", 
"PositionList", 
"PositionOne", 
"PowerSet", 
"PrintDClass", 
"PrintEquations", 
"PrintWitnesses", 
"ProductGraph", 
"ProductLabeledGraph", 
"RandomPermutation", 
"RandomT", 
"RankT", 
"RegularQT", 
"RegularSG", 
"RelationToMatrix", 
"RemoveDuplicates", 
"RemoveVertex", 
"RenumberRules", 
"ReplaceParts", 
"ReverseGraph", 
"RightIdealT", 
"RightNullQT", 
"RightNullSG", 
"RightOneQT", 
"RightOneSG", 
"RootList", 
"RShiftT", 
"RulesToPairs", 
"SeedConfiguration", 
"SelectOptions", 
"SelectorQ", 
"ShortestPath", 
"ShowArray", 
"Shuffle", 
"SimplifyEquations", 
"SimplifyRewriteSystem", 
"SolveSG", 
"StaircasePlot", 
"Status", 
"StronglyConnectedComponents", 
"SubGraph", 
"SubsetQ", 
"SymbolList", 
"SymmetricGroupSG", 
"TableSG", 
"ToAdjList", 
"ToAdjMatrix", 
"ToBitVector", 
"ToClasses", 
"ToDAG", 
"ToEdgeList", 
"ToEps", 
"ToIdentityString", 
"ToList", 
"ToTDGraph", 
"TransformationSG", 
"TransientPeriodicT", 
"TransitiveClosure", 
"TranspositionT", 
"TypeGraph", 
"UnitElement", 
"VertexSet", 
"Warshall", 
"WeaklyConnectedComponents", 
"WordQ", 
"WordReduce"
}];


DeclarePackage["Automata`automata`",{

"BEFA", 
"CA", 
"DFA", 
"FA", 
"NFA", 
"NNFA", 
"REP", 
"RES", 
"RET", 
"SA", 
"TS", 
"AcceptQFA", 
"AccessibleFA", 
"AddTransitionFA", 
"AllDFA", 
"AlphabetSize", 
"Alphabet", 
"AmbiguousQFA", 
"Arden", 
"BehaviorFA", 
"BFunctionToCA", 
"BuildBEFA", 
"BuildDFA", 
"BuildNNFA", 
"BuildStarDFA", 
"CirculantSA", 
"ClassifyCA", 
"CoAccessibleFA", 
"CodeterministicQFA", 
"ComplementFA", 
"CompleteFA", 
"CompleteQFA", 
"ComposeCA", 
"ComputationFA", 
"ComputationGraphFA", 
"ConcatenateFA", 
"ConvertToFA", 
"CounterDFA", 
"CoverQDFA", 
"DeBruijnEdges", 
"DeBruijnGraph", 
"DefiniteQFA", 
"DegreesFA", 
"DeleteStateFA", 
"DependencyCA", 
"DeterministicQFA", 
"EmptyDFA", 
"EmptyQFA", 
"EpsFreeQ", 
"EpsilonEliminationFA", 
"EquivalentQFA", 
"EvolutionCA", 
"FactorialQFA", 
"FinalVectorFA", 
"Final", 
"FiniteComplementSA", 
"FormatAutomata", 
"FormatX", 
"FrontierQ", 
"FrontierToDFA", 
"FSMQ", 
"FSurjectiveCA", 
"FullAlphabet", 
"FullTransitionMatrixFA", 
"FullTransitions", 
"FunctionToCA", 
"FunctionToDFA", 
"FunctionToSA", 
"GenerateDFA", 
"GenerateQuotients", 
"GlobalMapCA", 
"HomomorphismFA", 
"HurwitzProduct", 
"IdealBaseFA", 
"IdealQFA", 
"IdentityCA", 
"InfiniteQFA", 
"InfixFA", 
"InitialVectorFA", 
"Initial", 
"IntersectionFA", 
"InverseCA", 
"IrreducibleFA", 
"IsomorphicQDFA", 
"IterateCA", 
"IthSymbolDFA", 
"IthSymbolFA", 
"JoinSA", 
"LabelToCodeCA", 
"LanguageFA", 
"LanguageSort", 
"LanguageToSeries", 
"LeftQuotient", 
"LeftShiftCA", 
"LengthDFA", 
"LocalMapCA", 
"LocalUniversalFA", 
"LoopAutomatonFA", 
"MakeHomoDFA", 
"MakeHomomorphism", 
"MakeWord", 
"MatrixToTransitions", 
"MinimalFischerFA", 
"MinimizeDFA", 
"MinimizeFA", 
"ModCounterDFA", 
"NNFAToFA", 
"NoFactorFA", 
"NoPrefixFA", 
"NormalizeControl", 
"NormalizeFA", 
"NoSuffixFA", 
"NumberOfCA", 
"NumberOfDFA", 
"NumberOfTotalisticCA", 
"NumTransitions", 
"OrbitCA", 
"ParikhVector", 
"PermutationSA", 
"PermuteFA", 
"PlotComputationFA", 
"PolynomialToCA", 
"PrefixDFA", 
"PrefixQ", 
"PrimitiveCount", 
"PrimitiveQ", 
"PrintCA", 
"PrintFA", 
"ProductFA", 
"ProductTransitions", 
"ProperPrefixes", 
"QuotientDFA", 
"QuotientMachineFA", 
"RandomDFA", 
"RandomWord", 
"RankOfDFA", 
"RankToDFA", 
"REEpsQ", 
"RegularExpressionToBEFA", 
"RegularExpressionToFA", 
"RegularExpressionToNNFA", 
"RemoveTransitionFA", 
"REQ", 
"RESimplify", 
"ReverseFA", 
"RightShiftCA", 
"SelectFA", 
"SetFinalFA", 
"SetInitialFA", 
"SetInitialFinalFA", 
"ShowAcceptQFA", 
"ShrinkCA", 
"ShuffleProductFA", 
"SinkQDFA", 
"SinksDFA", 
"Size", 
"SquareSA", 
"StarFA", 
"StateMergeDFA", 
"States", 
"SubsetQFA", 
"Substitute", 
"SubwordCounterDFA", 
"SubwordDFA", 
"SubwordModCounterDFA", 
"SuffixesFA", 
"SuffixFA", 
"SumFA", 
"SwitchTransitionFA", 
"SyntacticCongruence", 
"SyntacticHomomorphism", 
"SyntacticSG", 
"TheInitial", 
"TheSinkDFA", 
"ToBlocks", 
"ToCharacters", 
"ToDFA", 
"ToEquationsDFA", 
"ToFA", 
"ToFrontierDFA", 
"ToGeneratorsFA", 
"ToGraphFA", 
"ToIndex", 
"ToKernelFA", 
"ToLabelCA", 
"ToNFA", 
"ToPeriodicFrontierDFA", 
"ToPrefixFA", 
"ToPrefix", 
"ToRegExp", 
"ToRegularExpressionFA", 
"ToRulesCA", 
"ToSA", 
"ToSeries", 
"ToSuffixFA", 
"TotalisticRuleToCA", 
"ToTotalisticRuleCA", 
"ToTransitions", 
"ToWord", 
"TransferSequenceFA", 
"TransitionFunctionFA", 
"TransitionMatrixFA", 
"TransitionsToMatrix", 
"Transitions", 
"TransitiveLangQFA", 
"TransitiveQFA", 
"TrimFA", 
"TropicalIdentityMatrix", 
"UnionFA", 
"VerifyFA", 
"WelchCA", 
"WidthCA", 
"WordBinomial", 
"WordConjugateQ", 
"WordConjugates", 
"WordFactorizations", 
"WordFactors", 
"WordFusion", 
"WordLength", 
"WordOrder", 
"WordPower", 
"WordPrefixes", 
"WordReverse", 
"WordRoot", 
"WordRotate", 
"WordShuffle", 
"WordSort", 
"WordSuffixes", 
"Words"
}];



If[ TrueQ[Global`$AutomataExperimental],Get["Automata/experimental.m"]];

(* end *)



Null

