



(* DO NOT EDIT THIS FILE *) 
(* package generated at Mon Nov 25 22:59:25 EST 2002 from SOURCEFILE *) 


(* Title: dimath *)

(* 
*  Author: Klaus Sutner
*  Affiliation: CMU
*  email: sutner@cs.cmu.edu
*)

(* 
*  Version: Version 4.6
*  Date: 2002.11.25
*)

BeginPackage["Automata`dimath`", "Graphics`Colors`"];


(*
*   System variables:   14
*   Options:            40
*   Function defs:      180
*   Functionals:        1
*   Data structures:    5
*)




AccCoaccGraph::usage = "AccCoaccGraph[G,S,T] constructs the subgraph of G induced by the vertices reachable from S and coreachable from T.";
AccessibleGraph::usage = "AccessibleGraph[G,A] constructs the subgraph 
of G induced by the vertices reachable from set A (given in positional 
notation).  AccessibleGraph uses the function 
WeaklyConnectedComponents.  
";
AlgebraicForm::usage = "AlgebraicForm[w] writes word w in algebraic 
form using exponents for runs of a symbol.
";
AllStringReplace::usage = "AllStringReplace[rw][w] generates all words obtainable 
from word w by applying the rewrite equations in rw once. 
The rewrite equations are given in the form {lhs,rhs}, both words. 
w can also be a list of words. ";
AllTimes::usage = "AllTimes[L1,L2] computes all products between 
elements in L1 and L2 using NonCommutativeMultiply.
";
All::usage = "All is an option value for various functions.";
AlternatingGroupSG::usage = "AlternatingGroupSG[n] returns the 
alternating group on n elements.  The group is returned as a SG 
term. Since the alternating group has n!/2 elements, this can only be 
used for small n.";
AnalyzeOrbit::usage = "AnalyzeOrbit[f,x] returns {t,p} where t is 
the length of the transient part of the orbit of point x under map 
f, and p is the length of the cyclic part. , and b is the entry point of 
the transient part on the cycle.  Computation is memoryless.  If 
ff[x] = f[f[x]] is slow to compute by composition, ff can be 
supplied as a third argument: AnalyzeOrbit[f,a,ff]. Option 
Cycle->True causes the cycle to be displayed (instead of b).
";
AperiodicQSG::usage = "AperiodicQSG[S] determines whether semigroup S 
is aperiodic. Also allows as input a list or sequence of generators 
for S.
";
AperiodicQT::usage = "AperiodicQT[x] determines whether transformation 
x is aperiodic.
";
AperiodicSG::usage = "AperiodicSG[S] returns the aperiodic elements of 
semigroup S.
";
AssignFunction::usage = "AssignFunction[h,P] defines h to be function 
with graph P, where P is a list of pairs (the graph of the function).   
Alternatively, AssignFunction[h,D,C] defines the function that maps the i-th 
element of the domain list D to the i-th element of the codomain list C 
(D and C must have the same length). 
Option  Opts->attributes  assigns function h the given attributes. 
Option  Kary->True  makes function h n-ary, assumes domain elements are lists.
";
BlocksToDClass::usage = "BlocksToDClass[db,S] converts a D-class in 
semigroup S from block representation to multiplier representation.";
BooleanComplement::usage = "BooleanComplement[M1,M2] computes the 
binary difference (pointwise) of two binary matrices M1 and M2, 
corresponding to relational complement. Also works with a single 
matrix. See RelationToMatrix.  
";
BooleanComposition::usage = "BooleanComposition[M1,M2] computes the 
binary dot product of two binary matrices M1 and M2, corresponding to 
relational composition. See RelationToMatrix. 
";
BooleanConverse::usage = "BooleanConverse[M] computes the transpose of 
a binary matrix M. corresponding to relational converse.  See RelationToMatrix. 
";
BooleanIntersection::usage = "BooleanIntersection[M1,M2] computes the 
binary product (pointwise) of two binary matrices M1 and M2, 
corresponding to relational intersection. See RelationToMatrix. 
";
BooleanPower::usage = "BooleanPower[M,n] computes the n-th power of 
the binary matrix M, corresponding to relational iteration. See 
RelationToMatrix. 
";
BooleanUnion::usage = "BooleanUnion[M1,M2] computes the binary sum 
(pointwise) of two binary matrices M1 and M2, corresponding to 
relational union. See RelationToMatrix. 
";
Boolean::usage = "Boolean is an option for TransitionMatrixFA.";
BoundCSM::usage = "BoundCSM is an option for GenerateCSM, limits the size of the 
generated cyclic semimodule.  Default is 1000.";
BoundETW::usage = "BoundETW is an option for EquationsToWitnesses, 
Default is 500.";
BoundGSG::usage = "BoundGSG is an option for GenerateSG that controls the 
maximum size of the generated semigroup.  
Default value is $generateSGBound = 1000.";
BoundWR::usage = "BoundWR is an upper bound for the number of 
reduction steps in WordReduce.  Default is 500.";
CartesianProduct::usage = "CartesianProduct[S1,...,Sk] computes the 
Cartesian product of lists S1,...,Sk. 
";
CirculantGraph::usage = "CirculantGraph[n,{d1,...,dr}] generates the 
circulant C(n;d1,...,dr) in edge-list form.
";
$closureBound::usage = "$closureBound is a default bound for the 
number of steps taken in the algorithm that computes the closure of a 
set with respect to a function. Default value is 10 to guard against 
exponential blow-up.";
ClosureBound::usage = "ClosureBound is an option for Closure and ClosureSearch.";
$closureSearchBound::usage = "$closureSearchBound is a default bound for the number 
of steps taken in the algorithm that tests whether a target element is 
in the closure of a set with respect to a function. 
Default value is 500 for the size of closure set to be computed.";
ClosureSearch::usage = "ClosureSearch[L,targ,ff,opts] determines whether
targ occurs in the closure of list L under the function ff (can also
be a sequence of functions).  The search is immediately truncated, so
that computation of the full closure can sometimes be avoided.  If
option SetClosure is set to True, the intermediate results are
properly flattened so that ff can be of type Type --> lists(Type). 
See also Closure.";
Closure::usage = "Closure[L,ff,opts] computes the closure of list L 
under the function ff (can also be a sequence of functions).  If 
option SetClosure is set to True, the intermediate results are 
properly flattened so that ff can be of type sometype --> 
lists(sometype). See also ClosureSearch. 
";
CollapseT::usage = "CollapseT[x] produces the image transformation 
associated with transformation x. If x lies in a group, CollapseT[x] 
produces a permutation.
";
ColorQ::usage = "ColorQ[x] tests whether x is a color 
specification. 
";
Cols::usage = "Cols is an option PrintEquations.";
CompCycles::usage = "CompCycles[cyc1,cyc2] computes composition of two 
permutations in disjoint cycle representation, return disjoint cycle representation.";
Concatenate::usage = "Concatenate[w1,..,wn] concatenates words w_1,...,w_n.  
Compatible with Eps (unlike StringJoin, the built-in command for concatenation).  
Also behaves properly with respect to lists of words.";
ConsT::usage = "ConsT[k,n] returns the constant transformation T[k,..,k] of length n.";
Curry::usage = "Curry[f] curries a function f of two variables: 
Curry[f][y][x] = f[x,y]. This is useful on occasion when a function of 
two variables is to be used in postfix notation: Range[3] // 
Curry[Append][5] yields {1, 2, 3, 5}.
";
CycleDecompositionT::usage = "CycleDecompositionT[x] returns the cycle 
decomposition of a permutation x. No test is made whether the given 
transformation is in fact a permutation, for arbitrary transformations 
a list of some orbits is produced.
";
CycleToT::usage = "CycleToT[cycles,n] converts to T-term.";
Cycle::usage = "Cycle is an option for AnalyzeOrbit that causes the 
limiting cycle to be displayed.";
CyclicQGraph::usage = "CyclicQGraph[G] tests whether graph G is cyclic.";
DClassDecomposition::usage = "DClassDecomposition[S] generates a list 
of all regular D-classes of semigroup S.  Option RegularOnly->False 
causes all D-classes to be generated.  Note that this involves 
computation of left and right ideals generated by irregular elements 
of S and becomes quite slow for large S.";
DClassDimensions::usage = "DClassDimensions[dc] returns the dimensions 
of D-class dc: (number of R-class, number of L-classes,size of 
H-classes); has attribute Listable. See also DClassSize.";
DClasses::usage = "DClasses is an option for GenerateSG, default is False.  
Applies only to the external algorithm, for the internal 
algorithm there is a separate function DClassDecomposition.";
DClassSize::usage = "DClassSize[dc] returns the size of D-class dc; 
has attribute Listable. See also DClassDimensions.";
DClassToBlocks::usage = "DClassToBlocks[dc] returns an expression a 
matrix of lists of transformations: {{{H11,H12,..},{H21,..},..}} 
where the Hij are the H-classes of the D-class dc (a tensor of rank 3).";
DClassT::usage = "DClassT[x,S] determines the D-class of a 
regular element x in a semigroup S. Coordinates are given as left and 
right multipliers.
";
DC::usage = "DC[lmult,rmult,H] is a header used for D-classes.  H is 
the basic H-class, lmult the list of left multipliers and rmult the 
list of right multipliers, produced by BlocksToDClass.";
$defaultexternal::usage = "$defaultexternal determines whether an external algorithm is 
used in certain commands (such as AccessibleFA, ToDFA, MinimizeFA, GenerateSG).  
Is set to True automatically if the MathLink connection to extaut has been properly 
established.";
$deffatline::usage = "$deffatline controls the width of emphasized lines in PlotTDGraph.  
The default is 0.005 and can be changed via option LineStyle.";
$deflabeloffset::usage = "$deflabeloffset controls the position of labels in GridPoints. Default value is 0.2.";
$defpointsize::usage = "$defpointsize controls the pointsize in function GridPoints.  
The default is 0.012 and can be changed as an optional parameter.";
$defthinline::usage = "$defthinline controls the width of plain lines in PlotTDGraph.  
The default is 0.005 and can be changed via option LineStyle.";
DegreeGraph::usage = "DegreeGraph[G,v] returns the degree of vertex v 
in graph G. Option Full->True causes the pair {in-deg,out-deg} to be 
returned.
";
Dependency::usage = "Dependency[L,k] computes the indices of the 
variables on which the n-ary function f represented by list L depends 
on.  Here L must have length k^n and function f is assumed to be of 
the form f : [k]^n --> [k]. Parameter k is optional and has default 
2. 
";
$dimathReleaseNumber::usage = "$dimathReleaseNumber is the release number of the loaded 
dimath package.";
DisjointQ::usage = "DisjointQ[L1,L2] tests whether lists L1 and L2 are 
disjoint.
";
DoShow::usage = "DoShow[X] displays graphics object X by setting the 
DisplayFunction to $DisplayFunction. Used in conjunction with NoShow 
and NoShowOne. 
";
DoTrace::usage = "DoTrace is an option for various functions.";
Drei::usage = "Drei[x] returns the third part of x: Drei[x] = x[[3]].";
EdgeQ::usage = "EdgeQ[G,x,y] tests whether edge (x,y) is present in 
graph G.
";
Edges::usage = "Edges[G] returns the edges of a graph G (form depends 
on type of graph). 
";
EnumForm::usage = "EnumForm[L] displays list L in ColumnForm with line 
numbers starting at 1, uses ColonForm to generate the line numbers. 
Has option Index->number.
";
Eps::usage = "Eps is used to denote the empty string, protected.  
Can also be used in the form \"Eps\" or \[Epsilon]. 
As a regular expression it denotes the singleton set {Eps}.
";
EquationsToWitnesses::usage = "EquationsToWitnesses[eq,K,opt] 
generates witnesses for the semigroup on generators K with defining 
relationes given by eq, a rewrite system. Note that the equations are 
only used in directed form left to right, no attempt is made to 
generate the Thue congruence. Option BoundETW->n defines n as upper 
for the number of witnesses produced, has default 500.";
Equations::usage = "Equations is an option for various functions.";
External::usage = "External is an option for various commands with an 
external implementation. If External is set to True, the external code 
will be called via MathLink.  The internal and external algorithms 
produce essentially the same output, though they may differ in various 
options. The system variable $defaultexternal can be used to control 
the automatic use of external code.";
FastPowerSet::usage = "Fast way to compute a powerset, using pattern matching.";
Filter::usage = "Filter is an option for GenerateSG and can be used to 
specify a function that will be applied to all the intermediate 
objects in the semigroup generated.  For example, Filter->Mod[#,2]& in 
conjunction with matrices could be used to generate a semigroup of 
matrices over the 2-element field. Note: this option is only available 
for the internal algorithm.";
FlattenOne::usage = "FlattenOne[x] is shorthand for Flatten[x,1].";
Frequencies::usage = "Frequencies[L] counts the occurrences of all 
elements in the list L, output suitablefor ListPlot.
";
FromBitVector::usage = "FromBitVector[B,U] transforms bit-vector B 
into a subset of universe U. Here, a bit-vector is understood to be a 
0/1 list.  
";
FromEps::usage = "FromEps[x] replaces all occurences of Eps,  
\"Eps\" and \[Epsilon] in x by the empty string.
";
FromIdentityString::usage = "FromIdentityString[xxx] replaces all 
occurences of $identitystring in xxx by the empty string.
";
Full::usage = "Full is a Boolean option for various functions.";
GenerateCSM::usage = "GenerateCSM[q0,dot,K,opts] produces the cyclic 
semimodule generated by q0. dot[p,s] must be an element of the 
semimodule where p is an element of the semimodule and s is a symbol 
in the alphabet.  

Options: Equations->False and BoundCSM->1000.";
$generateSGBound::usage = "$generateSGBound is a default bound for the size of a semigroup 
generated by GenerateSG. Default is 1000.";
GenerateSG::usage = "GenerateSG[gen] produces the semigroup S 
generated by the generators gen, see GEN. Option Full->True causes the 
corresponding monoid to be generated. NonCommutativeMultiply is used 
as multiplication for transformation semigroups. 

GenerateSG[gen,Equations->True] returns {S,W,eq} where S is the 
semigroup, W is a list of corresponding witnesses, and eq a list of 
equations for S.  Witnesses and equations are given as words over 
alphabet K which must have the same cardinality as gen.  With the 
internal implementation one can also generate semigroups of 
matrices. The operations for the matrix semiring must be overloaded on 
Plus and Times, operation Dot is used for matrix multiplication.";
GEN::usage = "GEN[n,k,{T1,..,Tk}] is a collection of k generators
(transformations [n] --> [n] or n by n matrices over a semiring).";
Graph::usage = "Graph[n,e,t,L,V] represents a directed graph on n 
nodes and e edges with vertex set V. Adjacencies are given by List L. 
L can be an edge list (t=1), a labeled edge list (t=2), anadjacency 
matrix (t=3), or an adjacency list (t=4).  V can be empty(in which 
case the vertex set is assumed to be [n]) or as an arbitrary list.";
GreenHQT::usage = "GreenHQT[x,y,S] tests whether transformations x and 
y are H-equivalent in semigroup S.";
GreenJQT::usage = "GreenJQT[x,y,S] tests whether transformations x and 
y are J-equivalent in semigroup S.";
GreenLQT::usage = "GreenLQT[x,y,S] tests whether transformations x and 
y are L-equivalent in semigroup S.";
GreenRQT::usage = "GreenRQT[x,y,S] tests whether transformations x and 
y are R-equivalent in semigroup S.
";
GridLine::usage = "GridLine[n,m,opts] draws an n by m grid of 
lines. Options: PlotStyle and GridOffset. 
";
GridOffset::usage = "GridOffset is an option for GridLine, determines 
starting coordinates for the grid. Default: {1,1}.";
GridPoints::usage = "GridPoints[n,m,opts] generates a graphics object 
representing an n by m grid of points.  Size and color of dots can be 
controlled by options. 
";
HClassSize::usage = "HClassSize[dc] returns the size of the H-classes 
of D-class dc; is Listable.";
HClassT::usage = "HClassT[x,S] determines the H-class of a regular 
element x in semigroup S.
";
HTrivialQSG::usage = "HTrivialQSG[S] tests whether semigroup S is 
H-trivial.
";
HueRasterColors::usage = "HueRasterColors[p] provides an alternative 
to $rastercolor. 
";
IdealT::usage = "IdealT[x,S] computes the two-sided ideal generated by 
transformation x in semigroup S.
";
IdemQT::usage = "IdemQT[x] tests whether transformation x is 
idempotent.
";
IdemSG::usage = "IdemSG[S] lists the idempotents of a semigroup S.";
$identitystring::usage = "$identitystring denotes the identity element of a monoid in 
rewrite rules produced by GenerateSG.  Default is 1 and should be changed if digit 
alphabets are used.";
ImageT::usage = "ImageT[x] gives the range of transformation x as an 
ordered list; Listable.
";
Index::usage = "Index is a possible value for option Type in function ToClasses.";
IndToWitnesses::usage = "IndToWitnesses[ind] returns a bit vector for the 
representatives for each class in an equivalence relation given by an 
index ind.  See MakeIndex and ToClasses.
";
InGroupQT::usage = "InGroupQT[x] tests whether transformation x lies 
in a group.";
InGroupSG::usage = "InGroupSG[S] produces all elements in semigroup S 
that belong to a subgroup of S.";
InverseT::usage = "InverseT[x] computes the inverse of a 
transformation x (in the group generated by x), if it exists.
";
IrreducibleQ::usage = "IrreducibleQ[w,eq] test is word w is 
irreducible with respect to the rewrite system eq. Note that only the 
left hand sides of eq are used.
";
JTrivialQSG::usage = "JTrivialQSG[S] tests whether semigroup S is 
J-trivial, i.e., whether all J-classes have cardinality 1.  Since S is 
finite this is the same as being D-trivial.
";
JTrivialSG::usage = "JTrivialSG[n] generates the J-trivial semigroup 
of all order preserving inflationary functions [n] --> [n].  
JTrivialSG[n,b] generates only those functions with values at least k.";
Kary::usage = "Kary is a Boolean option for AssignFunction, causes the
function to be treated as a k-ary function.";
KernelImageToT::usage = "KernelImageToT[ker,im] reconstructs a 
transformation given its range and kernel.  Note that this works only 
because kernels and ranges are ordered.
";
KernelT::usage = "KernelT[x] gives the kernel of transformation x; 
Listable.  Note that the kernel classes are ordered according to 
ImageT[x].  Hence, to compare two kernels as equivalence relations one 
has to sort them first.
";
KPermutationsR::usage = "KPermutationsR[L,k] produces a list of all 
k-permutations with replacement of elementstaken from list L. L = 
Range[ll] can be written as ll, default isll=2.  For negative values 
of k, all r-permutations, r <= |k|, are produced.
";
LabelEdgeList::usage = "LabelEdgeList[G,lab] inserts labels into the 
edge list of a graph.
";
LabelGrid::usage = "LabelGrid is an option for GridPoints, causes the
first and last column of grid points to be labeled by integers.";
LabelPoints::usage = "LabelPoints is an option for GridPoints, causes 
all grid points to be labeled by integers. 
Default is LabelPoints->None, change to LabelPoints->labelingfct.";
LeftIdealT::usage = "LeftIdealT[x,S] computes the left ideal generated 
by transformation x in semigroup S.
";
LeftNullQT::usage = "LeftNullQT[x,S] tests whether transformation x is 
a left null in S.
";
LeftNullSG::usage = "LeftNullSG[S] lists the left nulls of a semigroup S.";
LeftOneQT::usage = "LeftOneQT[x,S] tests whether transformation x is a left identity in S.
";
LeftOneSG::usage = "LeftOneSG[S] lists the left identities of a semigroup S.
";
LineStyle::usage = "LineStyle is an option for PlotTDGraph that 
controls thickness and color of the lines in the plot. 
Usage: LineStyle->{{col1,thick1},{col2,thick2}}.";
LocallyCommQSG::usage = "LocallyCommQSG[S] tests if semigroup S is locally commutative: 
eSe is commutative for each idempotent element e.";
LocallyIdemQSG::usage = "LocallyIdemQSG[S] tests if semigroup S is 
locally idempotent: eSe is idempotent for each idempotent element e.";
LongestPath::usage = "LongestPath[G] determines the length of a 
longest path in the acyclic part of graph G. These paths start at an 
indegree zero point and end at outdegree zero vertices or vertices 
belonging to a non-trivial strongly connected component. Option 
Full->True produces the lengths of such longest paths for all vertices.";
LShiftT::usage = "LShiftT[n] returns the left shift transformation T[2,3,..,n,1].";
MakeAlphabet::usage = "MakeAlphabet[K] returns {k,A} where k is the 
size of the alphabet and A the alphabet determined by K. K can be a 
list of symbols, strings of length one, or an integer.";
MakeFullAlphabet::usage = "MakeFullAlphabet[K] returns {k,KK} where k is the size of the 
proper alphabet given by K and KK is the proper alphabet.  
K may be an integer, a list of symbols or a list of characters.";
MakeIndex::usage = "MakeIndex[L,R] computes an index of list L with 
respect to equivalence relation R.  R has default SameQ. As a function 
[n] --> [n], the index is idempotent and deflationary. 
";
MakeMonoidSG::usage = "MakeMonoidSG[S] turns semigroup S into a monoid by 
adjoining a unit, if necessary.";
MakePlotRange::usage = "MakePlotRange[x1,x2,y1,y2] constructs 
PlotRange option, add proper margins. Used mostly internally in 
plotting functions. 
";
Matrix::usage = "Matrix is a possible value for option Type in function ToClasses.";
Merge12T::usage = "Merge12T[n] returns the transformation 
T[1,1,3,..,n].
";
MinusEins::usage = "MinusEins[x] returns the last part of x: MinusEins[x] = x[[-1]].";
MinusZwei::usage = "MinusZwei[x] returns the second to the last part of x: MinusZwei[x] = x[[-2]].";
MonoidQSG::usage = "MonoidQSG[S] tests whether semigroup S is a monoid.";
MultiCol::usage = "MultiCol is an option for PlotMatrix.";
NilpotentQSG::usage = "NilpotentQSG[S] tests whether semigroup S is 
nilpotent, i.e., whether null is the only idempotent element.
";
NonDecreasing::usage = "NonDecreasing[n,k] generates all non-decreasing 
sequences of length k over [n].
";
NonTransientGraph::usage = "NonTransientGraph[G] returns the non-transient strongly connected components of G (components that lie on a biinfinite path).";
NonTrivial::usage = "NonTrivial is an option for command SCC. Causes 
only those stronglyconnected components to be generated that contain 
at least one edge (possibly a self-loop).";
NoRest::usage = "NoRest is an option for PlotMatrix.";
NormalizeGraph::usage = "NormalizeGraph[M] normalizes graph G to have 
vertex set [n].
";
Normalize::usage = "Normalize is an option for several commands. 
In particular for procedures operating on FSMs, Normalize->1
causes the new machine to have a state set determined by the 
construction (rather than the generic [n]).  For example, for two DFAs 
M1 and M2, UnionFA[M1,M2,Normalize->1] produces a product machine with 
states {p,q} where p is a state in M1 and q a state in M2. 
Normalize->2 will also preserve the structure of the state set of 
the input machines.  See also $defaultnormalize, NormalizeControl.";
NRows::usage = "NRows is an option for PlotMatrix.";
NullQT::usage = "NullQT[x,S] tests whether transformation x is a null 
in semigroup S.
";
NullSG::usage = "NullSG[S] lists the null element of a semigroup S, if 
it exists.
";
$nullstring::usage = "$nullstring denoted the null element of a semigroup in rewrite rules
produced by GenerateSG.  
Default is 0 and should be changed if digit alphabets are used.";
NumEdges::usage = "NumEdges[G] returns the number of edges of a graph G.";
NumVertices::usage = "NumVertices[G] returns the number of vertices of 
a graph G.
";
OneQT::usage = "OneQT[x,S] tests whether transformation x is the 
identity in semigroup S.
";
OneSG::usage = "OneSG[S] lists the identity of a semigroup S, if it 
exists.
";
OneT::usage = "OneT[x] produces the identity transformation of size 
Length[x] where x is any transformation.  OneT[k] for integers k is 
self explanatory.
";
Opts::usage = "Opts is an option for AssignFunction. 
Controls the attributes of the defined function.";
OrderT::usage = "OrderT[x] returns the order of a permutation x.";
OutPairs::usage = "OutPairs is an option for command RemoveDuplicates.  Causes the ouput to be returned in pair-list format.";
PairsToRules::usage = "PairsToRules[rw] translates word pairs into rewrite rules. 
";
Pairs::usage = "Pairs[L1,L2] generates a list of pairs with elements 
taken from lists L1 and L2(must have the same length).  In general, 
produces k-tuples on k input lists.";
PartitionCumRest::usage = "PartitionCumRest[L,p] partitions list L into blocks of length 
p plus a possible rest of length Length[L] modulo p.";
Partitions::usage = "Partitions[n] returns the partitions of n. 
Partitions[n,m] returns the partitions of n whose largest component is 
at most m.";
PathGraph::usage = "PathGraph[n] generates a path of length n in edge-list form.
Option Full->True adds a self-loop at the last vertex.
";
Periodic::usage = "Periodic is an option for AnalyzeOrbit[f,a,opts] that 
speeds up the computation if the orbit is known to be periodic. 
Default is Periodic->False.";
PermuteGraph::usage = "PermuteGraph[G,p] applies isomorphism p to 
G. List p must be a permutation on [n].
";
PlotFunction::usage = "PlotFunction[f,A,n,opts] plots a picture of a 
function f on domain A, iterated n steps. Options are Full->False, 
DoTrace->All, PlotStyle and LineStyle. See also PlotTDGraph.";
PlotMatrix::usage = "PlotMatrix[M] plots a raster image of matrix M. 
The default colors are controlled by $rastercolors, 
Option RasterStyle->Automatic uses HueRasterColors. 
Option GridLines->False turns off the light gray grid.
Option Frame->False turns off the surrounding frame.

Option MultiCol->Turns turns on multi-column mode and chops the matrix 
into several blocks.   
Default number of rows in each block (except perhaps the last) is 30, 
can be changed with option NRow->nrows.
Option RView->True rotates the blocks sideways, and prints them in a single column. 
Option NoRest supresses trailing blocks of size less than NRows.
";
$plotrangeoffset::usage = "$plotrangeoffset controls the offset for MakePlotRange. Default value is 0.8.";
PlotRelation::usage = "PlotRelation[R,A,n,opts] plots a picture of a 
binary relation R on domain A, iterated n steps. The relation can be 
given as a Boolean function or a list of pairs. Options are 
Full->False, DoTrace->All, PlotStyle and LineStyle. See also 
PlotTDGraph.
";
PlotTDGraph::usage = "PlotTDGraph[gr,n,opts] plots a picture of a time 
dependent graph for n steps. Options are Full->False, DoTrace->All, 
PlotStyle and LineStyle.";
PlotT::usage = "PlotT[x,n] plots the first n powers of transformation 
x.  Option DoShow->False will not draw a grid. Default for n is 8.
";
PositionList::usage = "PositionList[L1,L2] generates a flattened list 
of the positions of the elements of list L2 in list L1.  All elements 
in L2 must occur in L1. 
";
PositionOne::usage = "PositionOne[xx,yy] evaluates to 
Position[xx,yy][[1,1]]. 
";
postload::usage = "postload[] sets some system parameters. 
Is executed automatically after the package is loaded.";
PowerSet::usage = "PowerSet[L,k] produces all k-element subsets of 
L. If k is omitted, the full power set of L is generate. Range[n] can 
be denoted by n.
";
preload::usage = "preload[] defines load messages. 
Is executed automatically before the package is loaded.";
PrintDClass::usage = "PrintDClass[dc] pretty prints a D-class dc; has 
attribute Listable.
";
PrintEquations::usage = "PrintEquations[eq] pretty prints a list of equations 
(produced by GenerateSG) in word form.  
Option Algebraic->True writes words in algebraic notation.
Option Cols->n prints in n column forma.";
PrintWitnesses::usage = "PrintWitnesses[S,wit] prints a table of 
witnesses and semigroup elements for semigroup S. See GenerateSG and 
SyntacticSG.
";
ProductGraph::usage = "ProductGraph[G1,G2] computes the Cartesian product H 
of two labeled graphs G1 and G2. H has as vertex set the Cartesian product of 
V1 and V2, and has an edge ((p,q),(p',q')) whenever p==p' and (q,q') in E2, 
or (p,p') in E1 and q==q'. 
Option Full->False produces the strict product instead:  (p,p') in E1 and (q,q') in E2.
";
ProductLabeledGraph::usage = "ProductLabeledGraph[G1,G2] computes the 
product H of two labeled graphs G1 and G2. H has an edge 
((p,p'),a,(q,q')) whenever there are edges (p,a,q) in G1 and (p',a,q') in G2.
";
RandomPermutation::usage = "RandomPermutation[k] produces a random 
permutation of [k].
";
RandomT::usage = "RandomT[n] generates a random transformation on [n]. 
The entries are chosen uniformly.
";
RankT::usage = "RankT[x] gives the rank of transformation x, i.e., the 
cardinality of its range and kernel; has attribute Listable.";
$rastercolors::usage = "$rastercolors is a list of rules that determines plot colors 
for RasterArray plots.  Array elements must be non-negative integers less than 10.";
RasterStyle::usage = "RasterStyle is an option for PlotMatrix, 
determines the colors used in the raster graphics. 
Default is $rastercolors, RasterStyle->Automatic uses HueRasterColors.";
Reflexive::usage = "Reflexive is a Boolean option for function TransitiveClosure 
(default False).";
RegularOnly::usage = "RegularOnly is an option for command 
DClassDecomposition.  Option RegularOnly->False causes all D-classes 
to be generated, rather than just the regular ones.  This option 
causes the internal version of the decomposition algorithm to be 
applied and should only be used for small semigroups.";
RegularQT::usage = "RegularQT[x,S] tests whether x is a regular 
element in semigroup S.
";
RegularSG::usage = "RegularSG[S] computes the regular elements in semigroup S.";
RelationToMatrix::usage = "RelationToMatrix[rel,A] converts a binary relation rel on A 
given by a Boolean function into a square binary matrix.";
Relation::usage = "Relation is a possible value for option Type in function ToClasses.";
RemoveDuplicates::usage = "RemoveDuplicates[L] removes duplicates from 
list L.  RemoveDuplicates[L1,L2] removes duplicates from list L1 and 
corresponding elements from list L2.  Option OutPairs->True generates 
output in pair form.";
RemoveVertex::usage = "RemoveVertex[G,x] removes vertex x from graph 
G. x must be given in positional notation. 
";
RenumberRules::usage = "RenumberRules[L,opts] produces a list of rules that renumber 
the elements of list L from 1 to Length[L].
Option Index->n starts numbering at n. 
Option Type->Backwards generates rules for conversion from integers to list items. 
";
ReplaceParts::usage = "ReplaceParts[x,r1,p1,r2,p2] performs two consecutive replacements.";
ReverseGraph::usage = "ReverseGraph[G] reverses all edges in a graph 
G.
";
$rewriteSimpBound::usage = "$rewriteSimpBound is a default bound for the number of 
transformation steps taken in the normalization algorithm for rewrite systems. 
Default value is 100.";
RightIdealT::usage = "RightIdealT[x,T] computes the right ideal 
generated by transformation x in semigroup S.
";
RightNullQT::usage = "RightNullQT[x,S] tests whether transformation x 
is a right null in semigroup S.
";
RightNullSG::usage = "RightNullSG[S] lists the right nulls of a semigroup S.";
RightOneQT::usage = "RightOneQT[x,S] tests whether transformation x is 
a right identity in semigroup S.
";
RightOneSG::usage = "RightOneSG[S] lists the right identities of a semigroup S.
";
RootList::usage = "RootList[L] computes the root of a list L: the shortest list K such that L = K^i.";
RShiftT::usage = "RShiftT[n] returns the right shift transformation T[n,1,2,..,n-1].";
RulesToPairs::usage = "RulesToPairs[rw] translates rewrite rules to word pairs.
";
RView::usage = "RView is an option for PlotMatrix.";
SeedConfiguration::usage = "SeedConfiguration[w,n,z] produces a seed 
configuration of length n with w at the center. Character z is used in 
place of 0. Also works with lists rather than words.
";
SelectOptions::usage = "SelectOptions[cmd,opts] selects those options from opts
that make sense for cmd.  SelectOptions[cmd,opts,{excl}] exludes options 
whose names are listed in {excl}. ";
SelectorQ::usage = "SelectorQ[L,LL] tests whether list L selects 
precisely one elment of each of the lists in LL.";
SetClosure::usage = "SetClosure is an option in Closure and 
ClosureSearch that determines the signature of the closure function.";
SG::usage = "SG[T1,..,Tm] is a header used for transformation semigroups. 
Elements are expressions of the form T[a1,..,an] where 1 <= ai <= n.";
ShortestPath::usage = "ShortestPath[G,s] constructs a shortest path 
from source vertex s in graph G to all vertices reachable from s. 
Output is of the form (u,d) where u is a vertex and d is its distance 
from s.  Option Full->True will produce the actual paths.";
ShowArray::usage = "ShowArray[L,k] produces a graphics array of width 
k from a linear list L of graphics objects.  Without k, default value 
Ceiling[Sqrt[Length[L]]] is used.";
Shuffle::usage = "Shuffle[L1,L2] shuffles two lists L1 and L2.  Also 
accepts input n for Range[n].
";
SimplifyEquations::usage = "SimplifyEquations[S,wit,eq] simplifies the \
defining relations eq of a semigroup S with witnesses wit by removing \
some redundancies. Also rewrites null as $nullstring (default: 0) and \
one as $identitystring (default: 1), if they exist in S.  Output of \
GenerateSG can be piped into SimplifyEquations.
";
SimplifyRewriteSystem::usage = "SimplifyRewriteSystem[eq] normalizes a 
rewrite system given by the directed equations eq. In the output, both 
the LHS and the RHS of all equations will be irreducible. The Thue congruence 
determined by eq is not affected by this transformation.  Note that 
SimplifyRewriteSystem is internally implemented and rather slow, do 
not use on more than 50 equations. See also SimplifyEquations.";
SolveSG::usage = "SolveSG[a,b,S] returns a list of all solutions 
of equation  a ** x == b  in semigroup S.
Option Full->False causes only the first solution to be returned
($Failed if no solution exists).
Option Where->Left solve the equation  x ** a == b  instead.
";
StaircasePlot::usage = "StaircasePlot[L,opts] generates a staircase plot of the data 
in list L (L must be a list of numbers). Options forwarded to Graphics.";
Status::usage = "Status[] displays session time in seconds, memory use 
and maximum memory use in mega bytes, as well as information about 
loaded contexts and links. Only contexts starting with a lower-case 
letter are reported. 
";
StronglyConnectedComponents::usage = "StronglyConnectedComponents[G,opts] computes the strongly connected 
components of graph G using a linear algorithm.  Option NonTrivial->True only returns 
the nontrivial components.  Uses external code.
";
SubGraph::usage = "SubGraph[G,L] constructs the subgraph of G induced 
by vertex set L. L must be given in positional notation. 
";
SubsetQ::usage = "SubsetQ[S1,S2] tests whether S1 is a subset of S2.";
SymbolList::usage = "SymbolList[sym,L] generates a list of symbols of the form 
symL1, symL2, .... L must be a list, Range[n] can be specified as n.";
SymmetricGroupSG::usage = "SymmetricGroupSG[n] returns the symmetric 
group on [n], uses GenerateSG.  Since the symmetric group has n! 
elements, this can only be used for small n.
";
TableSG::usage = "TableSG[S,W] prints the multiplication table of 
semigroup S using witnesses W. Substitutes 0 and 1 for null and identity, 
if they exist.";
ToAdjList::usage = "ToAdjList[G] converts a graph G into adjacency 
list form.
";
ToAdjMatrix::usage = "ToAdjMatrix[G] converts a graph G into adjacency 
matrix form.
";
ToBitVector::usage = "ToBitVector[S,U] transforms S into a bit vector 
over universe U.
";
ToClasses::usage = "ToClasses[L,R] generates the equivalence classes 
of list L with respect to equivalence relation R.  The relation R can 
be given as a binary relation, a Boolean function (option 
Type->Function), a binary matrix (option Type->Matrix), or an index 
(option Type->Index). In the last case, R must be a list of integers 
of length n = Length[L] whose entries are numbers in [n]: R[i]==j 
means that L[[i]] is in the j-th class. 
";
ToDAG::usage = "ToDAG[G] computes the directed acyclic graph obtained 
from G by collapsing its strongly connected components into points and 
preserving edges between these points.
";
ToEdgeList::usage = "ToEdgeList[G] converts a graph G into edge list 
form.
";
ToEps::usage = "ToEps[x] replaces all occurences of the empty string in x by \"Eps\".";
ToIdentityString::usage = "ToIdentityString[xxx] replaces all 
occurences of the empty string in xxx by $identitystring.
";
ToList::usage = "ToList[S] converts object S into a list: List@@S.";
ToTDGraph::usage = "ToTDGraph[{RR},m,opts] converts a sequence of relations 
RR to a time dependent graph, used mostly for plotting. See PlotTDGraph.";
TransformationSG::usage = "TransformationSG[n] returns the 
transformation semigroup on [n], uses GenerateSG. Since the full 
transformation semigroup has n^n elements, this can only be used for 
small n.
";
TransientPeriodicT::usage = "TransientPeriodicT[x] returns the length 
of the transient and periodic part of the semigroup generated by 
transformation x. If x is a permutation, the length of the periodic 
part is the order of x in the group generated by it.
";
TransitiveClosure::usage = "TransitiveClosure[B,opts] determines the 
transitive closure of Boolean matrix B. Option Reflexive->False. 
";
TranspositionT::usage = "TranspositionT[n,i] returns the transposition 
(i,i+1) of length n. Position i has default value 1.";
T::usage = "T[a1,..,an] denotes an element in a transformation semigroup, 
1 <= ai <= n.  Composition is defined on NonCommutativeMultiply and uses diagrammatic 
order: T1 ** T2 means: apply T1 first, then T2.";
TypeGraph::usage = "TypeGraph[G] returns the type of a graph G (see 
Graph). 
";
Type::usage = "Type is an option for ToClasses. 
Possible values are: Relation (default), Function, Matrix, Index.";
UnitElement::usage = "UnitElement[x] generates the unit element in the 
monoid to which x naturally belongs. More precisely, x can be a 
transformation, a boolean matrix, a matrix over the tropical semiring, 
or an integer matrix. Used in particular in GenerateSG.
";
VertexSet::usage = "VertexSet[G] returns the vertex set of a graph 
G.
";
Vier::usage = "Vier[x] returns the fourth part of x: Vier[x] = x[[4]].";
Warshall::usage = "Warshall[B] computes the star of Boolean matrix B 
using Warshall's algorithm. For efficency reasons, the matrix is 
actually required to be binary. Thus, if B represents a relation R on 
[n], Warshall[B] is the matrix representing the transitive closure
of the relation.  The algorithm is cubic in n.
Options are Reflexive->True and Full->True.  The latter produces the
transitive closure as well as the transitive reduction of the irreflexive
version of B.  Requires input to be acyclic.
";
WeaklyConnectedComponents::usage = "WeaklyConnectedComponents[G,X] computes the weakly connected 
component of X in graph G.  X can be a single vertex or a list of vertices 
(in either case, in positional notation).";
Where::usage = "Where is an option for SeedConfiguration that controls 
positioning of the seed pattern.  Default is Center, other possible values 
are Left or Right.
";
Witnesses::usage = "Witnesses is a Boolean option that controls
computation of witnesses during the generation of semigroups.
";
WordQ::usage = "WordQ[w] tests whether w is a word: w may be a symbol or a string.
";
WordReduce::usage = "WordReduce[w,eq,opt] reduces word w according to 
equations eq. The equations are only applied in directed form from 
left to right.  Uses StringReplace internally and may therefore 
perform several substitutions in one step. Option DoTrace->True causes 
a trace to be displayed.";
Zwei::usage = "Zwei[x] returns the second part of x: Zwei[x] = x[[2]].";


Begin["`Private`"];


AccCoaccGraph[ G_Graph, SS_List, TT_List, opts___?OptionQ ] := 
Module[ {VV,UU},
       VV = WeaklyConnectedComponents[G,SS];
       UU = WeaklyConnectedComponents[G//ReverseGraph,Intersection[VV,TT]];
       SubGraph[ G, Intersection[ VV, UU ], opts ]
];
AccCoaccGraph[ G_Graph, s_Integer, t_Integer, opts___?OptionQ ] := 
		AccCoaccGraph[ G, {s}, {t}, opts ];

AccessibleGraph[ G_Graph, SS_List, opts___?OptionQ ] := 
       SubGraph[ G, WeaklyConnectedComponents[G,SS], opts ];
AccessibleGraph[ G_Graph, p_Integer, opts___?OptionQ ] := 
		AccessibleGraph[ G, {p}, opts ];

(* Special graphs *)



AlgebraicForm[Eps|"Eps"|Global`\[Epsilon]|1|$identitystring] = $identitystring;
AlgebraicForm[0|$nullstring] = $nullstring;
AlgebraicForm[w_?WordQ] := Apply[ SequenceForm, makeruns@Characters@ToString[w] ]; 



AllStringReplace[L_List][{}] := {};

AllStringReplace[L_List][{ss__?WordQ}] := 
     Automata`automata`WordSort@Union@Flatten[ AllStringReplace[L] /@ {ss} ];

AllStringReplace[L_List][ss_?WordQ] := 
With[ {str = ToString[ss],
       LL = Map[ ToString, L /. Rule->List, {2} ] },
       Union[stringRep[str] /@ FlattenOne[ gethandle[str] /@ LL ] ]
];

(* is this really needed ? *)
AllStringReplace[rr_->tt_][ss_] := AllStringReplace[{{rr,tt}}][ss];

gethandle[ww_String][{u_String,v_String}] := Prepend[#,v]& /@ StringPosition[ww,u];

stringRep[s_String][{t_String, i_Integer, j_Integer} ] :=
	Concatenate[ StringTake[s,i-1], t, StringDrop[s,j] ];


AllTimes[A_List, B_List] :=
     Apply[NonCommutativeMultiply, CartesianProduct[A,B], {1}];
AllTimes[A_List,B_List,R__List] := AllTimes[AllTimes[A,B], R];

     

AlternatingGroupSG[n_] := SG[OneT[n]]   /;  n<3;
AlternatingGroupSG[n_Integer, opts___?OptionQ ] :=
	GenerateSG[ GEN[ n, n-2, Join[ {T@@Join[{2,3,1},Range[4,n]]},
		TranspositionT[n,1] ** (TranspositionT[n,#]& /@ Range[3,n-1]) ] ], opts ];


Options[AnalyzeOrbit]={Cycle->None, Periodic->False};

AnalyzeOrbit[ ff_, aa_, gg_, opts___?OptionQ ] := 
Module[ {slow,fast,peb,peb1,peb2,pcnt,qcnt,cyc},

	If[ Periodic /. {opts} /. Options[AnalyzeOrbit],
	    Return[ analyzePeriodicOrbit[ ff, aa, opts ] ] ];

	cyc = Cycle /. {opts} /. Options[AnalyzeOrbit];

	(*  find a point slow on the cycle  *)
	slow = ff[aa];
	fast = gg[aa];
	While[ slow=!=fast, 
			slow = ff[slow];
			fast = gg[fast];
	];
	
	(*  compute the length pcnt of the cycle  *)
	peb = ff[slow];
	pcnt = 1;
	While[ peb=!=slow, 
			pcnt++;
			peb = ff[peb] 
	];
	
	(*  find entry point on cycle  *)
	peb1 = aa;
	peb2 = Nest[ ff, aa, pcnt ];
	qcnt = 0;
	While[ peb1!=peb2, 
			peb1 = ff[peb1];
			peb2 = ff[peb2];
			qcnt++;
	];
	
	Switch[ cyc,
		None, 		{qcnt,pcnt},
		False,		{qcnt,pcnt,peb1},
		True,		{qcnt,pcnt,NestList[ff,peb1,pcnt-1]} 
	]
];

AnalyzeOrbit[ ff_, aa_, opts___?OptionQ ] := 
	AnalyzeOrbit[ ff, aa, ff[ff[#]]&, opts ];

analyzePeriodicOrbit[ ff_, aa_, opts___?OptionQ ] := 
Module[ {pcnt}, 

	(*  orbit must be a cycle  *)

	pcnt = 1;
	NestWhile[ (pcnt++; ff[#])&, ff[aa], #=!=aa& ]; 
	
	Switch[ Cycle /. {opts} /. Options[AnalyzeOrbit],
		None, 		{0,pcnt},
		False,		{0,pcnt,aa},
		True,		{0,pcnt,NestList[ff,aa,pcnt-1]} 
	]
];


AperiodicQSG[ SS_SG ] := 
Module[ {S,m,Sq,sq},

     S = ToList[SS];
     m = Length[First[S]];
     
     If[ m==1, Return[True] ];
     
     (* compute list x^2, x in S,
		convert to transformation t : [n] --> [n], 
		t(i) = position of S[[i]]^2 in S     
		r minimal such that 2^r >= m,  
     	compute list of 2^r-th powers of S via t^r *)
     	
     sq = FastExpoT[ T@@PositionList[ S, S^2 ], Ceiling[N[Log[2,m]]] ];
     Sq = S[[ ToList[sq] ]];
     Sq === Sq**S
]; 

AperiodicQSG[S_List] := 
    GenerateSG[GEN[Length@First[S],Length[S],S]] // AperiodicQSG;
AperiodicQSG[z__T]   := 
    GenerateSG[GEN[Length@First[{z}],1,{z}]] // AperiodicQSG;


AperiodicQT[x_T] := 
	With[ {xn = FastExpoT[x,Length[x]]}, xn === xn**x ];
	

AperiodicSG[S_SG] := ToList[Select[S,AperiodicQT]];


Options[AssignFunction]={Opts->{}, Kary->False};

AssignFunction[ h_, L_List, opts___?OptionQ ] := 
(
	ClearAll[h]; 
 	If[ Kary /. {opts} /.  Options[AssignFunction],    
	    Scan[ (h[Sequence@@First[#]]=Last[#])&, L ],
	    Scan[ (h[First[#]]=Last[#])&, L ]
	];
    	SetAttributes[h,Opts/.Flatten[{opts}]/.Options[AssignFunction]]; 
);

AssignFunction[ h_, L1_List, L2_List, opts___?OptionQ ] := 
    AssignFunction[ h, Pairs[L1,L2], opts ]; 


BlocksToDClass::irrg = "D-class is irregular, must supply semigroup.";

BlocksToDClass[ db_List, S_SG:SG[] ] := 
Module[ {e,x,H,pos,rm,lm,S1},
	e = Scan[ If[ #**#===#, Return[#] ]&, Flatten[db]]; (* find idempotent *)
	If[ e=!=Null,
		 pos = First@Position[db,e];
		 H  = db[[Sequence@@Drop[pos,-1]]];
		 rm = First /@ db[[First[pos]]];
		 lm = First /@ Thread[db][[Zwei[pos]]],
	(* else class is irregular *)
	If[ S===SG[], Message[BlocksToDClass::irrg]; Return[$Failed]];
	    S1 = MakeMonoidSG[S];
	    H  = db[[1,1]];
	    x  = First[H];
	    rm = SolveSG[x,#,S1,Full->False]& /@ First /@ First[db];
	    lm = SolveSG[x,#,S1,Full->False,Where->Left]& /@ First /@ First[Thread[db]]        
	];
	DC[lm,rm,H]
];


BooleanComplement[R_?MatrixQ] := 1-R;
BooleanComplement[R_?MatrixQ,S_?MatrixQ] := 
    BooleanIntersection[R,1-S];

BooleanComposition[R__?MatrixQ] := Sign@Dot[R];

BooleanConverse[R_?MatrixQ] := Transpose[R];


BooleanIntersection[R_?MatrixQ,S_?MatrixQ] := 
    MapThread[ Min, {R,S}, 2 ];

BooleanPower[R_?MatrixQ,0] := IdentityMatrix[Length[R]];
BooleanPower[R_?MatrixQ,n_Integer] := Sign[Dot@@Table[R,{n}]];

BooleanUnion[R_?MatrixQ,S_?MatrixQ] := 
    MapThread[ Max, {R,S}, 2 ];

Options[Boolean]={};

Options[BoundCSM]={};

Options[BoundETW]={};

Options[BoundGSG]={};

CartesianProduct[___,{},___] = {};
(* used to be  CP[L]==L  to simplify some functions in automata.m *)
CartesianProduct[ LL___List ] := Distribute[{LL},List];
CartesianProduct[ ints__Integer ]  := Distribute[Range /@ {ints},List];


CirculantGraph[n_Integer,d_List] := 
Module[{Q,k,ed},
	k = Length[d];
	Q = Range[0,n-1];
	ed = Thread[{Join@@Table[Q,{k}], Mod[#,n]& /@ Join@@((Q+#)& /@ d)}];
	Graph[ n, Length[ed], 1, ed+1, {} ]
];


$closureBound = 500;

Options[ClosureBound]={};

$closureSearchBound = 500;

Options[ClosureSearch]={SetClosure->False, ClosureBound:>$closureSearchBound};

ClosureSearch[ LL_List, targ_, ff__, opts___?OptionQ ] :=
Block[ {act,S,sc,cb},
	sc = If[ SetClosure /. {opts} /. Options[Closure], 2, 1 ];
	cb = ClosureBound /. {opts} /. Options[ClosureSearch];
	act = LL;
	S = {};
	While[ Length[act] > 0 && Length[S] < cb,
	       S   = Union[S,act];
	       If[ MemberQ[S,targ], Return[True] ];
	       act = Complement[Flatten[ Function[z,z /@ act] /@ {ff},sc],S];
	];
	False
];


Options[Closure]={SetClosure->False, ClosureBound->$closureBound};

Closure[ LL_List, ff__, opts___?OptionQ ] :=
Block[ {S,sc,cb},
	sc = If[ SetClosure /. {opts} /. Options[Closure], 2, 1 ];
	cb = ClosureBound /. {opts} /. Options[Closure];
	S = {};
	
	(* FP: the set of active elements is empty *)
	FixedPoint[ 
	    ( S   = Union[S,#]; Complement[Flatten[ Function[z,z /@ #] /@ {ff}, sc],S] )&,
	      LL,
	      cb ];
	S
];


CollapseT[z_] := 
With[ {ker = KernelT[z]},
     T@@(First /@ FlattenOne[Position[ker,#]& /@ ImageT[z]])
];

(* disjoint cycle decomposition for permuations *)
(* conversion cycles <--> T terms, composition of cycles *)


ColorQ[_RGBColor|_GrayLevel|_Hue] = True;
ColorQ[_] = False;


Options[Cols]={};

CompCycles[ {c1___List}, {c2___List} ] := 
	With[ {n = Max[{c1,c2}]},
		CycleDecompositionT[ CycleToT[{c1},n] ** CycleToT[{c2},n] ] ];
Concatenate[Eps|"Eps"|Global`\[Epsilon]] := "Eps";
Concatenate[x_?WordQ]  := ToString[x];
Concatenate[Eps|"Eps"|Global`\[Epsilon],yy_List] := yy;
Concatenate[xx_List,Eps|"Eps"|Global`\[Epsilon]] := xx;
Concatenate[xx___,Eps|"Eps"|Global`\[Epsilon],yy___] := Concatenate[xx,yy];
Concatenate[x__?WordQ] := StringJoin@@(ToString /@ {x});
Concatenate[{}]       := "Eps";
Concatenate[xx_List]  := Concatenate@@xx;
Concatenate[xx__List] := Apply[ Concatenate, CartesianProduct[xx], 1 ];
Concatenate[xx___,ww_?WordQ,yy___] := Concatenate[xx,{ww},yy];

ConsT[k_Integer,n_Integer] := T@@Table[k,{n}];
Curry[fff_] := Function[yyy,Function[xxx,fff[xxx,yyy]]];


Options[CycleDecompositionT]={Full->False};

CycleDecompositionT[x_T,opts___?OptionQ] := 
Module[ {all,testcyc,cycs,orb},
	all = Range[Length[x]];
	testcyc[ LL_List ] := 
		With[ {ss = x[[Last[LL]]]},
			If[ MemberQ[LL,ss], LL, Append[LL,ss] ]];
	cycs = {};
	
	While[ all=!={},
		orb = FixedPoint[ testcyc, {Min[all]} ];
		AppendTo[ cycs, orb ];
		all = Complement[all,orb];
	];
	If[ Full /. {opts} /. Options[CycleDecompositionT], 
	    cycs,
	    DeleteCases[ cycs, {_} ]
	]
];


CycleToT[ {cyc___List}, n_Integer ] := 
	OneT[n] /. Flatten[Thread[#->RotateLeft[#]]& /@ {cyc} ];

Options[Cycle]={};

CyclicQGraph[ G_Graph ] :=
Module[ { n,L,cnt,Z,indeg,in },

        (* compute indegrees *)
        n  = NumVertices[G];
	L  = Edges@ToAdjList[G];
        AssignFunction[indeg,Range[n],First /@ DegreeGraph[G,Full->True]];

        (* prepare candidates  *)
        Z = Select[Range[n],(indeg[#]==0)&];

        cnt = 0;
        While[ Length[Z]>0,
                cnt++;
                x = First[Z];
                Z = Rest[Z];
                Scan[(indeg[#]--;If[ indeg[#]==0, Z={Z,#}])&, L[[x]] ];
		Z = Flatten[Z]
        ];
    cnt < n
];


Options[DClassDecomposition]={RegularOnly->True};

DClassDecomposition[S_SG,opts___?OptionQ] := 
Module[ {idem,regular,d,S1,Sirr,dclist,makeDClass,hs,rs,sel0,sel1,
		lind,rind,lid,rid,inds,V,VV,scc,adjL,gr},
     regular = RegularOnly /.{opts}/.Options[DClassDecomposition];
     
     (* regular D-classes *)
     dclist = {};
     Sirr   = ToList[S];
     idem   = IdemSG[S];
     While[ Length[idem] > 0,
            d  = DClassT[First[idem],S];
            dL = Flatten@ToList@DClassToBlocks[d];
            dclist = {dclist,d};
            idem = Complement[ idem, dL ];
            If[!regular, Sirr = Complement[Sirr,dL]];
     ];
     If[ regular || Sirr==={}, Return[Flatten[dclist]] ];

     (* irregular D-classes *)
     makeDClass[ LL_List ] := 
     ( 
       VV   = V[[LL]];
       sel0 = Select[ inds, MemberQ[VV,Drop[#,-1]]& ];
       sel1 = Drop[#,-1]& /@ sel0;
       hs   = Count[sel1,First@sel1];
       rs   = Count[First/@sel1,First@First@sel1]/hs;
       Partition[ Partition[ Drei /@ sel0, hs ], rs ] 
     );
     
     S1 = MakeMonoidSG[S];     
     Scan[ (lid[#]:=lid[#]=LeftIdealT[#,S1])&,Sirr];
     Scan[ (rid[#]:=rid[#]=RightIdealT[#,S1])&,Sirr];
     AssignFunction[ lind, Sirr, First@MakeIndex[Sirr,lid[#1]===lid[#2]&]];
     AssignFunction[ rind, Sirr, First@MakeIndex[Sirr,rid[#1]===rid[#2]&]];
     
     inds = {rind[#],lind[#],#}& /@ Sirr // Sort;
     V    = Drop[#,-1]& /@ inds // Union;
     adjL = PositionList[V,Union[Cases[V,{First[#],_}],Cases[V,{_,Last[#]}]]]& /@ V;
     gr   = Graph[ Length[V], Plus@@( Length /@ adjL ), 4, adjL, {} ];
     scc  = StronglyConnectedComponents[gr];
     
     Join[ Flatten[dclist], BlocksToDClass[#,S]& /@ (makeDClass /@ scc) ]
];



Attributes[DClassDimensions]={Listable};

DClassDimensions[dc_DC] := ToList[Length /@ dc];

Options[DClasses]={};

Attributes[DClassSize]={Listable};

DClassSize[dc_DC] := Times@@DClassDimensions[dc];

Attributes[DClassToBlocks]={Listable};

DClassToBlocks[ dcl_DC ] := Outer[ (#1**dcl[[3]]**#2)&, dcl[[1]], dcl[[2]] ];


DClassT[z_T,S_SG] := 
Module[ {rank,Rz,Lz,H,SL,pairs,k1,k2},
     
    SL   = ToList[MakeMonoidSG[S]];
    rank = RankT[z];

    Rz  = RemoveDuplicates[z**SL,SL,OutPairs->True];
    Rz  = Select[Rz,(RankT[#[[1]]]==rank)& ];
    H   = Select[First /@ Rz,(ImageT[#]==ImageT[z])& ];
    Rz  = Zwei@RemoveDuplicates[ImageT[#[[1]]]& /@ Rz, Last /@ Rz ];
    Lz  = RemoveDuplicates[SL**z,SL,OutPairs->True];
    Lz  = Select[Lz,(RankT@First[#]==rank)& ];
    Lz  = Zwei@RemoveDuplicates[Sort@KernelT@First[#]& /@ Lz, Last /@ Lz];

    pairs = CartesianProduct[Lz,Rz];
    pairs = Select[ pairs, SelectorQ[ImageT[z**#[[2]]],KernelT[#[[1]]**z]]&];
    Rz  = Union[Last  /@ pairs];
    Lz  = Union[First /@ pairs];
    DC[Lz,Rz,H]
];


Options[DC]={};

Options[$defaultexternal]={};

$defaultexternal = False;

$deffatline = 0.005;

$deflabeloffset  = 0.2;

$defpointsize = 0.012;

$defthinline = 0.003;

Options[DegreeGraph]={Full->False};

DegreeGraph[G_Graph,v_Integer,opts___?OptionQ] := 
Module[{ed,in,out},
	full = Full /. {opts} /. Options[DegreeGraph];

	ed  = Edges@ToEdgeList[G];
	out = Length[Cases[ed,{v,__}]];
	in  = Length[Cases[ed,{__,v}]];
	If[ full, {in,out}, in + out ]
];

(*  dangerous, slow on big graphs *)
DegreeGraph[G_Graph,V_List,opts___?OptionQ] := 
Module[{degs,ed,in,out},
	full = Full /. {opts} /. Options[DegreeGraph];
	ed  = Edges@ToEdgeList[G];
	out[v_] := Length[Cases[ed,{v,__}]];
	in[v_]  := Length[Cases[ed,{__,v}]];
	degs = Thread[{in /@ V,out /@ V}];
	If[ full,  degs, Apply[Plus, degs, 1] ]
];

DegreeGraph[G_Graph,opts___?OptionQ] := 
Module[{deg,ed,ind,outd,makdeg},

	ed  = Edges@ToEdgeList[G];

	If[ Full /. {opts} /. Options[DegreeGraph], 
	    ind[_] = 0; outd[_] = 0;
	    makdeg[{a_,b_}] := (ind[b]=ind[b]+1; outd[a]=outd[a]+1);
	    Scan[ makdeg, ed ];
	    Return[ Thread[{ind /@ Range@NumVertices[G], outd /@ Range@NumVertices[G]}] ];
	];

        deg[_] = 0;
	makdeg[{a_,b_}] := (deg[b]=deg[b]+1; deg[a]=deg[a]+1);
	Scan[ makdeg, ed ];
	Return[ deg /@ Range@NumVertices[G] ];
];


Dependency[ lab_List, k_Integer:2 ] := 
With[ {n = Log[ k, Length[lab] ]}, 
	n - Select[ Range[0,n-1],
	 !SameQ@@(Flatten /@ Thread@Partition[Partition[lab,k^#],k])& ] // Sort
]; 


$dimathReleaseNumber = "4.6";

DisjointQ[L1_List,L2_List] := Length[Intersection[L1,L2]]==0;


DoShow[gr_,opts___?OptionQ ]   := 
	Show[gr,DisplayFunction->$DisplayFunction,opts]; 

Options[DoTrace]={};

Drei = Function[xx,xx[[3]]];   

EdgeQ[ G_Graph, x_Integer, y_Integer ] := 
Switch[ TypeGraph[G],
        1|2,  Cases[ Edges[G], {x,___,y} ]=!={},
        3,    Edges[G][[x,y]]==1,
        4,    MemberQ[ G[[x+1]], y ]
];



Edges[ G_Graph ]     := Vier[G];

Options[EnumForm]={Index->1};

EnumForm[LL_List,opts___?OptionQ] := 
With[ {nn = Index /. {opts} /. Options[EnumForm]},
	Apply[ ColonForm, Pairs[ Range[nn,nn+Length[LL]-1],LL], 1 ]] // ColumnForm;



Options[Eps]={};

Options[EquationsToWitnesses]={Full->False, BoundETW->500};

EquationsToWitnesses[ eq_List, K_:Automata`automata`$alphabet, opts___?OptionQ ] :=
Block[ {KK,pats,testwi,testw,wit,active,act,bound,nulls,
     x,wi,eqq,res},
     bound = BoundETW /. {opts} /. Options[EquationsToWitnesses];

     KK   = MakeAlphabet[K];
     eqq  = Map[ ToString, eq, {-1} ];
     pats = First /@ eqq;

     testwi[ w_, i_ ] := 
     ( wi = Concatenate[w,i];
       If[ StringPosition[wi,pats]==={}, 
			AppendTo[ wit, wi ]; AppendTo[ act, wi ] ]; );

     testw[w_] := Scan[ testwi[w,#]&, KK ];

     nulls = Cases[eqq,{_,$nullstring}];
     front = {};
     If[ Cases[eqq,{_,$identitystring|"Eps"}]=!={}, 
     		AppendTo[front,"Eps"] ];
     If[ nulls=!={}, AppendTo[front,First@First[nulls]] ];

     wit = {};
     active = {Eps};
     While[ Length[active]>0 && Length[wit]<bound,
            act = {};
            Scan[ testw, active ];
            active = act;
     ];
     res = Join[ front, wit ] // Automata`automata`WordSort;

     If[ (Full /. {opts} /. Options[EquationsToWitnesses]) &&
         !MemberQ[res,"Eps"],
         Prepend[res,"Eps"],
         res
	 ]
];


Options[Equations]={};

Options[External]={};

FastPowerSet[{}] = {{}};
FastPowerSet[{a_,xx___}] := With[{p=FastPowerSet[{xx}]}, Join[ p, Prepend[#,a]& /@ p ] ];


Options[Filter]={};

FlattenOne[xx_] := Flatten[xx,1];
Frequencies[L_List] := 
	With[ {LL = Union[L]},  Pairs[LL,Count[L,#]& /@ LL] ];


FromBitVector[B_List,UU_List] := UU[[ Flatten[Position[B,1]] ]];
FromBitVector[B_List,___] := Flatten[Position[B,1]];
    

FromEps[xx_] := xx /. {Eps->"","Eps"->"",Global`\[Epsilon]->""};

FromIdentityString[XX_] := XX /. {$identitystring->""};

Options[GenerateCSM]={Equations->False, BoundCSM->1000};


GenerateCSM[ q0_, dot_, K_:Automata`automata`$alphabet, opts___?OptionQ ] :=
Block[ {wit,val,testwi,testw,k,alph,S,act,active,eq,eqns,smax,x,wi},
     eqns   = Equations /. {opts} /. Options[GenerateCSM];
     smax   = BoundCSM  /. {opts} /. Options[GenerateCSM];

     {k,alph} = MakeFullAlphabet[K];
     If[ !eqns, Return[generatecsm[q0,dot,alph,smax]] ];

     testwi[ w_String, i_Integer ] :=
     (  
        wi = Concatenate[ w, alph[[i]] ];
        x  = dot[ val[w], alph[[i]] ];
        If[ MemberQ[S,x],
            AppendTo[ eq, {wi,wit[x]} ],
        (*else*)
            AppendTo[ S, x ];
            wit[x]  = wi;
            val[wi] = x;
            AppendTo[ act, wi ];
       ];
     );

     testw[w_String] := Scan[ testwi[w,#]&, Range[k] ];

     S          = {q0};
     act        = {};
     active     = {"Eps"};
     eq         = {};
     val["Eps"] = q0;
     wit[q0]    = "Eps";
     While[ Length[active] > 0 && Length[S] < smax,
			Scan[ testw, active ];
			{active,act} = {act,{}};
     ];
     
     {S,wit/@S,eq} 
];

(* brute force closure, apparently faster *)

generatecsm[ q0_, op_, alph_, smax_ ] :=
Module[ {act,S,gen},
     act = S = gen = {q0};
     While[ Length[act]>0 && Length[S]<smax,
        S   = Union[S,act];
        act = Complement[Union[Apply[ op, CartesianProduct[act,alph], 1 ]], S ];
     ];
     S
];


$generateSGBound = 1000;

Options[GenerateSG]={Full->False, Equations->False, Filter->Identity, DClasses->False, BoundGSG->$generateSGBound, External:>$defaultexternal};

GenerateSG[ gg_GEN, opts___?OptionQ ] :=
Block[ {gen,eqns,filt,S,mu,active,act,k,eq,towit,testwi,smax,x,wi,
     testw,mod,full,unit,g1,dclass,ss,ww,ee,K},

     (* call external code, but only on transformations  *)
     If[ (External /. {opts} /. Options[GenerateSG]) && 
         Head[First@Last[gg]]===T, 
         Return[ Automata`extaut`ExtGenerateSG[gg,opts] ] ];

     eqns   = Equations /. {opts} /. Options[GenerateSG];
     filt   = Filter    /. {opts} /. Options[GenerateSG];
     smax   = BoundGSG  /. {opts} /. Options[GenerateSG];
     full   = Full      /. {opts} /. Options[GenerateSG];
     dclass = DClasses  /. {opts} /. Options[GenerateSG];

     {k,K} = MakeFullAlphabet@Zwei[gg];
     gen   = Last[gg];
     g1    = First[gen];
     unit  = UnitElement[g1];
     If[ Head[g1]===T, 
         oper=NonCommutativeMultiply,
         oper=Dot
     ];

     If[ !(eqns || dclass), Return[generatesg[gen,oper,filt,smax,full]] ];

     testwi[ w_List, i_Integer ] :=
     (  wi = Append[w,i];
        x  = oper[ mu[w], gen[[i]] ] // filt;
        mu[wi] = x;
        If[ MemberQ[S,x],
            If[ eqns || dclass, AppendTo[ eq, {wi,towit[x]} ] ],
        (*else*)
            AppendTo[ S, x ];
            towit[x] = wi;
            AppendTo[ act, wi ];
        ]; );

     testw[w_List] := Scan[ testwi[w,#]&, Range[k] ];

     If[ full,
         S = {unit}; towit[unit]={},
         S = {}
     ];
     act    = {};
     eq     = {};
     active = {{}};
     mu[{}] = unit;
     While[ Length[active] > 0 && Length[S] < smax,
            Scan[ testw, active ];
            {active,act} = {act,{}};
     ];
     
     {ss,ww,ee} = {SG@@S,toword[#,K]&/@towit/@S, Map[toword[#,K]&,eq,{2}]};
     If[ dclass, 
         Append[ {ss,ww,ee}, DClassDecomposition[ss] ],
         {ss,ww,ee}
     ]
];


GenerateSG[ z__T, K_:Automata`automata`$alphabet, opts___?OptionQ ] := 
    GenerateSG[ GEN[ Length@First[z], K, {z} ], opts ];

generatesg[ z_List, op_, fil_, smax_, full_ ] :=
Module[ {act,S,gen},
     act = S = gen = z;
     If[ full, AppendTo[ S, UnitElement@First[z] ]];
     While[ Length[act]>0 && Length[S]<smax,
            S   = Union[S,act];
            act = Union[ Apply[ op, CartesianProduct[act,gen], 1 ] ] // fil;
            act = Complement[act,S];
     ];
     SG @@ S
];


padNums[n_Integer] := 
With[ {k = Length@IntegerDigits[n]},
      Apply[ StringJoin, PadLeft[#, k, " "] & /@ 
          Map[ ToString, IntegerDigits[Range[n]], {2} ], {1}]];

(* should use automata version *)

toword[ str_String, ___ ] := str;
toword[ {}, ___ ] = "Eps";
toword[ x_List, K_:$alphabet ] := StringJoin @@ MakeAlphabet[K][[x]];
toword[ r_Integer, k_Integer ] := 
        StringJoin@@(MakeAlphabet[k][[IntegerDigits[r,k]+1]]); 



Options[GEN]={};

Options[Graph]={};

Graph[n_,k_,i_,ed_] := Graph[n,k,i,ed,{}];


GreenHQT[x_T,y_T,S_SG] := GreenRQT[x,y,S] && GreenLQT[x,y,S];

GreenJQT[x_T,y_T,S_SG] := 
     RankT[x]===RankT[y] &&
     IdealT[x,S]===IdealT[y,S];

GreenLQT[x_T,y_T,S_SG] := 
     Sort[ImageT[x]]===Sort[ImageT[y]] &&
     LeftIdealT[x,S]===LeftIdealT[y,S];

GreenRQT[x_T,y_T,S_SG] := 
     Sort[KernelT[x]]===Sort[KernelT[y]] &&
     RightIdealT[x,S]===RightIdealT[y,S];

Options[GridLine]={PlotStyle->{GrayLevel[0.8],$defthinline}, GridOffset->{0,0}, Full->All};

Unprotect[PointSize,Thickness];
Attributes[PointSize] = {Flat};
Attributes[Thickness] = {Flat};
Protect[PointSize,Thickness];

GridLine[m_Integer,n_Integer, opts___?OptionQ] := 
Module[ {ps,xoff,yoff,full,lines},
	ps = PlotStyle /. {opts} /. Options[GridLine];
	{xoff,yoff} = GridOffset /. {opts} /. Options[GridLine];

	full = Full /. {opts} /. Options[GridLine];

	ps = 
	Switch[ ps, 
		_?ColorQ,     {ps,$defthinline},
		{_?ColorQ},   {ps[[1]],$defthinline},
		_Real,        {GrayLevel[0.8],ps},
		{_Real},      {GrayLevel[0.8],ps[[1]]},
		_,            ps
	];
	ps = MapAt[ Thickness, ps, 2 ];
	
	shift[{x_,y_}] := {x-xoff,y-yoff};

	lines = 
	Switch[ full,
		All,	Join[ Line/@Table[shift/@{{i,1},{i,m}},{i,n}],  
			      Line/@Table[shift/@{{1,i},{n,i}},{i,m}] ],
		_List,	{ Map[ Line, full, {-3} ] }
	];

	Graphics[ Join[ ps, lines ], 
     		MakePlotRange[n,m], 
     		SelectOptions[Graphics,opts] ]
];


Options[GridOffset]={};

Options[GridPoints]={LabelGrid->None, Full->All, LabelPoints->None, PlotStyle:>{{Blue,$defpointsize},{Red,1.2$defpointsize}}};

GridPoints[m_Integer,n_Integer,opts___?OptionQ] := 
Module[ {txtl,txtr,txtm,del,ps,full,lab,labf,labff,i,j,pnts},
	txtl = txtr = txtm = {};
	del  = $deflabeloffset + n/40; 
	ps   = PlotStyle /. {opts} /. Options[GridPoints];
	full = Full      /. {opts} /. Options[GridPoints];
	
	If[ (lab = LabelGrid /. {opts} /. Options[GridPoints]) =!= None, 
	    If[ lab===Automatic, labf = #&,
		If[ Head[lab]===List, labf = lab[[#]]&, labf = lab ]];
		txtl = Table[ Text[labf[i],{1-del,i},TextStyle->$TextStyle], {i,m} ];
		txtr = Table[ Text[labf[i],{n+del,i},TextStyle->$TextStyle], {i,m} ];
	];

	If[ (labff = LabelPoints /. {opts} /. Options[GridPoints]) =!= None, 
		txtm = Table[ Text[labff[j,i],{j-del/2,i-del/2},TextStyle->$TextStyle], {i,m},{j,n} ];
	];

	ps = 
	Switch[ ps, 
	    _?ColorQ,              {{ps,$defpointsize},{Red,1.2$defpointsize}},
	    {_?ColorQ},            {{ps[[1]],$defpointsize},{Red,1.2$defpointsize}},
	    _Real,		   {{Blue,ps},{Red,$defpointsize}},		
	    {_Real,_Real},         {{Blue,ps[[1]]},{Red,ps[[2]]}},		
	    {_?ColorQ,_Real},      {ps,{Red, 1.2 ps[[2]]}},
	    {_?ColorQ,_?ColorQ},   {{ps[[1]],$defpointsize},{ps[[2]],1.2$defpointsize}},	
	    _,                     ps
	];
	ps = MapAt[ PointSize, ps, {{1,2},{2,2}} ];		
	
	pnts = 
	Switch[ full,
		All,	{}, 
		_List,	full,
		_,	Select[CartesianProduct[n,m],full[#[[1]],#[[2]]]& ]
	];

     Graphics[ Join[ txtl, txtr, txtm,  
     		ps[[1]], Point /@ Complement[CartesianProduct[n,m],pnts], 
     		ps[[2]], Point /@ pnts],
     		MakePlotRange[n,m], 
     		SelectOptions[Graphics,opts] ]
];


Attributes[HClassSize]={Listable};

HClassSize[dc_DC] := Last[DClassDimensions[dc]];

HClassT[ a_T, S_SG ] :=
    Union[ Select[ Union[ a**ToList[S] ], (ImageT[#]===ImageT[a])& ] ];
         

HTrivialQSG[S_SG] := Union[HClassSize[DClassDecomposition[S]]]==={1};

HueRasterColors[(p_Integer)?Positive, off_:0] := 
  With[{RR = Range[0,p-1]}, Thread[RR -> (Hue[N[#1/p]+off] &) /@ RR]];
   

IdealT[x_T,S_SG] := 
With[ {S1 = ToList@MakeMonoidSG[S]}, 
		Union@AllTimes[S1,Union[x**S1]]
];


IdemQT[a_]   := a**a === a;

IdemSG[S_SG] := Select[ ToList[S], IdemQT ];
$identitystring = "1";
ImageT[ a_T ]   := ToList@Union[a];

Options[Index]={};


IndToWitnesses[ind_List] := 
Block[ {cnt=0}, If[#>cnt,cnt++;1,0]& /@ ind];


InGroupQT[ a_T ]  := SelectorQ[ ImageT[a], KernelT[a] ];

InGroupSG[ S_SG ] := Select[ ToList[S], InGroupQT ];



(*  Null-Elements  *)



InverseT[x_T] := 
Module[ {ord},
     If[ RankT[x]==Length[x],
      Return[T@@(Last /@ 
           Sort[Reverse /@ Pairs[Range@Length[x],ToList[x]]])] ];
     ord = OrderT[CollapseT[x]];
     If[ ord==1, x, x^(ord-1) ]
];



IrreducibleQ[ Eps|"Eps"|Global`\[Epsilon], __ ] = True;
IrreducibleQ[ w_?WordQ, rs_List ] :=
With[ { ww = ToString[w],
        rss = Concatenate["*", First/@(rs /. (x_?WordQ -> y_?WordQ) -> {x,y}),"*"]},
        Catch[ 
        	If[ StringMatchQ[ww,#], Throw[False] ]& /@ rss;
        	Throw[True]
        ]
];
IrreducibleQ[ W_List, rs_List ] :=
With[ { rss = Concatenate["*", First/@(rs /. (x_?WordQ -> y_?WordQ) -> {x,y}) ,"*"]},
       Function[ww, Catch[ 
        	If[ StringMatchQ[ww,#], Throw[False] ]& /@ rss;
        	Throw[True] ] ] /@ ToString /@ W
       
];


JTrivialQSG[S_SG] := Union[DClassSize[DClassDecomposition[S]]]==={1};

shiftT[T[x__]] := T@@({x}+Table[1,{Length[{x}]}]);



JTrivialSG[n_Integer] := JTrivialSG[n,1];
JTrivialSG[n_Integer,a_Integer] := jtrivialsg[n,a];

jtrivialsg[0,_] = {};
jtrivialsg[n_Integer,0] = jtrivialsg[n,1]; 
jtrivialsg[n_Integer,n_Integer] := SG[ConsT[n,n]];
jtrivialsg[n_Integer,a_Integer] := jtrivialsg[n,a] =
Sort[ SG@@Join[ 
     ToList[jtrivialsg[n,a+1]],
     Insert[#,a,1]& /@ (shiftT /@ ToList[jtrivialsg[n-1,a-1]]) 
]];
shiftT[T[x__]] := T@@({x}+Table[1,{Length[{x}]}]);


Options[Kary]={};

KernelImageToT[ker_List,im_List] := 
     T@@(Last /@ Sort@Flatten[Thread /@ Pairs[ker,im],1]);

(*  one-generated subsemigroups  *)

(* order of a permutation *)

KernelT[ a_T ]  := Flatten[Position[a,#]]& /@ ImageT[a];

KPermutationsR[ 1, r_Integer ] := 
        If[ NonNegative[r], Return[ Table[1,{r}] ]    ];

KPermutationsR[ ll_Integer:2, r_Integer ] := 
Module[ {next0,next,perm,cumperm},
        perm =  {{}};
        cumperm = {};
        next0[x_] := Sequence @@ (Append[x,#]& /@ Range[ll]);
        next[L_List] := next0 /@ L;
        If[ NonNegative[r],    
            Nest[ next, perm, r ],
            Scan[ (cumperm=Join[ cumperm, perm=next[perm] ])&, Range[-r] ];
            cumperm
        ]
];

KPermutationsR[ L_List, r_Integer ] := 
    If[ NonNegative[r],    
        L[[#]]& /@ KPermutationsR[Length[L],r],
        Map[ L[[#]]&, KPermutationsR[Length[L],r], {2} ]            
];




LabelEdgeList[ G_Graph, lab_List ] := 
    ReplaceParts[ G, 2, 3, Thread[ {First/@Edges[G], lab, Last/@Edges[G]}], 4 ];


Options[LabelGrid]={};

Options[LabelPoints]={};

LeftIdealT[x_T,S_SG]  := Union[ToList[MakeMonoidSG[S]]**x];

LeftNullQT[ a_T, S_SG ] :=  a**a===a && And @@ ((a**#===a)& /@ S);

LeftNullSG[ S_SG ] := Select[ ToList[S], LeftNullQT[#,S]& ];
LeftOneQT[ a_, S_SG ] := a**a===a && ((a**#)& /@ S)===S;

LeftOneSG[ S_SG ] := Select[ ToList[S], LeftOneQT[#,S]& ];

Options[LineStyle]={};

LocallyCommQSG[ S_SG ] := 
Module[ {A,SL,eSe,idem},
      idem = IdemSG[S];
      SL = ToList[S];
      And@@( Function[ e, 
                 eSe = Union[e**SL**e];
                 A = Partition[ AllTimes[eSe,eSe], Length[eSe] ];
                 A===Transpose[A] ] /@ idem )
];



LocallyIdemQSG[ S_SG ] := 
With[ {idem = IdemSG[S],SL = ToList[S]},
      And@@( SubsetQ[ Union[#**SL**#], idem ]& /@ idem )
];


Options[LongestPath]={Full->False};


LongestPath[ G_Graph, opts___?OptionQ ] :=
Module[ {expl,explore,n,deg,indeg,Q,adj,dd,x},

     expl[x_] := explore[x,#]& /@ adj[[x]];
     explore[x_,u_] := 
      ( If[ dd[u]<dd[x]+1, dd[u]=dd[x]+1 ];  (* update depth of vertex u *)
        indeg[u] = indeg[u]-1;
        If[ indeg[u]==0, AppendTo[Q,u]] );
           
     n   = NumVertices[G];
     deg = First /@ DegreeGraph[G,Full->True];
     AssignFunction[indeg,Range[n],deg];
     Q   = Select[ Range[n], indeg[#]==0& ];

     dd[_]= 0;
     adj = Edges@ToAdjList[G];
     While[ Q =!= {},
            x = First[Q];
            Q = Rest[Q];
            expl[x];
     ];
     If[ Full /. {opts} /. Options[LongestPath], 
         dd /@ Range[n], 
         Max[dd /@ Range[n]] ]
];


LShiftT[n_Integer,k_Integer:1] := T @@ RotateLeft[Range[n],k];
MakeAlphabet[k_Integer?Negative]  := 
     If[ -k<11, ToString /@ Range[0,-k-1],
          Join[ ToString /@ Range[0,9], FromCharacterCode /@ Range[97,86-k] ] ];
MakeAlphabet[k_Integer?NonNegative]  := FromCharacterCode /@ Range[97,96+k];
MakeAlphabet[K_List] := ToString /@ K; 

MakeFullAlphabet[k_Integer] := { Abs[k], MakeAlphabet[k] }; 
MakeFullAlphabet[K_List]   := {Length[K],ToString /@ K};
MakeIndex[ LL_List, R_ ] := 
Block[ {h,hh,findindex,top},
        top = 1;
        h[_] := 0;
        h[First[LL]] = 1;
        hh[1] = First[LL];
        
        findindex[x_] := 
        (    Scan[ If[ R[x,hh[#]], h[x]=#;Return[] ]&, Range[top] ];
             If[ h[x]==0, h[x]=++top; hh[top]=x ]; h[x]  );    
        
        { findindex /@ LL, top }
];

MakeIndex[ LL_List ] := 
Block[ {hh,top},
        top = 1;
        hh[_] = 0;
        hh[First[LL]] = 1;
        
        { If[ hh[#]==0, hh[#]=++top, hh[#] ]& /@ LL, top }
];


MakeMonoidSG[ S_SG, gen___ ] := If[ MonoidQSG[S,gen], S, Prepend[S,OneT@First[S]]]; 

MakePlotRange[ x2_, y2_ ] := MakePlotRange[ 1, x2, 1, y2 ]; 
MakePlotRange[ x1_, x2_, y1_, y2_ ] := 
	PlotRange->{{x1-$plotrangeoffset,x2+$plotrangeoffset}, 
				{y1-$plotrangeoffset,y2+$plotrangeoffset}};


Options[Matrix]={};

Merge12T[n_Integer] := T @@ Join[ {1,1}, Range[3,n] ];


MinusEins = Function[xx,xx[[-1]]];
MinusZwei = Function[xx,xx[[-2]]];

MonoidQSG[ S_SG ] := OneSG[S]=!={};

MonoidQSG[ S_SG, gen_List ] := 
Module[ {id,unit,n,i},
     If[ MemberQ[S,OneT@First[S]], Return[True] ];
     id = IdemSG[S];
     i  = 1;
     n  = Length[id];
     unit = False;
     While[ !unit && i <= n,
      unit = OneQT[ id[[i++]], gen ]
     ];
     unit
];


Options[MultiCol]={};

NilpotentQSG[S_SG] := Sort[IdemSG[S]]===Sort[NullSG[S]];


NonDecreasing[n_Integer, 0 ] := {{}};
NonDecreasing[n_Integer, k_Integer?Positive] :=
Module[ {ind, iter}, 
	ind = Table[Unique[], {k}];
	iter = Thread[{ind, Prepend[Drop[ind, -1], 1], Table[n, {k}]}];
	Flatten[Table[Evaluate[ind], Evaluate[Sequence @@ iter]], k - 1]
];


NonTransientGraph[G_Graph] := 
Module[ {dag,comps,ntcomps,ntr},
	dag = ToDAG[G];
	comps = VertexSet[dag];
	ntcomps = Select[ comps, (Length[#]>1 || EdgeQ[G,First[#],First[#]])& ];
	ntr = PositionList[comps,ntcomps];
	ntr = Intersection[
		WeaklyConnectedComponents[dag,ntr], 
		WeaklyConnectedComponents[ReverseGraph[dag],ntr]];
	SubGraph[dag,ntr,Normalize->2]
]; 

Options[NonTrivial]={};

Options[NoRest]={};

NormalizeGraph[ G_Graph ] := ReplacePart[ G, {}, -1 ];


Options[Normalize]={};

Options[NRows]={};

NullQT[ a_T, S_SG ] := LeftNullQT[a,S] && RightNullQT[a,S];
(* NullSG[ S_SG ] := Intersection[ LeftNullSG[S], RightNullSG[S] ]; *)

NullSG[SS_SG] :=
Module[{idem,Lnul},
      idem = IdemSG[SS];
      Lnul = Select[ idem, LeftNullQT[#,SS]& ];
      Select[ Lnul, RightNullQT[#,SS]& ]       
];


$nullstring = "0";

NumEdges[ G_Graph ]  := Zwei[G];
NumVertices[ G_Graph ]      := First[G];

OneQT[ a_, S_SG ] := LeftOneQT[a,S] && RightOneQT[a,S];
OneQT[ a_, gen_List ] := (a**#)& /@ gen===gen && (#**a)& /@ gen===gen;
     

OneSG[SS_SG] :=
Module[{n,idem,Lone},
      n = Length@First[SS];
      If[ MemberQ[SS,OneT[n]], Return[{OneT[n]}] ];
      idem = IdemSG[SS];
      Lone = Select[ idem, LeftOneQT[#,SS]& ];
      Select[ Lone, RightOneQT[#,SS]& ]        
];

OneSG[SS_SG,gen_List] :=
Module[{n,idem,Lone},
      n = Length@First[SS];
      If[ MemberQ[SS,OneT[n]], Return[{OneT[n]}] ];
      idem = IdemSG[SS];
      Lone = Select[ idem, (#**gen===gen)& ];
      Select[ Lone, (gen**#===gen)& ]
];



OneT[k_Integer] := T@@Range[k];
OneT[a_T]       := OneT[Length[a]];
ConstantT[i_Integer,n_Integer] := T@@Table[i,{n}];

Options[Opts]={};

OrderT[ x_T ] := 
    If[ RankT[x]!=Length[x], 
	0,
	LCM@@( Length /@ CycleDecompositionT[x,Full->True] ) ];
Options[OutPairs]={};


PairsToRules[ rw_ ] :=
Module[ {x,y}, rw  /. {x_?WordQ,y_?WordQ} -> (x->y) ];


Pairs[LL__List] := Thread[{LL}];

PartitionCumRest[ LL_List, p_Integer?Positive ] := Partition[ LL, p, p, 1, {} ];


Partitions[n_Integer?NonNegative] := Partitions[n,n];
Partitions[n_Integer?Negative,_] := {};
Partitions[0,m_Integer?NonNegative] := {{}};
Partitions[n_Integer,1] := {Table[1,{n}]};
Partitions[_,0] := {};
Partitions[n_Integer,m_Integer?NonNegative] :=
  Join[ Prepend[#,m]& /@ Partitions[n-m,m], Partitions[n,m-1] ];


Options[PathGraph]={Full->False};

PathGraph[n_,opts___?OptionQ] := 
Module[ {ed}, 
	ed = Partition[Range[n],2,1];
	If[ Full /. {opts} /. Options[PathGraph],  AppendTo[ed,{n,n}] ];
	Graph[ n, Length[ed], 1, ed ]
];


Options[Periodic]={};

PermuteGraph[ G_Graph, perm_List ] := 
Module[{ed,n,h},
        n = NumVertices[G];
        If[ Length[perm]=!=n, Return[G]];
        AssignFunction[h,Pairs[Range[n],perm]];
        ed = Switch[ TypeGraph[G],
                     1, Sort[Map[ h, Edges[G], {2} ]],
                     2, Sort[ {h[#[[1]]],#[[2]],h[#[[3]]]}& /@ Edges[G] ],
                     3, Thread[Thread[Edges[G][[perm]]][[perm]]],
                     4, Sort /@ Map[ h, Edges[G][[perm]], {2} ]
            ];
        res = ReplacePart[ G, ed, 4 ];
        If[ MinusEins[G]==={},
            res, 
            ReplacePart[ res, VertexSet[G][[perm]], -1 ]
        ]
];
        


PlotFunction[ ff_, A_List, num_Integer:8, opts___?OptionQ ] := 
With[ {R = Pairs[Range[Length[A]],( ff /@ A ) /. RenumberRules[A]], n = Length[A]}, 
		PlotTDGraph[ ToTDGraph[ Table[ R, {num} ], n ], n, opts ] ];

PlotFunction[ ff_, n_Integer, num_Integer:8, opts___?OptionQ ] := 
With[ {R = Pairs[Range[n], ff /@ Range[n]]}, 
		PlotTDGraph[ ToTDGraph[ Table[ R, {num} ], n ], n, opts ] ];


Options[PlotMatrix]={Frame->True, GridLines->False, MultiCol->False, NRows->30, RView->False, NoRest->False, RasterStyle:>$rastercolors};

PlotMatrix[mm_?MatrixQ,opts___?OptionQ] := 
If[  MultiCol /. {opts} /. Options[PlotMatrix], 
     plotmatrixblocks[ mm, opts ], 
     plotmatrix[ mm, opts ]
];

plotmatrix[mm_?MatrixQ,opts___?OptionQ] := 
Module[ {ps,gr,asp,grdl,frm,mmm},
	{ps,grdl,frm,rv} = {RasterStyle,GridLines,Frame,RView} /. {opts} /. Options[PlotMatrix];
	If[ ps === Automatic, ps = HueRasterColors[Max[Flatten[mm]]+1] ];

        mmm = If[ rv, Thread[mm], mm ];

	asp  = Length[mmm]/Length@First[mmm];

	gr   = 
	If[ frm, 
	    Graphics[RasterArray@Reverse[mmm /. ps],AspectRatio->asp,Frame->True,FrameTicks->None], 
	    Graphics[RasterArray@Reverse[mmm /. ps],AspectRatio->asp]
	];

	Switch[ grdl,
		False, Show[ gr, SelectOptions[Graphics, opts, {GridLines} ]],
		True,  Show[ {gr,GridLine[Length[mmm]+1,Length@First[mmm]+1, GridOffset->{1,1} ]}, 
			     SelectOptions[Graphics, opts, {GridLines} ]],
		_,     Show[ {gr, GridLine[Length[mmm]+1,Length@First[mmm]+1, 
				  GridOffset->{1,1}, PlotStyle->grdl ]}, 
			     SelectOptions[Graphics, opts, {GridLines} ]]
	]
];

plotmatrix[L_?VectorQ,opts___?OptionQ] := plotmatrix[{L} , opts]; 

plotmatrixblocks[L_?MatrixQ, opts___?OptionQ] :=
Module[ {part, gr, nr, rv},
        nr = NRows /. {opts} /. Options[PlotMatrix];
        rv = RView /. {opts} /. Options[PlotMatrix];
 
        If[ NoRest /. {opts} /. Options[PlotMatrix],
            part = Partition[L, nr],
            part = Partition[L, nr, nr, 1, {} ]
        ];
 
        If[ rv, part = Thread /@ part ];
        gr = plotmatrix[#, DisplayFunction->Identity, SelectOptions[PlotMatrix, opts]]& /@ part;
        ShowArray[ gr, If[ rv, 1, Length[part] ] ]
];


$plotrangeoffset  = 0.8;

PlotRelation[ {RR___List}, A_List, opts___?OptionQ ] := 
With[ {n = Length[A]}, 
	PlotTDGraph[ ToTDGraph[ {RR}, n ], n, opts ] ];
	
PlotRelation[ {RR___List}, n_Integer, opts___?OptionQ ] := 
	PlotTDGraph[ ToTDGraph[ {RR}, n ], n, opts ];


(*  R: A x A -->  Bool   representing relation on A *) 

PlotRelation[ R_, A_List, num_Integer:1, opts___?OptionQ] := 
With[ {RL = Select[ CartesianProduct[A,A], R[ #[[1]],#[[2]] ]& ] /. RenumberRules[A]},
		PlotRelation[ Table[RL,{num}], A, opts ]
]; 

PlotRelation[ R_, n_Integer, num_Integer:1, opts___?OptionQ ] := 
	PlotRelation[ R, Range[n], num, opts];

(*  ff : A --> A  function  *)


Options[PlotTDGraph]={DoTrace->All, Full->False, PlotStyle:>{{Blue,$defpointsize},{Red,1.2$defpointsize}}, LineStyle:>{{GrayLevel[.5],$defthinline},{Black,$deffatline}}};

PlotTDGraph[ gr_Graph, n_Integer, opts___?OptionQ ] := 
Module[ {m,V,ed,RtoV,ls,ps,A,B,res,acc,VV,edd},

	m  = NumVertices[gr]/n;
	V  = rktocp[n] /@ Range[n m];
	ed = Edges[gr];

	ps = PlotStyle /. {opts} /. Options[PlotTDGraph];
	ls = LineStyle /. {opts} /. Options[PlotTDGraph];
	
	ls =
	Switch[ ls, 
		_?ColorQ,              {{ls,$defthinline},{Black,$deffatline}},
		{_?ColorQ},            {{ls[[1]],$defthinline},{Black,$deffatline}},
		{_Real,_Real},         {{GrayLevel[.5],ls[[1]]},{Black,ls[[2]]}},		
		{_?ColorQ,_Real},      {ls,{Black, $deffatline}},
		{_?ColorQ,_?ColorQ},   {{ls[[1]],$defthinline},{ls[[2]],$deffatline}},	
		_,                     ls
	];
	ls = MapAt[ Thickness, ls, {{1,2},{2,2}} ];		

	{A,B} = 
	Switch[ (sel = DoTrace /. {opts} /. Options[PlotTDGraph]),
		None|{},            {{},{}},
		All,                {Range[n],Range[n]},
		{__Integer},        {sel,Range[n]},
		{All,{__Integer}},  {Range[n],sel[[2]]},
		_,                  sel
	];
	
	B   = B + n(m-1);  (* fix positional notation *)
	acc = AccCoaccGraph[gr,A,B];
	VV  = VertexSet[acc];
	edd = Select[ ed, MemberQ[VV,#[[1]]]&&MemberQ[VV,#[[2]]]& ];
     
	(* grid points, lines for orbits, high light orbits *)
	(* GridPoints usese MakePlotRange automatically     *)
	res =  
	{ 
	    GridPoints[n,m,PlotStyle->ps,Full->(rktocoord[n] /@ VV),
						SelectOptions[GridPoints,opts] ],
	    Graphics[ Join[ ls[[2]], Line /@  Map[ rktocoord[n], edd, {2}] ],
 			 	MakePlotRange[m,n], SelectOptions[Graphics,opts]  ]
	};
 		   
 	If[ Full /. {opts} /. Options[PlotTDGraph],
 		PrependTo[ res, Graphics[ Join[ ls[[1]], 
			    Line /@  Map[ rktocoord[n], ed, {2}] ],
			    MakePlotRange[m,n] ] ] ];

 	Show[ res, SelectOptions[Graphics,opts] ]
];


Options[PlotT]={DoShow->False};


PlotT[ t_T, num_Integer:8, opts___?OptionQ] := 
	PlotFunction[ t[[#]]&, Length[t], num, Frame->True, FrameTicks->None, opts ]; 

PlotT[ tt__T, opts___?OptionQ ] := 
With[ {n = Length[First[{tt}]] },
	PlotRelation[ Pairs[Range[n],ToList[#]]& /@ {tt}, n, Frame->True, FrameTicks->None, opts ] ]; 

PlotT[ {tt__T}, opts___?OptionQ ] := 
	With[ {n = Length[First[{tt}]] },
	PlotRelation[ Pairs[Range[n],ToList[#]]& /@ {tt}, Range[n], opts ]];


(* Basic operations on transformations *)

SetAttributes[{ImageT,KernelT,RankT}, Listable];


PositionList[L1_List,L2_List] := Flatten[ Position[L1,#]& /@ L2 ];

(* careful, second list iterpreted as option *)
Attributes[AssignFunction]={HoldFirst};

PositionOne[xx_,yy_] := Position[xx,yy][[1,1]];


Options[postload]={};

If[ Global`$AutomataMessages, Message[dimath::ldend,$dimathReleaseNumber] ];


PowerSet[L_List] := 
	Sort[ Distribute[{{},{#}}& /@ Union[L],List,List,List,Union]];
PowerSet[n_Integer?NonNegative] := PowerSet[Range[n]];

PowerSet[n_Integer,0] := {{}}; 
PowerSet[n_Integer,k_Integer?Positive] := {}  /;  n < k;  
PowerSet[n_Integer,k_Integer?Positive] := 
Module[ {ind, iter},
	ind = Table[ Unique[], {k}];
	iter = Thread[ { ind, Prepend[Drop[ind, -1], 0] + 1, Range[ n-k+1, n ] } ];
	       Flatten[  Table[  Evaluate[ind], Evaluate[Sequence@@iter] ], k-1 ]
] /;    0 < k <= n;

PowerSet[L_List,0] := {{}};
PowerSet[L_List,1] := Partition[L,1];
PowerSet[L_List,k_Integer?Positive] := {L} /; (k == Length[L]);
PowerSet[L_List,k_Integer?Positive] := {}  /; (k > Length[L]);
PowerSet[ L_List, k_Integer ] := 
	  L[[#]] & /@ PowerSet[Length[L], k]  /; 0 < k <= Length[L];


dimath::ldend = "dimath loaded, version: `1`.\n
Modified built-ins:\n
(1) NonCommutativeMultiply: is Listable.\n
(2) ToString[Eps|\"Eps\"]==>\"\"."; 


prt=Unprotect[ToString];
ToString[Eps|"Eps"|Global`\[Epsilon]] := "";
Protect[prt];


Attributes[PrintDClass]={Listable};

SetAttributes[PrintDClass,Listable];

PrintDClass[ d_DC ] := 
Module[ {s,r,H,n,m,z,h,i,j},
     {s,r,H} = ToList[d];
     z = H[[1]];
     {n,m,h} = DClassDimensions[d];
     Print["---------------------------------------------------------"];
     Print["dimensions:  ",n," by ",m," by ",h];
     Print["H: ", H ];
     Print["---------------------------------------------------------"];
     Print["  "];
     Do[
        Print[ "image: ", ImageT[z**r[[j]]] ];
        Do[
           Print["   kernel: ", KernelT[ s[[i]]**z**r[[j]] ] ];
           Print["       H-class:  ", s[[i]]**H**r[[j]] ];
        , {i,n} ];
        Print[];
     , {j,m} ];
];



Options[PrintEquations]={Cols->None, Algebraic->False};


PrintEquations[eq_List,opts___?OptionQ]:=
Module[{eqs,cols,vspace},
	If[ Algebraic/.{opts}/.Options[PrintEquations],
		vspace=2; eqs=Map[AlgebraicForm,eq,{2}],
		vspace=1; eqs=eq
	];
	eqs = Thread[Rule[First/@eqs,Last/@eqs]];
	cols = Cols /. {opts} /. Options[PrintEquations];
	If[ cols===None, 
	    eqs = Apply[ ColonForm, Pairs[padNums[Length[eqs]],eqs], {1} ] ];
	
	Switch[ cols,
		None, TableForm[ eqs, TableSpacing->{vspace,1}],
		_Integer, TableForm[ Partition[eqs,cols], TableSpacing->{1,2}]
	]
];

Format[algfrm[a_,1]] := a;
Format[algfrm[a_,i_]] := Subscripted[a[i],0,-1];
makeruns[LL_List] := Apply[ algfrm, {First[#],Length[#]}& /@ Split[LL], 1 ];


PrintWitnesses[ S_SG|S_List, wit_List ] :=
     TableForm[  Thread[{wit,ToList[S]}], 
		 TableHeadings->{Automatic,None}, TableSpacing->{1,1}, TableDepth->2 ];


Options[ProductGraph]={Full->True};

ProductGraph[ G1_Graph, G2_Graph, opts___?OptionQ ] := 
Block[ { ed, e1, e2, edges, V }, 

       e1 = Edges[G1];
       e2 = Edges[G2];

       If[ Full /. {opts} /. Options[ProductGraph], 
	   edges[{x_, y_}] := 
		 CartesianProduct[{{x, y}},
		 Join[ CartesianProduct[{x}, Last /@ Cases[e2, {y, _}]], 
		       CartesianProduct[Last /@ Cases[e1, {x, _}], {y}] ]],
       (* else *)
	   edges[{x_, y_}] := CartesianProduct[{{x, y}}, 
		 CartesianProduct[Last /@ Cases[e1, {x, _}], Last /@ Cases[e2, {y, _}]]]
       ];

       V = CartesianProduct[NumVertices[G1],NumVertices[G2]];
       ed = FlattenOne[edges /@ V];
       Graph[ Length[V], Length[ed], 1, ed/.RenumberRules[V], V ]
];


ProductLabeledGraph[ G1_Graph, G2_Graph ] := 
Block[ { ed, L1, L2, prod, edges, alph, t1, t2, V, rules }, 

    L1 = Edges[G1];
    L2 = Edges[G2];
    alph = Union[ Zwei /@ Join[L1,L2] ];
     
    prod[{x_, y_}] := { {x[[1]],y[[1]]}, x[[2]], {x[[3]],y[[3]]} };
    edges[a_] := 
    (   
        t1 = Cases[L1,{_,a,_}];
        t2 = Cases[L2,{_,a,_}];
        ed = Join[ ed, prod /@ CartesianProduct[t1,t2] ]; 
    );
    ed = {};
    Scan[ edges, alph ];
    V = CartesianProduct[VertexSet[G1],VertexSet[G2]]; 
    Graph[ Length[V], Length[ed], 2, ed/.RenumberRules[V], V ]
];


RandomPermutation[k_Integer] := 
	Last /@ Sort[Pairs[Random[Integer,{1,k}]& /@ Range[k],Range[k]]];


RandomT[n_Integer] := T@@Table[ Random[Integer,{1,n}], {n} ];


Attributes[RankT]={Listable};

RankT[ a_T ]    := Length[ ImageT[a] ];

$rastercolors = 
	{ 0 -> RGBColor[0.8, 1., 1.], 
	  1 -> RGBColor[0., 0., 1.], 
	  2 -> RGBColor[1., 0., 1.], 
	  3 -> RGBColor[1., 1., 0.], 
	  4 -> RGBColor[0.45, 1., 0.], 
	  5 -> RGBColor[1., 0., 0.], 
	  6 -> RGBColor[0., 1., 1.], 
	  7 -> RGBColor[0.53, 0.26, 0.12], 
	  8 -> RGBColor[0.75, 0.75, 0.75], 
	  9 -> RGBColor[0., 0., 0.]};

Options[RasterStyle]={};

Options[Reflexive]={};

Options[RegularOnly]={};

RegularQT[ x_T, S_SG ] := TrueQ[Scan[If[x**#**x===x, Return[True]]&,S]];
    

RegularSG[ S_SG ] := ToList[Select[S,RegularQT[#,S]&]];
RelationToMatrix[ R_List, n_Integer ] := ReplacePart[ Array[0&,{n,n}], 1, R ];
RelationToMatrix[ R_List, L_List ] := RelationToMatrix[ R, Length[L] ];
RelationToMatrix[ rel_, L_List ] := Table[ If[rel[L[[i]],L[[j]]],1,0], {i,Length[L]}, {j,Length[L]} ];
RelationToMatrix[ rel_, n_Integer ] := Table[ If[rel[i,j],1,0], {i,n}, {j,n} ];


Options[Relation]={};

Options[RemoveDuplicates]={OutPairs->False};

RemoveDuplicates[LL_List] :=
Module[ {new},
	new = {};
	Scan[ If[!MemberQ[new,#], AppendTo[new,#]]& , LL ];
	new
];

RemoveDuplicates[L1_List,L2_List,opts___?OptionQ] :=
Block[ {new,curr,next},
        
        next[{x_,y_}] := If[ x=!=curr, curr=x; AppendTo[new,{x,y}] ];

        new = {};
        curr = {L1[[1]]};
        Scan[ next, Sort[Pairs[L1,L2]] ];
        If[ OutPairs /. {opts} /. Options[RemoveDuplicates],
            new, 
            {First /@ new, Last /@ new}
        ]
];

RemoveVertex[GG_Graph,x_Integer] := 
Module[ {h,ed,newedge,n,VV},
        n  = NumVertices[GG];
        VV = Join[Range[x-1],Range[x+1,n]];
        AssignFunction[h, Pairs[VV,Range[n-1]] ];
        newedge[{u_,v_}] := {h[u],h[v]};
        newedge[{u_,a_,v_}] := {h[u],a,h[v]};
        ed = newedge /@ Select[Edges[GG],(First[#]=!=x && Last[#]=!=x)&];
        res = ReplaceParts[ GG, n-1, 1, Length[ed], 2, ed, 4 ];
        If[ MinusEins[GG]==={},
            res, 
            ReplacePart[ res, VertexSet[GG][[VV]], -1 ]
        ]
];



Options[RenumberRules]={Type->Forward, Index->1};


RenumberRules[L_List, opts___?OptionQ ] := 
With[ { ind = Index /. {opts} /. Options[RenumberRules]},
    	If[ (Type /. {opts} /. Options[RenumberRules]) === Forward, 
      		Thread[ L -> Range[ind, ind + Length[L] - 1] ],
      		Thread[ Range[ind, ind + Length[L] - 1] -> L ] ]
];

ReplaceParts[ xx_, r1_, p1_, r2_, p2_ ] := 
	ReplacePart[ ReplacePart[ xx, r1, p1 ], r2, p2 ]; 
ReplaceParts[ xx_, r1_, p1_, r2_, p2_, r3_, p3_ ] := 
	ReplacePart[ ReplacePart[ ReplacePart[ xx, r1, p1 ], r2, p2 ], r3, p3 ]; 

ReverseGraph[ G_Graph ] := 
Module[{e,GG},
      Switch[ TypeGraph[G],
      1|2, MapAt[ Reverse, G, {4,#}& /@ Range[NumEdges[G]] ],
      3,   ReplacePart[ G, Thread@Edges[G], 4 ],
      4,   GG = ToEdgeList[G];
           ToAdjList[ MapAt[ Reverse, GG, {4,#}& /@ Range[NumEdges[G]] ] ]
      ]
];



$rewriteSimpBound = 100;

RightIdealT[x_T,S_SG] := Union[x**ToList[MakeMonoidSG[S]]];


RightNullQT[ a_T, S_SG ] := a**a===a && And @@ ((#**a===a)& /@ S);

RightNullSG[ S_SG ] := Select[ ToList[S], RightNullQT[#,S]& ];
RightOneQT[ a_, S_SG ] := ((#**a)& /@ S)===S;

RightOneSG[ S_SG ] := Select[ ToList[S], RightOneQT[#,S]& ];


RootList[L_List] := 
Module[ {n,div,r},
	n = Length[L];
	If[ n==1, Return[L] ];
			
	div = Divisors[n];	
	If[ Length[div]==2,      (* n is prime *)
		Return@If[ Length[Union[L]]==1, Take[L,1], L ]
	];
	
	r = Catch[ Map[ If[ Length@Union@Partition[L,#]==1, Throw[#] ]&, div ] ];
	(* Scan does not work !!! *) 
	Take[L,r]
];


RShiftT[n_Integer,k_Integer:1] := T @@ RotateRight[Range[n],k];

RulesToPairs[ rw_ ] :=
Module[ {x,y}, rw  /. { ( x_?WordQ -> y_?WordQ ) -> {x,y} } ];


Options[RView]={};

Options[SeedConfiguration]={Where->Center};

SeedConfiguration[ str_String:"1", n_Integer, zero_String:"0", opts___?OptionQ] := 
StringJoin@@Switch[ Where /. {opts} /. Options[SeedConfiguration], 
	Center, PadLeft[ str, n, zero, Floor[nn/2]],
	Right,  PadLeft[ str, n, zero ],
	_,      PadRight[ str, n, zero ]			
];

SeedConfiguration[s_List:{1}, n_Integer, zero_Integer:0, opts___?OptionQ] := 
Switch[ Where /. {opts} /. Options[SeedConfiguration], 
	Center, PadLeft[ s, n, zero, Floor[(n-Length[s])/2]],
	Right,  PadLeft[ s, n, zero ],
	_,      PadRight[ s, n, zero ]			
];





SelectOptions[ cmd_Symbol, opts___?OptionQ ] :=
        SelectOptions[ First /@ Options[cmd], opts ];

SelectOptions[ L_List, opts___?OptionQ ] :=
        Sequence@@Select[ Flatten[{opts}], MemberQ[L, First[#]]& ];
 
SelectOptions[cmd_Symbol,opts___?OptionQ,{excl__}] := 
		SelectOptions[ Options[cmd],opts,{excl}];
	
SelectOptions[L_List,opts___?OptionQ,{excl__}] := 
With[ {OO = Complement[First/@L,{excl}]},
	Sequence@@Select[ Flatten[{opts}],MemberQ[OO,First[#]]& ] ];


SelectorQ[ im_List, ker_List ] := 
     Union[ Length /@ (Intersection[#,im]& /@ ker) ] === {1};    


Options[SetClosure]={};

Options[ShortestPath]={Full->False};

ShortestPath[ G_Graph, s_Integer, opts___Rule ] := 
Block[ {Q,R,d,pre,bfs,getpath},
	Q = R = {s};
	d[s] = 0;
	d[_] := -1;
	pre[s] = s;
	
	adjl = Edges@ToAdjList[G];
	
	bfs[x_][y_] := 
		If[ d[y]==-1, 
		    d[y]=d[x]+1; pre[y]=x; 
		    AppendTo[Q,y]; AppendTo[R,y] ];
		    
	
	While[ Q =!= {},
		   x = First[Q];
		   Q = Rest[Q];
		   
		   Scan[ bfs[x], adjl[[x]] ];
    ];
    
    If[ Full /. {opts} /. Options[ShortestPath], 
		getpath[z_] := {z} /; pre[z]==z;
		getpath[z_] := Append[ getpath[pre[z]], z ];
		getpath /@ Sort[R],
    (*else*)
  	    {#,d[#]}& /@ Sort[R]
    ]
];


ShowArray[LL_List,k_Integer,opts___?OptionQ] := 
    Show[ 
	GraphicsArray[ Partition[LL,k,k,1,{}],SelectOptions[GraphicsArray,opts]],
        SelectOptions[Graphics,opts]
    ];

ShowArray[gr_List,opts___?OptionQ] := 
	ShowArray[gr,Ceiling@N@Sqrt@Length[gr], opts ];


Shuffle[{},L_List] = {L};
Shuffle[L_List,{}] = {L};
Shuffle[L1_List,L2_List] := 
        Union[ 
            Prepend[#,First[L1]]& /@ Shuffle[Rest[L1],L2],
            Prepend[#,First[L2]]& /@ Shuffle[L1,Rest[L2]]
        ];
        
Shuffle[n1_Integer,n2_Integer] := 
        Shuffle[ Table[1,{n1}], Table[2,{n2}] ];



Options[SimplifyEquations]={Full->True};

SimplifyEquations[ S_SG, W_List, eqn_List, opts___?OptionQ ] := 
Module[ {one,theone,onewit,null,thenull,nullwit,
    neweq,oldeq,e1,e11,len,rules,front,full,eqs},

    full = Full /. {opts} /. Options[SimplifyEquations];

    oldeq = eqn;
    rules = {};
    front = {};
    neweq = {};
    While[ oldeq != {},
	e1  = First[oldeq];
	e11 = First[e1];
	neweq = Append[ neweq, e1 ];
	oldeq = Select[Rest@oldeq, (StringPosition[First[#],e11]==={})&];
    ];

    If[ full, 
	one = OneSG[S];
	If[ one != {},
	    theone = First[one];
	    onewit = W[[PositionOne[S,theone]]];
	    front = {{onewit,$identitystring}};
	    rules = {onewit->$identitystring};
	    neweq = Select[neweq,(StringPosition[ #[[1]], onewit ]==={})& ];
	];
	null = NullSG[S];
	If[ null != {} && null != one,
	    thenull = First[null];
	    nullwit = W[[PositionOne[S,thenull]]];
	    front = Append[ front, {nullwit,$nullstring} ];       
	    rules = Append[ rules, nullwit->$nullstring];
	    neweq = Select[neweq,(StringPosition[ #[[1]], nullwit ]==={})& ];
	];
    ];  
     
    eqs = Join[ front, neweq /. rules ]; 
    If[ onewit==="Eps" && Length@Cases[eqs,{_,$identitystring}]>1,
        Rest[eqs],
        eqs
    ]
];

SimplifyEquations[ {S_SG, W_List, eqn_List}, opts___?OptionQ ] := 
    SimplifyEquations[ S, W, eqn, opts ];



Options[SimplifyRewriteSystem]={DoTrace->False};


SimplifyRewriteSystem[ eqn_List, opts___?OptionQ ] := 
With[ {trc = DoTrace /. {opts} /. Options[SimplifyRewriteSystem],
	oldidstr = $identitystring},
	$identitystring = "";
	$rewritetrace = {};
	$rewriteequs  = Map[ ToString, RulesToPairs[eqn], {2}];
	FixedPoint[ (simpright[];simpleft[trc])&, $rewriteequs, $rewriteSimpBound ];
	$identitystring = oldidstr;

	If[ trc, {$rewriteequs,$rewritetrace}, $rewriteequs ] // ToEps
];

fastReduce[ "", _ ] = "";
fastReduce[ w_String, equ_List ] :=
   With[ {rules = Apply[Rule,equ,1]}, FixedPoint[ StringReplace[#,rules]&, ToString[w] ]];


simpright[] := 
	$rewriteequs = MapAt[ fastReduce[#,$rewriteequs]&, $rewriteequs, 
                              Table[ {i,2}, {i,Length[$rewriteequs]} ] ];
		
simpleft[trc_] := 
(
    pp = findred[First/@$rewriteequs]; 
    If[ pp=!=0,
	{i,j} = pp; (* equation j reduces i *) 

	If[ $rewriteequs[[i]]==$rewriteequs[[j]], 
	    $rewriteequs = Drop[ $rewriteequs, {i} ];
	    (* If[ trc, AppendTo[ $rewritetrace, {i,j} ] ]; *)
	    If[ trc, AppendTo[ $rewritetrace, "EQUAL" ] ];
	    Return[$rewriteequs] 
	];

	If[ StringLength[$rewriteequs[[i,1]]] > StringLength[$rewriteequs[[j,1]]] ||
         	    WordOrder[ $rewriteequs[[i,2]], $rewriteequs[[j,2]] ]==-1, 
	    {ll,rr} = $rewriteequs[[i]];
	    $rewriteequs = Drop[ $rewriteequs, {i} ];
	    If[ trc, AppendTo[ $rewritetrace, {i,j} ] ]; 
	    If[ j>i, j-- ];
	    pp = First@StringPosition[ll,$rewriteequs[[j,1]]];
	    nl = StringJoin[ StringTake[ll,pp[[1]]-1], $rewriteequs[[j,2]], StringDrop[ll,pp[[2]]] ];

	    If[ ClosureSearch[{nl},rr,AllStringReplace[$rewriteequs],SetClosure->True], 
		If[ trc, AppendTo[ $rewritetrace, {} ] ];
		Return[$rewriteequs]
	    ];
			
	    neweq = Reverse@Automata`automata`WordSort[{nl,rr}];
	    $rewriteequs = Append[ $rewriteequs, neweq ];
	    If[ trc, AppendTo[ $rewritetrace, neweq ] ]; 
	];
    ]; 
    $rewriteequs
);

findred[ W_List ] := 
Block[{n,test,res,j,i},
	n = Length[W];
	test[i_] := 
	( 
	    j = 1;
	    While[ j<=n,  
		If[ i=!=j && (StringPosition[W[[i]],W[[j]]]=!={}), Return[{i,j}] ];
		j++; 
	    ];
	   0 
	);
			
	i = 1;
	While[ i<=n, 
		res = test[i];
		If[ res=!=0, Return[res] ];
		i++;
	];
	0
];


Options[SolveSG]={Full->True, Where->Right};


SolveSG[{a_T,b_T},S_SG,opts___?OptionQ] := SolveSG[a,b,S,opts];
SolveSG[a_T,b_T,S_SG,opts___?OptionQ] :=
Module[{res},
     If[ Right === (Where /. {opts} /. Options[SolveSG]),
         res = Select[ ToList[S], (a**#===b)& ],
         res = Select[ ToList[S], (#**a===b)& ]
     ];
     If[ Full /. {opts} /. Options[SolveSG],
         res,
	 If[ res==={}, $Failed, First[res] ]
     ]
];

Options[StaircasePlot]={Full->False, PlotStyle->Blue};

StaircasePlot[L_List,opts___?OptionQ] := 
Module[ {n,xcoor,op,ps,grf},
	n = Length[L];
        xcoor = Join[ {1}, Flatten[Pairs[Range[2,n],Range[2,n]]], {n+1} ];
	If[ Full /. {opts} /. Options[StaircasePlot], 
	    grf =  Polygon[ Join[Pairs[xcoor,Flatten[Pairs[L,L]]], {{n+1,L[[1]]}}] ],
	    grf =  Line[Pairs[xcoor,Flatten[Pairs[L,L]]]] 
	];
	ps = PlotStyle /. {opts} /. Options[StaircasePlot]; 
        Graphics[ { ps, grf }, 
		  PlotRange->{{0,n+2},{-2,Max[L]+1}},
		  SelectOptions[Graphics,opts]]  // Show
];


Status[] := 
Print[
	$Version,", RN: ",$ReleaseNumber,"\n",
	"dimath:     ", $dimathReleaseNumber,"\n",
	"automata:   ", Automata`automata`$automataReleaseNumber,"\n",
	"time:       ", 
	StringJoin@Flatten@Thread[
		{RotateRight[ToString/@Date[],3],{":",":","  ","/","/",""}}],"\n",
	"time used:  ",TimeUsed[],"\n",
	"memory:     ",MemoryInUse[]/2^20//N,"\n",
	"packages:   ",Select[ $Packages, StringMatchQ[#, "Automata`*"]& ],"\n",
	"links:      ",Links[]
];



Options[StronglyConnectedComponents]={NonTrivial->False, External:>$defaultexternal};

StronglyConnectedComponents[ G_Graph, opts___?OptionQ ] :=
Module[ {ntriv, GG},

    If[ NonTrivial /. {opts} /. Options[StronglyConnectedComponents], 
    	ntriv=1, ntriv=0 ];

(* bad, should convert to most convenient type *) 
    If[ TypeGraph[G]=!=1 && TypeGraph[G]=!=4, 
        GG = ToAdjList[G],
        GG = G 
    ];

    If[ External /. {opts} /. Options[StronglyConnectedComponents], 
        Automata`extaut`ExtStronglyConnectedComponents[GG,ntriv],
        procSCC[GG,ntriv]
    ] // Function[ xx, Sort[xx,(Min[#1]<Min[#2])&]]
];


procSCC[ G_Graph, ntriv_ ] :=
Block[ {n, adjc, curr, comps, comp, cnt, dfsnum, lownum, dfs, dfsact}, 

    n    = NumVertices[G];
    adjc = Edges@ToAdjList[G];
    
                        (* initialize dfsnum and lownum arrays to 0 *)
    dfsnum[_Integer]=0; 
    lownum[_Integer]=0;

                                           (* auxiliary procedures  *)
    dfs[ x_Integer ] := 
    (   
        lownum[x] = dfsnum[x];
        Scan[  dfsact[x], adjc[[x]] ];     (* explore all sons of x *)
    
        If[ lownum[x]===dfsnum[x],          (* x is a root *)
            comp = Select[ curr, (dfsnum[#] >= dfsnum[x])& ];
            AppendTo[ comps, Sort[comp] ];
            curr = Complement[ curr, comp ]
        ]        
    );

    dfsact[x_Integer][y_Integer] :=                    (* explore son y of x *)
    (   If[ dfsnum[y] === 0,
            dfsnum[y] = ++cnt;
            AppendTo[ curr, y ];
            dfs[y];
            lownum[x] = Min[lownum[x],lownum[y]]
        ];
        If[ dfsnum[y] < dfsnum[x] && MemberQ[ curr, y ],
            lownum[x] = Min[ lownum[x], dfsnum[y] ]
        ] 
    );

                                           (*  perform exploration  *)
    curr  = {};
    comps = {};
    cnt   = 0;
    Scan[ If[ dfsnum[#]===0, dfsnum[#]=++cnt; AppendTo[curr,#]; dfs[#] ]&, 
          Range[n] ];

    If[ ntriv==1,
        Select[ comps, (Length[#]>1 || MemberQ[ adjc[[First[#]]], First[#] ] )& ],  
        comps
    ]
];


Options[SubGraph]={Normalize->1};

SubGraph[ G_Graph, LL_List, opts___?OptionQ ] := 
Module[ {ed,n,h,edh},
	ed = Edges@ToEdgeList[G];
	n  = Length[LL];
	AssignFunction[h,LL,Range[n]];
	ed = Select[ed, (MemberQ[LL,First[#]] && MemberQ[LL,Last[#]])& ];
	edh = If[ TypeGraph[G]==1,
			Partition[h /@ Flatten[ed],2],
			renum[{p_,a_,q_}] := {h[p],a,h[q]};
			renum /@ ed
		];
        res = Graph[ n, Length[edh], 1, edh, {} ];
        Switch[ Normalize /. {opts} /. Options[SubGraph],
            0, res,
            1, ReplacePart[ res, LL, -1 ],
            2, ReplacePart[ res, VertexSet[G][[LL]], -1 ]
        ]
];



SubsetQ[S1_List,S2_List] := Union[S1,S2]===Union[S2];
SymbolList[ str_String, ll_Integer ] := SymbolList[ str, Range[ll] ]; 
SymbolList[ str_String, LL_List] := ToExpression /@ (StringJoin[ str, ToString[#] ]& /@ LL);

SymmetricGroupSG[n_Integer, opts___?OptionQ ] :=
     GenerateSG[ GEN[n,2,{RShiftT[n], TranspositionT[n]}], opts ];


TableSG[ SS_SG, W_List ] := 
Module[ {S,mult,towit,one,theone,onewit,null,thenull,nullwit},
     S = ToList[SS];
     AssignFunction[towit,S,W];
      
     one = OneSG[SS];
     If[ one=!={},
         theone = First[one];
         onewit = W[[PositionOne[SS,theone]]];
         towit[theone] = $identitystring;
     ];
     null = NullSG[SS];
     If[ null=!={},
      thenull = First[null];
      nullwit = W[[PositionOne[SS,thenull]]];
           towit[thenull] = $nullstring; 
     ];

     mult = Apply[ NonCommutativeMultiply, CartesianProduct[S,S], 1 ];
     mult = Partition[ towit /@ mult, Length[S] ]; 
     TableForm[ mult, TableDepth->2, TableHeadings->{towit/@S,towit/@S} ]
];


ToAdjList[ G_Graph ] := 
Module[ {adjl,n,V},
     Switch[ TypeGraph[G],
     1, n = NumVertices[G];
        adjl = Table[ {}, {n} ];
        Scan[ (AppendTo[ adjl[[First[#]]], Last[#] ])&, Edges[G] ];
        ReplaceParts[ G, 4, 3, adjl, 4 ],
     2, n = NumVertices[G];
        adjl = Table[ {}, {n} ];
        Scan[ (AppendTo[ adjl[[First[#]]], Rest[#] ])&, Edges[G] ];
        ReplaceParts[ G, 5, 3, Flatten /@ adjl, 4 ],
     3, n = NumVertices[G];
        ReplaceParts[ G, 4, 3, Flatten@Position[#,1]& /@ Edges[G], 4 ],
     4|5,  G
     ]
];


ToAdjMatrix[ G_Graph ] := 
Module[ {n,mat},
        If[ TypeGraph[G]==3, Return[G] ];

        n   = NumVertices[G];
		mat = Table[0,{n},{n}];
		Scan[ (mat[[ First[#], Last[#] ]] = 1)&, Edges[ToEdgeList[G]] ];
        ReplaceParts[ G, 3, 3, mat, 4 ]
];




ToBitVector[S_List,UU_List]   := If[MemberQ[S,#],1,0]& /@ UU;
ToBitVector[S_List,n_Integer] := If[MemberQ[S,#],1,0]& /@ Range[n];
    

Options[ToClasses]={Type->Relation};

ToClasses[ A_List, r_, opts___?OptionQ]:=
Switch[  Type  /.{opts} /.  Options[ToClasses],
	Function, 
	    Map[ Last, Split[ Sort@Pairs[r /@ A,A],First[#1]==First[#2]&],{2}],
	Relation,          
	    Map[ Last, Split[ Sort@Pairs[First@MakeIndex[A,r], A],First[#1]==First[#2]&],{2}],
	Matrix, 
	    Union[(A[[Flatten[Position[#1,1]]]]&)/@ r],
	Index,
	    Map[ Last, Split[Sort@ Pairs[ r, A],#1[[1]]==#2 [[1]]& ],{2}]
];



Options[ToDAG]={Normalize->1};

ToDAG[ G_Graph, opts___?OptionQ ] := 
Module[ {comps,n,hh,ed,edh,P,pair,VV},
	pair[{L_List,i_Integer}] := CartesianProduct[L,{i}];
        n  = NumVertices[G];
        ed = Edges@ToEdgeList[G];
	If[ TypeGraph[G]==2, ed = Drop[#,{2}]& /@ ed ];
        comps = StronglyConnectedComponents[G];
        P = Thread[ {comps,Range[Length[comps]]} ];
        AssignFunction[ hh, FlattenOne[pair /@ P]  ];
        edh = Select[Union[Map[hh,ed,{2}]],(First[#]=!=Last[#])&]; 
	Switch[ Normalize /. {opts} /. Options[ToDAG],
		0,  VV = {},
		1,  VV = comps,
		2,  VV = VertexSet[G][[#]]& /@ comps 
	];
        Graph[ Length[comps], Length[edh], 1, edh, VV ]
];



ToEdgeList[ G_Graph ] := 
Module[ {n,ed,P},
     Switch[ TypeGraph[G],
     1|2,   G,
     3,     n = NumVertices[G];
            ed = Flatten[Thread /@ Pairs[ Range[n], 
                        Flatten@Position[#,1]& /@ Edges[G] ], 1 ];
            ReplaceParts[ G, 1, 3, ed, 4 ],
     4,     n = NumVertices[G];
            P = Thread[ {Range[n], Edges[G] } ];
            ReplaceParts[ G, 1, 3, FlattenOne[ Thread/@P ], 4 ]
     ]
];
        

ToEps[xx_] := xx /. {""->"Eps"};
ToIdentityString[XX_]   := XX /. ""->$identitystring;

(*  bad, $identitystring should be an option  *)


ToList[S_] := List@@S;
Options[ToTDGraph]={Normalize->0};


(*  vertex set in TD-graph is  [n] x [m] --> space x time  *)
(*  but ordered by columns, not like CartesianProduct[n,m] *)
(*  must reverse for plotting                              *)
(*  ranking and unranking:                                 *)

cptork[n_Integer][{x_,y_}] := (y-1)n+x;
rktocp[n_Integer][z_]    := { Mod[z-1,n]+1,Quotient[z-1,n]+1};
rktocoord[n_Integer][z_] := { Quotient[z-1,n]+1,Mod[z-1,n]+1};
coordtork[n_Integer][{x_,y_}] := (x-1)n+y;

TDGiedges[n_Integer][L_List,{i_Integer}] := 
	L /. {x_Integer,y_Integer}->{(i-1)n+x,n*i+y};

TDGmakeEdges[n_Integer][ LL_List ] := 
	FlattenOne@MapIndexed[ TDGiedges[n], LL ];

ToTDGraph[ {RR___List}, n_Integer, opts___?OptionQ ] :=
Module[ {m,ed,V},
	m  = Length[{RR}] + 1;
	ed = TDGmakeEdges[n][{RR}];
	If[ 0==(Normalize /. {opts} /. Options[ToTDGraph]),
	    V = {},
	    V  = rktocp[n] /@ Range[n m]
	];
	Graph[ m n, Length[ed], 1, ed, V ]
];


TransformationSG[n_Integer, opts___?OptionQ ] := 
     GenerateSG[ GEN[n,3,{RShiftT[n], TranspositionT[n], Merge12T[n]}], opts ];


TransientPeriodicT[xx_T] := 
Module[ {kx,L},
     If[ RankT[xx]==Length[xx], Return[{0,OrderT[xx]}]];
     kx = CollapseT[xx];
     L  = FixedPointList[ CollapseT, xx ];
     { Max[Length[L]-2,0], OrderT[Last[L]] }
];


Options[TransitiveClosure]={Reflexive->False};

TransitiveClosure[R_?MatrixQ,opts___?OptionQ] := 
If[ Reflexive /. {opts} /. Options[TransitiveClosure],
    FixedPoint[ Sign[#1.#1]&,    Sign[R+IdentityMatrix[Length[R]]]],
    FixedPoint[ Sign[#1+#1.#1]&, Sign[R] ]
];


TranspositionT[n_Integer,i_Integer:1] :=  
	(OneT[n]/.{i->i+1,i+1->i})  /;  1 <= i < n;
	
TranspositionT[n_Integer,i_Integer, j_Integer ] :=  
	(OneT[n]/.{i->j,j->i})  /;  1 <= i <= n && 1 <= j <= n;
	

Options[T]={};

prot = Unprotect[NonCommutativeMultiply];
SetAttributes[NonCommutativeMultiply,Listable];
Protect[Evaluate[prot]];

NonCommutativeMultiply[T[x__]] ^:= T[x];
NonCommutativeMultiply[T[x__],T[y__]]  ^:= T[y][[{x}]];
NonCommutativeMultiply[T[x__],T[y__],z__T]  ^:= 
      NonCommutativeMultiply[T[y][[{x}]],z];

T[x__]^k_ ^:= FastExpoT[ T[x], k ];

FastExpoT[ x_T, 0 ] := OneT[x];
FastExpoT[ x_T, 1 ] := x;
FastExpoT[ x_T, n_Integer ] :=
Block[ {fastexpo},
     fastexpo[1] = x;
     fastexpo[m_Integer?Positive] := 
     	fastexpo[m] = fastexpo[Floor[m/2]] ** fastexpo[Ceiling[m/2]];
     fastexpo[n]
]; 


TypeGraph[ G_Graph ] := Drei[G];

Options[Type]={};

UnitElement[a_T] := T@@Range@Length[a];
UnitElement[mat_?MatrixQ] := 
     Switch[ Head[First@First[mat]],
         TS, TropicalIdentityMatrix[Length[mat]],
         _,  IdentityMatrix[Length[mat]]
      ];

(* uses strings internally *)


VertexSet[ G_Graph ] := If[ MinusEins[G]==={}, Range[First[G]], MinusEins[G] ];


Vier = Function[xx,xx[[4]]];
Options[Warshall]={Full->False, Reflexive->False};


Warshall[ e_?MatrixQ, opts___?OptionQ ] := 
Module[ {i,j,n,ee},
    ee = Sign[e];
    n  = Length[e];
    If[ Reflexive /. {opts} /. Options[Warshall],
        ee = ReplacePart[ ee, 1, Pairs[Range[n],Range[n]] ] ];
    If[ Full /. {opts} /. Options[Warshall],
      ee = ReplacePart[ ee, 0, Pairs[Range[n],Range[n]] ];
      Do[ If[ ee[[i,k]] > 0,
                ee[[i]] = MapThread[
		          Function[{a,b},If[ a>0 && b>0, 2, a ]], {ee[[i]],ee[[k]]} ]] , 
      {k,n}, {i,n} ];
      { Sign[ee], ee /. {2->0} }
      , (* else *)
      Do[ If[ ee[[i,k]] > 0,
                ee[[i]] = MapThread[ Max, {ee[[i]],ee[[k]]} ]] , 
      {k,n}, {i,n} ];
      ee
    ]
];
           

WeaklyConnectedComponents[ G_Graph, x_Integer ] := WeaklyConnectedComponents[G,{x}];

WeaklyConnectedComponents[ G_Graph, A_List ] :=
Block[ { n, L, cnt, h },

    n = NumVertices[G];
    L = Edges@ToAdjList[G];
    h[_]=0;
    
                                     (* explore all sons of x *)
    dfs[ x_Integer ] := Scan[  dfsact, L[[x]] ]; 

                                     (* explore son y of x *)
    dfsact[ y_ ] := If[ h[y] == 0, h[y] = ++cnt; dfs[ y ] ];
    
                                     (*  perform exploration  *)
    cnt = 0;
    Scan[ If[ h[#]==0, h[#] = ++cnt; dfs[#];]&, A ];
    Select[ Range[n], (h[#]>0)& ]
];



WordQ[_Symbol|_String] = True;
WordQ[_] = False;


Options[WordReduce]={DoTrace->False, BoundWR->500};

WordReduce[ Eps|"Eps"|Global`\[Epsilon], ___ ] = $identitystring;
WordReduce[ w_?WordQ, equ_List, opts___?OptionQ ] :=
	WordReduce[ {w}, equ, opts ];

WordReduce[ LL_List, equ_List, opts___?OptionQ ] :=
Block[ {trace,eq,nulleq,nullpat,rules,red,bnd},
    trace = DoTrace /. {opts} /. Options[WordReduce];
    bnd   = BoundWR /. {opts} /. Options[WordReduce];
    (* trace only useful for single words *)
    If[ trace, Return[ traceWordReduce[LL[[1]],equ] ] ];
    eq      = Map[ ToString, equ, {2} ];
    nulleq  = Cases[eq,{_,$nullstring}];
    nullpat = First /@ nulleq;
    rules   = Apply[ Rule, FromIdentityString[Complement[eq,nulleq]], 1 ];
    If[ nulleq==={},
        red[s_] := StringReplace[s, rules ],
        red[s_] :=
           If[ StringPosition[s,nullpat]==={},
               StringReplace[s, rules ],
               $nullstring
           ]
    ];
    
    If[ Length[LL]==1,
	    ToIdentityString[ FixedPoint[ red, ToString[First[LL]], bnd ] ],
	    ToIdentityString[ FixedPoint[ red, ToString[#], bnd ]& /@ LL ]
	]
];


traceWordReduce[ w_?WordQ, eqq_List ] := 
Block[ {curr,trace,eq,pats,gethandle,go,handle,pos},
    curr = ToString[w];
    trace = {curr};
    eq   = Map[ ToString, eqq, {2} ];
    pats = Flatten /@ Pairs[ Range@Length[eq], eq /. Rule -> List ];
    gethandle[ww_String,{i_Integer,u_String,v_String}] := 
        Join[{i,u,v},#]& /@ StringPosition[ww,u];
    go = True;
            (* Sort: first applicable rule chosen *)
    While[ go,   
           handle = Sort@FlattenOne@Cases[gethandle[curr,#]& /@ pats,{__}];
           If[ handle === {},
              go   = False,
              pos  = First[handle];
              AppendTo[trace,Drop[pos,{2,3}]];
              curr = StringJoin[ StringTake[curr,pos[[4]]-1], pos[[3]], 
                                 StringDrop[curr,pos[[5]]] ];
              AppendTo[trace,curr]
           ];
    ];
    TableForm[ Partition[Append[trace,{}], 2 ],
        TableDepth->2, TableSpacing->{1,5}, 
        TableHeadings->{Automatic,None} ]
];


Zwei = Function[xx,xx[[2]]];   


End[];



AccCoaccGraph::args = "Wrong argument(s), try AccCoaccGraph[G,S,T]";
AccCoaccGraph[__] := $Failed /; Message[AccCoaccGraph::args];
AccessibleGraph::args = "Wrong argument(s), try AccessibleGraph[G,A]";
AccessibleGraph[__] := $Failed /; Message[AccessibleGraph::args];
AlgebraicForm::args = "Wrong argument(s), try AlgebraicForm[w]";
AlgebraicForm[__] := $Failed /; Message[AlgebraicForm::args];
AllTimes::args = "Wrong argument(s), try AllTimes[L1,L2]";
AllTimes[__] := $Failed /; Message[AllTimes::args];
AlternatingGroupSG::args = "Wrong argument(s), try AlternatingGroupSG[n]";
AlternatingGroupSG[__] := $Failed /; Message[AlternatingGroupSG::args];
AnalyzeOrbit::args = "Wrong argument(s), try AnalyzeOrbit[f,x]";
AnalyzeOrbit[__] := $Failed /; Message[AnalyzeOrbit::args];
AperiodicQSG::args = "Wrong argument(s), try AperiodicQSG[S]";
AperiodicQSG[__] := $Failed /; Message[AperiodicQSG::args];
AperiodicQT::args = "Wrong argument(s), try AperiodicQT[x]";
AperiodicQT[__] := $Failed /; Message[AperiodicQT::args];
AperiodicSG::args = "Wrong argument(s), try AperiodicSG[S]";
AperiodicSG[__] := $Failed /; Message[AperiodicSG::args];
AssignFunction::args = "Wrong argument(s), try AssignFunction[h,P]";
AssignFunction[__] := $Failed /; Message[AssignFunction::args];
BlocksToDClass::args = "Wrong argument(s), try BlocksToDClass[db,S]";
BlocksToDClass[__] := $Failed /; Message[BlocksToDClass::args];
BooleanComplement::args = "Wrong argument(s), try BooleanComplement[M1,M2]";
BooleanComplement[__] := $Failed /; Message[BooleanComplement::args];
BooleanComposition::args = "Wrong argument(s), try BooleanComposition[M1,M2]";
BooleanComposition[__] := $Failed /; Message[BooleanComposition::args];
BooleanConverse::args = "Wrong argument(s), try BooleanConverse[M]";
BooleanConverse[__] := $Failed /; Message[BooleanConverse::args];
BooleanIntersection::args = "Wrong argument(s), try BooleanIntersection[M1,M2]";
BooleanIntersection[__] := $Failed /; Message[BooleanIntersection::args];
BooleanPower::args = "Wrong argument(s), try BooleanPower[M,n]";
BooleanPower[__] := $Failed /; Message[BooleanPower::args];
BooleanUnion::args = "Wrong argument(s), try BooleanUnion[M1,M2]";
BooleanUnion[__] := $Failed /; Message[BooleanUnion::args];
CartesianProduct::args = "Wrong argument(s), try CartesianProduct[S1,...,Sk]";
CartesianProduct[__] := $Failed /; Message[CartesianProduct::args];
CirculantGraph::args = "Wrong argument(s), try CirculantGraph[n,{d1,...,dr}]";
CirculantGraph[__] := $Failed /; Message[CirculantGraph::args];
ClosureSearch::args = "Wrong argument(s), try ClosureSearch[L,targ,ff,opts]";
ClosureSearch[__] := $Failed /; Message[ClosureSearch::args];
Closure::args = "Wrong argument(s), try Closure[L,ff,opts]";
Closure[__] := $Failed /; Message[Closure::args];
CollapseT::args = "Wrong argument(s), try CollapseT[x]";
CollapseT[__] := $Failed /; Message[CollapseT::args];
ColorQ::args = "Wrong argument(s), try ColorQ[x]";
ColorQ[__] := $Failed /; Message[ColorQ::args];
CompCycles::args = "Wrong argument(s), try CompCycles[cyc1,cyc2]";
CompCycles[__] := $Failed /; Message[CompCycles::args];
Concatenate::args = "Wrong argument(s), try Concatenate[w1,..,wn]";
Concatenate[__] := $Failed /; Message[Concatenate::args];
ConsT::args = "Wrong argument(s), try ConsT[k,n]";
ConsT[__] := $Failed /; Message[ConsT::args];
Curry::args = "Wrong argument(s), try Curry[f]";
Curry[__] := $Failed /; Message[Curry::args];
CycleDecompositionT::args = "Wrong argument(s), try CycleDecompositionT[x]";
CycleDecompositionT[__] := $Failed /; Message[CycleDecompositionT::args];
CycleToT::args = "Wrong argument(s), try CycleToT[cycles,n]";
CycleToT[__] := $Failed /; Message[CycleToT::args];
CyclicQGraph::args = "Wrong argument(s), try CyclicQGraph[G]";
CyclicQGraph[__] := $Failed /; Message[CyclicQGraph::args];
DClassDecomposition::args = "Wrong argument(s), try DClassDecomposition[S]";
DClassDecomposition[__] := $Failed /; Message[DClassDecomposition::args];
DClassDimensions::args = "Wrong argument(s), try DClassDimensions[dc]";
DClassDimensions[__] := $Failed /; Message[DClassDimensions::args];
DClassSize::args = "Wrong argument(s), try DClassSize[dc]";
DClassSize[__] := $Failed /; Message[DClassSize::args];
DClassToBlocks::args = "Wrong argument(s), try DClassToBlocks[dc]";
DClassToBlocks[__] := $Failed /; Message[DClassToBlocks::args];
DClassT::args = "Wrong argument(s), try DClassT[x,S]";
DClassT[__] := $Failed /; Message[DClassT::args];
DegreeGraph::args = "Wrong argument(s), try DegreeGraph[G,v]";
DegreeGraph[__] := $Failed /; Message[DegreeGraph::args];
Dependency::args = "Wrong argument(s), try Dependency[L,k]";
Dependency[__] := $Failed /; Message[Dependency::args];
DisjointQ::args = "Wrong argument(s), try DisjointQ[L1,L2]";
DisjointQ[__] := $Failed /; Message[DisjointQ::args];
DoShow::args = "Wrong argument(s), try DoShow[X]";
DoShow[__] := $Failed /; Message[DoShow::args];
EdgeQ::args = "Wrong argument(s), try EdgeQ[G,x,y]";
EdgeQ[__] := $Failed /; Message[EdgeQ::args];
Edges::args = "Wrong argument(s), try Edges[G]";
Edges[__] := $Failed /; Message[Edges::args];
EnumForm::args = "Wrong argument(s), try EnumForm[L]";
EnumForm[__] := $Failed /; Message[EnumForm::args];
EquationsToWitnesses::args = "Wrong argument(s), try EquationsToWitnesses[eq,K,opt]";
EquationsToWitnesses[__] := $Failed /; Message[EquationsToWitnesses::args];
FastPowerSet::args = "Wrong argument(s), try FastPowerSet[L]";
FastPowerSet[__] := $Failed /; Message[FastPowerSet::args];
FlattenOne::args = "Wrong argument(s), try FlattenOne[x]";
FlattenOne[__] := $Failed /; Message[FlattenOne::args];
Frequencies::args = "Wrong argument(s), try Frequencies[L]";
Frequencies[__] := $Failed /; Message[Frequencies::args];
FromBitVector::args = "Wrong argument(s), try FromBitVector[B,U]";
FromBitVector[__] := $Failed /; Message[FromBitVector::args];
FromEps::args = "Wrong argument(s), try FromEps[x]";
FromEps[__] := $Failed /; Message[FromEps::args];
FromIdentityString::args = "Wrong argument(s), try FromIdentityString[xxx]";
FromIdentityString[__] := $Failed /; Message[FromIdentityString::args];
GenerateCSM::args = "Wrong argument(s), try GenerateCSM[q0,dot,K,opts]";
GenerateCSM[__] := $Failed /; Message[GenerateCSM::args];
GenerateSG::args = "Wrong argument(s), try GenerateSG[gen]";
GenerateSG[__] := $Failed /; Message[GenerateSG::args];
GreenHQT::args = "Wrong argument(s), try GreenHQT[x,y,S]";
GreenHQT[__] := $Failed /; Message[GreenHQT::args];
GreenJQT::args = "Wrong argument(s), try GreenJQT[x,y,S]";
GreenJQT[__] := $Failed /; Message[GreenJQT::args];
GreenLQT::args = "Wrong argument(s), try GreenLQT[x,y,S]";
GreenLQT[__] := $Failed /; Message[GreenLQT::args];
GreenRQT::args = "Wrong argument(s), try GreenRQT[x,y,S]";
GreenRQT[__] := $Failed /; Message[GreenRQT::args];
GridLine::args = "Wrong argument(s), try GridLine[n,m,opts]";
GridLine[__] := $Failed /; Message[GridLine::args];
GridPoints::args = "Wrong argument(s), try GridPoints[n,m,opts]";
GridPoints[__] := $Failed /; Message[GridPoints::args];
HClassSize::args = "Wrong argument(s), try HClassSize[dc]";
HClassSize[__] := $Failed /; Message[HClassSize::args];
HClassT::args = "Wrong argument(s), try HClassT[x,S]";
HClassT[__] := $Failed /; Message[HClassT::args];
HTrivialQSG::args = "Wrong argument(s), try HTrivialQSG[S]";
HTrivialQSG[__] := $Failed /; Message[HTrivialQSG::args];
HueRasterColors::args = "Wrong argument(s), try HueRasterColors[p]";
HueRasterColors[__] := $Failed /; Message[HueRasterColors::args];
IdealT::args = "Wrong argument(s), try IdealT[x,S]";
IdealT[__] := $Failed /; Message[IdealT::args];
IdemQT::args = "Wrong argument(s), try IdemQT[x]";
IdemQT[__] := $Failed /; Message[IdemQT::args];
IdemSG::args = "Wrong argument(s), try IdemSG[S]";
IdemSG[__] := $Failed /; Message[IdemSG::args];
ImageT::args = "Wrong argument(s), try ImageT[x]";
ImageT[__] := $Failed /; Message[ImageT::args];
IndToWitnesses::args = "Wrong argument(s), try IndToWitnesses[ind]";
IndToWitnesses[__] := $Failed /; Message[IndToWitnesses::args];
InGroupQT::args = "Wrong argument(s), try InGroupQT[x]";
InGroupQT[__] := $Failed /; Message[InGroupQT::args];
InGroupSG::args = "Wrong argument(s), try InGroupSG[S]";
InGroupSG[__] := $Failed /; Message[InGroupSG::args];
InverseT::args = "Wrong argument(s), try InverseT[x]";
InverseT[__] := $Failed /; Message[InverseT::args];
IrreducibleQ::args = "Wrong argument(s), try IrreducibleQ[w,eq]";
IrreducibleQ[__] := $Failed /; Message[IrreducibleQ::args];
JTrivialQSG::args = "Wrong argument(s), try JTrivialQSG[S]";
JTrivialQSG[__] := $Failed /; Message[JTrivialQSG::args];
JTrivialSG::args = "Wrong argument(s), try JTrivialSG[n]";
JTrivialSG[__] := $Failed /; Message[JTrivialSG::args];
KernelImageToT::args = "Wrong argument(s), try KernelImageToT[ker,im]";
KernelImageToT[__] := $Failed /; Message[KernelImageToT::args];
KernelT::args = "Wrong argument(s), try KernelT[x]";
KernelT[__] := $Failed /; Message[KernelT::args];
KPermutationsR::args = "Wrong argument(s), try KPermutationsR[L,k]";
KPermutationsR[__] := $Failed /; Message[KPermutationsR::args];
LabelEdgeList::args = "Wrong argument(s), try LabelEdgeList[G,lab]";
LabelEdgeList[__] := $Failed /; Message[LabelEdgeList::args];
LeftIdealT::args = "Wrong argument(s), try LeftIdealT[x,S]";
LeftIdealT[__] := $Failed /; Message[LeftIdealT::args];
LeftNullQT::args = "Wrong argument(s), try LeftNullQT[x,S]";
LeftNullQT[__] := $Failed /; Message[LeftNullQT::args];
LeftNullSG::args = "Wrong argument(s), try LeftNullSG[S]";
LeftNullSG[__] := $Failed /; Message[LeftNullSG::args];
LeftOneQT::args = "Wrong argument(s), try LeftOneQT[x,S]";
LeftOneQT[__] := $Failed /; Message[LeftOneQT::args];
LeftOneSG::args = "Wrong argument(s), try LeftOneSG[S]";
LeftOneSG[__] := $Failed /; Message[LeftOneSG::args];
LocallyCommQSG::args = "Wrong argument(s), try LocallyCommQSG[S]";
LocallyCommQSG[__] := $Failed /; Message[LocallyCommQSG::args];
LocallyIdemQSG::args = "Wrong argument(s), try LocallyIdemQSG[S]";
LocallyIdemQSG[__] := $Failed /; Message[LocallyIdemQSG::args];
LongestPath::args = "Wrong argument(s), try LongestPath[G]";
LongestPath[__] := $Failed /; Message[LongestPath::args];
LShiftT::args = "Wrong argument(s), try LShiftT[n]";
LShiftT[__] := $Failed /; Message[LShiftT::args];
MakeAlphabet::args = "Wrong argument(s), try MakeAlphabet[K]";
MakeAlphabet[__] := $Failed /; Message[MakeAlphabet::args];
MakeFullAlphabet::args = "Wrong argument(s), try MakeFullAlphabet[K]";
MakeFullAlphabet[__] := $Failed /; Message[MakeFullAlphabet::args];
MakeIndex::args = "Wrong argument(s), try MakeIndex[L,R]";
MakeIndex[__] := $Failed /; Message[MakeIndex::args];
MakeMonoidSG::args = "Wrong argument(s), try MakeMonoidSG[S]";
MakeMonoidSG[__] := $Failed /; Message[MakeMonoidSG::args];
MakePlotRange::args = "Wrong argument(s), try MakePlotRange[x1,x2,y1,y2]";
MakePlotRange[__] := $Failed /; Message[MakePlotRange::args];
Merge12T::args = "Wrong argument(s), try Merge12T[n]";
Merge12T[__] := $Failed /; Message[Merge12T::args];
MonoidQSG::args = "Wrong argument(s), try MonoidQSG[S]";
MonoidQSG[__] := $Failed /; Message[MonoidQSG::args];
NilpotentQSG::args = "Wrong argument(s), try NilpotentQSG[S]";
NilpotentQSG[__] := $Failed /; Message[NilpotentQSG::args];
NonDecreasing::args = "Wrong argument(s), try NonDecreasing[n,k]";
NonDecreasing[__] := $Failed /; Message[NonDecreasing::args];
NonTransientGraph::args = "Wrong argument(s), try NonTransientGraph[G]";
NonTransientGraph[__] := $Failed /; Message[NonTransientGraph::args];
NormalizeGraph::args = "Wrong argument(s), try NormalizeGraph[M]";
NormalizeGraph[__] := $Failed /; Message[NormalizeGraph::args];
NullQT::args = "Wrong argument(s), try NullQT[x,S]";
NullQT[__] := $Failed /; Message[NullQT::args];
NullSG::args = "Wrong argument(s), try NullSG[S]";
NullSG[__] := $Failed /; Message[NullSG::args];
NumEdges::args = "Wrong argument(s), try NumEdges[G]";
NumEdges[__] := $Failed /; Message[NumEdges::args];
NumVertices::args = "Wrong argument(s), try NumVertices[G]";
NumVertices[__] := $Failed /; Message[NumVertices::args];
OneQT::args = "Wrong argument(s), try OneQT[x,S]";
OneQT[__] := $Failed /; Message[OneQT::args];
OneSG::args = "Wrong argument(s), try OneSG[S]";
OneSG[__] := $Failed /; Message[OneSG::args];
OneT::args = "Wrong argument(s), try OneT[x]";
OneT[__] := $Failed /; Message[OneT::args];
OrderT::args = "Wrong argument(s), try OrderT[x]";
OrderT[__] := $Failed /; Message[OrderT::args];
PairsToRules::args = "Wrong argument(s), try PairsToRules[rw]";
PairsToRules[__] := $Failed /; Message[PairsToRules::args];
Pairs::args = "Wrong argument(s), try Pairs[L1,L2]";
Pairs[__] := $Failed /; Message[Pairs::args];
PartitionCumRest::args = "Wrong argument(s), try PartitionCumRest[L,p]";
PartitionCumRest[__] := $Failed /; Message[PartitionCumRest::args];
Partitions::args = "Wrong argument(s), try Partitions[n]";
Partitions[__] := $Failed /; Message[Partitions::args];
PathGraph::args = "Wrong argument(s), try PathGraph[n]";
PathGraph[__] := $Failed /; Message[PathGraph::args];
PermuteGraph::args = "Wrong argument(s), try PermuteGraph[G,p]";
PermuteGraph[__] := $Failed /; Message[PermuteGraph::args];
PlotFunction::args = "Wrong argument(s), try PlotFunction[f,A,n,opts]";
PlotFunction[__] := $Failed /; Message[PlotFunction::args];
PlotMatrix::args = "Wrong argument(s), try PlotMatrix[M]";
PlotMatrix[__] := $Failed /; Message[PlotMatrix::args];
PlotRelation::args = "Wrong argument(s), try PlotRelation[R,A,n,opts]";
PlotRelation[__] := $Failed /; Message[PlotRelation::args];
PlotTDGraph::args = "Wrong argument(s), try PlotTDGraph[gr,n,opts]";
PlotTDGraph[__] := $Failed /; Message[PlotTDGraph::args];
PlotT::args = "Wrong argument(s), try PlotT[x,n]";
PlotT[__] := $Failed /; Message[PlotT::args];
PositionList::args = "Wrong argument(s), try PositionList[L1,L2]";
PositionList[__] := $Failed /; Message[PositionList::args];
PositionOne::args = "Wrong argument(s), try PositionOne[xx,yy]";
PositionOne[__] := $Failed /; Message[PositionOne::args];
PowerSet::args = "Wrong argument(s), try PowerSet[L,k]";
PowerSet[__] := $Failed /; Message[PowerSet::args];
PrintDClass::args = "Wrong argument(s), try PrintDClass[dc]";
PrintDClass[__] := $Failed /; Message[PrintDClass::args];
PrintEquations::args = "Wrong argument(s), try PrintEquations[eq]";
PrintEquations[__] := $Failed /; Message[PrintEquations::args];
PrintWitnesses::args = "Wrong argument(s), try PrintWitnesses[S,wit]";
PrintWitnesses[__] := $Failed /; Message[PrintWitnesses::args];
ProductGraph::args = "Wrong argument(s), try ProductGraph[G1,G2]";
ProductGraph[__] := $Failed /; Message[ProductGraph::args];
ProductLabeledGraph::args = "Wrong argument(s), try ProductLabeledGraph[G1,G2]";
ProductLabeledGraph[__] := $Failed /; Message[ProductLabeledGraph::args];
RandomPermutation::args = "Wrong argument(s), try RandomPermutation[k]";
RandomPermutation[__] := $Failed /; Message[RandomPermutation::args];
RandomT::args = "Wrong argument(s), try RandomT[n]";
RandomT[__] := $Failed /; Message[RandomT::args];
RankT::args = "Wrong argument(s), try RankT[x]";
RankT[__] := $Failed /; Message[RankT::args];
RegularQT::args = "Wrong argument(s), try RegularQT[x,S]";
RegularQT[__] := $Failed /; Message[RegularQT::args];
RegularSG::args = "Wrong argument(s), try RegularSG[S]";
RegularSG[__] := $Failed /; Message[RegularSG::args];
RelationToMatrix::args = "Wrong argument(s), try RelationToMatrix[rel,A]";
RelationToMatrix[__] := $Failed /; Message[RelationToMatrix::args];
RemoveDuplicates::args = "Wrong argument(s), try RemoveDuplicates[L]";
RemoveDuplicates[__] := $Failed /; Message[RemoveDuplicates::args];
RemoveVertex::args = "Wrong argument(s), try RemoveVertex[G,x]";
RemoveVertex[__] := $Failed /; Message[RemoveVertex::args];
RenumberRules::args = "Wrong argument(s), try RenumberRules[L,opts]";
RenumberRules[__] := $Failed /; Message[RenumberRules::args];
ReplaceParts::args = "Wrong argument(s), try ReplaceParts[x,r1,p1,r2,p2]";
ReplaceParts[__] := $Failed /; Message[ReplaceParts::args];
ReverseGraph::args = "Wrong argument(s), try ReverseGraph[G]";
ReverseGraph[__] := $Failed /; Message[ReverseGraph::args];
RightIdealT::args = "Wrong argument(s), try RightIdealT[x,T]";
RightIdealT[__] := $Failed /; Message[RightIdealT::args];
RightNullQT::args = "Wrong argument(s), try RightNullQT[x,S]";
RightNullQT[__] := $Failed /; Message[RightNullQT::args];
RightNullSG::args = "Wrong argument(s), try RightNullSG[S]";
RightNullSG[__] := $Failed /; Message[RightNullSG::args];
RightOneQT::args = "Wrong argument(s), try RightOneQT[x,S]";
RightOneQT[__] := $Failed /; Message[RightOneQT::args];
RightOneSG::args = "Wrong argument(s), try RightOneSG[S]";
RightOneSG[__] := $Failed /; Message[RightOneSG::args];
RootList::args = "Wrong argument(s), try RootList[L]";
RootList[__] := $Failed /; Message[RootList::args];
RShiftT::args = "Wrong argument(s), try RShiftT[n]";
RShiftT[__] := $Failed /; Message[RShiftT::args];
RulesToPairs::args = "Wrong argument(s), try RulesToPairs[rw]";
RulesToPairs[__] := $Failed /; Message[RulesToPairs::args];
SeedConfiguration::args = "Wrong argument(s), try SeedConfiguration[BBBBB]";
SeedConfiguration[__] := $Failed /; Message[SeedConfiguration::args];
SelectOptions::args = "Wrong argument(s), try SelectOptions[cmd,opts]";
SelectOptions[__] := $Failed /; Message[SelectOptions::args];
SelectorQ::args = "Wrong argument(s), try SelectorQ[L,LL]";
SelectorQ[__] := $Failed /; Message[SelectorQ::args];
ShortestPath::args = "Wrong argument(s), try ShortestPath[G,s]";
ShortestPath[__] := $Failed /; Message[ShortestPath::args];
ShowArray::args = "Wrong argument(s), try ShowArray[L,k]";
ShowArray[__] := $Failed /; Message[ShowArray::args];
Shuffle::args = "Wrong argument(s), try Shuffle[L1,L2]";
Shuffle[__] := $Failed /; Message[Shuffle::args];
SimplifyEquations::args = "Wrong argument(s), try SimplifyEquations[S,wit,eq]";
SimplifyEquations[__] := $Failed /; Message[SimplifyEquations::args];
SimplifyRewriteSystem::args = "Wrong argument(s), try SimplifyRewriteSystem[eq]";
SimplifyRewriteSystem[__] := $Failed /; Message[SimplifyRewriteSystem::args];
SolveSG::args = "Wrong argument(s), try SolveSG[a,b,S]";
SolveSG[__] := $Failed /; Message[SolveSG::args];
StaircasePlot::args = "Wrong argument(s), try StaircasePlot[L,opts]";
StaircasePlot[__] := $Failed /; Message[StaircasePlot::args];
Status::args = "Wrong argument(s), try Status[]";
Status[__] := $Failed /; Message[Status::args];
StronglyConnectedComponents::args = "Wrong argument(s), try StronglyConnectedComponents[G,X]";
StronglyConnectedComponents[__] := $Failed /; Message[StronglyConnectedComponents::args];
SubGraph::args = "Wrong argument(s), try SubGraph[G,L]";
SubGraph[__] := $Failed /; Message[SubGraph::args];
SubsetQ::args = "Wrong argument(s), try SubsetQ[S1,S2]";
SubsetQ[__] := $Failed /; Message[SubsetQ::args];
SymbolList::args = "Wrong argument(s), try SymbolList[sym,L]";
SymbolList[__] := $Failed /; Message[SymbolList::args];
SymmetricGroupSG::args = "Wrong argument(s), try SymmetricGroupSG[n]";
SymmetricGroupSG[__] := $Failed /; Message[SymmetricGroupSG::args];
TableSG::args = "Wrong argument(s), try TableSG[S,W]";
TableSG[__] := $Failed /; Message[TableSG::args];
ToAdjList::args = "Wrong argument(s), try ToAdjList[G]";
ToAdjList[__] := $Failed /; Message[ToAdjList::args];
ToAdjMatrix::args = "Wrong argument(s), try ToAdjMatrix[G]";
ToAdjMatrix[__] := $Failed /; Message[ToAdjMatrix::args];
ToBitVector::args = "Wrong argument(s), try ToBitVector[S,U]";
ToBitVector[__] := $Failed /; Message[ToBitVector::args];
ToClasses::args = "Wrong argument(s), try ToClasses[L,R]";
ToClasses[__] := $Failed /; Message[ToClasses::args];
ToDAG::args = "Wrong argument(s), try ToDAG[G]";
ToDAG[__] := $Failed /; Message[ToDAG::args];
ToEdgeList::args = "Wrong argument(s), try ToEdgeList[G]";
ToEdgeList[__] := $Failed /; Message[ToEdgeList::args];
ToEps::args = "Wrong argument(s), try ToEps[x]";
ToEps[__] := $Failed /; Message[ToEps::args];
ToIdentityString::args = "Wrong argument(s), try ToIdentityString[xxx]";
ToIdentityString[__] := $Failed /; Message[ToIdentityString::args];
ToList::args = "Wrong argument(s), try ToList[S]";
ToList[__] := $Failed /; Message[ToList::args];
ToTDGraph::args = "Wrong argument(s), try ToTDGraph[{RR},m,opts]";
ToTDGraph[__] := $Failed /; Message[ToTDGraph::args];
TransformationSG::args = "Wrong argument(s), try TransformationSG[n]";
TransformationSG[__] := $Failed /; Message[TransformationSG::args];
TransientPeriodicT::args = "Wrong argument(s), try TransientPeriodicT[x]";
TransientPeriodicT[__] := $Failed /; Message[TransientPeriodicT::args];
TransitiveClosure::args = "Wrong argument(s), try TransitiveClosure[B,opts]";
TransitiveClosure[__] := $Failed /; Message[TransitiveClosure::args];
TranspositionT::args = "Wrong argument(s), try TranspositionT[n,i]";
TranspositionT[__] := $Failed /; Message[TranspositionT::args];
TypeGraph::args = "Wrong argument(s), try TypeGraph[G]";
TypeGraph[__] := $Failed /; Message[TypeGraph::args];
UnitElement::args = "Wrong argument(s), try UnitElement[x]";
UnitElement[__] := $Failed /; Message[UnitElement::args];
VertexSet::args = "Wrong argument(s), try VertexSet[G]";
VertexSet[__] := $Failed /; Message[VertexSet::args];
Warshall::args = "Wrong argument(s), try Warshall[B]";
Warshall[__] := $Failed /; Message[Warshall::args];
WeaklyConnectedComponents::args = "Wrong argument(s), try WeaklyConnectedComponents[G,X]";
WeaklyConnectedComponents[__] := $Failed /; Message[WeaklyConnectedComponents::args];
WordQ::args = "Wrong argument(s), try WordQ[w]";
WordQ[__] := $Failed /; Message[WordQ::args];
WordReduce::args = "Wrong argument(s), try WordReduce[w,eq,opt]";
WordReduce[__] := $Failed /; Message[WordReduce::args];





(* options *)
Protect[All, Boolean, BoundCSM, BoundETW, BoundGSG, BoundWR, ClosureBound, Cols, Cycle, DClasses, DoTrace, Eps, Equations, External, Filter, Full, GridOffset, Index, Kary, LabelGrid, LabelPoints, LineStyle, Matrix, MultiCol, NonTrivial, NoRest, Normalize, NRows, Opts, OutPairs, Periodic, RasterStyle, Reflexive, RegularOnly, Relation, RView, SetClosure, Type, Where, Witnesses];
(* headers *)
Protect[DC, GEN, Graph, SG, T];
(* functionals *)
Protect[AllStringReplace];
(* functions *)
Protect[AccCoaccGraph, AccessibleGraph, AlgebraicForm, AllTimes, AlternatingGroupSG, AnalyzeOrbit, AperiodicQSG, AperiodicQT, AperiodicSG, AssignFunction, BlocksToDClass, BooleanComplement, BooleanComposition, BooleanConverse, BooleanIntersection, BooleanPower, BooleanUnion, CartesianProduct, CirculantGraph, ClosureSearch, Closure, CollapseT, ColorQ, CompCycles, Concatenate, ConsT, Curry, CycleDecompositionT, CycleToT, CyclicQGraph, DClassDecomposition, DClassDimensions, DClassSize, DClassToBlocks, DClassT, DegreeGraph, Dependency, DisjointQ, DoShow, EdgeQ, Edges, EnumForm, EquationsToWitnesses, FastPowerSet, FlattenOne, Frequencies, FromBitVector, FromEps, FromIdentityString, GenerateCSM, GenerateSG, GreenHQT, GreenJQT, GreenLQT, GreenRQT, GridLine, GridPoints, HClassSize, HClassT, HTrivialQSG, HueRasterColors, IdealT, IdemQT, IdemSG, ImageT, IndToWitnesses, InGroupQT, InGroupSG, InverseT, IrreducibleQ, JTrivialQSG, JTrivialSG, KernelImageToT, KernelT, KPermutationsR, LabelEdgeList, LeftIdealT, LeftNullQT, LeftNullSG, LeftOneQT, LeftOneSG, LocallyCommQSG, LocallyIdemQSG, LongestPath, LShiftT, MakeAlphabet, MakeFullAlphabet, MakeIndex, MakeMonoidSG, MakePlotRange, Merge12T, MonoidQSG, NilpotentQSG, NonDecreasing, NonTransientGraph, NormalizeGraph, NullQT, NullSG, NumEdges, NumVertices, OneQT, OneSG, OneT, OrderT, PairsToRules, Pairs, PartitionCumRest, Partitions, PathGraph, PermuteGraph, PlotFunction, PlotMatrix, PlotRelation, PlotTDGraph, PlotT, PositionList, PositionOne, PowerSet, PrintDClass, PrintEquations, PrintWitnesses, ProductGraph, ProductLabeledGraph, RandomPermutation, RandomT, RankT, RegularQT, RegularSG, RelationToMatrix, RemoveDuplicates, RemoveVertex, RenumberRules, ReplaceParts, ReverseGraph, RightIdealT, RightNullQT, RightNullSG, RightOneQT, RightOneSG, RootList, RShiftT, RulesToPairs, SeedConfiguration, SelectOptions, SelectorQ, ShortestPath, ShowArray, Shuffle, SimplifyEquations, SimplifyRewriteSystem, SolveSG, StaircasePlot, Status, StronglyConnectedComponents, SubGraph, SubsetQ, SymbolList, SymmetricGroupSG, TableSG, ToAdjList, ToAdjMatrix, ToBitVector, ToClasses, ToDAG, ToEdgeList, ToEps, ToIdentityString, ToList, ToTDGraph, TransformationSG, TransientPeriodicT, TransitiveClosure, TranspositionT, TypeGraph, UnitElement, VertexSet, Warshall, WeaklyConnectedComponents, WordQ, WordReduce];

EndPackage[];



(* package end *)

