



(* DO NOT EDIT THIS FILE *) 
(* package generated at Mon Nov 25 22:59:30 EST 2002 from SOURCEFILE *) 


(* Title: extaut *)

(* 
*  Author: Klaus Sutner
*  Affiliation: CMU
*  email: sutner@cs.cmu.edu
*)

(* 
*  Version: Version 5.0
*  Date: 2001.12.31
*)

BeginPackage["Automata`extaut`", "Automata`dimath`", "Automata`automata`", "Automata`extcalls`"];


(*
*   System variables:   3
*   Options:            0
*   Function defs:      27
*   Functionals:        0
*   Data structures:    0
*)




DemolishFA::usage = "DemolishFA[M] prepares a FSM M for transmission over the link
by removing structured state sets and alphabets. See also RebuildFA.";
ExtAccessibleFA::usage = "ExtAccessibleFA[M] computes the accessible part of a DFA M.
Uses external code.";
ExtBalancedQCA::usage = "ExtBalancedQCA[C,b] tests if CA C is b-balanced.
Uses external code.";
ExtClassifyCA::usage = "ExtClassifyCA[C] classifies a cellular automaton C.  
Returns 0: not surjective, 1: surjective, 2: open, 3: injective.
Uses external code.";
ExtComposeCA::usage = "ExtComposeCA[C1,C2] comutes the composition of CAs C1 and C2.
Uses external code.";
ExtDefiniteQFA::usage = "ExtDefiniteQFA[M,opts] tests whether SA M is definite.
Uses external code.";
ExtEpsilonEliminationFA::usage = "ExtEpsilonEliminationFA[M,opts] performs epsilon elimination of an FA M.
Uses external code.";
ExtEquivalentQFA::usage = "ExtEquivalentQFA[M1,M2] checks whether FSMs M1 and M2 are equivalent 
(by testing isomorphism of the corresponding minimal automata).
Uses external code.";
ExtGenerateSG::usage = "ExtGenerateSG[gen,opts] computes the semigroup generated by gen. 
Option Equations->True causes the canonical rewrite rules to be generated.
Option DClasses->True causes the regular D-class decomposition to be generated. 
Uses external code. 
Default alphabet is {a,b,c,...}, currently no other alphabets available.";
ExtIsomorphicQDFA::usage = "ExtIsomorphicQDFA[M1,M2] checks whether DFAs M1 and M2 are isomorphic. 
Uses external code.";
ExtLanguageFA::usage = "ExtLanguageFA[M,r] computes the acceptance language of a DFA M for words 
of length r (up to and including length r for negative r).  
The alphabet is assumed to be {a,b,c,...}.
Uses exernal code.";
ExtMinimizeFASize::usage = "ExtMinimizeFASize[M] returns the size of the minimal DFA for M.  
If M is nondeterministic, the power automaton is computed first.  Then Hopcroft's 
algorithm is used for state merging, but only the number of states is returned.  
Uses external code.";
ExtMinimizeFA::usage = "ExtMinimizeFA[M,opts] minimizes a finite state machine M.  
If M is nondeterministic, the power automaton is computed first.  
Then Hopcroft's algorithm is used for state merging.  
Option Normalize.
Uses external code.";
ExtOrbitCA::usage = "ExtOrbitCA[C,t,pat,opts] plots the evolution of pat for t steps of 
a 1-dim cellular automaton C. 
Option Boundary->Fixed. 
Uses external code.";
ExtProductDFA::usage = "ExtProductDFA[M1,M2,opts] returns the product of two DFAs M1 and M2 
(over the same alphabet).  Only the accessible part of the full product automaton is generated.  
Uses external code.";
ExtQuotientDFA::usage = "ExtQuotientDFA[M1,M2,opts] returns the quotient automaton of two DFAs M1 and M2 
(over the same alphabet).   The left quotient of M2 with respect to M1 is calculated. 
Uses external code.";
ExtREToFA::usage = "ExtREToFA[reg,opts] converts a regular expression to an FA.
Uses external code.";
ExtStronglyConnectedComponents::usage = "ExtStronglyConnectedComponents[G,opts] computes the strongly connected 
components of digraph G. 
Uses external code.";
ExtSyntacticSG::usage = "ExtSyntacticSG[M,opts] generates the syntactic semigroup of DFA M.  
Option Equations->True causes the canonical rewrite rules to be generated.
Option DClasses->True causes the regular D-class decomposition to be generated. 
Uses external code.";
ExtToDFASize::usage = "ExtToDFASize[M] returns the size of the accessible part of the 
power set machine of M. 
Uses external code.";
ExtToDFAWitnesses::usage = "ExtToDFAWitnesses[M] returns a list of witnesses for the states of 
the power set machine.
Uses external code.";
ExtToDFA::usage = "ExtToDFA[M] converts finite state machine M to a DFA.
Option Normalize.
Uses external code.";
ExtToKernelFA::usage = "ExtToKernelFA[M,L,opts] computes the kernel automaton of M where 
M is an eps-free SA or FA. L is a list of sets of states that are the generators of 
the kernel automaton. 
Option Full (default: False).  
Option Normalize (default: 1).
Uses external code.";
ExtToWelchCA::usage = "ExtToWelchCA[C,opts] computes the Welch indices and Welch automata 
for a cellular automaton C.
Uses external code.";
ExtWelchCA::usage = "ExtWelchCA[C] computes the Welch indices for a cellular automaton C.
Uses external code.";
$linkDebug::usage = "$linkDebug, if set to True, causes the actual
command string sent to the external parser to be displayed.";
$maxParseSize::usage = "$maxParseSize controls the size of the longest
possible command string sent to extaut, default is 200000. Changes
must be made in parser.h (MAX_PARSE_SIZE) and extaut.m. You will have
to recompile the external code for the changes to take effect.";
postload::usage = "postload[] sends messages.
Is executed automatically after the package is loaded.";
preload::usage = "preload[] defines messages. 
Is executed automatically before the package is loaded.";
RebuildFA::usage = "RebuildFA[Mnew,Mold,st,norm] rebuilds a FSM received from the link.";
$res::usage = "$res is used to return results from external computations. 
In particular in case of failure, $res is set to $Failure.";
SendProgram::usage = "SendProgram[cmds] sends a (sequence of) command(s) to aut, t
he automata calculator.  Stringifies arguments and concatenates them in order to 
produce a string suitable for MLParseProg.  SendProgram checks the result returned by 
MLParseProg, and flushes the link if need be. This command is used extensively in extaut.m.  
Do not use SendProgram directly unless you are familiar with the syntax of the input language 
for the automata calculator. The link may break or hang if you send improper commands.
Uses external code.";


Begin["`Private`"];


DemolishFA[M_?FSMQ] := ReplacePart[ Drop[ M, -2 ], AlphabetSize[M], 2 ];


Options[ExtAccessibleFA]={Normalize:>$defaultnormalize};

ExtAccessibleFA[M_DFA,opts___?OptionQ] := 
( 
    norm = Normalize /. {opts} /. Options[ExtAccessibleFA];
    stat = {};
    If[ norm==0,
        m  = SendProgram[ "acc[", M, "]" ],
        m  = SendProgram[ "dd = acc[", M, ",0]" ];
        stat = SendProgram[ "states[dd]" ];        
    ];
    RebuildFA[ m, M, stat, norm ]	
);


ExtBalancedQCA[ C_CA, b_Integer ] := 1===SendProgram[ "bal[", C, ",", b,"]" ];


ExtClassifyCA[ C_CA ] := SendProgram[ "analyze[", C, "]" ];


ExtComposeCA[ C1_CA, C2_CA ] := 
Module[ {cc,rr},
    cc = SendProgram[ "compose[", C1, ",", C2, "]" ];
    ReplacePart[ cc, Drei[C1], 3 ]
];


Options[ExtDefiniteQFA]={Full->False};

ExtDefiniteQFA[ S_SA, opts___?OptionQ ] := 
(
    If[ Full /. {opts} /. Options[ExtDefiniteQFA], 
        SendProgram[ " longpath[tograph[squaresa[", S, "]]]" ],
        SendProgram[ "size[ scc[ tograph[squaresa[", S, " 1 ]]" ]==1 ]
);


Options[ExtEpsilonEliminationFA]={Normalize:>$defaultnormalize};

ExtEpsilonEliminationFA[M_FA,opts___?OptionQ] := 
(
    norm = Normalize /. {opts} /. Options[ExtAccessibleFA];
    RebuildFA[ SendProgram[ "epselim[", M, "]" ], M, {}, norm ]
);


ExtEquivalentQFA[ M1_?FSMQ, M2_?FSMQ ] := 
    SendProgram[ "equal[acc[minimize[",M1,"]],acc[minimize[",M2,"]]]" ]==1;


Options[ExtGenerateSG]={Equations->False, DClasses->False};

ExtGenerateSG[ gen_GEN, opts___?OptionQ ] := 
Module[ {how,wid,wit,one,sg,dcl},

    how = 0;
    If[ Equations /. {opts} /. Options[ExtGenerateSG], how=1 ];
    If[ DClasses  /. {opts} /. Options[ExtGenerateSG], how=2 ];

    {wid,one,sg} = SendProgram["ss = generate[", gen, ",", how, "]" ];

    sg = SG@@Apply[ T, Partition[ sg, wid ], {1} ];

    If[ how>0, (* semigroup, witnesses *)
       wit = SendProgram["witlist[ss]"];       
       equ = SendProgram["eqlist[ss]"];
       wit = wit /. ""->"Eps";
       equ = equ /. ""->"Eps";
    ];

    If[ how>1,  (* plus equations and D-classes *)
        dcl = SendProgram["dclist[ss]"];
	dcl = toDClass[#,wid]& /@ dcl;
    ];

    Switch[ how,
        0,  sg,
        1,  {sg,wit,equ},
        2,  {sg,wit,equ,dcl}
    ]
];

toDClass[ {dim_List,LL___:Integer}, n_Integer ] := 
DC@@(First@Fold[ Partition[#1,#2]&, Apply[T,Partition[{LL},n],{1}], Reverse[dim] ]);


ExtIsomorphicQDFA[ M1_DFA, M2_DFA ] := SendProgram[ "equal[acc[",M1,"],acc[",M2,"]]" ]==1;


ExtLanguageFA[ M_DFA|M_FA|M_SA, n_Integer ] := 
(
    LLL = SendProgram[ "mm = minimize[", M, "]; tolang[ mm,", n, "]" ]; 
    If[ LLL===$Failed, Return[$Failed] ];
    If[ Negative[n], 
        If[ Intersection[ Final[M], Initial[M] ]=!={},
            Prepend[ LLL, {"Eps"} ],
            Prepend[ LLL, {} ]
        ],
        LLL
    ]
);

ExtLanguageFA[ M_NFA, n_Integer ] := ExtLanguageFA[ ToFA[M], n ];


ExtMinimizeFASize[M_DFA] := SendProgram[ "size[minimize[", M, "]" ];


Options[ExtMinimizeFA]={Normalize:>$defaultnormalize};

ExtMinimizeFA[M_DFA,opts___?OptionQ] := 
(   
    norm = Normalize /. {opts} /. Options[ExtMinimizeFA];
    stat = {};
    If[ norm==0,
        m    = SendProgram[ "acc[minimize[acc[", M, "]]]" ],
        m    = SendProgram[ "dd = acc[minimize[acc[", M, ",0],0],0]" ];
	stat = SendProgram[ "states[dd]" ];
    ];
    RebuildFA[ m, M, stat, norm ]	
);

ExtMinimizeFA[M_FA,opts___?OptionQ] := 
(
    norm = Normalize /. {opts} /. Options[ExtMinimizeFA];
    stat = {};
    If[ norm==0,
        m = SendProgram[ "acc[minimize[", M, "]]" ],
        m = SendProgram[ "dd = acc[minimize[", M, ",0],0]" ];
	stat = SendProgram[ "states[dd]" ];
    ];
    RebuildFA[ m, M, stat, norm ]	
);
    
ExtMinimizeFA[M_SA|M_NFA,opts___?OptionQ] := ExtMinimizeFA[ToFA[M,opts],opts];


Options[ExtOrbitCA]={Boundary->Cyclic};

ExtOrbitCA[ C_CA, t_Integer:40, opts___?OptionQ ] := 
    ExtOrbitCA[C,SeedConfiguration[{1},2t+1],t,opts];

ExtOrbitCA[ C_CA, str_String, t_Integer:40, opts___?OptionQ ] := 
    ExtOrbitCA[ C, ToIndex[str,Alphabet[C]]-1, t, opts ];

ExtOrbitCA[ C_CA, init_List, t_Integer:40, opts___?OptionQ ] := 
Module[ {n,w,k,cyc,rule},
    cyc  = If[ (Boundary /. {opts} /. Options[ExtOrbitCA])===Cyclic, 1, 0 ];
    w    = WidthCA[C];
    k    = AlphabetSize[C];
    n    = Length[init];
    Partition[ SendProgram[ "orbit[", C, ",", init, ",", t, ",", cyc, "]" ], n ]
];


Options[ExtProductDFA]={Normalize->0};
ExtProductDFA[M1_DFA,M2_DFA,opts___?OptionQ] := 
(   
    norm = Normalize /. {opts} /. Options[ExtProductDFA];
    stat = {};
    If[ norm==0,
        m    = SendProgram[ "proddfa[", M1, ",", M2, "]" ],
        m    = SendProgram[ "p = proddfa[", M1, ",", M2, ", (0,0) ]" ];
	stat = SendProgram[ "states[p]" ];
    ];
    RebuildFA[ m, M1, stat, norm ]	
);


Options[ExtQuotientDFA]={Normalize->0};

ExtQuotientDFA[M1_DFA,M2_DFA,opts___?OptionQ] := 
(
    norm = Normalize /. {opts} /. Options[ExtQuotientDFA];
    stat = {};
    If[ norm==0,
        m    = SendProgram[ "quotdfa[", M1, ",", M2, "]" ],
        m    = SendProgram[ "p = quotdfa[", M1, ",", M2, ", 0 ]" ];
	stat = SendProgram[ "states[p]" ];
    ];
    RebuildFA[ m, M1, stat, norm ]	
);
    

Options[ExtREToFA]={EpsElim->True};

Attributes[ExtREToFA]={HoldFirst};

ExtREToFA[re_,opts___] := 
( 
restr = "<"<>StringReplace[StringDrop[StringDrop[ToString[Hold[re]],5],-1]," "->""]<>">";
    eps = Automata`automata`EpsElim /. {opts} /. Options[ExtREToFA];
    If[ eps,
        SendProgram[ "epselim[", restr, "]" ],
        SendProgram[ restr ]      
    ]
);


ExtStronglyConnectedComponents[ GG_Graph, ntriv_ ] := SendProgram[ "scc[", GG, ",", ntriv, "]" ];


Options[ExtSyntacticSG]={Equations->False, DClasses->False};

ExtSyntacticSG[ M_DFA, opts___?OptionQ ] := ExtGenerateSG[ ToGeneratorsDFA[M], opts ];


ExtToDFASize[M_FA] := SendProgram[ "todfasize[",M,"]" ];

ExtToDFASize[M_SA|M_NFA] := ExtToDFASize[M//ToFA];


ExtToDFAWitnesses[M_FA] := SendProgram[ M, "todfawit" ] /. {""->"Eps"};

ExtToDFAWitnesses[M_SA|M_NFA] := ExtToDFAWitnesses[M//ToFA];


Options[ExtToDFA]={Normalize->0};

ExtToDFA[M_FA|M_SA,opts___?OptionQ] := 
(   
    norm = Normalize /. {opts} /. Options[ExtToDFA];
    stat = {};
    If[ norm==0,
        m = SendProgram[ "todfa[", M, "]" ],
        m = SendProgram[ "dd = todfa[", M, ",0]" ];
        stat = SendProgram[ "states[dd]" ];        
    ];
    RebuildFA[ m, M, stat, norm ]	
);

ExtToDFA[M_NFA,opts___?OptionQ] := ExtToDFA[M//ToFA,opts];


Options[ExtToKernelFA]={Normalize->1, Full->False};

ExtToKernelFA[ M_SA, LL_List, opts___?OptionQ] := 
(   
    norm = Normalize /. {opts} /. Options[ExtToKernelFA];
    stat = {};
    If[ norm==0, 
        m  = SendProgram[ "kernel[", M, ",", LL, "]" ],
        m  = SendProgram[ "ss = kernel[", M, ",", LL, ",0]" ];
        stat = SendProgram[ "states[ss]" ];
    ]; 
    RebuildFA[ m, M, stat, norm ]	
);

ExtToKernelFA[ M_FA, LL_List, opts___?OptionQ] := 
(   
    norm = Normalize /. {opts} /. Options[ExtToKernelFA];
    stat = {};
    m    = SendProgram[ "ss = kernel[", ToSA[M], ",", LL, ",0]" ];
    stat = SendProgram[ "states[ss]" ];
    ini  = PositionList[ stat, LL ];
    fin  = Select[ stat, (Intersection[#,Final[M]]=!={})& ];
    fin  = PositionList[ stat, fin ];
    RebuildFA[ SetInitialFinalFA[m,ini,fin], M, stat, norm ]	
);


Options[ExtToWelchCA]={Normalize->1};

ExtToWelchCA[ C_CA, opts___?OptionQ ] :=
Module[ {wl,wr,k,alph,rules,w,stat,norm},

    norm = Normalize /. {opts} /. Options[ExtToWelchCA];
    If[ norm==0, 
	{wl,wr} = SendProgram[ "towelch[",C,"]" ], 
	{wl,wr} = SendProgram[ "ss = towelch[", C, ",0]" ]
    ]; 

    wl  = ReplacePart[ wl, Drei[C], 2 ];
    wr  = ReplacePart[ wr, Drei[C], 2 ];

    {nwl,nwr} = SendProgram[ "( size[H[states[H[ss]]]], size[H[states[H[T[ss]]]]] )" ];
    If[ norm==1, 
	stat = SendProgram[ "states[H[ss]]" ];
	wl = ReplacePart[ wl, stat, -1 ]; 
	stat = SendProgram[ "states[H[T[ss]]]" ];
	wr = ReplacePart[ wr, stat, -1 ]; 
    ]; 

                                     (*  massage output for option Full  *)
    If[ norm==2,
        {k,alph} = Alphabet[C];
        w  = WidthCA[C] - 1;
        rules = Thread[ Range[k^w] -> Words[w,alph] ];
        wl = ReplacePart[ wl, First[wl]/.rules, -1 ];
        wr = ReplacePart[ wr, First[wr]/.rules, -1 ];
    ];
    {{nwl,nwr},{wl,wr}}
];


ExtWelchCA[ C_CA ] := 
( 
     SendProgram[ "ss = towelch[", C, ",0];" ];
     SendProgram[ "( size[H[states[H[ss]]]], size[H[states[H[T[ss]]]]] )" ]
);


$linkDebug = False;

$maxParseSize = 200000;

If[ Or@@( StringMatchQ[#,"*extaut*" ]& /@ First /@ Links[] ), 
    $defaultexternal=True;
    If[ Global`$AutomataMessages, Message[extaut::ldmsg] ],
(* else flag error *)
    Message[extaut::lderr] 
];


extaut::lderr = "\nLaoding the external part of automata failed.
$defaultexternal is now set to False, you can still use the internal code.";

extaut::ldmsg = "extaut loading. $defaultexternal set to True.";

sendInst::toobig = "Command string is too long. See $MaxParseSize."; 

sendInst::parerr = "The external parser failed on input `1`. 
Check if input is properly formed.";

sendInst::reterr = "The external calculator failed on input `1`. 
Remaining packets on the link will be discarded.";

sendInst::debug = "Length: `1`.  Command: `2`."; 


RebuildFA[ m_DFA|m_FA|m_SA, M_, st_, norm_Integer ] := 
ReplaceParts[ m, M[[2]], 2, M[[-2]], -2, 
Switch[ norm,
	0, {},
	1, st,
	2, AssignFunction[ fff, Range[Size[M]], States[M], ListAble->True ]; fff[st]
], -1 ];


$res = $Failure;

SendProgram[ cmd_String ] := 
(
    If[ StringLength[cmd] > $maxParseSize, 
        Message[sendInst::toobig]; Return[$Failed] ];

    If[ $linkDebug, Message[sendInst::debug,StringLength[cmd],cmd] ];

    $res = $Failed;
    $res = Automata`extcalls`MLParseProg[ cmd<>"\n" ]; 

    (* check if there is garbage on the link, flush *) 
    If[ LinkReadyQ[Global`extlink], 
        Message[sendInst::reterr, cmd ];
        While[ LinkReadyQ[Global`extlink],
               LinkRead[Global`extlink] 
        ];
    ];
 
    (* warning message if return value is $Failed *)
    If[ $res===$Failed, Message[sendInst::parerr, cmd] ];

    (* return hopefully correct result *)      
    $res
);

SendProgram[ cmds__ ] := SendProgram[ StringJoin@@( stringify /@ {cmds} ) ];

(* compress spaces; lists, function calls --> () *)
reprl = { " "->"", "{"->"(", "}"->")" };

stringify[M_?FSMQ]    := StringReplace[ ToString@DemolishFA[M], reprl ];
stringify[ CA[ r_Integer, w_Integer, k_Integer ] ] := 
			StringReplace[ ToString[CA[ r, w, Abs[k] ]], reprl ];
stringify[G_Graph] :=  StringReplace[ ToString[Drop[ ToAdjList[G], -1 ]], reprl ];
stringify[GEN[w_,k_,L_List]]    := 
		StringReplace[ ToString[ 
		Join[ {w, k}, Flatten@Apply[List,L,{1}]-1 ]], reprl ];
stringify[str_String] := str; 
stringify[xxx_]    := StringReplace[ ToString[xxx], reprl ];



End[];



DemolishFA::args = "Wrong argument(s), try DemolishFA[M]";
DemolishFA[__] := $Failed /; Message[DemolishFA::args];
ExtAccessibleFA::args = "Wrong argument(s), try ExtAccessibleFA[M,opts]";
ExtAccessibleFA[__] := $Failed /; Message[ExtAccessibleFA::args];
ExtBalancedQCA::args = "Wrong argument(s), try ExtBalancedQCA[C,b]";
ExtBalancedQCA[__] := $Failed /; Message[ExtBalancedQCA::args];
ExtClassifyCA::args = "Wrong argument(s), try ExtClassifyCA[C]";
ExtClassifyCA[__] := $Failed /; Message[ExtClassifyCA::args];
ExtComposeCA::args = "Wrong argument(s), try ExtComposeCA[C1,C2]";
ExtComposeCA[__] := $Failed /; Message[ExtComposeCA::args];
ExtDefiniteQFA::args = "Wrong argument(s), try ExtDefiniteQFA[M,opts]";
ExtDefiniteQFA[__] := $Failed /; Message[ExtDefiniteQFA::args];
ExtEpsilonEliminationFA::args = "Wrong argument(s), try ExtEpsilonEliminationFA[M,opts]";
ExtEpsilonEliminationFA[__] := $Failed /; Message[ExtEpsilonEliminationFA::args];
ExtEquivalentQFA::args = "Wrong argument(s), try ExtEquivalentQFA[M1,M2]";
ExtEquivalentQFA[__] := $Failed /; Message[ExtEquivalentQFA::args];
ExtGenerateSG::args = "Wrong argument(s), try ExtGenerateSG[gen,opts]";
ExtGenerateSG[__] := $Failed /; Message[ExtGenerateSG::args];
ExtIsomorphicQDFA::args = "Wrong argument(s), try ExtIsomorphicQDFA[M1,M2]";
ExtIsomorphicQDFA[__] := $Failed /; Message[ExtIsomorphicQDFA::args];
ExtLanguageFA::args = "Wrong argument(s), try ExtLanguageFA[M,r]";
ExtLanguageFA[__] := $Failed /; Message[ExtLanguageFA::args];
ExtMinimizeFASize::args = "Wrong argument(s), try ExtMinimizeFASize[M]";
ExtMinimizeFASize[__] := $Failed /; Message[ExtMinimizeFASize::args];
ExtMinimizeFA::args = "Wrong argument(s), try ExtMinimizeFA[M,opts]";
ExtMinimizeFA[__] := $Failed /; Message[ExtMinimizeFA::args];
ExtOrbitCA::args = "Wrong argument(s), try ExtOrbitCA[C,t,pat,opts]";
ExtOrbitCA[__] := $Failed /; Message[ExtOrbitCA::args];
ExtProductDFA::args = "Wrong argument(s), try ExtProductDFA[M1,M2,opts]";
ExtProductDFA[__] := $Failed /; Message[ExtProductDFA::args];
ExtQuotientDFA::args = "Wrong argument(s), try ExtQuotientDFA[M1,M2,opts]";
ExtQuotientDFA[__] := $Failed /; Message[ExtQuotientDFA::args];
ExtREToFA::args = "Wrong argument(s), try ExtREToFA[reg,opts]";
ExtREToFA[__] := $Failed /; Message[ExtREToFA::args];
ExtStronglyConnectedComponents::args = "Wrong argument(s), try ExtStronglyConnectedComponents[G,opts]";
ExtStronglyConnectedComponents[__] := $Failed /; Message[ExtStronglyConnectedComponents::args];
ExtSyntacticSG::args = "Wrong argument(s), try ExtSyntacticSG[M,opts]";
ExtSyntacticSG[__] := $Failed /; Message[ExtSyntacticSG::args];
ExtToDFASize::args = "Wrong argument(s), try ExtToDFASize[M]";
ExtToDFASize[__] := $Failed /; Message[ExtToDFASize::args];
ExtToDFAWitnesses::args = "Wrong argument(s), try ExtToDFAWitnesses[M]";
ExtToDFAWitnesses[__] := $Failed /; Message[ExtToDFAWitnesses::args];
ExtToDFA::args = "Wrong argument(s), try ExtToDFA[M,opts]";
ExtToDFA[__] := $Failed /; Message[ExtToDFA::args];
ExtToKernelFA::args = "Wrong argument(s), try ExtToKernelFA[M,L]";
ExtToKernelFA[__] := $Failed /; Message[ExtToKernelFA::args];
ExtToWelchCA::args = "Wrong argument(s), try ExtToWelchCA[C,opts]";
ExtToWelchCA[__] := $Failed /; Message[ExtToWelchCA::args];
ExtWelchCA::args = "Wrong argument(s), try ExtWelchCA[C]";
ExtWelchCA[__] := $Failed /; Message[ExtWelchCA::args];
RebuildFA::args = "Wrong argument(s), try RebuildFA[Mnew,Mold,st,norm]";
RebuildFA[__] := $Failed /; Message[RebuildFA::args];
SendProgram::args = "Wrong argument(s), try SendProgram[prog]";
SendProgram[__] := $Failed /; Message[SendProgram::args];





(* options *)
Protect[];
(* headers *)
Protect[];
(* functionals *)
Protect[];
(* functions *)
Protect[DemolishFA, ExtAccessibleFA, ExtBalancedQCA, ExtClassifyCA, ExtComposeCA, ExtDefiniteQFA, ExtEpsilonEliminationFA, ExtEquivalentQFA, ExtGenerateSG, ExtIsomorphicQDFA, ExtLanguageFA, ExtMinimizeFASize, ExtMinimizeFA, ExtOrbitCA, ExtProductDFA, ExtQuotientDFA, ExtREToFA, ExtStronglyConnectedComponents, ExtSyntacticSG, ExtToDFASize, ExtToDFAWitnesses, ExtToDFA, ExtToKernelFA, ExtToWelchCA, ExtWelchCA, RebuildFA, SendProgram];

EndPackage[];



(* package end *)

