



(* DO NOT EDIT THIS FILE *) 
(* package generated at Mon Nov 25 22:59:28 EST 2002 from SOURCEFILE *) 


(* Title: automata *)

(* 
*  Author: Klaus Sutner
*  Affiliation: CMU
*  email: sutner@cs.cmu.edu
*)

(* 
*  Version: Version 4.6
*  Date: 2002.11.25
*)

BeginPackage["Automata`automata`", "Automata`dimath`"];


(*
*   System variables:   8
*   Options:            25
*   Function defs:      218
*   Functionals:        0
*   Data structures:    11
*)




AcceptQFA::usage = "AcceptQFA[M,x,opts] tests whether machine M 
accepts input x.  Option DoTrace->True produces a trace of the 
computation.  Option Multiplicity->True computes the multiplicity of x 
with respect to M.";
AccessibleFA::usage = "AccessibleFA[M] constructs the accessible part 
of a FSM M.  The initial state of a DFA is renumbered to 1.  The 
operation is idempotent and can be used to check equivalence of DFAs. 
Supports option Normalize.
";
AddTransitionFA::usage = "AddTransitionFA[M,p,w,q] adds the transition 
{p,w,q} to M.  Here w may be a word.  Can also be used in the form 
AddTransitionFA[M,{p,w,q}] or AddTransitionFA[M,L] where L is a list 
of transitions.
";
AllDFA::usage = "AllDFA[K] constructs a DFA that accepts all words over alphabet K.
With option Full->False only non-empty words are accepted.
";
Alphabetic::usage = "Alphabetic is an option for FunctionToSA and 
FunctionToDFA. ";
AlphabetSize::usage = "AlphabetSize[K] returns the size of the alphabet K.
 Also applicable to machines.
";
$alphabet::usage = "$alphabet is the default alphabet used in some 50 
commands.  The preset value is 2, which represents alphabet {a,b}. 
Can be changed by user, but note that sizes of languages and machines 
may increase drastically.
";
Alphabet::usage = "Alphabet[M] returns the proper alphabet of machine M 
(a finite state machine or a CA). M can also be a word or a list of words.";
AmbiguousQFA::usage = "AmbiguousQFA[M,opts] tests whether FSM M is ambiguous. 
Option Full->True in addition returns the product automaton. 
Option External.";
Arden::usage = "Arden[eq] solves a linear equation eq over the 
language semiring using Arden's lemma. The second component of the 
resulting equation is a rational expression, possibly containing 
additional variables.  Use in conjunction with Substitute.
";
$automataReleaseNumber::usage = "$automataReleaseNumber is the release number of the loaded 
automata package.";
BEFA::usage = "BEFA[n,T] denotes a begin-exit automaton.  By default, 
1 is the initial state (begin) and n is the final state (exit).  No 
transitions end at the begin and no transitions start at the exit.  T 
is a list of transitions {p,a,q} where the states are in positional 
notation but the symbol is a character.  Used only in the conversion 
of regular expressions to FAs.";
BehaviorFA::usage = "BehaviorFA[M,p,r] constructs a part of the 
behavior of state p in automaton M (the acceptance language of the 
machine M with p as only initial state). Only words of length r (or: 
up to length r) are generated, see also LanguageFA.
";
BFunctionToCA::usage = "BFunctionToCA[f,w] constructs a CA of width w 
over alphabet {0,1} whose local map is given by f, a boolean 
expression in variables x1 to xw. Negated variables can be denoted by 
xx1 to xxw. Plus and Times can be used instead of logical Or and 
And. See PolynomialToCA for conversion of polynomials mod k to 
CAs. See FunctionToCA for a general conversion procedure.
";
$bottom::usage = "$bottom is the default object used for the trap 
state added to machines by CompleteFA.  Initialized to -1.
";
Boundary::usage = "Boundary is an option for ToBlocks.  
Acceptable values: Cyclic, Fixed and None.";
BuildBEFA::usage = "BuildBEFA[w] constructs a BEFA that accepts 
exactly the word w.
";
BuildDFA::usage = "BuildDFA[w1,..,wi,K] constructs the minimal DFA for 
the finite language L = {w1,..,wi} over alphabet K. Option 
Normalize->1 causes the state set to be preserved in structured form: 
a set of sets of words, more precisely, all left quotients of L. Also 
accepts a list L of words as input. See also QuotientDFA.";
BuildNNFA::usage = "BuildNNFA[w] constructs a NNFA that accepts 
exactly the word w (returns only the tail of the automaton).
";
BuildStarDFA::usage = "BuildStarDFA[w,K] builds a DFA for the language 
w*.
";
CA::usage = "CA[lab,w,K] denotes a linear cellular automaton with 
width w, alphabet K (default: {0,1,..,k-1}) and local rule given by 
the list lab.  Alternatively, a non-negative integer r less than 
k^{k^w} can be used instead of lab.  Numbering convention: the last 
symbol in lab labels the selfloop at 00..00.";
CirculantSA::usage = "CirculantSA[n,d,lab,alph] constructs an SA with 
transition diagram a circulant graph C(n;d).
";
ClassifyCA::usage = "ClassifyCA[C] determines whether the CA C is 
injective, open, surjective, or neither, and returns output 3,2,1, and 
0, respectively.  With option Full->True returns the type, and the 
non-transient part of the collapse of the square de Bruijn graph of C.
";
CoAccessibleFA::usage = "CoAccessibleFA[M] returns the coaccessible 
part of a finite state machine M. Result will be an FA even if M is a DFA.
";
CodeterministicQFA::usage = "CodeterministicQFA[M] tests whether the 
transition function of M is codeterministic (M can be an FA, NFA or 
SA).
";
ComplementFA::usage = "ComplementFA[M] generates a DFA that accepts 
the complement of the acceptance language of FA M (for a DFA this is 
accomplished by interchanging final and non-final states, a 
nondeterministic machine is converted to a DFA first). 
ComplementFA[M1,M2] constructs a DFA for the language L(M1) - 
L(M2).
";
CompleteFA::usage = "CompleteFA[M] adds a sink to M if necessary to 
produce a complete automaton.
";
CompleteQFA::usage = "CompleteQFA[M] tests whether the finite state 
machine M is complete.
";
ComposeCA::usage = "ComposeCA[C1,C2] composes CAs C1 and C2 (first C1, then C2).
";
ComputationFA::usage = "ComputationFA[M,w] determines all computations 
of machine M on input w (starting at an initial state).
";
ComputationGraphFA::usage = "ComputationGraphFA[M,w,opts] produces the 
unfolding of the finite state machine M with respect to input 
w. Returns a TDGraph object, see there. Options currently not used.
";
ConcatenateFA::usage = "ConcatenateFA[M1,..,Mn] generates an FA that 
accepts the concatenation of the acceptance languages of M_1,...,M_n.  
Options are Normalize->1 and EpsElim->False.";
ConvertToFA::usage = "ConvertToFA[H,Q,K,A,I,F,opts] converts to a FSM 
with head H, states Q, alphabet K, transitions A, initial/final states 
I/F. Options are Normalize->0 and ToMatrix->True. The latter causes a 
list of transitions to be converted into a matrix (for DFA and 
NFA).
";
CounterDFA::usage = "CounterDFA[a,n,K] constructs a DFA for the 
language of all words x over alphabet K such that |x|_a = n.  For 
negative n, all words such that |x|_a <= |n| are accepted.
";
CoverQDFA::usage = "CoverQDFA[M1,M2,opts] tests whether there is a partial 
surjective homomorphism from DFA M1 to DFA M2.  
Option DoTrace->True causes the homomorphism to be displayed.
";
Cyclic::usage = "Cyclic is a possible value for option Boundary in 
ToBlocks and various operations on cellular automata.
";
DeBruijnEdges::usage = "DeBruijnEdges[w,K,opts] generates an edge list 
for the de Bruijn graph of width w over digit alphabet K (default: K = 
{0,1}).  See DeBruijnGraph. 
";
DeBruijnGraph::usage = "DeBruijnGraph[w,K,opts] generates the de 
Bruijn graph of width w over alphabet K (default: K = {0,1}).  The 
nodes in this graph are words of length w over K, and the edges are of 
the form (ax,xb) where x is a word of length w-1 and a and b are 
symbols.  These graphs are (k,k)-regular: all nodes have indegree and 
outdegree k = |K|.  They are also Eulerian and Hamiltonian. Option 
Normalize->True renumbers vertices.
";
$defaultnormalize::usage = "$defaultnormalize is the default value for 
the option Normalize that is used in many algorithms operating on 
finite state machines.  Option Normalize determines whether the states 
of the output machine are normalize to [n] or are preserved in their 
original form which depends on the algorithm in question.  Most 
importantly, for ToDFA and MinimizeFA the non-normalized states are 
sets of states of the input machine.  For product machines, 
non-normalized states are pairs of states to the input machines. The 
default value for $defaultnormalize set during start-up is 0, 
corresponding to fully normalize machines with state set [n]. Setting 
Normalize->1 will produce state sets whose type determined by the 
operation performed, but the input machines are all treated as if 
their state setswere normalized. Lastly, Normalize->2 will not only 
preserve the state structure with respect to the last operation, but 
also the state sets of the input machines. Note that the memory 
requirement of non-normalized machines may be significantly larger 
than for their normalized counterparts. This true in particular for 
machines produced by command pipelines like 
ProductSA[m1,m2] // ToDFA // MinimizeFA if normalization is turned off.";
DefiniteQFA::usage = "DefiniteQFA[M] tests wether $M$ is definite by 
computing the strongly connected components of the corresponding 
product machine. If option Full->True is set, the definite-depth of 
the machine is computed. See ProductSA.
";
DegreesFA::usage = "DegreesFA[M] returns a K by Q matrix of integers 
where entry (a,p) is the number of transitions with source p and label 
a.
";
DeleteStateFA::usage = "DeleteStateFA[M,p] removes state p from 
machine M (p can also be a list of states, M can be an FA, NFA or 
SA).
";
DependencyCA::usage = "DependencyCA[C] returns a list of the indices 
of the variables upon which the local map of cellular automaton C 
depends. See also Dependency.
";
DeterministicQFA::usage = "DeterministicQFA[M] tests whether the 
transition relation of M is deterministic (M can be an FA, NFA or SA). 
With option  Full->True  it checks whether M is d-deterministic 
(and returns d or Infinity, correspondingly).
";
DFA::usage = "DFA[Q,K,T,q0,F] denotes a deterministic finite 
automaton.  Q is the number of states, K the alphabet, T the 
transition matrix (format: K by Q), q0 the initial state, and F the 
set of final states.  Q may also be a list of objects. The entries in 
T, q0 and F are always in positional notation.";
EdgeLU::usage = "EdgeLU is an option for LocalUniversalFA that can be 
used to select edges.  See LocalUniversalFA.
";
EmptyDFA::usage = "EmptyDFA[K] constructs a DFA that accepts the empty 
language over alphabet K.
";
EmptyQFA::usage = "EmptyQFA[M] tests whether the acceptance language 
of M is empty (essentially, by computing the accessible part).
";
Empty::usage = "Empty is a regular expression that denotes the empty 
set.
";
EpsElim::usage = "EpsElim is an option for StarFA and 
RegularExpressionToFA, EpsElim->False supresses epsilon elimination 
and returns an FA with epsilon moves.
";
EpsFreeQ::usage = "EpsFreeQ[M] tests whether an FA, SA or BEFA is epsilon-free.
";
EpsilonEliminationFA::usage = "EpsilonEliminationFA[M] converts a FA 
into an equivalent epsilon-free FA.  With option DoTrace->True it 
returns {m,t1,t2,t3} where m is the epsilon-free FA, t1 is a list of 
the epsilon transitions of M, t2 is a list of the non-epsilon 
transitions, and t3 represents the transitive, reflexive closure of 
t1. All are given as binary relations on the state set of M.
";
EquivalentQFA::usage = "EquivalentQFA[M1,M2] tests whether automata M1 
and M2 are equivalent.  For deterministic machines the union-find 
algorithm is used.  However, if the input is non-deterministic a 
conversion to a deterministic machine is performed, so the algorithm 
has potentially exponential space and time complexity.

";
EvolutionCA::usage = "EvolutionCA[C,X,t,opts] plots t (default: 40) 
steps in the evolution of pattern X under the global map of cellular 
automaton C.  The pattern is specified as a list, the default for X is 
a one-point seed generated by SeedConfiguration. Option Boundary 
controls boundary conditions. See also GlobalMapCA and OrbitCA.";
FactorialQFA::usage = "FactorialQFA[M,opts] tests whether the language accepted 
by FSM M is factorial (closed under factors).";
FA::usage = "FA[Q,K,T,I,F] denotes a general finite automaton.  Q is 
the number of states, K the alphabet, T a list of transitions 
{p,a,q}, I the set of initial states, and F the set of final states. 
Q may also be a list of objects. The entries in T, I and F are always 
in positional notation.";
FinalVectorFA::usage = "FinalVectorFA[M] computes the vector of final 
states of M, has option Boolean->True.
";
Final::usage = "Final[M] returns a list of the final state(s) of 
finite state machine M in positional notation.
";
FiniteComplementSA::usage = "FiniteComplementSA[w,opts] returns the canonical 
SA that accepts the language of all words not containing w as a factor. 
Option Normalize.";
FinLU::usage = "FinLU is an option for LocalUniversalFA that can be 
used to select final states.  See LocalUniversalFA.
";
Fixed::usage = "Fixed is an option for ToBlocks.
";
FLBound::usage = "FLBound is an option for LanguageFA in mode Full->True.
Defaultvalue  FLBound->50, limits the fixed point computation.";
FormatAutomata::usage = "FormatAutomata[fmt] controls formatting of the 
output form of finite state machines and graphs. FormatAutomata[None] turns off
all formatting. FormatAutomata[Some] supresses the structured part. 
FormatAutomata[Automatic] applies Short[#,$shortlines]& to potentially 
large parts of the expression. FormatAutomata[Full] prints a string such as \"-DFA-\".
";
FormatX::usage = "FormatX[b] where b = True formats X so X[i] prints in 
subscript notation. 
Mildly useful to display a system of linear equations over the language semiring. 
FormatX[False] turns formatting off. ";
FrontierQ::usage = "FrontierQ[L,K] test whether language L is a 
frontier over alphabet K.  Note that L is supposed to be prefix.
";
FrontierToDFA::usage = "FrontierToDFA[gamma,F] converts frontier 
automaton (gamma,F) into a DFA. gamma is a list of rewrite rules
(or word pairs), and F a list of words.
";
FSMQ::usage = "FSMQ[m] tests whether m is a finite state machine. 
Currently allowed headers for m: DFA, NFA, FA, SA, NNFA and BEFA.
";
FSurjectiveCA::usage = "FSurjectiveCA[C] tests whether a given 
surjective CA C is F-surjective.  C must be quiescent.
";
FullAlphabet::usage = "FullAlphabet[M] returns {k,KK} where k is the 
size of the proper alphabet of machine M and KK is the proper 
alphabet.
";
FullTransitionMatrixFA::usage = "FullTransitionMatrixFA[m,opts] returns the transitions
 of a machine expressed as a matrix over a semiring
 (integers, Boolean, or tropical).
";
FullTransitions::usage = "FullTransitions[M] returns the transition 
matrix (for DFAs and NFAs) or the labeled transition list (for all 
others), where M is a finite state machine.  The entries in a labeled 
transition list are of the {p,a,q} where p and q are states in 
positional notation, and a is a symbol from the alphabet of the 
automaton (or Eps.  See also Transitions.
";
FunctionToCA::usage = "FunctionToCA[f,w,k] constructs a CA of width w 
over alphabet {0,..,k-1} whose local map is given by f (f must be a 
w-ary function of integer arguments and return integer results in the 
proper range). See alse ToFunctionCA.
";
FunctionToDFA::usage = "FunctionToDFA[Q,K,del,q0,F,opts] returns the DFA determined 
by Q, K, del, q0 and F.  Here  del : Q x K --> Q  is a function. 
Option  Alphabetic->False  uses Range[k] instead of a list of letters.
Option Normalize.";
FunctionToSA::usage = "FunctionToSA[Q,K,del,opts] returns the SA determined 
by Q, K, and del.  Here  del : Q x K --> pow(Q)  is a function. 
Option  Alphabetic->False  uses Range[k] instead of a list of letters.
Option Normalize.";
GenerateDFA::usage = "GenerateDFA[q0,dot,K,fin] produces the cyclic 
semimodule generated by q0 and operation dot as well as the 
corresponding accessible DFA (whose final states are determined by 
predicate fin).  dot[p,s] must be an element of the semimodule p is an 
element of the semimodule and s is a symbol in the alphabet.  Returns 
the triple {Q,wit,M}.";
GenerateQuotients::usage = "GenerateQuotients[L,k] computes all 
quotients of a finite language L (over alphabet K).
";
GlobalMapCA::usage = "GlobalMapCA[f,C,opts] assigns the global map of 
cellular automaton C to symbol f.  Options are Boundary->Cyclic and WordMap->True.
";
HomomorphismFA::usage = "HomomorphismFA[M,hom,alph] generates an FA 
that accepts the image of the acceptance language of M under 
homomorphism hom.  The homomorphism is given as a list of words over 
the target alphabet alph. Alternatively, hom may be a homomorphism as 
defined by MakeHomomorphism.
";
Hopcroft::usage = "Hopcroft is an option for StateMergeDFA, causes 
Hopcroft's O(n lg n) algorithm to be used.  Note that in the internal 
implementation, the supposedly quadratic algorithm based on indexes is 
actually faster.
";
HurwitzProduct::usage = "HurwitzProduct[S1,S2] computes the Hurwitz 
product of two formal power series, see ToSeries.
";
IdealBaseFA::usage = "IdealBaseFA[M] constructs a DFA for the base of the language of M, 
assuming that this language forms an ideal; does not check. 
Use IdeaQFA[M] to verify that M is suitable input.";
IdealQFA::usage = "IdealQFA[M] tests whether the language of M forms an ideal. 
Use as test for IdeaBaseFA[M] to verify that M is suitable input.";
IdentityCA::usage = "IdentityCA[w,k] returns the CA whose global map 
is the identity map, properly centered.
";
Implementation::usage = "Implementation is an option for 
LanguageFA. Allow the user to select one of three algorithms.
";
InfiniteQFA::usage = "InfiniteQFA[M] tests whether the acceptance 
language of M is infinite.  Here M is required to be an NFA.
";
InfixFA::usage = "InfixFA[w,K] constructs an FA that accepts all words 
with infix w (over alphabet K).
";
IniLU::usage = "IniLU is an option for LocalUniversalFA, determines 
initial states. See LocalUniversalFA.
";
InitialVectorFA::usage = "InitialVectorFA[M] computes the vector of 
initial states of M, has option Boolean->True.
";
Initial::usage = "Initial[M] returns a list of the initial state(s) of 
finite state machine M in positional notation.
";
IntersectionFA::usage = "IntersectionFA[M1,M2,opts] generates a finite state machine 
that accepts the intersection of the acceptance languages of M1 and M2. 
Option Full->True constructs full product machine.
Option Normalize->1 preserves states Q1xQ2.";
InverseCA::usage = "InverseCA[C] computes the inverse of CA C. 
Make sure that C is in fact reversible, InverseCA does not check.";
IrreducibleFA::usage = "IrreducibleFA[W,K] returns the canonical tree 
automaton that accepte all words not containg a factor w from the the 
list W.  Option Full->True produces a machine that accepts all words 
of the form xw where w is in W.  The latter machine is used in WordReduce.
";
IsomorphicQDFA::usage = "IsomorphicQDFA[M1,M2] tests whether two DFAs 
M1 and M2 are isomorphic. Option DoTrace->True causes the isomorphism 
to be displayed (if it exists). Note that only the accessible part of 
the machines is considered.
";
IterateCA::usage = "IterateCA[C,t] iterates the CA C t-times.  Note 
that iteration produces an exponential blow-up in the size of the CA: 
the width is t(w-1)+1, where w is the width of $C$.
";
IthSymbolDFA::usage = "IthSymbolDFA[s,i,K] constructs a DFA for the 
language: all x whose i-th symbol is s (over alphabet K).
";
IthSymbolFA::usage = "IthSymbolFA[s,i,K] constructs an FA for the 
language: all x whose i-th symbol is s (over alphabet K).
";
JoinSA::usage = "JoinSA[M1,M2,A,opts] determines the join of two SAs. 
The states that are to be identified are specified in the list of pairs A. 
Option Normalize.";
LabelToCodeCA::usage = "LabelToCodeCA[CA[lab,w,k]] converts a CA from 
label to code form. The least significant digit of code number r is 
determined by the last element of list lab.
";
LanguageFA::usage = "LanguageFA[M,n] displays all words of length n 
accepted by M, (for negative n: all words up to length |n|).  
Option SizeOnly->True generates only the first n values of the growth function of the language.  
Option Multiplicity->True generates a multiset rather than a set for nondeterministic machines.  
Option MakeTrim->True transforms the automaton into a trim FA.  
Option Full->True generates all words accepted by a FSM, does not check first 
whether the acceptance language is finite (can use FLBound to control 
size of computation, default FLBound->50).  
Option Implementation->i selects and algorithm (i = 1,2,3 for deterministic 
machines and i = 1,2 for nondeterministic ones, default is i=1).";
LanguageSort::usage = "LanguageSort[LL] sorts a list LL of languages 
in natural order, also sorts the languages (uses WordSort).
";
LanguageToSeries::usage = "LanguageToSeries[L] adds multiplicities 1 
to a language L, generates a formal power series. See also ToSeries, 
HurwitzProduct.
";
LeftQuotient::usage = "LeftQuotient[w,L] computes the left quotient of 
a finite language L.
";
LeftShiftCA::usage = "LeftShiftCA[k] returns the left shift cellular 
automaton over alphabet k.
";
LengthDFA::usage = "LengthDFA[n,K] constructs a DFA for the language 
of all words x over alphabet K of length n.  For negative n, all words 
such that |x| <= |n| are accepted.  n can also be replaced by a list 
of non-negative integers.
";
ListAble::usage = "ListAble is an option for MakeHomomorphism.
";
$LLL::usage = "$LLL is a global parameter for the recursive language 
map in command LanguageFA with option Implementation->3 (only for 
DFAs).  Can be used to produce a trace of the algorithm.";
LocalMapCA::usage = "LocalMapCA[f,C,opts] assigns the local map of 
cellular automaton C to symbol f. 
Options are WordMap->True.
";
LocalUniversalFA::usage = "LocalUniversalFA[n,K,opts] generates the 
n-local-universal FA. Transitions, initial and final states are 
determined via options EdgeLU, IniLU and FinLU; the defaults are: 
True&. Supports option Normalize.
";
LoopAutomatonFA::usage = "LoopAutomatonFA[M] converts DFA M into a 
loop automaton.  Used in connection with the finite power property.
";
MakeHomoDFA::usage = "MakeHomoDFA[h,M1,M2] tests whether there is a 
homomorphism from DFA M1 to DFA M2. In case of success, h is the 
homomorphism; has attribute Listable.
";
MakeHomomorphism::usage = "MakeHomomorphism[f,A,B] makes symbol f a 
homomorphism defined by f[a_i] = b_i.  A must be an alphabet, B a list 
of words of the same length as A. Option Listable->True attaches the 
attribute Listable to the function.
";
MakeTrim::usage = "MakeTrim is an option for LanguageFA.  Causes the 
automaton to be replaced with its trim version before the language is 
computed.
";
MakeWord::usage = "MakeWord[a,i,b,j,...] generates the word a^ib^j ...";
MatrixToTransitions::usage = "MatrixToTransitions[n,K,A] converts a 
transition matrix A into the corresponding list of transitions, K 
denotes the alphabet.
";
MinimalFischerFA::usage = "MinimalFischerFA[M,opts] returns the minimal Fischer 
automaton associated with M.  FSM M must accept a transitive, factorial 
and extensible language for this to work, MinimalFischerFA does not check. 
Options are Full->True, Normalize and External.";
MinimizeDFA::usage = "MinimizeDFA[M] computes the minimal automaton of 
a DFA M using only internal code. Unlike MinimizeFA, this function 
does not handle nondeterministic machines and is useful mostly to 
produce traces of the minimization algorithm. The standard algorithm 
has quadratic time complexity, and option Hopcroft->True uses a O(n 
log n) algorithm, at least in theory. Other options are Normalize and 
DoTrace.
";
MinimizeFA::usage = "MinimizeFA[M,opts] computes the minimal automaton of a 
finite state machine M, using the external code whenever possible.  If 
M is nondeterministic, the power automaton is computed first, 
therefore the time and space complexity is potentially exponential. 
Option DoTrace generates a trace to the minimization process. 
Options Normalize, External.  See also MinimizeDFA.";
ModCounterDFA::usage = "ModCounterDFA[a,r,n,K] constructs a DFA for 
the language of all words x over alphabet K such that the number of 
a's in x is congruent r modulo n.
";
NFA::usage = "NFA[n,k,A,I,F,K,Q] denotes a non-deterministic finite 
automaton.  n is the number of states, k the alphabet size, A the 
transition matrix (format: k by n) whose entries are subsets of [Q], I 
the set of initial states, and F the set of final states.  K is the 
alphabet and Q the structured state set. The entries in A, I and F are 
always in positional notation.";
NNFAToFA::usage = "NNFAToFA[M,K] converts the tail M of an NNFA into the 
corresponding FA over alphabe K.
";
NNFA::usage = "NNFA[n,E,L,I,F,e] denotes the tail of a 
McNaughton-Yamada type finite automaton. Meaning of the fields: n: 
number of states (other than the virtual initial states), E: edges in 
the diagram, L: labels of the nodes, I: states at distance 1 from the 
initial state, F: final states, e: bit indicating whether Eps is accepted.";
NoFactorFA::usage = "NoFactorFA[M,opts] constructs an FA for the language of all words x 
in the acceptance language L of M such that no factor of x is also in L. 
Option Normalize.";
NoPrefixFA::usage = "NoFactorFA[M,opts] constructs an FA for the language of all words x 
in the acceptance language L of M such that no proper prefix of x is also in L. 
Option Normalize.";
NormalizeControl::usage = "NormalizeControl[] turns off normalization for 
finite state machines.  Equivalent to setting Normalize->2.  
Can be turned on with NormalizeControl[0].";
NormalizeFA::usage = "NormalizeFA[M] normalizes finite state machine M 
to have state set [n]. This will only affect the last, normally 
invisible field of the expression representing the automaton. 
See FormatAutomata[].
";
NoSuffixFA::usage = "NoSuffixFA[M,opts] constructs an FA for the language of all words x 
in the acceptance language L of M such that no proper suffix of x is also in L. 
Option Normalize.";
NumberOfCA::usage = "NumberOfCA[w,k] determinces the number of CAs of 
width w and an alphabet of size k.  See also NumberOfTotalisticCA.
";
NumberOfDFA::usage = "NumberOfDFA[n,k] computes the number of DFAs on 
n states and k symbols.
";
NumberOfTotalisticCA::usage = "NumberOfTotalisticCA[w,k] determinces 
the number of totalistic CAs of width w and alphabet {0,1,...,k-1}. 
See also ToTotalisticRuleCA and TotalisticRuleToCA.
";
NumTransitions::usage = "NumTransitions[M] returns the number of 
transitions in FSM M.
";
OrbitCA::usage = "OrbitCA[C,pat,t,opts] computes the orbit of pattern 
pat under application of the global map of cellular automaton C up to 
time t. Options are Boundary->Cyclic and External. The pattern pat can 
be string or a list. Note that currently the external code handles 
only lists.";
ParikhVector::usage = "ParikhVector[w,K] computes the Parihk vector of 
word w over alphabet K.
";
PermutationSA::usage = "PermutationSA[perm,K] constructs an SA from 
the list of permuations perm over alphabet K.
";
PermuteFA::usage = "PermuteFA[M,L] permutes the states of FSM M 
according to permutation L, a list of length Size[M].
";
PlotComputationFA::usage = "PlotComputationFA[M,x,opts] graphs the 
computation of FSM M on input x. Option ShowAll->False causes only 
persistent branches to be displayed.
";
PolynomialToCA::usage = "PolynomialToCA[pol,w,k] constructs a CA of 
width w over alphabet {0,..,k-1} whose local map is given by the 
polynomial pol.  The values of pol are taken modulo k. k has default 
2. See alse BFunctionToCA for conversion of boolean polynomials to 
CAs.
";
postload::usage = "postload[] sets some system parameters. 
Is executed automatically after the package is loaded.";
PrefixDFA::usage = "PrefixDFA[w,K] constructs a DFA that accepts all 
words with prefix w (over alphabet K).
";
PrefixQ::usage = "PrefixQ[x,y] tests whether word x is a prefix of 
word y.
";
preload::usage = "preload[] Is executed automatically before the package is loaded and 
provides a hook for actions to be taken before loading the automata packages.  
Defines in particular load messages. 
";
PrimitiveCount::usage = "PrimitiveCount[n,k] returns the number of 
primitive words of length n over a k symbol alphabet. Uses the 
built-in Moebius function.
";
PrimitiveQ::usage = "PrimitiveQ[w] tests whether word w is primitive, 
i.e, not the power of a shorter word. Uses built-in StringPosition.
";
PrintCA::usage = "PrintCA[C] pretty-prints the local function of 
cellular automaton C as a table of replacement rules.
";
PrintFA::usage = "PrintFA[M] pretty prints a finite state machine M. 
Option Full->True tries to print non-normalized state sets. 
Option TransOnly->True only prints the transitions.
";
ProductFA::usage = "ProductFA[M1,M2] computes the product automata M1 
and M2. Note that the full product machine is generated, not just the 
accessible part. Option Normalize->1 prevents normalization.";
ProductTransitions::usage = "ProductTransitions[T1,T2,k] computes the 
product of transition lists T1 and T2 over an alphabet of size k.  The 
new transitions are of the form ((p,q),a,(p',q')) where (p,a,p') is a 
transition in T1 and (q,a,q') is a transition in T2.  
Option Full->1 identifies (p,q) and (q,p), 
option Full->2 identifies (p,q) and (q,p) and omits the diagonal (p,p). 
";
ProperPrefixes::usage = "ProperPrefixes[W] computes the set of all 
proper prefixes of the finite language W. On frontiers, this operation 
is the inverse to ToPrefix. If W is only prefix but not right closed, 
the corresponding set would be \SS - W \SS and therefore infinite.
";
QuotientDFA::usage = "QuotientDFA[L,K] computes the quotient automaton 
of a finite language L (over alphabet K). The resulting DFA is 
minimal.  Also used in BuildDFA.";
QuotientMachineFA::usage = "QuotientMachineFA[M1,M2] computes an FA 
for the language: all words y such that there is a word x in L(M1) 
such that xy is in L(M2).  Supports option Normalize.
";
RandomDFA::usage = "RandomDFA[n,K] produces a random DFA over alphabet 
K on n states.  All fields of the machine are chosen uniformly.
";
RandomWord::usage = "RandomWord[n,K] produces a random word over 
alphabet K of length n.  Symbols are chosen uniformly.
";
RankOfDFA::usage = "RankOfDFA[M] computes the rank of the DFA M with 
respect to the canonical enumeration, see also RankToDFA.
";
RankToDFA::usage = "RankToDFA[r,n,k] computes the DFA of rank r on n 
states and k symbols with respect to the canonical enumeration, see 
also RankOfDFA.
";
REEpsQ::usage = "REEpsQ[exp] tests whether the language denoted by 
regular expression exp contains Eps.  The regular expression must be 
proper, i.e., it must be built solely from the headers REP, RES and 
RET but cannot contain arithmetic operators such as Plus and 
NonCommutativeMultiply. Convert with ToRegExp if necessary.
";
RegExpSimp::usage = "RegExpSimp is an option for 
ToRegularExpressionFA.  Forces Kleene's algorithm to be used without 
simplification.  Do not use on machines with more than about 6 
states.
";
$regexrules::usage = "$regexrules is a set of simplification rules for 
regular expressions.  The rules are definied in automata.m and 
can be augmented by the user.  Make sure not to introduce any cycles, 
though.  Used automatically in ToRegExp.";
RegularExpressionToBEFA::usage = "RegularExpressionToBEFA[exp] 
computes the BEFA for regular expression exp.
";
RegularExpressionToFA::usage = "RegularExpressionToFA[exp,K] computes 
an FA for regular expression exp over alphabet K.  Option 
Thompson->True will build a Thompson style FA with 
epsilon-moves. Option EpsElim->True constructs a Thompson style FA and 
performs eps-elimination.  Option SizeOnly->True will return the size 
of the FA without computing it.";
RegularExpressionToNNFA::usage = "RegularExpressionToNNFA[exp] computes the NNFA for regular expression exp.
";
RemoveTransitionFA::usage = "RemoveTransitionFA[M,p,w,q] removes the 
transition {p,w,q} from M.  Here w may be a symbol or an integer. 
Can also be used in the form RemoveTransitionFA[M,{p,w,q}] or 
RemoveTransitionFA[M,L] where L is a list of transitions.  See also 
AddTransitionFA[M,{p,w,q}].
";
REP::usage = "REP is a header for regular expressions, denotes union.  
REP is polyadic.";
REQ::usage = "REQ[w,exp] computes the left quotient rational 
expression w^{-1} exp.  Here exp is a proper rational expression and w 
is a word.  Note that no attempt at simplification is made (neither 
for the result nor for the intermediate expressions when |w|>1). 
Thus, the size of the expressions may grow exponentially.
";
RESimplify::usage = "RESimplify[exp] tries to simplify the regular 
expression exp using the rules defined in $regexrules.
";
RES::usage = "RES is a header for regular expressions, denotes Kleene 
star.  RES is unary.";
RET::usage = "RET is a header for regular expressions, denotes 
concatenation.  RET is polyadic.";
ReverseFA::usage = "ReverseFA[M] reverses a FSM M by flipping 
transitions and interchanging initial and final states. Result is an 
FA or SA.
";
RightShiftCA::usage = "RightShiftCA[k] returns the right shift over alphabet k.";
SA::usage = "SA[n,k,T,K,Q] denotes a semi automaton.  n is the number 
of states, k the alphabet size, T a list of transitions {p,a,q}, K 
the alphabet, and Q the structured state set (any list of length 
n). The entries in T are always in positional notation.  All states 
are considered initial and final.";
SelectFA::usage = "SelectFA[M,L] computes the subautomaton of M 
induced by the states in list L (positional notation).  Supports 
option Normalize.
";
SetFinalFA::usage = "SetFinalFA[M,F] returns FSM M with final states 
changed to F.  SAs are converted to FAs.
";
SetInitialFA::usage = "SetInitialFA[M,I] returns FSM M with initial 
states changed to I. SAs are converted to FAs.
";
SetInitialFinalFA::usage = "SetInitialFA[M,I,F] returns FSM M with 
initial states changed to I and final states changed to F. SAs are 
converted to FAs.";
$shortlines::usage = "$shortlines is the second argument given to 
Short[] when a long field of a finite state machine (or a graph) is 
printed in its short form. See also $shortlength.";
ShowAcceptQFA::usage = "ShowAcceptQFA[x,M] produces a trace of the 
computation of machine M on input x, pipe through MatrixForm.
";
ShowAll::usage = "ShowAll is an option for PlotComputationFA, displays 
all steps in the computation. If set to False only persistent paths 
are shown.
";
ShowEdges::usage = "ShowEdges is an option for PlotComputationFA, 
returns the edges of the computation graph rather than a graphics 
object.
";
ShrinkCA::usage = "ShrinkCA[C] eliminates the initial and final 
segment of variables that are superfluous in cellular automaton C, if 
any. Option Full->True also returns the number of deleted variables.
";
ShuffleProductFA::usage = "ShuffleProductFA[M1,M2] generates a finite 
state machine that accepts the shuffle product of the acceptance 
languages of FSMs M1 and M2.
";
SinkQDFA::usage = "SinkQDFA[M] tests whether DFA M is a sink 
automaton, i.e., whether the only non-final state of M is a trap state.
";
SinksDFA::usage = "SinksDFA[M] returns a list of all sinks in DFA M 
(in positional notation).  See also TheSinkDFA.
";
SizeOnly::usage = "SizeOnly is an option in RegularExpressionToFA that 
returns only the size of the FA without computing the whole machine. 
Similarly as an option in LanguageFA it generates a list of the first 
n values of the growth function of the language.
";
Size::usage = "Size[M] returns the number of states of machine M.
";
Some::usage = "Some is an option for FormatAutomata.
";
SquareSA::usage = "SquareSA[M] computes the product semiautomaton of 
semiautomaton M with itself. Option Full->1 generates only the 
part below and including the diagonal. Option Full->2 generates only the 
part below the diagonal. Option Normalize->1 prevents normalization.";
StarFA::usage = "StarFA[M] generates a FA that accepts the Kleene star 
of the acceptance languages of M. Options are Normalize->1 and 
EpsElim->False.
";
StateMergeDFA::usage = "StateMergeDFA[M,L] performs state-merging on a 
DFA M according to the equivalence relation represented by list L (an 
index, as produced for example by MakeIndex). No tests are performed 
to check if L is admissible with respect to M.
";
States::usage = "States[M] returns the state set of finite state 
machine M (in structured form if available, otherwise a list [n]).
";
SubsetQFA::usage = "SubsetQFA[M1,M2] tests whether the acceptance 
language of M1 is a subset of the acceptance language of M2.  Uses 
ToDFA if input is non-deterministic and therefore has potentially 
exponential space and time requirement.
";
Substitute::usage = "Substitute[eq1,eq2] substitutes a linear equation 
eq2 over the language semiring into eq1. Used in conjunction with Arden.
";
SubwordCounterDFA::usage = "SubwordCounterDFA[w,p,K] constructs a DFA 
that accepts all words x such that WordBinomial[x,w]=p (over alphabet K). 
Option Normalize->1.";
SubwordDFA::usage = "SubwordDFA[w,K] constructs a DFA that accepts all 
words that contain subword w (over alphabet K).
";
SubwordModCounterDFA::usage = "SubwordModCounterDFA[w,r,p,K] 
constructs a DFA that accepts all words x such that 
WordBinomial[x,w]=r modulo p (over alphabet K). Supports option Normalize.
";
SuffixesFA::usage = "SuffixesFA[w,K] constructs an FA that accepts all 
suffixes of word w (over alphabet K).
";
SuffixFA::usage = "SuffixFA[w,K] constructs an FA that accepts all 
words with suffix w (over alphabet K).
";
SumFA::usage = "SumFA[M1,M2,opts] computes the disjoint sum of two 
machines M1 and M2.  Unlike UnionFA the output automaton is always nondeterministic.
SumFA is polyadic. Option Normalize->1 preservers the state 
set as a disjoint union.
";
SwitchTransitionFA::usage = "SwitchTransitionFA[M,p,q] switches the 
transition {p,w,q} in M to {p,w+1,q}.  Here w+1 is the successor 
of w in the alphabet of the machine. Can also be used in the form 
SwitchTransitionFA[M,{p,q}] or SwitchTransitionFA[M,L] where L is a 
list of pairs of states. See also AddTransitionFA[M,{p,w,q}] and 
RemoveTransitionFA[M,{p,w,q}].
";
SyntacticCongruence::usage = "SyntacticCongruence[M,r] determines the 
syntactic congruence classes of all words of length up to r.  Can also 
be used in the form SyntacticCongruence[gen,alph,r] where gen is a 
list of generators for the transition semigroup of M.
";
SyntacticHomomorphism::usage = "SyntacticHomomorphism[f,M] computes 
the syntactic homomorphism f : K^* --> S from the set of all words to 
the syntactic semigroup S of DFA M.
";
SyntacticSG::usage = "SyntacticSG[M] generates the transition 
semigroup of M.  Make sure to minimize M to obtain the syntactic 
semigroup of the acceptance language of M.
";
TheInitial::usage = "TheInitial[M] returns the initial state of a DFA 
M in positional notation.
";
TheSinkDFA::usage = "TheSinkDFA[M] tests whether DFA M contains a 
sink, returns the position of the first in the state list, or 0 if no 
sink exists.
";
Thompson::usage = "Thompson is an option in RegularExpressionToFA.  By 
default, Thompson has value False and a McNaughton-Yamada type machine 
is used in the conversion.
";
ToBlocks::usage = "ToBlocks[L,w,opts] partitions a list L into a list of 
overlapping blocks of width w (with offset 1).  Has default 
Boundary->Cyclic, alternatively Fixed, a padding element, or None. 
Also works when L is a word rather than a list, returns a list of words.
";
ToCharacters::usage = "ToCharacters[w] converts symbols and strings to 
a list of atomic characters (like built-in command Characters for 
strings only). Behaves properly with respect to Eps.
";
ToDFA::usage = "ToDFA[M] converts an FA, NFA or SA to an equivalent 
DFA.  Option Normalize->1 preserves states as elements of power set of 
[n], where n is the size of M . Option Normalize->2 preserves states 
as elements of power set of Q, where Q is the state set of M. Note the 
in particular the last option may increase the size of the date 
structure representing the automaton considerably (internally as well 
as externally). In the internal implementation, option Full->True 
produces the full power automaton.
";
ToEquationsDFA::usage = "ToEquationsDFA[M] converts DFA M into a 
system of equations.
";
ToFA::usage = "ToFA[M] converts a FSM to an equivalent FA. If M is a 
semiautomaton all states will be initial as well as final.  Also 
converts a CA to the corresponding de Bruijn automaton.";
ToFrontierDFA::usage = "ToFrontierDFA[M] converts DFA M into the 
corresponding frontier automaton.
";
ToGeneratorsFA::usage = "ToGeneratorsFA[M] converts the transition 
matrix of a DFA into a list of generators for the transition semigroup 
of the machine.
";
ToGraphFA::usage = "ToGraphFA[M] converts a finites state machine M 
into the underlying transition diagram: a directed graph with point 
set Q. Option Unlabeled->False generates a labeled edge list.
";
ToIndex::usage = "ToIndex[w,K] converts a word over a sorted alphabet 
K to the corresponding list of indexes. Thus ToIndex[abb,{a,b@]} 
evaluates to {1,2,2}.
";
ToKernelFA::usage = "ToKernelFA[M,L,opts] generates the kernel 
automaton of M generated from the states in list L. The entries in 
L can be single integers in [n], where n is the size of M, or lists 
of such integers. The default for L is {{p1},...,{pm}} where 
the pi are the initial states of M.  Supports option Normalize.";
ToLabelCA::usage = "ToLabelCA[C] ...
";
ToMatrix::usage = "ToMatrix is an option for ConvertToFA.  Transforms 
a list of transformations into a transition matrix, as needed for DFAs 
and NFAs.
";
ToNFA::usage = "ToNFA[M] converts FSM M to an equivalent NFA.  If M is 
a semiautomaton all states will be initial as well as final.";
ToPeriodicFrontierDFA::usage = "ToPeriodicFrontierDFA[M] converts DFA 
M into the corresponding periodic frontier automaton.
";
ToPrefixFA::usage = "ToPrefixFA[M] converts a FSM into a machine that 
accepts the language of all prefixes of words in the language of M.
";
ToPrefix::usage = "ToPrefix[W,K] computes the prefix set corresponding 
to the finite language W over alphabet K. The algorithm actually 
computes W K - W. On prefix-closed sets, this operation is the inverse 
to ProperPrefixes.
";
ToRegExp::usage = "ToRegExp[exp] converts an expression containing 
arithmetic operators + and ** (Plus and NonCommutativeMultiply) into 
the corresponding regular expression containing only headers REP, RET 
and RES. This conversion is used automatically in all commands 
operating on regular expressions.";
ToRegularExpressionFA::usage = "ToRegularExpressionFA[M] uses Kleene's 
algorithm to convert an FA into an equivalent regular expression. 
Option RegExpSimp->False turns the built-in simplification rules off. 
The simplification rules are stored in $regexrules and can be 
augmented by the user. Use only on small machines.
";
ToRulesCA::usage = "ToRulesCA[C] converts the local map of a cellular 
automaton C into a corresponding list of Mathematica replacement 
rules. Option WordMap->False produces replacement rules for lists 
rather than words.
";
ToSA::usage = "ToSA[M] converts a FSM to the corresponding 
semiautomaton by stripping off initial and final states (and 
converting to a list of transitions if necessary).  Also converts a CA 
to the corresponding de Bruijn semiautomaton.";
ToSeries::usage = "ToSeries[L] converts a list L with multiplicities 
into a formal power series of words with integer coefficients.  Uses 
Hold to bypass Mathematica's sorting algorithm.
";
ToSuffixFA::usage = "ToSuffixFA[M] converts a FSM into a machine that 
accepts the language of all suffixes of words in the language of M.
";
TotalisticRuleToCA::usage = "TotalisticRuleToCA[r,w,k] produces the 
ordinary CA with totalistic rule number r and width w. The alphabet is 
always of the form {0,1,...,k-1}).  See also ToTotalisticRuleCA.
";
ToTotalisticRuleCA::usage = "ToTotalisticRuleCA[C] determines the 
totalistic rule number r of a given CA C. No test is performed.  See 
also TotalisticRuleToCA.
";
ToTransitions::usage = "ToTransitions[L,K] translates a list of 
transitions with string labels into a proper transition list in 
positional notation with respect to alphabet K.
";
ToWord::usage = "ToWord[L,K] converts a list of indexes to the 
corresponding word over sorted alphabet K (default alphabet is $alphabet).  
Thus ToWord[{1,2,2},{a,b}] evaluates to abb.";
$transdispwidth::usage = "$transdispwidth controls the number of 
transitions displayed in one row in PrintFA.  Default is 20.";
TransferSequenceFA::usage = "TransferSequenceFA[M,S,T] computes a 
shortest word x (in length-lex order) that leads to state t from state 
s in machine M, if such a word exists, for (s,t) in S \times T. 
Default for S is Initial[M] and for T Final[M]. The output is given as 
a S \times T matrix of words.  A dash in position (s,t) indicates that 
there is no computation im M from s to t.
";
TransitionFunctionFA::usage = "TransitionFunctionFA[M,delta,opts] 
assigns to delta the transition function Q \times A^* \to Q (which may 
be multi-valued for nondeterministic machines).  Option Full->True 
causes delta to compute a whole trace of the computation.
";
TransitionMatrixFA::usage = "TransitionMatrixFA[M,f,opts] constructs 
the natural homomorphism from all words to matrices over a semiring R.
The default for R is the semiring of natural numbers.
Option Type->Boolean selects the Boolean semiring, and option 
Type->Tropical selects the tropical semiring. Note that Boolean 
matrices are implemented as binary matrices (see Boolean).
";
TransitionsToMatrix::usage = "TransitionsToMatrix[n,K,T] converts a 
list of transitions T into the corresponding k by n matrix, where k is 
the alphabet size.  If the transitions are deterministic and complete 
a matrix for a DFA is produced (an integer matrix of depth 2), 
otherwise the matrix for an NFA is computed (an integer matrix of 
depth 3).
";
Transitions::usage = "Transitions[M] returns the transition matrix 
(for DFAs and NFAs) or transitions list (for all others), where M is a 
finite state machine. The entries in a transition list are of the 
{p,a,q} where p and q are states, and a is a symbol.  All are given 
in positional notation, and Eps is represented by 0.  See also 
FullTransitions.
";
TransitiveLangQFA::usage = "TransitiveLangQFA[M] tests whether the language 
accepted by M is transitive.  Assumes that M is factorial, does not check.   
Option External.";
TransitiveQFA::usage = "TransitiveQFA[M,opts] tests whether M is transitive.  
Option DoTrace->True causes the strongly connected components of the transition 
diagram of M to be displayed.";
TransOnly::usage = "TransOnly is an option for PrintFA, if set to True 
only the transitions will be printed.
";
TrimFA::usage = "TrimFA[M] constructs the trim part of FA M: only 
states that are accessible from Initial[M] and coaccessible from 
Final[M] are retained.  Can also be used as TrimFA[M,S,T] where S and 
T are arbitrary lists of source and target states.
";
TropicalIdentityMatrix::usage = "TropicalIdentityMatrix[n] generates 
the n by n identity matrix in the tropical semiring. The display 
format of TS[Infinity] is I, and TS[x] is displayed as x for all 
natural numbers x.
";
Tropical::usage = "Tropical is an option for TransitionMatrixFA, 
matrix is generated over the tropical semiring. See also 
LoopAutomatonFA.
";
TS::usage = "TS[x] denotes an element in the tropical semiring; x is a 
non-negative integer or Infinity. The arithmetic operations Plus, 
Times and Power work as usual.";
UnionFA::usage = "UnionFA[M1,M2] generates a finite state machine
that accepts the union of the acceptance languages of M1 and M2.  Uses
a product machine construction for DFAs and disjoint union for other
machines.  Unlike with SumFA the output machine is deterministic
when the input machines are so deterministic.
Option Full->True constructs full product machine,
option Normalize->1 preserves state set Q1 \times Q2.  UnionFA is polyadic.
";
Unlabeled::usage = "Unlabeled is an option for ToGraphFA, causes an 
unlabeled graph to be generated.
";
VerifyFA::usage = "VerifyFA[M] checks if M is properly constructed. 
Recommended if a machine is constructed 'by hand'. Currently, VerifyFA 
is quite feeble and needs improvement.
";
WelchCA::usage = "WelchCA[C,opts] computes the Welch indices of a surjective cellular automaton C.  
Make sure that C is in fact surjective, WelchCA does not check. 
Option Full->True also produces the actual Welch automata.";
WidthCA::usage = "WidthCA[C] returns the width of a cellular automaton C.
";
WordBinomial::usage = "WordBinomial[u,v] generalizes binomial 
coefficients to words, counts the number of subwords v in u.  Option 
DoTrace->True shows values for all prefixes of u and v.
";
WordConjugateQ::usage = "WordConjugateQ[u,v] tests whether words u and v are conjugates.
";
WordConjugates::usage = "WordConjugates[w] generates all conjugates of 
a word w. Is listable.
";
WordFactorizations::usage = "WordFactorizations[w] generates all 
factorizations uv of a word w, returns a list of pairs {u,v} such 
that w = uv.
";
WordFactors::usage = "WordFactors[w] generates a list of all factors 
of word w. Returns output in length-lex order. Is listable.
";
WordFusion::usage = "WordFusion[u,v,r] returns the r-fusion of words u 
and v.  The input must have length at least r (default r=1).  Returns 
Null if the fusion of the two input words is undefined.
";
WordLength::usage = "WordLength[w] computes the length of word w very 
much like StringLength but accepts symbols as input and treats the 
empty word Eps properly.
";
WordMap::usage = "WordMap is an option for ToRulesCA, default is True, 
False causes a list substitution table to be generated.";
WordOrder::usage = "WordOrder[u,v] returns -1,0,+1 depending on the 
position of u and v in the length-lex order: u is less than v in the 
length-lex order if the length of u is less than the length of v, or 
if u and v have the same length but u precedes v lexicographically. 
This order is used in many algorithms and in particular in the 
semimodule generation algorithm, see GenerateCSM.
";
WordPower::usage = "WordPower[w,k] returns word ww...w (k times).
";
WordPrefixes::usage = "WordPrefixes[w] generates all prefixes of w, 
sorted by WordSort. Also works on lists of words.  See also 
ProperPrefixes.
";
WordReverse::usage = "WordReverse[w] reverses the word w like 
StringReverse but accepts symbols as input and treats Eps properly.
";
WordRoot::usage = "WordRoot[w] computes the root of a word w, i.e., 
the shortest word u such that w is a power of u.
";
WordRotate::usage = "WordRotate[w,n] rotates the word w by n places to 
the left and treats Eps properly. n has default 1.
";
WordShuffle::usage = "WordShuffle[u,v] generates the shuffle language 
u || v.  Also accepts lists of words as input.
";
WordSort::usage = "WordSort[L] sorts a list L of words in length-lex 
order: first by length, then lexicographically.  For example, on 
alphabet {a,b} the order is Eps, a, b, aa, ab, ba, bb, aaa, aab ... 
See also WordOrder.
";
WordSuffixes::usage = "WordSuffixes[w] generates all suffixes of w, 
sorted by WordSort. Also works on lists of words.
";
Words::usage = "Words[r,K] produces a list of words of length r over 
alphabet K (default K = $alphabet). For negative r all words up to 
length -r are generated.  One symbol alphabets produce a flattened list.
";


Begin["`Private`"];


Options[AcceptQFA]={DoTrace->False, Multiplicity->False};

AcceptQFA[ M_DFA, xx_?WordQ, opts___?OptionQ ] := 
Block[  {A,tr,f},
     A  = Transitions[M];
     
     (*  f: transition function of M *)
     f[p_,a_] := f[p,a] = A[[a,p]];   
     tr = FoldList[ f, TheInitial[M], ToIndex[xx,Alphabet[M]] ];
     
     If[ DoTrace /. {opts} /. Options[AcceptQFA], 
     	States[M][[tr]], 
     	MemberQ[ Final[M], Last[tr] ] 
     ]
];

AcceptQFA[ M_NFA, xx_?WordQ, opts___?OptionQ ] := 
Block[  {A,tr,f},

     If[ Multiplicity /. {opts} /. Options[AcceptQFA], 
     	Return[ acceptmult[ToFA[M],xx] ] ];

     A  = Transitions[M];

     (*  transition function of M *)
     f[p_,a_] := f[p,a] = Union[ Flatten[ A[[a,p]] ]];   
     tr = FoldList[ f, Initial[M], ToIndex[xx,Alphabet[M]] ];
     
     If[ DoTrace /. {opts} /. Options[AcceptQFA], 
         (States[M][[#]])& /@ tr,
         Length[ Intersection[ Last[tr], Final[M] ] ] > 0
     ]
];


AcceptQFA[ M_FA|M_SA, xx_?WordQ, opts___?OptionQ ] := 
     AcceptQFA[ ToNFA[M], xx, opts ];

acceptmult[M_,xx_] :=
Module[ {n,ff}, 
     n = Size[M];
     TransitionMatrixFA[ M, ff ];    
     ToBitVector[Initial[M],n].ff[xx].ToBitVector[Final[M],n]
];




Options[AccessibleFA]={Normalize:>$defaultnormalize, External:>$defaultexternal};

AccessibleFA[ M_?FSMQ, opts___?OptionQ ] := 
Module[  {k,KK,n,Q,nacc,visit,hh,dfs,dfsact,count,
acc,Ini,A,A1,tr,F1,I1,adjlist,norm}  ,
     norm = Normalize /. {opts} /. Options[AccessibleFA];
     
     If[ (External /. {opts} /. Options[AccessibleFA]) && Head[M]===DFA,
         Return[ Automata`extaut`ExtAccessibleFA[M,opts] ] ];

     n = Size[M];
     {k,kk,KK} = GetAlphabet[M];
     Ini = Initial[M];
     Attributes[visit]={Listable};
     Attributes[hh]={Listable};
     adjlist = Edges@ToAdjList@ToGraphFA[M];
     
     visit[_]=0;
     count = 1;
     dfs[z_Integer] := 
      ( If[ visit[z]==0,  visit[z]=count; hh[count++]=z ];
     Scan[ dfsact, adjlist[[z]] ]);
     dfsact[z_Integer] := 
        If[ visit[z]==0, visit[z]=count; hh[count++]=z; dfs[z] ];

     Scan[ dfs, Ini ];
       
     acc  = hh[Range[count-1]];
     nacc = Length[acc];

     If[ Head[M]===FA || Head[M]===SA,
         AA = Select[ Transitions[M], (visit[#[[1]]] > 0)& ];
         tr = Length[AA];
         AA = MapAt[ visit, AA,
                    Join[CartesianProduct[Range[tr],{1}],
                    CartesianProduct[Range[tr],{3}]] ],
     (* else *)     
         A  = Thread[Transitions[M]]; 
         AA = Thread[ Map[visit,A[[acc]],{2}] ]
     ];
     F1 = visit[Intersection[acc,Final[M]]];
     I1 = visit[Ini];

     res = Switch[ Head[M],
       DFA,      DFA[ nacc, kk, AA, I1[[1]], Sort[F1], KK, {} ],
       NFA|FA,    FA[ nacc, kk, AA, Sort[I1], Sort[F1], KK, {} ],
       SA,        SA[ nacc, kk, AA, KK, {} ]
     ];

    Switch[ norm,
       0, res, 
       1, ReplacePart[ res, acc, -1 ],
       2, ReplacePart[ res, States[M][[acc]], -1 ]
     ]
];



Options[AddTransitionFA]={};

AddTransitionFA[ m_FA|m_SA, p_Integer, w_?WordQ, q_Integer ] := 
Module[ {n,nn,ww,P,tr,alph},
     alph = Alphabet[m];
     n  = nn = Size[m];
     If[ p>n, nn++ ];
     If[ q>n, nn++ ];
     lw = WordLength[w];
     If[ lw <= 1, 
         ww = If[ lw==0, 0, PositionOne[Alphabet[m],ToString[w]] ]; 
         res = ReplaceParts[ m, Join[Transitions[m],{{p,ww,q}}], 3, nn, 1],
     (* else: word longer than 1 *)
         ww = ToIndex[w,alph]; 
         nn += lw - 1;
         P  = Thread@Partition[ Join[ {p}, Range[n+1,nn], {q} ], 2, 1 ];
         tr = Thread[ { First@P, ww, Last@P } ];
         res = ReplaceParts[ m, Join[Transitions[m],tr], 3, nn, 1 ];
     ];
     If[ MinusEins[m]==={}, 
         res,
         ReplacePart[ res, Join[States[m],Range[n+1,nn]], -1 ]
     ]
];

AddTransitionFA[ m_FA|m_SA, p_Integer, w_Integer, q_Integer ] := 
    AddTransitionFA[ m, p, ToWord[{w},Alphabet[m]], q];  (* terrible *) 
AddTransitionFA[ m_FA|m_SA, {p_Integer, w_?WordQ, q_Integer} ] := 
     AddTransitionFA[ m, p, w, q ];
AddTransitionFA[ m_FA|m_SA, tr:{___List} ] := 
     Last@FoldList[ AddTransitionFA, m, tr ];




Options[AllDFA]={Full->True};

Options[AllDFA]={Full->True};

AllDFA[ K_:$alphabet, opts___?OptionQ ] := 
If[ Full /. {opts} /. Options[AllDFA],
    DFA[1, AlphabetSizeS[K], Table[{1},{AlphabetSize[K]}], 1, {1},
	  MakeShortAlphabet[K], {} ],
    DFA[2, AlphabetSizeS[K], Table[{2,2},{AlphabetSize[K]}], 1, {2}, 
	MakeShortAlphabet[K], {} ]
];


Options[Alphabetic]={};

Options[AlphabetSize]={};

AlphabetSize[k_Integer]   := Abs[k]; 
AlphabetSize[K_List]      := Length[K]; 
AlphabetSize[M_?FSMQ]     := Abs@Zwei[M];
AlphabetSize[C_CA]        := Abs@Drei[C];

AlphabetSizeS[k_Integer]  := k; 
AlphabetSizeS[K_List]     := Length[K]; 

MakeShortAlphabet[k_Integer] := {};
MakeShortAlphabet[K_List] := ToString /@ K;

GetAlphabet[M_?FSMQ] := { Abs@Zwei[M], Zwei[M], MinusZwei[M] };

(* FullAlphabet for machines, words, and lists of words *)
$alphabet = 2;
Options[Alphabet]={};

Alphabet[ M_?FSMQ ] := If[ MinusZwei[M]=!={}, MinusZwei[M],  MakeAlphabet@Zwei[M] ];
Alphabet[ C_CA ] := MakeAlphabet@Drei[C];

Alphabet[ "Eps"|Eps|Global`\[Epsilon] ] = {};
Alphabet[ w_?WordQ ] := Union@Characters@ToString[w];
Alphabet[ W_List ]   := Union@Flatten[ FullAlphabet /@ W ];

Options[AmbiguousQFA]={Full->False, External:>$defaultexternal};

AmbiguousQFA[m_?FSMQ,opts___?OptionQ] := 
Module[{ss,g,V,dia,rdia,rrdia,tt},

	If[ DeterministicQFA[m], Return[False] ];

        ss = SquareSA[ ToSA[m], Full -> 1, Normalize -> 1]; 
        g = ToGraphFA[ss, Normalize -> 2]; 
        V = VertexSet[g]; 
        dia = PositionList[V, Cases[V, {x_, x_}]]; 
        rdia = Complement[WeaklyConnectedComponents[g, dia], dia]; 
        rrdia = Intersection[WeaklyConnectedComponents[g, rdia], dia];
	tt  = rrdia =!= {};
	If[ Full /. {opts} /. Options[AmbiguousQFA],
	    {tt,ss}, tt ]
];
     

Options[Arden]={};

Arden[ Equal[LS_,RS_] ] :=
Module[ {mc,ac},
     mc = Select[RS,!FreeQ[#,LS]&];
     mc = mc //. distrib;
     mc = mc //. $regexrules;
     mc = mc //. RET[x__,LS]:>RET[x];
     mc = mc //. $regexrules;
     ac = Select[RS,FreeQ[#,LS]&];
     ac = ac //. $regexrules;
     Equal[LS, RET[RES[mc],ac] //. $regexrules ]
];


distrib = RET[x__,REP[z1_,z2__]] :> REP[RET[x,z1],RET[x,REP[z2]]];


Options[$automataReleaseNumber]={};

$automataReleaseNumber = "4.6";

Options[BEFA]={};

unionBEFA[ M1_BEFA, M2_BEFA ] := 
Module[ {n1, n2, T1, T2},
     n1 = Size[ M1 ];
     n2 = Size[ M2 ];
     T1 = Transitions[M1] /. {x_Integer,s_,n1} :> {x,s,n1+n2-2} ;
     T2 = Transitions[M2] /. {x_Integer,s_,y_Integer} :> {x+n1-2,s,y+n1-2};
     T2 = T2 /. {n1-1,s_,y_Integer} :> {1,s,y};
     BEFA[ n1+n2-2, Union[T1,T2] ]
];
unionBEFA[ M1_BEFA, M2_BEFA, z___BEFA ] := 
      unionBEFA[ unionBEFA[ M1, M2 ], z ];
      
concatenateBEFA[ M1_BEFA, M2_BEFA ] := 
Module[ {n1,n2,T1,T2},
     n1 = Size[M1];
     n2 = Size[M2];
     T1 = Transitions[M1];
     T2 = Map[ shiftrans[n1-1,n1-1,#]&, Transitions[M2] ];
     BEFA[ n1+n2-1, Union[T1,T2] ]
];
concatenateBEFA[ M1_BEFA, M2_BEFA, z___BEFA ] := 
     concatenateBEFA[ concatenateBEFA[ M1, M2 ], z ];
      
starBEFA[ M_BEFA ] := 
Module[ {n, Tr},
     n = Size[ M ];
     Tr = Map[ shiftrans[1,1,#]&, Transitions[M] ];
     BEFA[ n+2, Union[Tr,{{1,"Eps",2},{n+1,"Eps",2},{2,"Eps",n+2}}] ]
];


BehaviorFA[ M_?FSMQ, p_Integer?Positive, r_Integer ] := 
    LanguageFA[ MinimizeFA@SetInitialFA[M,{p}], r ];


Options[BFunctionToCA]={};

BFunctionToCA[ ff_, w_Integer ] := 
Module[ {rules,bfct,lab},
    rules =  Join[ Thread[ SymbolList["xx",w]->Not/@SymbolList["x",w] ], 
                           {Plus->Or, Times->And} ];
    bfct = Function[ Evaluate[SymbolList["x",w]], Evaluate[ff /. rules] ];
    lab  = Apply[ bfct, Reverse@KPermutationsR[2,w]/.{1->False,2->True}, 1 ] /. {False->0,True->1};
    CA[ FromDigits[lab,2], w, -2 ]
];

$bottom = -1;
Options[Boundary]={};

Options[BuildBEFA]={};

BuildBEFA[Empty]      := BEFA[2,{}];
BuildBEFA[Eps|"Eps"|Global`\[Epsilon]]  := BEFA[2,{{1,"Eps",2}}];
BuildBEFA[x_?WordQ]   := 
Module[ {L,n,Tr},
     L = ToCharacters[x];
     n = Length[L] + 1;
     Tr = Thread[ {Range[n-1], L, Range[2,n]} ];
     BEFA[ n, Tr ]
];
    
(*     McNaughton-Yamada style normal NFAs  *)

makeNNFA[xx_Symbol|xx_String] := BuildNNFA[xx];
makeNNFA[xx_REP]    := unionNNFA @@ (makeNNFA /@ xx);
makeNNFA[xx_RET]    := concatenateNNFA @@ (makeNNFA /@ xx);
makeNNFA[xx_RES]    := starNNFA[ makeNNFA[First[xx]] ];

sizeNNFA[ e_?WordQ ] := WordLength[e];
sizeNNFA[ e_REP|e_RET ] := Plus @@ (sizeNNFA/@e);
sizeNNFA[ e_RES ]    := sizeNNFA[e[[1]]];


Options[BuildDFA]={Normalize:>$defaultnormalize};

BuildDFA[Eps|"Eps"|Global`\[Epsilon],K_:$alphabet,opts___?OptionQ] :=
    DFA[2, AlphabetSizeS[K], Table[{2,2},{AlphabetSize[K]}], 1, {1},
        MakeShortAlphabet[K], {} ];
BuildDFA[z__?WordQ,K_:$alphabet,opts___?OptionQ] := QuotientDFA[{z},K,opts];
BuildDFA[L_List,K_:$alphabet,opts___?OptionQ]    := QuotientDFA[L,K,opts]; 
      

Options[BuildNNFA]={};

BuildNNFA[Eps|"Eps"|Global`\[Epsilon]] := NNFA[0,{},{},{},{},1];
BuildNNFA[Empty]     := NNFA[0,{},{},{},{},0];
BuildNNFA[ xx_ ]     := 
With[ {n=WordLength[xx]},
      NNFA[ n, Partition[Range[n],2,1], ToCharacters[xx], {1}, {n}, 0 ]
];

unionNNFA[ M1_NNFA, M2_NNFA ] := 
Module[ {n=M1[[1]], I1=M1[[4]], F1=M1[[5]], I2, F2},
     I2 = M2[[4]] + n;
     F2 = M2[[5]] + n;
     NNFA[    
            n + M2[[1]],
            Union[ M1[[2]], M2[[2]] + n ],
            Join[ M1[[3]], M2[[3]] ],
            Union[ I1, I2 ],
            Union[ F1, F2 ],
            Max[ M1[[6]], M2[[6]] ] 
     ]
];
unionNNFA[ M1_NNFA, M2_NNFA, M___NNFA ] := 
     unionNNFA[ unionNNFA[ M1, M2 ], M ];
       
concatenateNNFA[ M1_NNFA, M2_NNFA ] := 
Module[ {n=M1[[1]], I1=M1[[4]], F1=M1[[5]], I2, F2},
     I2 = M2[[4]] + n;
     F2 = M2[[5]] + n;
     
     NNFA[    
	   n + M2[[1]],
	   Union[ M1[[2]], M2[[2]]+n, CartesianProduct[F1,I2] ],
	   Join[ M1[[3]], M2[[3]] ],
	   If[M1[[6]]==0, I1, Union[ I1, I2 ] ],
	   If[M2[[6]]==0, F2, Union[ F1, F2 ] ],
	   M1[[6]] M2[[6]]
     ]
];
concatenateNNFA[ M1_NNFA, M2_NNFA, M___NNFA ] := 
    concatenateNNFA[ concatenateNNFA[ M1, M2 ], M ];
       
starNNFA[ M_NNFA ] := 
    ReplaceParts[ M, Union[ Zwei[M], CartesianProduct[M[[5]],M[[4]]] ], 2, 
1, 6 ];



Options[BuildStarDFA]={};

BuildStarDFA[ w_?WordQ, K_:$alphabet ] :=
Module[  {n,lab,tr,k,alph},      
    {k,alph} = MakeFullAlphabet[K];
    lab = ToIndex[w,alph];
    n   = Length[lab];
    tr  = Thread[ { Range[n],lab,RotateLeft@Range[n] } ];
    tr  = Last /@ 
          (FA[ n, AlphabetSizeS[K], tr, {1}, {1}, {}, {} ] // CompleteFA 
// Transitions // Sort);
    DFA[ Max@Flatten[tr], AlphabetSizeS[K], Thread@Partition[tr,k], 1, {1}, 
         MakeShortAlphabet[K], {} ]
];



Options[CA]={};

CA[r_Integer] := CA[r,3,-2];
CA[r_Integer,w_Integer] := CA[r,w,-2];
Unprotect[C];
ClearAll[C];


Options[CirculantSA]={};

CirculantSA[n_Integer,d_List,lab_List,K_:$alphabet] := 
With[
     { ed   = Edges@CirculantGraph[n,d],
       digs = ToIndex[ StringJoin@@(ToString /@ lab), K ]}, 
     SA[ n, AlphabetSizeS[K], Thread[{First/@ed, digs,Last/@ed}], {}, {} ]
];


Options[ClassifyCA]={Full->False, External:>$defaultexternal};

ClassifyCA[ C_CA, opts___?OptionQ ] := 
Module[{full,n,G,cmp,dag,dia,dd,type,ext},
    ext  = External /. {opts} /. Options[ClassifyCA];
    full = Full /. {opts} /. Options[ClassifyCA];
    
    If[ !full && ext, Return[Automata`extaut`ExtClassifyCA[C]] ];

    (* check 1-balance *)
    If[ !full && Length@Union[Last /@ Frequencies@ToLabelCA[C]] > 1,
    	 Return[0] 
    ];

    n  = AlphabetSize[C]^(WidthCA[C]-1);
     
    dag  = NonTransientGraph@ToGraphFA@SquareSA[ ToSA[C],Full->1];
    cmp  = VertexSet[dag];
    dia  = PositionOne[cmp,1];             (* position of diagonal SCC *)
    dd   = DegreeGraph[dag,PositionOne[cmp,dia]];
    type = 
        Which[
           Length[cmp]==1 && Length[cmp[[dia]]]==n,  3,
           dd==0 && Length[cmp[[dia]]]==n,           2,
           Length[cmp[[dia]]]==n,                    1,
           True,				     0
	];
    If[ full, {type,dag}, type ]
];       




Options[CoAccessibleFA]={Normalize:>$defaultnormalize, External:>$defaultexternal};

CoAccessibleFA[M_?FSMQ,opts___?OptionQ] := 
Module[ {mc,perm},

     norm = Normalize /. {opts} /. Options[AccessibleFA];

     mc = ReverseFA[ AccessibleFA[ ReverseFA[M], Normalize->1 ]];

     If[ norm == 0, Return[ NormalizeFA[mc] ] ];

     perm = Last /@ Sort[Pairs[States[mc], Range[Size[mc]]]];
     res = PermuteFA[ mc, perm ];

     If[ norm == 1, Return[ res ] ];

     ReplacePart[ res, States[M][[States[mc]]][[perm]], -1 ]

];




Options[CodeterministicQFA]={Full->False};

CodeterministicQFA[ m_?FSMQ, opts___?OptionQ ] := DeterministicQFA[ReverseFA[m],opts];


Options[ComplementFA]={};

ComplementFA[ M_?FSMQ ] := 
Module[ {MM},
     MM = ToDFA[M];
     ReplacePart[ MM, Complement[Range[Size[MM]],Final[MM]], 5 ] 
];

ComplementFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
Module[ {MM1,MM2},
     MM1 = ToDFA[M1];
     MM2 = ComplementFA[M2];
     IntersectionFA[ MM1, MM2, opts ]
];


concatenateFA[ M1_FA, M2_FA, opts___?OptionQ ] := 
Module[ {k,kk,KK,n1,n2,Q1,Q2,Tmid,Tr,norm,eps,M},
     norm = Normalize /. {opts} /. Options[ConcatenateFA];
     eps  = EpsElim /. {opts} /. Options[StarFA];
     
     {k,kk,KK} = GetAlphabet[M1];
     n1 = Size[M1];
     n2 = Size[M2];
     Tmid = CartesianProduct[ Final[M1], {0}, Initial[M2]+n1 ];
     Tr   = Join[ Transitions[M1], Tmid, 
                  shiftrans[n1,n1,#]& /@ Transitions[M2] ];
     res  = FA[ n1+n2, kk, Tr, Initial[M1], Final[M2]+n1, KK, {} ];
     If[ eps, res = EpsilonEliminationFA[res] ];
     Switch[ norm,
	0, res, 
	1|2, ReplacePart[ res, Join[{1,#}& /@ States[M1], {2,#}& /@ States[M2]], -1 ]
     ]
];





CompleteFA[ m_FA ] := 
Module[ {n1,deg,add,tr,k},
    deg  = DegreesFA[m];
    If[ Min[Flatten[deg]] > 0, Return[m] ];
    k   = AlphabetSize[m];
    n1  = Size[m] + 1;
    tr  = Transitions[m];
    add[d_Integer,{s_Integer,p_Integer} ] := 
        If[ d==0, AppendTo[ tr, {p,s,n1} ]; ];
    MapIndexed[ add, deg, {2} ];
    tr  = Join[ tr, CartesianProduct[{n1},Range[k],{n1}] ];
    res = ReplaceParts[ m, n1, 1, tr, 3 ];
    If[ MinusEins[m]==={},
        res,  
	ReplacePart[ res, Append[ States[m], $bottom ], -1 ] 
    ]
];

CompleteFA[ M_DFA ] := M;
CompleteFA[ M_NFA ] := ToNFA@CompleteFA@ToFA[M];
CompleteFA[ M_SA ]  := ToSA@CompleteFA@ToFA[M];


Options[CompleteQFA]={};

CompleteQFA[ M_?FSMQ ] := !MemberQ[ FlattenOne[ DegreesFA[M] ], 0 ];




Options[ComposeCA]={External:>$defaultexternal};

ComposeCA[ C1_CA, C2_CA, opts___?OptionQ ] :=
Module[ {k,alph,w,f1,f2,B,norm},

    If[ External  /. {opts} /. Options[ComposeCA], 
	Return[ Automata`extaut`ExtComposeCA[C1,C2] ] ];

    w = WidthCA[C1] + WidthCA[C2] - 1;
    {k,alph} = FullAlphabet[C1];
	
    GlobalMapCA[f1,C1,WordMap->True,Boundary->None];
    LocalMapCA[f2,C2,WordMap->True];
    B = f2[f1[#]]& /@ Reverse@Words[w,alph];
    CA[ FromDigits[PositionList[alph,B]-1,k], w, Drei[C1] ]
];
ComposeCA[C1_CA,C2_CA,C__CA,opts___?OptionQ] := 
     ComposeCA[ComposeCA[C1,C2,opts],C,opts];
ComposeCA[C_CA,opts___?OptionQ] := C;




Options[ComputationFA]={ShowAll->True};

ComputationFA[ M_DFA|M_FA|M_SA, xx_?WordQ, opts___?OptionQ ] = 
    ComputationFA[ ToNFA[M], xx, opts ];

ComputationFA[ M_NFA, xx_?WordQ, opts___?OptionQ ] :=
Block[  {alph,A,ff,fff,repl,trac,comps},

    alph = Alphabet[M];
    A = Transitions[M];

    (* build computations *)
    ff[L_List,a_Integer] := ff[p,a] = 
       Flatten /@ CartesianProduct[{Append[L,a]},
       				Union@Flatten[ A[[a,Last[L]]] ] ];
    fff[L_List,a_Integer] := FlattenOne[ ff[#,a]& /@ L ];
    
    (* replace indices by symbols *)
    repl[L_List] := MapAt[alph[[#]]&,L,{#}&/@(2Range[Length[L]/2])];   
    trac[L_List] := First /@ Partition[ Append[L,0], 2 ]; 
    
    comps = Last@FoldList[ fff, {#}& /@ Initial[M], ToIndex[xx, alph]];
    If[ ShowAll /. {opts} /. Options[ComputationFA], 
        repl /@ comps,
        trac /@ comps 
    ] 
];




Options[ComputationGraphFA]={};

ComputationGraphFA[ M_FA, w_?WordQ, opts___?OptionQ ] := 
	ToTDGraph[ 
		Function[ i, Drop[#,{2}]& /@ Cases[ Transitions[M], {_,i,_} ] ] /@ 
		ToIndex[ w, Alphabet[M] ], Size[M] ];

ComputationGraphFA[ M_NFA|M_SA|M_DFA, w_?WordQ, opts___?OptionQ ] := 
	ComputationGraphFA[ ToFA[M], w, opts ]; 




Options[ConcatenateFA]={EpsElim->True, Normalize:>$defaultnormalize};

ConcatenateFA[ M1_?FSMQ, M2_?FSMQ, M__?FSMQ, opts___?OptionQ ] := 
    ConcatenateFA[ ConcatenateFA[ M1, M2, opts ], M, opts ]; 

ConcatenateFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
    Which[ 
     Head[M1]===BEFA && Head[M2]===BEFA,  concatenateBEFA[M1,M2],
     Head[M1]===NNFA && Head[M2]===NNFA,  concatenateNNFA[M1,M2],
     True,                                concatenateFA[ ToFA[M1], ToFA[M2], opts ]
    ];


concatenateFA[ M1_FA, M2_FA, opts___?OptionQ ] := 
Module[ {k,kk,KK,n1,n2,Q1,Q2,Tmid,Tr,norm,eps,M},
     norm = Normalize /. {opts} /. Options[ConcatenateFA];
     eps  = EpsElim /. {opts} /. Options[StarFA];
     
     {k,kk,KK} = GetAlphabet[M1];
     n1 = Size[M1];
     n2 = Size[M2];
     Tmid = CartesianProduct[ Final[M1], {0}, Initial[M2]+n1 ];
     Tr   = Join[ Transitions[M1], Tmid, 
                  shiftrans[n1,n1,#]& /@ Transitions[M2] ];
     res  = FA[ n1+n2, kk, Tr, Initial[M1], Final[M2]+n1, KK, {} ];
     If[ eps, res = EpsilonEliminationFA[res] ];
     Switch[ norm,
	0, res, 
	1|2, ReplacePart[ res, Join[{1,#}& /@ States[M1], {2,#}& /@ States[M2]], -1 ]
     ]
];


Options[ConvertToFA]={Normalize:>$defaultnormalize, ToMatrix->False};

ConvertToFA[ H_, Q_List, K_, Tr_List, Ini_, Fin_, opts___?OptionQ ] := 
Module[ {QQ,n,kk,KK,alph,hh,A,totrans,norm,tomat},
    norm  = Normalize /. {opts} /. Options[ConvertToFA];
    tomat = ToMatrix  /. {opts} /. Options[ConvertToFA];
    
    n  = Length[Q];
    QQ = If[ norm==0, {}, Q ];
    alph = MakeAlphabet[K];
    kk = AlphabetSizeS[K];
    KK = MakeShortAlphabet[K];
    AssignFunction[hh,Q,Range[n]];
    hh[x_Integer] := x;
    totrans[{x_,y_Integer,z_}] := {hh[x],y,hh[z]};
    totrans[{x_,y_,z_}] := {hh[x],First@ToIndex[y,alph],hh[z]};
     
    Switch[ H,
    DFA, If[ tomat, 
             A = TransitionsToMatrix[n,K,totrans /@ Tr],
             A = Map[ hh, Tr, {2} ]
         ];
         DFA[ n, kk, A, hh[Ini], hh/@Fin, KK, QQ ],
    NFA, If[ tomat,
             A = TransitionsToMatrix[n,K,totrans /@ Tr],
             A = Map[ hh, Tr, {3} ]
         ];
         NFA[ n, kk, A, hh/@Ini, hh/@Fin, KK, QQ ],
    FA,  FA[ n, kk, totrans /@ Tr, hh/@Ini, hh/@Fin, KK, QQ ]
    ]
];
     
ConvertToFA[ SA, Q_List, K_, Tr_List, opts___?OptionQ ] := 
Module[ {QQ,n,kk,KK,alph,hh,A,totrans,norm},
    norm  = Normalize /. {opts} /. Options[ConvertToFA];
    
    n  = Length[Q];
    QQ = If[ norm==0, {}, Q ];
    alph = MakeAlphabet[K];
    kk = AlphabetSizeS[K];
    KK = MakeShortAlphabet[K];
    AssignFunction[hh,Q,Range[n]];
    hh[x_Integer] := x;
    totrans[{x_,y_,z_}] := {hh[x],First@ToIndex[y,alph],hh[z]};
     
    SA[ n, kk, totrans /@ Tr, KK, QQ ]
];

     

Options[CounterDFA]={Normalize:>$defaultnormalize};

CounterDFA[ a_, n_Integer?NonNegative, K_:$alphabet, opts___?OptionQ ] := 
    CounterDFA[ a, {n}, K, opts ];

CounterDFA[ a_, n_Integer?Negative, K_:$alphabet, opts___?OptionQ ] := 
    CounterDFA[ a, Range[0,-n], K, opts ];

CounterDFA[ a_, LL_List, K_:$alphabet, opts___?OptionQ ] := 
Module[{A,R,p,k,alph,mm,norm},
    norm = Normalize /. {opts} /. Options[CounterDFA];
    {k,alph} = MakeFullAlphabet[K];
    nn = Max[LL] + 2;
    R  = Range[nn];
    p  = First@ToIndex[a,alph];
    A  = Join[ Table[R,{p-1}], {Append[Range[2,nn],nn]}, Table[R,{k-p}] ];
    mm = DFA[ nn, AlphabetSizeS[K], A, 1, LL+1, MakeShortAlphabet[K], {} ];
    If[ norm==0,
        mm,  
        ReplacePart[ mm, Range[0,nn-1], -1 ] 
    ]
];





Options[CoverQDFA]={DoTrace->False};

CoverQDFA[ M1_DFA, M2_DFA, opts___?OptionQ ] :=
Module[ { n1, n2, Q1, Q2, h, dom, rng, prefin2, cover, trace },
     trace = DoTrace /. {opts} /. Options[CoverQDFA];
     
     n1 = Size[M1];
     n2 = Size[M2];

     If[ !MakeHomoDFA[ h, M1, M2 ], Return[False] ];
     
     (* test h for surjectivity and compatibility with final states  *)
     dom = Select[ Range[n1], (h[#] > 0)& ];
     rng = Union[ h[dom] ];
     If[ Length[ rng ] < n2, Return[False] ];
     
     prefin2 = Select[ dom, (MemberQ[ Final[M2], h[#] ])& ];
     cover = Sort[ Intersection[Final[M1],dom] ]===Sort[prefin2];

     If[ trace, 
         If[ cover, Thread[{States[M1][[dom]],States[M2][[h[dom]]]}], False ],
         cover
     ]
];


Options[Cyclic]={};

Options[DeBruijnEdges]={Normalize->1};


DeBruijnEdges[ w_Integer, K_:{0,1}, opts___?OptionQ ] := 
Module[ {k,alph,norm,Rn,B},
	norm = Normalize /. {opts} /. Options[DeBruijnEdges];
	{k,alph} = MakeFullAlphabet[K];
	Rn = Range[k^w];
	B  = Pairs[ Flatten[Thread@Table[Rn,{k}]], Join@@Table[Rn,{k}] ];
	If[ norm==0, 
		B, 
		{ StringJoin@@alph[[IntegerDigits[#[[1]],k,w]+1]],
		  StringJoin@@alph[[IntegerDigits[#[[2]],k,w]+1]] }& /@ (B-1) 
	]
];



Options[DeBruijnGraph]={Normalize->0};

DeBruijnGraph[ ww_Integer, K_:{0,1}, opts___?OptionQ ] := 
Module[ {k,norm},
     norm = Normalize /. {opts} /. Options[DeBruijnGraph];
     k = AlphabetSize[K]; 
     res = Graph[ k^ww, k^(ww+1), 1, DeBruijnEdges[ww,K,Normalize->0], {} ];
     If[ norm==0,
         res,
	 ReplacePart[ res, Words[ww,K], -1 ]
     ]
];


Options[$defaultnormalize]={};

$defaultnormalize = 0;

Options[DefiniteQFA]={Full->False, External:>$defaultexternal};

DefiniteQFA[ M_?FSMQ, opts___?OptionQ ] := 
Module[ {mm,gr},

    mm = ToSA[M];
    If[ External /. {opts} /. Options[DefiniteQFA],
	Return[ Automata`extaut`ExtDefiniteQFA[ mm, opts ] ] ];

    gr = ToGraphFA@SquareSA[mm,Full->0];

    If[ Full /. {opts} /. Options[DefiniteQFA],
        LongestPath[gr],
        Length@StronglyConnectedComponents[gr,NonTrivial->True]==1
    ]
];       








Options[DegreesFA]={};

DegreesFA[ m_?FSMQ ] := Map[ Length, Transitions@ToNFA[m], {2} ];


Options[DeleteStateFA]={Normalize->1};

DeleteStateFA[m_FA|m_SA,P_List,opts___?OptionQ] := 
Module[ {tt,n,nn,Q,nQ,h,R,newtr},
     {k,kk,KK} = GetAlphabet[m];
     n  = Size[m];
     R  = Complement[Range[n],P];
     nn = n - Length[P];
     AssignFunction[h,R,Range[nn]];
     newtr[{pp_,a_,qq_}] := {h[pp],a,h[qq]};
     tt = newtr /@ Select[Transitions[m],
           (!MemberQ[P,First[#]]&&!MemberQ[P,Last[#]])&];
     res = If[ Head[m]===FA,
               FA[ nn, kk, tt, h /@ Complement[Initial[m],P],
                   h /@ Complement[Final[m],P], KK, {} ],
               SA[ nn, kk, tt, KK, {} ]
           ];
     Switch[ Normalize /. {opts} /. Options[DeleteStateFA],
	 0, res,
         1, ReplacePart[ res, R, -1 ],
         2, ReplacePart[ res, States[m][[R]], -1 ]
     ]         
];
      
DeleteStateFA[m_FA|m_SA,p_Integer,opts___?OptionQ] := DeleteStateFA[m,{p},opts];
DeleteStateFA[m_DFA,pp_,opts___?OptionQ] := DeleteStateFA[ToFA[m],pp,opts];





Options[DependencyCA]={};

DependencyCA[ C_CA ] := Dependency[ ToLabelCA[C], AlphabetSize[C] ];


Options[DeterministicQFA]={Full->False};

SetAttributes[DeterministicQFA,Listable];

DeterministicQFA[ M_SA, opts___?OptionQ ] := 
Module[ {n, s2, ss2, diag, P, pos, fa2, lp},
    
    	If[ ! (Full /. {opts} /. Options[DeterministicQFA]),  
      		Return[ detQFA[M] ] ];
    
    	n = Size[M];
    	s2 = SquareSA[M, Full -> 1, Normalize -> 1];
    	diag = FoldList[ #1 + #2 &, 1, Range[n, 2, -1]];
    	P = Complement[ 
	    Last /@ Select[Transitions[s2], MemberQ[diag, #[[1]]] &], diag ] ;
    	If[ P == {}, Return[0]];
    	P = States[s2][[#]] & /@ P;
    	ss2 = SquareSA[ M, Full -> 2, Normalize -> 1];
    	pos = PositionList[ States[ss2], P ];
    	fa2 = SetInitialFinalFA[ ss2, pos, Range[Size[ss2]] ];
    	If[ InfiniteQFA[fa2], Return[Infinity] ];
    	lp = LongestPath[ ReverseGraph@ToGraphFA[fa2] , Full -> True];
    	Max[ lp[[pos]] ] + 1
];

DeterministicQFA[ M_?FSMQ, opts___?OptionQ ] := 
    DeterministicQFA[  ToSA[M], opts ]; 

detQFA[ m_DFA ] = True;
detQFA[ m_NFA ] := Max[Length /@ FlattenOne@Transitions[m] ] <= 1;
detQFA[m_SA|m_FA] := detQFA@ToNFA[m];




Options[DFA]={};

DFA[n_,k_,t_,i_,f_] := DFA[n,k,t,i,f,{},{}];

Options[EdgeLU]={};

Options[EmptyDFA]={};

EmptyDFA[ K_:$alphabet ] := 
    DFA[1, AlphabetSizeS[K], Table[{1},{AlphabetSize[K]}], 1, {}, 
	MakeShortAlphabet[K], {} ];


Options[EmptyQFA]={};

EmptyQFA[ M_?FSMQ ] := Final@AccessibleFA[M]==={};


Options[Empty]={};

Options[EpsElim]={};

 
EpsFreeQ[ M_FA|M_SA ] := Cases[Transitions[M], {_,0,_} ]==={};
EpsFreeQ[ M_BEFA ] := Cases[Transitions[M], {_,Eps|"Eps"|\[Epsilon],_} ]==={};
 

Options[EpsilonEliminationFA]={DoTrace->False, Normalize:>$defaultnormalize, External:>$defaultexternal};

EpsilonEliminationFA[ M_FA, opts___?OptionQ ] :=
Module[ {Lout,close,eps,neps,Tr1,Ini,Ini0,Fin,n,g,
     epsadjlst,G,component,trace,ext},
     trace = DoTrace /. {opts} /. Options[EpsilonEliminationFA];

     If[ EpsFreeQ[M], Return[M] ];

     If[ !trace && (External /. {opts} /. Options[EpsilonEliminationFA]), 
         Return[ Automata`extaut`ExtEpsilonEliminationFA[M,opts] ] ];

     n   = Size[M];
     Ini = Initial[M];
     Fin = Final[M];
     eps = Drop[#,{2}]& /@ Cases[Transitions[M], {_,0,_} ];
     If[ eps==={}, Return[M] ];
     neps = DeleteCases[ Transitions[M], {_,0,_} ];
     
     close[ {p_,a_,q_} ] :=
      Partition[ Flatten@CartesianProduct[ {{p,a}}, Lout[[q]] ], 3 ];
     
     epsadjlst[x_]  := Flatten[ Select[eps,(#[[1]]===x)&] ];
    
     component[ x_ ] := 
     Module[ { h, hh, dfs, dfsact, count=1 },
             h[_]=0;
             dfs[ z_Integer ] := Scan[  dfsact, G[[z]] ];   
             dfsact[ z_ ] := 
                 If[ h[z]==0, h[z]=count++; hh[count]=z; dfs[z] ];
             h[x]  = 1;
             hh[1] = x;
             dfs[ x ];
             hh /@ Range[count]
     ];
     
     G    = epsadjlst /@ Range[n]; 
     Lout = component /@ Range[n];
     Tr1  = Union[ Flatten[ close /@ neps, 1 ] ];
     Ini0 = Union[ Flatten[ Lout[[#]]& /@ Ini ] ];
     res  = ReplacePart[ ReplacePart[ M, Tr1, 3 ], Ini0, 4 ];
     If[ trace,
         { res, eps, neps, Lout},
         res
     ]
];

EpsilonEliminationFA[ M_BEFA, opts___?OptionQ ] := 
     EpsilonEliminationFA[ M // ToFA, opts ];

EpsilonEliminationFA[ M_SA, opts___?OptionQ ] := 
     EpsilonEliminationFA[ M // ToFA, opts ] // ToSA;

EpsilonEliminationFA[ M_DFA|M_NFA, opts___?OptionQ ] := M;




Options[EquivalentQFA]={DoTrace->False, External:>$defaultexternal};

SetAttributes[EquivalentQFA,Listable];

EquivalentQFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
     If[ External /. {opts} /. Options[EquivalentQFA], 
         Automata`extaut`ExtEquivalentQFA[ M1, M2 ],

         If[ DoTrace /. {opts} /. Options[EquivalentQFA],
	     equivalentfull[ToDFA[M1],ToDFA[M2]], 
	     equivalentfast[ToDFA[M1],ToDFA[M2]]
         ]
     ];


equivalentfull[M1_DFA,M2_DFA] := 
Module[ {n1,n2,nn,K,FF,uf,act,p,q,r1,r2,L},
	n1 = Size[M1];
	n2 = Size[M2];
	nn = n1 + n2;
	K = Alphabet[M1];
	FF = Join[ Final[M1], Final[M2] + n1 ];
	
	AssignFunction[uf,Range[nn],Range[nn]];
	
	TransitionFunctionFA[M1,del1];
	TransitionFunctionFA[M2,del2];
	
	act = {{TheInitial[M1],TheInitial[M2]}};
	
	While[ act =!= {},
		{p,q} = First[act];
		act = Rest[act];
		r1 = FixedPoint[uf,p];
		r2 = FixedPoint[uf,q+n1];
		
		If[ r1 != r2, 
			uf[r2] = r1;
			Scan[  AppendTo[act,{del1[p,#],del2[q,#]}]&, K ];
		];
	];
	L = FixedPoint[uf,#]& /@ Range[nn];
	{n1,n2,FF,ToClasses[Range[nn],L,Type->Index]}
];	


equivalentfast[M1_DFA,M2_DFA] := 
Module[ {n1,n2,nn,K,F1,F2,uf,act,p,q,r1,r2},
	n1 = Size[M1];
	n2 = Size[M2];
	nn = n1 + n2;
	K = Alphabet[M1];
	F1 = Final[M1];
	F2 = Final[M2];
	
	AssignFunction[uf,Range[nn],Range[nn]];
	
	TransitionFunctionFA[M1,del1];
	TransitionFunctionFA[M2,del2];
	
	act = {{TheInitial[M1],TheInitial[M2]}};
	
	Catch[
		While[ act =!= {},
		       {p,q} = First[act];
		       act = Rest[act];
		       r1 = FixedPoint[uf,p];
		       r2 = FixedPoint[uf,q+n1];
		       If[ Xor[ MemberQ[F1,p], MemberQ[F2,q] ], Throw[False] ];
			
		       If[ r1 != r2, 
			   uf[r2] = r1;
			   Scan[  AppendTo[act,{del1[p,#],del2[q,#]}]&, K ];
		       ];
	        ];
		Throw[True]
	]
];


Options[EvolutionCA]={Boundary->Cyclic, External:>$defaultexternal};

EvolutionCA[ C_CA, t_Integer:40, opts___?OptionQ ] := 
     EvolutionCA[C,SeedConfiguration[{1},2t+1],t,opts];

EvolutionCA[ C_CA, pat_List, t_Integer:40, opts___?OptionQ ] := 
     PlotMatrix[ OrbitCA[C,pat,t,opts], 
		 SelectOptions[PlotMatrix,opts], SelectOptions[Graphics,opts] ];
		

Options[FactorialQFA]={Full->False, External:>$defaultexternal};


FactorialQFA[ m_?FSMQ, opts___?OptionQ  ]:=
Module[{mm,p,sa,res},
	mm = MinimizeFA[m,SelectOptions[MinimizeFA,opts,{Full}]];
	If[ Size[mm] == 1, Return[True] ];
	p = TheSinkDFA[mm];
	If[ p == 0, Return[False] ];
	sa = ToSA@DeleteStateFA[ mm, p];
	res = IsomorphicQDFA[ mm, MinimizeFA[sa,SelectOptions[MinimizeFA,opts,{Full}]] ];
	If[ Full /. {opts} /. Options[FactorialQFA], 
            {res,sa}, res 
	]
];


Options[FA]={};

FA[n_,k_,t_,i_,f_]  :=  FA[n,k,t,i,f,{},{}];

Options[FinalVectorFA]={};

FinalVectorFA[ M_?FSMQ, opts___?OptionQ ] :=
         ToBitVector[Final[M],Size[M]];


PathToWord[ M_?FSMQ, LL_List ] := 
Module[ {tr,run},
	tr  = Transitions@ToFA[M];
	run = Zwei@First@Cases[tr, {First[#],_,Last[#]}]& /@ Partition[LL,2,1];
	ToWord[ run, Alphabet[M] ]
];




Options[Final]={};

Final[ M_DFA|M_NFA|M_FA ] := M[[5]];
Final[ M_SA ] := Range@Size[M];

(*    FSM modifiers, verification   *)




Options[FiniteComplementSA]={Normalize:>1};


FiniteComplementSA[ w_?WordQ, K_:2, opts___?OptionQ ] := 
FiniteComplementSA[ {w}, K, opts ];

FiniteComplementSA[ W_List, K_:2, opts___?OptionQ ] := 
Block[{k,alph,tr,n,Q,norm,test,maketr,edge},
     norm = Normalize /. {opts} /. Options[FiniteComplementSA];
     
     maketr[xx_String]  := 
     If[ StringLength[xx]<n,
	     {StringDrop[xx,-1],Last@ToIndex[xx,alph],xx},
	     {StringDrop[xx,-1],Last@ToIndex[xx,alph],StringDrop[xx,1]}
     ];
    
     {k,alph} = MakeFullAlphabet[K];
     n = Max[ WordLength /@ W ];
     Q = Words[ -n, alph ];
     Q = Select[ Q, 
     (!Or@@(Function[xx,StringMatchQ[#,xx]]/@Concatenate["*",W,"*"])&) ];
     tr  = ToEps[ maketr /@ Rest[Q] ] /. RenumberRules[Q];
     Q = Select[ Q, WordLength[#]<n& ];
     res = SA[ Length[Q], AlphabetSizeS[K], tr, MakeShortAlphabet[K], {} ];
     If[ norm==0, 
         res, 
         ReplacePart[ res, Q, -1 ]
     ]     
];


Options[FinLU]={};

Options[Fixed]={};

Options[FLBound]={};


FormatAutomata[Null|None] := 
Module[{prt},
	prt=Unprotect[SA,FA,DFA,NFA,Graph];
	Unset[Format[SA[n_,k_,t_,__]]]; 
	Unset[Format[FA[n_,k_,t_,i_,f_,__]]];
	Unset[Format[NFA[n_,k_,t_,i_,f_,__]]];
	Unset[Format[DFA[n_,k_,t_,i_,f_,__]]];
	Unset[Format[Graph[v_,e_,i_,ed_,__]]];
	Protect[prt];
];

FormatAutomata[Some] := 
Module[{prt},
	prt=Unprotect[SA,FA,DFA,NFA,Graph];
	Format[SA[n_,k_,t_,__]] := HoldForm[SA[n,k,t]];	
	Format[FA[n_,k_,t_,i_,f_,__]] := HoldForm[FA[n,k,t,i,f]];
	Format[NFA[n_,k_,t_,i_,f_,__]] := HoldForm[NFA[n,k,t,i,f]];
	Format[DFA[n_,k_,t_,i_,f_,__]] := HoldForm[DFA[n,k,t,i,f]];
	Format[Graph[v_,e_,i_,ed_,__]] := HoldForm[Graph[v,e,i,ed]];
	Protect[prt];
];

FormatAutomata[Automatic] := 
Module[{prt},
	prt=Unprotect[SA,FA,DFA,NFA,Graph];
	Format[SA[n_,k_,t_,__]] := HoldForm[SA[n,k,Short[t,#]]]&[$shortlines];	
	Format[FA[n_,k_,t_,i_,f_,__]] := HoldForm[FA[n,k,Short[t,#],Short[i,#],Short[f,#]]]&[$shortlines];
	Format[NFA[n_,k_,t_,i_,f_,__]] := HoldForm[NFA[n,k,Short[t,#],Short[i,#],Short[f,#]]]&[$shortlines];
	Format[DFA[n_,k_,t_,i_,f_,__]] := HoldForm[DFA[n,k,Short[t,#],Short[i,#],Short[f,#]]]&[$shortlines];
	Format[Graph[v_,e_,i_,ed_,__]] := HoldForm[Graph[v,e,i,Short[ed,#]]]&[$shortlines];
	Protect[prt];
];

FormatAutomata[SizeOnly] := 
Module[{prt},
	prt=Unprotect[SA,FA,DFA,NFA,Graph];
	Format[SA[n_,k_,t_,__]] := HoldForm[SA[n,k]];	
	Format[FA[n_,k_,t_,i_,f_,__]] := HoldForm[FA[n,k]];
	Format[NFA[n_,k_,t_,i_,f_,__]] := HoldForm[NFA[n,k]];
	Format[DFA[n_,k_,t_,i_,f_,__]] := HoldForm[DFA[n,k]];
	Format[Graph[v_,e_,i_,ed_,__]] := HoldForm[Graph[v,e,i]];
	Protect[prt];
];

FormatAutomata[Full] := 
Module[{prt},
	prt=Unprotect[SA,FA,DFA,NFA,Graph];
	Format[SA[n_,k_,t_,__]] := "-SA-";
	Format[FA[n_,k_,t_,i_,f_,__]] := "-FA-";
	Format[NFA[n_,k_,t_,i_,f_,__]] := "-NFA-";
	Format[DFA[n_,k_,t_,i_,f_,__]] := "-DFA-";
	Format[Graph[v_,e_,i_,ed_,__]] := "-Graph-";
	Protect[prt];
];




Options[FormatX]={};

FrontierQ[W_List,K_:$alphabet] := 
Module[ {KK = MakeAlphabet[K], WW  = WordSort[ToString /@ W]}, 
     If[ WW==={""} || WW==={"Eps"}, Return[True] ];
     ToPrefix[ Union[Flatten[ProperPrefixes[WW]]], K ]===WW
];



FrontierToDFA[{eqq_List,F_List},K_:$alphabet] := FrontierToDFA[eqq,F,K];

FrontierToDFA[eqq_List,F_List,K_:$alphabet] := 
Module[ {eqL,n,Q,delta,del,next,q,KK},
     KK  = MakeAlphabet[K];
     eq  = Map[ ToString, eqq /. (x_?WordQ -> y_?WordQ) -> {x,y}, {2} ];
     eqL = First /@ eq;
     Q = WordSort[Union[Flatten[WordPrefixes[StringDrop[#,-1]& /@ eqL]]]];
     n   = Length[Q];
     AssignFunction[ next, eq/.{Eps->"Eps",""->"Eps",Global`\[Epsilon]->"Eps"} ];
     delta[p_,s_] := 
      ( q = Concatenate[p,s]; If[MemberQ[Q,q],q,next[q]] );
     del[s_] := delta[#,s]& /@ Q;
     DFA[ n, K, PositionList[Q,del[#]]& /@ KK, 1, 
          PositionList[Q,F/.{Eps->"Eps",""->"Eps",Global`\[Epsilon]->"Eps"}], KK, Q ]
];


Options[FSMQ]={};

FSMQ[x_]  := MemberQ[{DFA,NFA,FA,BEFA,NNFA,SA},Head[x]];
matFAQ[x_] := MemberQ[{DFA,NFA},Head[x]];


Options[FSurjectiveCA]={};

FSurjectiveCA[ C_CA ] := 
Module[{w,k,alph,A,lab,G},
     w   = WidthCA[C];
     {k,alph} = MakeFullAlphabet@Drei[C];
     A   = DeBruijnEdges[w-1,alph,Normalize->0];
     lab = Reverse@IntegerDigits[ First[C], k, k^w ];
     A   = Thread[ {First/@A, lab, Last/@A}  ];
     A   = Complement[ Cases[A,{_,0,_}], {{1,0,1}} ];
     G   = Graph[ k^(w-1), Length[A], 1, Drop[#,{2}]& /@ A, {} ];
     If[ CyclicQGraph[G], 0, 1 ]
];     



Options[FullAlphabet]={};

FullAlphabet[ M_?FSMQ|M_CA ] :=  {AlphabetSize[M],Alphabet[M]};


Options[FullTransitionMatrixFA]={Type->None};

FullTransitionMatrixFA[M_NFA|M_DFA|M_SA, opts___?OptionQ ] := 
    FullTransitionMatrixFA[ ToFA[M], opts ];
    
FullTransitionMatrixFA[ M_FA, opts___?OptionQ ] :=
Module[ {ff},
    Switch[ Type /. Release[{opts}] /. Options[TransitionMatrixFA],
	None,      Automata`automata`Private`natTransitionMatrixFA[M,ff];
			Plus@@( ff /@ Alphabet[M] ),
	Boolean,   Automata`automata`Private`booleanTransitionMatrixFA[M,ff];
			Plus@@( ff /@ Alphabet[M] ) // Sign,
	Tropical,  Automata`automata`Private`tropicalTransitionMatrixFA[M,ff];
			Plus@@( ff /@ Alphabet[M] ) // Sign
    ]
];



Options[FullTransitions]={};

FullTransitions[ M_FA|M_SA ] := 
With[ {alph = Prepend[ Alphabet[M], "Eps" ]}, 
    MapAt[ alph[[#+1]]&, Thread@Transitions[M], 2 ] // Thread
];
FullTransitions[ M_DFA|M_NFA ] := FullTransitions[ ToFA[M] ];


Options[FunctionToCA]={};

FunctionToCA[ ff_, w_Integer, k_Integer] := 
With[ {kk = Abs[k]},
     CA[ FromDigits[Apply[ff,Reverse[CartesianProduct@@Table[kk,{w}]-1],1],kk],w,k]
];



Options[FunctionToDFA]={Alphabetic->True, Normalize:>$defaultnormalize};

 
FunctionToDFA[ Q_List, K_, del_, q0_, F_, opts___?OptionQ ] := 
Module[ {n,k,alph,KK,A,tt,qq0,FF},
	n = Length[Q];
	{k,alph} = MakeFullAlphabet[K];
	
	If[ Alphabetic /. {opts} /. Options[FunctionToSA],
		A = alph, A = Range[0,k-1] ];
		
	tt = Map[ PositionOne[Q,#]&,
		Thread@Partition[Apply[ del, CartesianProduct[Q,A],{1}], k], {2}];

        qq0 = PositionOne[Q,q0];
        FF  = PositionList[Q,F];
	If[ IntegerQ[K], k = K; KK={}, KK=alph ];

	If[ 0 == (Normalize /. {opts} /. Options[FunctionToDFA]),
	    DFA[ n, k, tt, qq0, FF, KK, {} ],
	    DFA[ n, k, tt, qq0, FF, KK, Q ]
	]
];


Options[FunctionToSA]={Alphabetic->True, Normalize:>$defaultnormalize};

FunctionToSA[ Q_List, K_, del_, opts___?OptionQ ] := 
Module[ {n,k,alph,dist,tt},
	n = Length[Q];
	{k,alph} = MakeFullAlphabet[K];
	
	If[ Alphabetic /. {opts} /. Options[FunctionToSA],
		A = alph, A = Range[k] ];
		
	dist[{p_,s_},L_List] := Flatten /@ CartesianProduct[{{p,s}},L];
	tt = Pairs[ FlattenOne@Table[ {j,i}, {j,n}, {i,k} ],
		PositionList[Q,#]& /@ Apply[ del, CartesianProduct[Q,A], {1} ] ];
	tt = FlattenOne@Apply[ dist, tt, {1} ];

	If[ 0 == (Normalize /. {opts} /. Options[FunctionToSA]),
	  SA[ n, k, tt, {}, {} ],
	  SA[ n, k, tt, alph, Q ]
	]
];


Options[GenerateDFA]={};

GenerateDFA[ q0_, op_, K_, fin_ ] := 
Block[ {next,Q,W,eq,eqL,eqR,KK,Kc,del,F},
     next[s_] := ((Concatenate[#,s])& /@ W) /. Thread[eqL->eqR];

     {Q,W,eq} = GenerateCSM[q0,op,K,Equations->True];
     eqL = First /@ eq;
     eqR = Last /@ eq;
     KK  = MakeAlphabet[K];
     del = PositionList[W,next[#]]& /@ KK;
     F   = Select[Q,fin];
     { Q, W, DFA[ Length[Q], AlphabetSizeS[K], del, PositionOne[Q,q0], 
			 PositionList[Q,F], MakeShortAlphabet[K], {} ] }
];


Options[GenerateQuotients]={};

GenerateQuotients[ L_, K_:$alphabet ] :=
Module[ {Q,curr,A,B,k,alph},
    {k,alph} = MakeFullAlphabet[K];
    curr = 0; 
    Q = { L };
    While[ Length[Q] > curr,
           A = Q[[ ++curr ]];
           B = LeftQuotient[#,A]& /@ alph; 
           If[ !MemberQ[Q,#], AppendTo[Q,#] ]& /@ B 
    ];
    Q
];




Options[GlobalMapCA]={Boundary->Cyclic, WordMap->False};

Attributes[GlobalMapCA]={HoldFirst};

GlobalMapCA[ ff_, C_CA, opts___?OptionQ ] := 
(
    ClearAll[ff];
    If[ WordMap  /. {opts} /. Options[GlobalMapCA],
    	makeWordMap[ ff, C, opts ],
    	makeListMap[ ff, C, opts ]
    ];
);

$zpref[w_Integer?Positive] := Table["0",{w}];

makeWordMap[ ff_, C_CA, opts___?OptionQ ] := 
Module[ {w,ww,rules},
    w   = WidthCA[C];
    ww  = Ceiling[w/2];
    rules = Dispatch@ToRulesCA[C,WordMap->True];

    ff = 
    Switch[ Boundary /. {opts} /. Options[GlobalMapCA],
    	Cyclic, StringJoin[ (StringJoin /@ Partition[ToCharacters[#],w,1,ww]) /. rules]&,
    	Fixed,  StringJoin[ (StringJoin /@ Partition[ToCharacters[#],w,1,ww,First@Alphabet[C]]) /. rules]&,
	None,   StringJoin[ (StringJoin /@ Partition[ToCharacters[#],w,1])/.rules]&
    ];
];
	
makeListMap[ ff_, C_CA, opts___?OptionQ ] := 
Module[ {w,ww,rules},
    w   = WidthCA[C];
    ww  = Ceiling[w/2];
    rules = Dispatch@ToRulesCA[C,WordMap->False];

    ff = 
    Switch[ Boundary /. {opts} /. Options[GlobalMapCA],
	    Cyclic, (Partition[#,w,1,ww] /. rules)&,
	    Fixed,  (Partition[#,w,1,ww,$defzero] /. rules)&,
	    None,   (Partition[#,w,1] /. rules)&
    ];
];
	




HomomorphismFA[ M_FA, hom_List, K_ ] := 
With[
     { newtr = Union[FullTransitions[M] /. Thread[Alphabet[M]->(ToString/@hom)]],
       m0 = FA[ Size[M], AlphabetSizeS[K], {}, Initial[M], Final[M], 
              MakeShortAlphabet[K], {} ] },
     Last@FoldList[ AddTransitionFA, m0, newtr ]
];

HomomorphismFA[ M_DFA|M_NFA, hom_List, K_ ] := 
     HomomorphismFA[ M//ToFA, hom, K ];

HomomorphismFA[ M_?FSMQ, hom_, K_ ] := 
     HomomorphismFA[M, hom /@ Alphabet[M], K ];


Options[Hopcroft]={};

Options[HurwitzProduct]={};

HurwitzProduct[ L1_List, L2_List ] := 
Module[ {inc,S},

     inc[u_,v_] := 
     CartesianProduct[ WordShuffle[First[u],First[v]],
     {Last[u] Last[v]} ];
       
     S = FlattenOne[ Apply[ inc, CartesianProduct[L1,L2], 1 ]];
     S = Sort[ {WordLength[#[[1]]],#[[1]],#[[2]]}& /@ S ];
     (Rest/@S)  //.
     {x___,{u_,c1_},{u_,c2_},z___} :> {x,{u,c1+c2},z}
];     
      
languagemult[M_NFA,n_Integer] := 
Module[  {L,k,alph,Ini,F,A,tmp,prep,words,toword,W,grid},

     {k,alph} = FullAlphabet[ M ];
     Ini = Initial[ M ];
     F   = Final[ M ];
     A   = Thread[Transitions[ M ]];

     toword[ x_List ] := StringJoin @@ alph[[x]]; 
     prep[ {a_,L_} ] := Prepend[#,a]& /@ L;
     
     (* all words w : p-->q, |w| = s *)    
     L[0,p_,q_] := L[0,p,q] = If[ p==q, {{}}, {} ];
       
     L[s_,p_,q_] := L[s,p,q] =
      ( tmp = Apply[ Join, Map[ L[s-1,#,q]&, A[[p]], {2} ], 1 ];
        Flatten[ prep /@ Pairs[ Range[k], tmp ], 1 ] );
      
     (* all words w : p-->q, p in Ini, q in Fin, |w| = s *)
     grid = CartesianProduct[Ini,F];
     words[s_] := toword /@ Flatten[ Map[ L[s,#[[1]],#[[2]]]&, grid ], 1 ];

     If[ Positive[n],
         Frequencies[words[n]],
         W = words /@ Range[-n];
         neps = Length[ Intersection[Final[M], Initial[M]] ];
         If[ Positive[neps],
             Prepend[ Frequencies /@ W, {{"Eps",neps}} ],
             Prepend[ Frequencies /@ W, {} ]
         ]
     ]
];



IdealBaseFA[ MM_?FSMQ ] := 
Module[{m,m1},
	m  = MinimizeFA[MM];
	m1 = MinimizeFA@IntersectionFA[ m, MinimizeFA@NoPrefixFA[m] ];
	MinimizeFA@IntersectionFA[ m1, MinimizeFA@NoSuffixFA[m] ]
];
			

IdealQFA[ MM_?FSMQ ] := 
With[ {all = AllDFA[Alphabet[MM]]},
	EquivalentQFA[ ConcatenateFA[ all, MM, all ], MM ] ];


Options[IdentityCA]={};

IdentityCA[w_Integer,k_Integer:-2] := 
With[ {kk = Abs[k],
	wl = Ceiling[(w-1)/2],
	wr = Floor[(w-1)/2]},
	CA[FromDigits[ Flatten@Table[i,{kk^wr},{i,kk,1,-1},{kk^wl}]-1,kk],w,k]  
];
	

Options[Implementation]={};

Options[InfiniteQFA]={};

InfiniteQFA[ M_?FSMQ ] := CyclicQGraph@ToGraphFA@TrimFA@ToFA[M];




Options[InfixFA]={Normalize:>$defaultnormalize};

InfixFA[ w_?WordQ, K_:$alphabet, opts___?OptionQ ] :=
Module[  {n,lab,k,alph,T1,Tn,TT,norm},
    norm = Normalize /. {opts} /. Options[InfixFA];
    
    {k,alph} = MakeFullAlphabet[K];
    lab = ToIndex[ w, alph ];
    n   = Length[lab] + 1;
    T1  = Thread[ {Table[1,{k}],Range[k],Table[1,{k}]} ];
    Tn  = Thread[ {Table[n,{k}],Range[k],Table[n,{k}]} ];
    TT  = Thread[ {Range[n-1],lab,Range[2,n]} ];
    res = FA[n, AlphabetSizeS[K], Join[T1,TT,Tn], {1}, {n}, MakeShortAlphabet[K], {} ];
    If[ norm==0,
        res, 
        ReplacePart[ res, WordPrefixes[w], -1 ]
    ]
];



Options[IniLU]={};

Options[InitialVectorFA]={};

InitialVectorFA[ M_?FSMQ, opts___?OptionQ ] :=
         ToBitVector[Initial[M],Size[M]];


Options[Initial]={};

Initial[ M_DFA ]  := If[ Head@Vier[M]===List, Vier[M], {Vier[M]} ];
Initial[ M_FA|M_NFA ] := Vier[M];
Initial[ M_SA ] := Range@Size[M];


Options[IntersectionFA]={Full->False, Normalize:>$defaultnormalize};

IntersectionFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
                ProductFA[ M1, M2, Type->"Intersection", opts ];
    
IntersectionFA[ M1_?FSMQ, M2_?FSMQ, M___?FSMQ, opts___?OptionQ ] := 
    IntersectionFA[ IntersectionFA[ M1, M2, opts ], M, opts ];


Options[InverseCA]={External:>$defaultexternal};

InverseCA[CA[r_Integer,1,k_Integer]] := 
Module[{lab,Rk,h,hh},
     lab = ToLabelCA[CA[r,1,k]];
     Rk  = Range[0,Abs[k]-1];
     AssignFunction[h,Rk,ToExpression/@Reverse@lab];
     AssignFunction[hh,h/@Rk,Rk];
     CA[ToString /@ Reverse[hh /@ Rk],1,k] // LabelToCodeCA
];

InverseCA[C_CA,opts___?OptionQ] := 
Module[{Wl,Wr,defl,defr,ww,sa,Lr,Ll,join,LL,k,alph,ll,rul,lab},

    {Wl,Wr} = Last@WelchCA[C,Full->True];
    defl = DefiniteQFA[Wl,Full->True];
    defr = DefiniteQFA[Wr,Full->True];
    ww = defl + defr;
    sa = ToSA[ C ];
    Lr = fullanguage[ sa, defl ];
    Ll = fullanguage[ ReverseFA[sa], defr ];
    join[ {L1_List,L2_List} ] := 
	    Apply[ StringJoin, CartesianProduct[ StringReverse/@L1, L2 ], 1 ];
    LL = Sort@FlattenOne@MapIndexed[ CartesianProduct, join /@ Pairs[Ll,Lr] ];
    {k,alph} = FullAlphabet[C];
    ll  = k^(WidthCA[C]-1);
    rul = Thread[ Range[ll] -> Flatten[ Thread[ Table[alph,{ll/k}] ] ] ];
    lab = Reverse[ (Last /@ LL) /. rul ];
    CA[ lab, ww, Drei[C] ] // LabelToCodeCA // ShrinkCA
];

(* compute lists of all words where |w|=r, delta(p,w)!=0, for all p *)

fullanguage[ M_SA, r_Integer ] :=
Module[ {n,k,alph,tr,extone,extt,extend,rul,w,a,p,L},
    {k,alph} = FullAlphabet[M];
    n   = Size[M];
    tr  = Partition[FlattenOne@Transitions@ToNFA[M],n];
    rul = Thread[Pairs[Table[alph[[#]],{n}],tr[[#]]]& /@ Range[k] ];
    extend[ L_List  ] := FlattenOne[ extone /@ L ];
    extone[ {w_,p_} ] := FlattenOne[ extt[ w, # ]& /@ rul[[p]] ];
    extt[ w_, {a_,L_List} ] := { w<>a, # }& /@ L;
    Union /@ Map[ First , Nest[ extend, {{"",#}}, r ]& /@ Range[n], {2} ]
];


Options[IrreducibleFA]={Full->False, Normalize:>$defaultnormalize};


IrreducibleFA[ L_List, K_:$alphabet, opts___?OptionQ ] := 
Module[ {LL,Q,QQ,maketrans,fix,tr,full,norm,alph,aalph},
    full = Full /. {opts} /. Options[IrreducibleFA];
    norm = Normalize /. {opts} /. Options[IrreducibleFA];
    alph = MakeAlphabet[K];
    LL = ToString /@ L;
    Q  = Complement[ Flatten[WordPrefixes[LL]], LL ] // WordSort;
    QQ = Join[ Q, LL ];
    maketrans[ {p_, a_} ] := 
    ( xx = Concatenate[p,a];
                     (* delete prefix until in QQ *)
      While[ !MemberQ[ QQ, xx ], xx = StringDrop[xx,1] /. ""->"Eps" ];
                     (* new transition only if xx in Q *)
      If[ MemberQ[ Q, xx ], {p,a,xx}, {} ]
    );
    aalph = Complement[ alph, LL ];
    tr = Cases[ maketrans /@ CartesianProduct[ Q, aalph ], {__} ];
    If[ full, 
        fix[{p_,a_,q_}] := 
        {PositionOne[Q,p], PositionOne[alph,a], PositionOne[QQ,q]};
        res = FA[ Length[QQ], AlphabetSizeS[K], fix /@ tr, {1}, 
	          PositionList[QQ,LL], 
                  MakeShortAlphabet[K], {} ];
        If[ norm==0, 
	    res, 
 	    ReplacePart[ res, QQ, -1 ]
        ],
    (* else *)
        fix[{p_,a_,q_}] := 
        {PositionOne[Q,p], PositionOne[alph,a], PositionOne[Q,q]};
        res = FA[ Length[QQ], AlphabetSize[K], 
                  fix /@ Select[tr,MemberQ[Q,Last[#]]&], 
                  {1}, Range@Length[Q], 
                  MakeShortAlphabet[K], {} ];
        If[ norm==0, 
	    res, 
 	    ReplacePart[ res, Q, -1 ]
        ]
    ]
];




Options[IsomorphicQDFA]={DoTrace->False, External:>$defaultexternal};

IsomorphicQDFA[ M1_DFA, M2_DFA, opts___?OptionQ ] :=
Module[ { n1, n2, Q1, Q2, k, h, A1, A2, F1, F2, iso, trace },

     If[ Size[M1] != Size[M2], Return[False] ];
     If[ AlphabetSize[M1] != AlphabetSize[M2], Return[False] ];

     If[ !trace && (External /. {opts} /. Options[IsomorphicQDFA]), 
         Return[ Automata`extaut`ExtIsomorphicQDFA[M1,M2] ] ];

     trace = DoTrace /. {opts} /. Options[IsomorphicQDFA];
     n1 = Size[M1];
     n2 = Size[M2];
     
     F1 = Final[M1]; 
     F2 = Final[M2];
     If[ Length[F1] != Length[F2], Return[False] ];
       
     If[ !MakeHomoDFA[ h, M1, M2 ], Return[False] ];
     
     (* test h for surjectivity and 
      compatibility with final states  *)
     If[ Length[ Union[ h[ Range[n1] ] ] ] != n1, Return[False] ];
     
     iso = Sort[h[F1]]===Sort[F2];
     
     If[ trace, 
         If[ iso, Thread[{States[M1],States[M2][[h[Range[n1]]]]}], False ],
         iso
     ]
];


Options[IterateCA]={Normalize:>$defaultnormalize};

IterateCA[ C_CA, t_Integer:2, opts___?OptionQ ] :=
Module[ {k,alph,w,wt,nt,ff,B,norm},
     norm = Normalize /. {opts} /. Options[IterateCA];
      
     {k,alph} = FullAlphabet[C];
     w  = WidthCA[C];
     wt = t w - t + 1;
     GlobalMapCA[ff,C,WordMap->True,Boundary->None];
     B  = Nest[ff,#,t]& /@ Reverse@Words[wt,alph];
     If[ norm==0,
         CA[ FromDigits[PositionList[alph,B]-1,k], wt, Drei[C] ],
     (*else*)
         CA[ B, wt, Drei[C] ]
     ]
];




Options[IthSymbolDFA]={Normalize:>$defaultnormalize};

IthSymbolDFA[s_,r_Integer?Negative,K_:$alphabet,opts___?OptionQ] := 
Block[ {k,alph,norm,torow,next1,next2,si,n,Q1,Q2,Q,tr,rules,F},
     {k,alph} = MakeFullAlphabet[K];
     norm = Normalize /. {opts} /. Options[IthSymbolDFA];
     torow[ss_] := Last /@ Sort@Select[tr, (#[[2]]===ss)& ];
     next1[L_List] := {L,#,Append[L,#]}& /@ Range[k];
     next2[L_List] := {L,#,Append[Rest[L],#]}& /@ Range[k];
     
     si  = First@ToIndex[s,alph];
     n   = (k^(-r+1)-1)/(k-1);
     Q1  = FlattenOne[ KPermutationsR[k,#]& /@ Range[0,-r-1] ];
     Q2  = KPermutationsR[k,-r];
     Q   = Join[Q1,Q2];
     tr  = Join[FlattenOne[next1 /@ Q1],FlattenOne[next2 /@ Q2]];
     rules = Thread[ Q->Range[n] ];
     tr  = tr /. rules;
     F   = Select[Q2,(First[#]==si)&]/.rules;
     res = DFA[n, AlphabetSizeS[K], torow /@ Range[k], 1, F, 
               MakeShortAlphabet[K], {} ];
     If[ norm==0,
         res,
         ReplacePart[ res, Words[r,alph], -1 ]
     ]     
];

IthSymbolDFA[s_,r_Integer?Positive,K_:$alphabet,opts___?OptionQ] := 
Module[ {k,alph,norm,row,A},
     {k,alph} = MakeFullAlphabet[K];
     norm = Normalize /. {opts} /. Options[IthSymbolDFA];
     
     row = Join[ Range[2,r], {r+2,r+1,r+2} ];
     A   = row& /@ Range[k];
     A[[First[ToIndex[s,alph]],r]] = r+1;
     res = DFA[r+2, AlphabetSizeS[K], A, 1, {r+1}, MakeShortAlphabet[K], {}];
     If[ norm==0,
         res,
         ReplacePart[ res, Range[0,r+1], -1]
     ]     
];
(* this should be done with  Words[-r-1,k] ... *)


Options[IthSymbolFA]={Normalize:>$defaultnormalize};

IthSymbolFA[ s_, r_Integer?Negative, K_:$alphabet, opts___?OptionQ ] :=
Module[{n,A,A1,A2,k,norm},
    norm = Normalize /. {opts} /. Options[IthSymbolFA];
    k  = AlphabetSize[K];
    ss = First@ToIndex[ s, K ];
    n  = -r+1;
    A1 = Append[ Thread[ {Table[1,{k}],Range[k],Table[1,{k}]} ], {1,ss,2} ]; 
    A2 = Thread[ {Table[#,{k}],Range[k],Table[#+1,{k}]} ]& /@ Range[2,n-1];
    A = Sort@Join[ A1, FlattenOne[A2] ];
    res = FA[n, AlphabetSizeS[K], A, {1}, {n}, MakeShortAlphabet[K], {} ];
    If[ norm==0,
        res, 
        ReplacePart[ res, Range[0,n-1], -1 ]
    ]
];

IthSymbolFA[ s_, r_Integer?Positive, K_:$alphabet, opts___?OptionQ ] :=
Module[{n,A,A1,A2,k,norm},
    norm = Normalize /. {opts} /. Options[IthSymbolFA];
    k  = AlphabetSize[K];
    ss = First@ToIndex[ s, K ];
    n  = r+1;
    A1 = Append[ Thread[ {Table[n,{k}],Range[k],Table[n,{k}]} ], {n-1,ss,n} ]; 
    A2 = Thread[ {Table[#,{k}],Range[k],Table[#+1,{k}]} ]& /@ Range[n-2];
    A = Sort@Join[ A1, FlattenOne[A2] ];
    res = FA[n, AlphabetSizeS[K], A, {1}, {n}, MakeShortAlphabet[K], {} ];
    If[ norm==0,
        res, 
        ReplacePart[ res, Range[0,n-1], -1 ]
    ]
];


Options[JoinSA]={Normalize:>$defaultnormalize};

JoinSA[ M1_SA, M2_SA, A_List, opts___?OptionQ ] := 
Module[ {k,kk,KK,n1,n2,na,A1,A2,h,f1,f2,f,g,gg,T1,T2},
     
	{k,kk,KK} = Automata`automata`Private`GetAlphabet[M1];
	n1  = Size[ M1 ];
	n2  = Size[ M2 ];
	na  = Length[A];
	T1  = Transitions[M1];
	A1  = First /@ A;
	A2   = Last /@ A;
	AssignFunction[ h,  Reverse /@ A ];
	AssignFunction[ f1, Range[n1], States[M1] ];	
	AssignFunction[ f2, Range[n2], States[M2] ];	
	AssignFunction[ gg,  Complement[Range[n2],A2], Range[ n1+1,n1+n2-na] ];
	g[x_] := If[ MemberQ[A2,x], h[x], gg[x] ];
	shiftrans[ {x_,s_,z_} ] := {g[x],s,g[z]};
	T2  = shiftrans /@ Transitions[M2];
	res = SA[ n1+n2-Length[A], kk, Join[T1,T2], KK, {} ];

	Switch[ Normalize /. {opts} /. Options[JoinSA],
	    0,	res,
	    1|2,
		ReplacePart[ res, 
		    Join[ If[MemberQ[A1,#],{0,f1[#]},{1,f1[#]}]& /@ Range[n1],
			{2,#}& /@ f2 /@ Complement[Range[n2],A2]], -1 ]
	]
];


Options[LabelToCodeCA]={};

LabelToCodeCA[ CA[ r_Integer, w_, K_] ] := CA[r,w,K];
LabelToCodeCA[ CA[ lab_List, w_Integer, K_] ] :=
   CA[ FromDigits[ToIndex[StringJoin@@lab,MakeAlphabet[K]]-1,AlphabetSize[K]], w, K ];
LabelToCodeCA[ lab_List, w_Integer, K_ ] :=
   FromDigits[ToIndex[StringJoin@@lab,MakeAlphabet[K]]-1,AlphabetSize[K]];






Options[LanguageFA]={Multiplicity->False, SizeOnly->False, MakeTrim->False, Full->False, FLBound->50, Implementation->1};


(* a kludge *)
LanguageFA[ M_?FSMQ, opts___?OptionQ ] := LanguageFA[M,0,opts];

LanguageFA[ M_DFA|M_NFA, 0 ] := 
      If[ DisjointQ[Initial[M],Final[M]], {}, {"Eps"} ]; 

LanguageFA[ M_DFA, n_Integer, opts___?OptionQ ] := 
Module[ {size,coacc},

     If[ SizeOnly /. {opts} /. Options[LanguageFA],
         Return[ languagesize[M,n] ] ];
     
     If[ Full /. {opts} /. Options[LanguageFA],
         Return[ fulllang[M,SelectOptions[fulllang,opts,{Full}] ] ] ];
     
     If[ MakeTrim /. {opts} /. Options[LanguageFA],
         Return[nondetlanguage[TrimFA@ToFA[M],n]] ];
 
     Switch[ Implementation /. {opts} /. Options[LanguageFA],
             1, detlanguage1[M,n],
             2, detlanguage2[M,n],
             3, detlanguage3[M,n]
     ]
];


LanguageFA[ M_NFA|M_FA|M_SA, n_Integer, opts___?OptionQ ] := 
Module[ {MM},

     If[ SizeOnly /. {opts} /. Options[LanguageFA],
         Return[ languagesize[M//ToNFA,n] ] ];
     
     If[ Multiplicity /. {opts} /. Options[LanguageFA],
         Return[ languagemult[M//ToNFA,n] ] ];
     
     If[ MakeTrim /. {opts} /. Options[LanguageFA],
     MM = ToNFA@TrimFA@ToFA[M],
     MM = M//ToNFA ];
     
     Switch[ Implementation /. {opts} /. Options[LanguageFA],
             1, nondetlanguage1[MM,n],
             2, nondetlanguage2[MM,n]
     ]      
];


detlanguage1[ M_DFA, r_Integer, opts___?OptionQ ] :=
Module[ {n,k,alph,F,tr,LL,L0,ext,extend,rule,selectfin,sink,killsink},
    
     {k,alph} = FullAlphabet[M];
     n   = Size[M];
     F   = Final[M];
     tr  = Transitions[M];
     rule = Thread[ Pairs[ Table[alph[[#]],{n}],tr[[#]] ]& /@ Range[k] ];
     sink = TheSinkDFA[M];
     If[ sink>0,
         killsink[X_List] := Select[X,(Last[#]=!=sink)&];
         rule = killsink /@ rule
     ];
     
     extend[ {x_,p_} ] := ext[x,#]& /@ rule[[p]];
     ext[x_,{a_,q_}] := {StringJoin[x,a],q};
     selectfin[ LL_List ] := First /@ Select[ LL, MemberQ[F,Last[#]]& ];
    
     L0 = {{"",TheInitial[M]}};
     If[ Positive[r],
         LL = Nest[ Flatten[extend/@#,1]&, L0, r ];
         Union@selectfin[LL],
     (* else *)
         LL = NestList[ Flatten[extend/@#,1]&, L0, -r ];
         LL = Union@selectfin[#]& /@ Rest[LL];
         If[ MemberQ[ F, TheInitial[M] ],
             Prepend[ LL, {"Eps"} ],
             Prepend[ LL, {} ]
         ]
     ]
];

detlanguage2[ M_DFA, r_Integer ] := 
Module[  {k,alph,F,A,subst,toword,selectfin,L0,LL},
     {k,alph} = FullAlphabet[M];
     F  = Final[M];
     A  = Thread@Transitions[M];
      
     subst[L_List] := Flatten[ A[[L]] ];
     toword[w_Integer,{rr_Integer}] := 
      StringJoin@@alph[[IntegerDigits[w,k,rr]+1]];
     toword[L_List,{rr_Integer}] := toword[#,{rr}]& /@ L;
     selectfin[L_List,{rr_Integer}] := 
      First /@ Select[Pairs[Range[0,k^rr-1],L],MemberQ[F,Last[#]]&];
     
     L0 = Initial[M];
     If[ Positive[r],
         LL = Nest[ subst, L0, r ];
         LL = selectfin[LL,{r}];
         toword[#,{r}]& /@ LL,
     (* else *)
         LL = NestList[ subst, L0, -r ];
         LL = MapIndexed[ selectfin, Rest[LL] ];
         LL = MapIndexed[ toword, LL ];
         If[ MemberQ[ F, TheInitial[M] ],
             Prepend[ LL, {"Eps"} ],
             Prepend[ LL, {} ]
         ]
     ]
];

detlanguage3[ M_DFA, n_Integer ] := 
Module[  {k,alph,F,A,prep,words,W,sink},

     {k,alph} = FullAlphabet[ M ];
     F    = Final[ M ];
     A    = Thread[Transitions[ M ]];
      
     prep[{}] = {};
     prep[ {P_,a_} ] := Concatenate[a,P];  (* StringJoin[a,#]& /@ P; *)

     (* L[s,p,q]: all words w : p-->q, |w| = s *)    
     Clear[$LLL];
     sink = TheSinkDFA[M];
     If[ sink>0, $LLL[_,sink,_] = {} ];     
     
     $LLL[0,p_,q_] := If[ p==q, {"Eps"}, {} ];
       
     $LLL[s_,p_,q_] := $LLL[s,p,q] =
       Flatten[ prep /@ Pairs[$LLL[s-1,#,q]& /@ A[[p]], alph] ];
      
     words[s_] := Sort@Flatten[ $LLL[s,TheInitial[M],#]& /@ F];
       
     If[ Positive[n],
         words[n],
     (*else*)
         W = words /@ Range[-n];
         If[ MemberQ[ F, TheInitial[M] ],
             Prepend[ W, {"Eps"} ],
             Prepend[ W, {} ]
         ]
     ]
];


nondetlanguage1[ M_NFA, n_Integer ] := 
Module[  {L,k,alph,II,FF,A,tmp,prep,words,W,grid},

     {k,alph} = FullAlphabet[M];
     II   = Initial[M];
     FF   = Final[M];
     A    = Thread[Transitions[M]];

     prep[ {P_,a_} ] := Concatenate[a,P];  (* StringJoin[a,#]& /@ P; *)

     (* all words w : p-->q, |w| = s *)    
     L[0,p_,q_]  := L[0,p,q] = If[ p==q, {""}, {} ];
     L[s_,p_,q_] := L[s,p,q] =
     (  tmp = Apply[ Union, Map[ L[s-1,#,q]&, A[[p]], {2} ], 1 ];
        FlattenOne[ prep /@ Pairs[ tmp, alph ] ] );
      
     words[s_] := 
       Union[Flatten[ L[s,#[[1]],#[[2]]]& /@ CartesianProduct[II,FF] ]];
       
     If[ Positive[n],
         words[n],
         Prepend[ words /@ Range[-n], If[ DisjointQ[II,FF],{},{"Eps"}]]
     ]
];

nondetlanguage2[ M_NFA, r_Integer ] :=
Module[ {n,k,alph,II,FF,tr,LL,ext,extend,rule,selectfin},
     {k,alph} = FullAlphabet[M];
     n   = Size[M];
     II  = Initial[M];
     FF  = Final[M];
     tr  = Transitions[M];
     rule = Thread[ Pairs[ Table[alph[[#]],{n}],tr[[#]] ]& /@ Range[k] ];
    
     extend[ {x_,p_} ] := ext[x,#]& /@ rule[[p]];
     ext[x_,{a_,Q_}] := Sequence@@({StringJoin[x,a],#}& /@ Q);
     selectfin[ LL_List ] := 
      First /@ Select[ LL, MemberQ[FF,Last[#]]& ];
    
     If[ Positive[r],
         LL = Nest[ Union@Flatten[extend/@#,1]&, {"",#}& /@ II, r ];
         Union@selectfin[LL],
     (* else *)
         LL = NestList[ Flatten[extend/@#,1]&, {"",#}& /@ II, -r ];
         LL = Union@selectfin[#]& /@ Rest[LL];
         Prepend[ LL, If[ DisjointQ[II,FF],{},{"Eps"}]]
     ]
];

languagemult[ M_NFA, r_Integer ] :=
Module[ {n,k,alph,II,FF,LL,rule,ext,extend,selectfin},
    
     {k,alph} = FullAlphabet[M];
     n   = Size[M];
     II  = Initial[M];
     FF  = Final[M];
     tr  = Transitions[M];
     rule = Thread[ Pairs[ Table[alph[[#]],{n}],tr[[#]] ]& /@ Range[k] ];
     
     extend[ {x_,p_} ] := ext[x,#]& /@ rule[[p]];
     ext[x_,{a_,Q_}] := Sequence@@({StringJoin[x,a],#}& /@ Q);
     selectfin[ LL_List ] := 
      First /@ Select[ LL, MemberQ[FF,Last[#]]& ];
     
     If[ Positive[r],
         LL = Nest[ Flatten[extend/@#,1]&, {"",#}& /@ II, r ];
         Frequencies@selectfin[LL],
     (* else *)
         LL = NestList[ Flatten[extend/@#,1]&, {"",#}& /@ II, -r ];
         LL = selectfin[#]& /@ Rest[LL];
         neps = Length[ Intersection[Final[M], Initial[M]] ];
         If[ Positive[neps],
             Prepend[ Frequencies /@ LL, {{"Eps",neps}} ],
             Prepend[ Frequencies /@ LL, {} ]
         ]     
     ]
];



languagesize[ M_DFA, r_Integer ] :=
Module[ {n,Q,QQ,B,Ini,Fin,numbers,ff}, 
     
     n   = Size[M];
     Q   = Range[n];
     Ini = ToBitVector[ Initial[M], Q ];
     Fin = ToBitVector[ Final[M], Q ];
     
     (* make Q by Q multiplicity matrix *)
     TransitionMatrixFA[M,ff];
     QQ = Plus @@ (ff /@ Alphabet[M]);
     If[ NonNegative[r],
         Return[ Ini.MatrixPower[QQ,r].Fin ],
     (*else*)
         B = IdentityMatrix[n];
         numbers = ( x = Ini.B.Fin; B = B.QQ; x )&;    
         numbers /@ Range[0,-r]
     ]
];

languagesize[ M_NFA, r_Integer ] := 
     If[ Positive[r], Length[languagemult[M,r]], Length /@ 
languagemult[M,r] ];

languagemult[ M_NFA, r_Integer ] :=
Module[ {n,k,alph,II,FF,LL,rule,ext,extend,selectfin},
    
     {k,alph} = FullAlphabet[M];
     n   = Size[M];
     II  = Initial[M];
     FF  = Final[M];
     tr  = Transitions[M];
     rule = Thread[ Pairs[ Table[alph[[#]],{n}],tr[[#]] ]& /@ Range[k] ];
     
     extend[ {x_,p_} ] := ext[x,#]& /@ rule[[p]];
     ext[x_,{a_,Q_}] := Sequence@@({StringJoin[x,a],#}& /@ Q);
     selectfin[ LL_List ] := 
      First /@ Select[ LL, MemberQ[FF,Last[#]]& ];
     
     If[ Positive[r],
         LL = Nest[ Flatten[extend/@#,1]&, {"",#}& /@ II, r ];
         Frequencies@selectfin[LL],
     (* else *)
         LL = NestList[ Flatten[extend/@#,1]&, {"",#}& /@ II, -r ];
         LL = selectfin[#]& /@ Rest[LL];
         neps = Length[ Intersection[Final[M], Initial[M]] ];
         If[ Positive[neps],
             Prepend[ Frequencies /@ LL, {{"Eps",neps}} ],
             Prepend[ Frequencies /@ LL, {} ]
         ]     
     ]
];

(* local Full currently disabled *)

Options[fulllang]={FLBound->50,Full->False};

fulllang[M_?FSMQ,opts___?OptionQ] := 
Module[ {MM,tr,fin,extend,paths,bnd},
	MM = TrimFA@ToFA[M];
	tr = FullTransitions@MM;
	fin = Final[MM];
	extend[{}] = {};
	extend[{x___,p_}] := 
		FlattenOne /@ CartesianProduct[{{x,p}},Cases[tr,{p,aa__}->{aa}]];
	extend[ {LL__List} ] := FlattenOne[ extend /@ {LL} ];
	bnd = Min[ FLBound /. {opts} /. Options[fulllang], Size[MM]]; 
	paths = Select[ FlattenOne@FixedPointList[ extend, {#}& /@ Initial[MM], bnd ], 
			MemberQ[fin,Last[#]]& ];
	If[ Full /. {opts} /. Options[fulllang], 
		paths,
		WordSort@Union[ Concatenate[Last /@ Partition[#,2]]& /@ paths ]
	]
];


Options[LanguageSort]={};

LanguageSort[ LL_List ] := WordSort[ WordSort /@ LL ]; 




Options[LanguageToSeries]={};

LanguageToSeries[L_List] := Pairs[ L, Table[1,{Length[L]}] ]; 


Options[LeftQuotient]={};

LeftQuotient[ Eps|"Eps"|Global`\[Epsilon], v_?WordQ ] := v;
LeftQuotient[ u_?WordQ, v_?WordQ ] := 
With[ {us = ToString[u],vs = ToString[v]}, 
     If[ PrefixQ[us,vs],
         If[ us===vs,
             "Eps",
             StringDrop[vs,WordLength[us]]
         ],
         Empty
     ]
];

LeftQuotient[ Eps|"Eps"|Global`\[Epsilon], L_List ] := L;
LeftQuotient[ x_?WordQ, L_List ] := 
With[ {xs = ToString[x],xl = WordLength[x],LL = ToString/@L},
     ToEps[ StringDrop[#,xl]& /@ Select[LL,StringMatchQ[#,StringJoin[ToString[x],"*"]]& ] ]
];



Options[LeftShiftCA]={};

LeftShiftCA[k_Integer] := 
With[ {kk = Abs[k]},
     CA[ FromDigits[ Flatten@Table[ i, {kk^2}, {i,kk-1,0,-1} ], kk ], 3, k ]
];


Options[LengthDFA]={Normalize:>$defaultnormalize};

LengthDFA[ n_Integer?NonNegative, K_:$alphabet, opts___?OptionQ ] := 
    LengthDFA[ {n}, K, opts ];

LengthDFA[ n_Integer?Negative, K_:$alphabet, opts___?OptionQ ] := 
    LengthDFA[ Range[0,-n], K, opts ];

LengthDFA[ LL_List, K_:$alphabet, opts___?OptionQ ] := 
Module[{A,k,mm,norm},
    norm = Normalize /. {opts} /. Options[LengthDFA];
    k   = AlphabetSize[K];
    nn  = Max[LL] + 2;
    A   = Table[ Append[Range[2,nn],nn], {k} ];
    mm  = DFA[ nn, AlphabetSizeS[K], A, 1, LL+1, MakeShortAlphabet[K], {} ];
    If[ norm==0,
        mm,  
        ReplacePart[ mm, Range[0,nn-1], -1 ] 
    ]
];




Options[ListAble]={};

Options[$LLL]={};

Options[LocalMapCA]={WordMap->False};

Attributes[LocalMapCA]={HoldFirst};

 
LocalMapCA[ ff_, C_CA, opts___?OptionQ ] := 
With[ {wmp = WordMap /. {opts} /. Options[LocalMapCA]},
	AssignFunction[ ff, Sequence@@domCodomCA[C,wmp], Kary->Not[wmp] ]
];

domCodomCA[ C_CA, b_ ] := 
Module[ {lab,k,alph,w,n},
     L   = First[C];
     w   = WidthCA[C];
     {k,alph} = FullAlphabet[C];
     n   = k^w;
     
     If[ b, 
		{ StringJoin@@alph[[#]]& /@ (IntegerDigits[Range[0,n-1],k,w]+1),
		  Reverse[ alph[[IntegerDigits[L,k,n]+1]] ] },
		{ IntegerDigits[Range[0,n-1],k,w], Reverse[IntegerDigits[L,k,n]] }
     ]
];


Options[LocalUniversalFA]={Normalize:>$defaultnormalize, EdgeLU->Function[x,True], IniLU->Function[x,True], FinLU->Function[x,True]};

LocalUniversalFA[ n_Integer, K_:$alphabet, opts___?OptionQ ] := 
Block[{k,alph,Tr,Q,Ini,Fin,rules,norm,test,ini,fin,
     testedge,makelabel,edge},
     norm = Normalize /. {opts} /. Options[LocalUniversalFA];
     test = EdgeLU    /. {opts} /. Options[LocalUniversalFA];
     ini  = IniLU     /. {opts} /. Options[LocalUniversalFA];
     fin  = FinLU     /. {opts} /. Options[LocalUniversalFA];
     
     testedge[{x_,y_}] := test[ x<>StringTake[y,-1] ];
     makelabel[{x_,y_}]  := {x,Last@ToIndex[y,alph],y};
    
     {k,alph} = MakeFullAlphabet[K];
     Tr  = makelabel /@ Select[ DeBruijnEdges[n,alph], testedge ];
     
     Q   = Union[ First/@Tr, Last/@Tr ];
     Ini = Select[Q,ini];
     Fin = Select[Q,fin];
     rules = RenumberRules[Q];
     Tr  = Tr  /. rules;
     Ini = Ini /. rules;
     Fin = Fin /. rules;
     res = FA[ Length[Q], AlphabetSizeS[K], Tr, Ini, Fin, MakeShortAlphabet[K], {} ];
     If[ norm==0, 
         res, 
         ReplacePart[ res, Q, -1 ]
     ]
];






Options[LoopAutomatonFA]={};

LoopAutomatonFA[ M_FA ] :=
Module[  {k,kk,alph,n1,Tr,T1,T2,TT,TT1,TT2,TT3,Ini,Fin},
     {k,kk,KK} = GetAlphabet[M];
     n1  = Size[M]+1;
     Ini = Initial[M];
     Fin = Final[M];
     Tr  = Transitions[M];
     T1  = Select[ Tr, MemberQ[Ini,First[#]]& ];
     T2  = Select[ Tr, MemberQ[Fin, Last[#]]& ];
     TT1 = {n1,#[[2]],#[[3]]}& /@ T1;
     TT2 = {#[[1]],#[[2]],n1}& /@ T2;
     TT3 = {n1,#[[2]],n1}& /@ Intersection[T1,T2];
     TT  = Union[ Tr, TT1, TT2, TT3 ];
     FA[ n1, kk, TT, {n1}, {n1}, KK, {} ]
];
     
LoopAutomatonFA[ M_NFA ] := LoopAutomatonFA[ ToFA[M] ];     
LoopAutomatonFA[ M_DFA ] := LoopAutomatonFA[ ToFA[M] ];     



BEFAToFA[ M_BEFA, K_:$alphabet ] := 
     FA[ Size[M], AlphabetSizeS[K], 
         ToTransitions[Transitions[M],K], {1}, {Size[M]}, 
MakeShortAlphabet[K], {} ];
     
unionBEFA[ M1_BEFA, M2_BEFA ] := 
Module[ {n1, n2, T1, T2},
     n1 = Size[ M1 ];
     n2 = Size[ M2 ];
     T1 = Transitions[M1] /. {x_Integer,s_,n1} :> {x,s,n1+n2-2} ;
     T2 = Transitions[M2] /. {x_Integer,s_,y_Integer} :> {x+n1-2,s,y+n1-2};
     T2 = T2 /. {n1-1,s_,y_Integer} :> {1,s,y};
     BEFA[ n1+n2-2, Union[T1,T2] ]
];
unionBEFA[ M1_BEFA, M2_BEFA, z___BEFA ] := 
      unionBEFA[ unionBEFA[ M1, M2 ], z ];
      
concatenateBEFA[ M1_BEFA, M2_BEFA ] := 
Module[ {n1,n2,T1,T2},
     n1 = Size[M1];
     n2 = Size[M2];
     T1 = Transitions[M1];
     T2 = Map[ shiftrans[n1-1,n1-1,#]&, Transitions[M2] ];
     BEFA[ n1+n2-1, Union[T1,T2] ]
];
concatenateBEFA[ M1_BEFA, M2_BEFA, z___BEFA ] := 
     concatenateBEFA[ concatenateBEFA[ M1, M2 ], z ];
      
starBEFA[ M_BEFA ] := 
Module[ {n, Tr},
     n = Size[ M ];
     Tr = Map[ shiftrans[1,1,#]&, Transitions[M] ];
     BEFA[ n+2, Union[Tr,{{1,"Eps",2},{n+1,"Eps",2},{2,"Eps",n+2}}] ]
];

makeBEFA[xx_Symbol|xx_String] := BuildBEFA[xx];
makeBEFA[xx_REP]    := unionBEFA @@ (makeBEFA /@ xx);
makeBEFA[xx_RET]    := concatenateBEFA @@ (makeBEFA /@ xx);
makeBEFA[xx_RES]    := starBEFA[ makeBEFA[First[xx]] ];

sizeBEFA[ ee_Symbol|ee_String ] := WordLength[ee] + 1;
sizeBEFA[ ee_REP ]    := Plus @@ (sizeBEFA/@ee) - 2 Length[ee] + 2;
sizeBEFA[ ee_RET ]    := Plus @@ (sizeBEFA/@ee) - Length[ee] + 1;
sizeBEFA[ ee_RES ]    := sizeBEFA[ee[[1]]] + 2;


Attributes[MakeHomoDFA]={HoldFirst};


MakeHomoDFA[ h_, M1_DFA, M2_DFA ] :=
Module[ { A1, A2, dfs, dfsact, homo },

    ClearAll[h];
    SetAttributes[h,Listable];
    SetAttributes[dfsact,Listable];

    A1 = Thread[Transitions[M1]]; 
    A2 = Thread[Transitions[M2]];
    homo = True;
    
    (* initialize h array to 0 *)
    h[_]=0;
    
    (* explore all sons of x *)
    dfs[ x_Integer ] := dfsact[ A1[[x]], A2[[h[x]]] ];     
    
    (* explore successor delta[x,a] *)
    dfsact[ p_, q_ ] := 
        If[ h[p] == 0, 
            h[p] = q; dfs[p],
            If[ h[p] != q, homo = False ]
        ];
     
    (*  perform exploration  *)
    h[TheInitial[M1]] = TheInitial[M2];
    dfs[ TheInitial[M1] ];
    homo
];


Options[MakeHomomorphism]={ListAble->False};

Attributes[MakeHomomorphism]={HoldFirst};


MakeHomomorphism[ ff_, ss_List, tt_List, opts___?OptionQ ] := 
Module[ {rules},
    ClearAll[ff];
    rules = Thread[ (ToString /@ ss)->(ToString /@ tt) ];
    If[ ListAble /. {opts} /. Options[MakeHomomorphism], 
        Attributes[ff]={Listable};
        ff[xx_String] := ToEps@StringReplace[xx,rules]; 
        ff[xx_Symbol|xx_Integer] := 
           ToEps@StringReplace[ToString[xx],rules], 
    (* else *)
        ff = (ToEps@StringReplace[ToString[#],rules])& 
    ]; 
    rules
];



Options[MakeTrim]={};

Options[MakeWord]={};

makeWordRepeat[{a_,i_}] := StringJoin@@Table[ToString[a],{i}];
MakeWord[w__] := ToEps[ StringJoin@@(makeWordRepeat /@ Partition[{w},2]) ];


Options[MatrixToTransitions]={};

MatrixToTransitions[ K_, {A__List} ] := 
With[ {k = AlphabetSize[K], n = Zwei@Dimensions[{A}] }, 
     Thread /@ FlattenOne[ Thread /@ 
     		Pairs[ Table[ii,{k},{ii,n}], Table[ii,{ii,k},{n}], {A} ] ]
];  



Options[MinimalFischerFA]={Full->False, Normalize:>$defaultnormalize, External:>$defaultexternal};

MinimalFischerFA[ s_CA|s_FA, opts___?OptionQ ] := MinimalFischerFA[ToSA[s,opts],opts];
MinimalFischerFA[ s_DFA , opts___?OptionQ ] := 
    MinimalFischerFA[ ToSA@DeleteStateFA[ s, TheSinkDFA[s] ], opts ];

MinimalFischerFA[ s_SA, opts___?OptionQ ] := 
Module[ {mb, mbs, mm, dag, pos, res},
	mb  = MinimizeFA[s,opts];
	mbs = ToSA[mb,opts];
	If[ Size[mbs]==1, Return[mbs] ];	
	mm  = DeleteStateFA[ mbs, TheSinkDFA[mb] ];
	dag = ToDAG[ToGraphFA[ mm, Normalize->1 ]];
	pos = Position[ DegreeGraph[ dag, Full->True ], {_,0} ][[1,1]];
	res = SelectFA[ mm, VertexSet[dag][[ pos ]] ];
	If[ 0 == (Normalize /. {opts} /. Options[MinimalFischerFA]),
	    res, 
	    res = ReplacePart[ res, States[mbs], -1 ]
	];
	If[ Full /. {opts} /. Options[MinimalFischerFA],
	    { res, mb, VertexSet[dag][[pos]]  }, res ]
];


Options[MinimizeDFA]={Normalize:>$defaultnormalize, DoTrace->False, Hopcroft->False};

MinimizeDFA[ M_DFA, opts___?OptionQ ] :=
Module[ {n,norm,t,A,h,p1,p2,makechar,refine,
     nn,F,Ini,trace,tt,top,findpos,B,ff,MM},

    hopcr = Hopcroft  /. {opts} /. Options[MinimizeFA];    
    If[ hopcr, Return[ hopcroft[M,opts] ]];

    norm  = Normalize /. {opts} /. Options[MinimizeFA];    
    trace = DoTrace   /. {opts} /. Options[MinimizeFA];    

    tt = {};
    n = Size[ M ];
    A = Transitions[ M ];
    
(*  uses characteristic maps of equivalence relations *)       
    findpos[x_] := 
    If[ h[Last[x]]==0, h[Last[x]]=First[x], h[Last[x]] ];    
    
    makechar[ L_List ] := 
    (  Clear[h];
       h[_] := 0;
       LL = Pairs[ Range[Length[L]], L ];
       h[First[LL]] = 1;
       findpos /@ LL  );
    
    refine[s_] := 
    (  B = Thread[ Prepend[ s[[#]]& /@ A, s ] ];
       If[ trace, AppendTo[tt,B] ];
       makechar[B] );
    
(*  initialize characteristic function of F,Q-F *)
    p1 = Min[ Final[M] ];
    If[ p1=!=1, p2 = 1, p2 = Min[ Complement[ Range[n], Final[M] ]]];
    t  = If[ MemberQ[Final[M],#],p1,p2]& /@ Range[n];
    
(*  refine partition until no new classes occur *)
    t = FixedPoint[ refine, t ];

(*  renumber everything to get output DFA *)
    nn  = Length@Union[t];
    AssignFunction[ ff, Union[t], Range[nn] ];
    MM = StateMergeDFA[ M, ff /@ t, opts ];
    If[ trace,  { MM, tt }, MM ]
];






Options[MinimizeFA]={DoTrace->False, Normalize:>$defaultnormalize, External:>$defaultexternal};

MinimizeFA[ M_DFA, opts___?OptionQ ] := 
    If[ External /. {opts} /. Options[MinimizeFA], 
        Automata`extaut`ExtMinimizeFA[M,SelectOptions[ExtMinimizeFA,opts]],    
        MinimizeDFA[ AccessibleFA[ M, SelectOptions[AccessibleFA,opts] ], 
			SelectOptions[MinimizeDFA,opts] ]
    ];

MinimizeFA[ M_NFA|M_FA|M_SA, opts___?OptionQ ] := 
    If[ External /. {opts} /. Options[MinimizeFA], 
        Automata`extaut`ExtMinimizeFA[M,SelectOptions[ExtMinimizeFA,opts]],    
        MinimizeDFA[ToDFA[M,SelectOptions[ToDFA,opts,{Full}]],opts]
    ];

hopcroft[ M_DFA, opts___?OptionQ ] :=
Module[ {n,Q,k,KK,alph,norm,h,hh,nn,F,Ini,trace,ttrace,tr,pred, 
     trans,Fin,nop,cnop,part,targ,next,ppiv,sym,piv,j,
     inv,invtr,split,splitpart,getpivot,updatenext},

    norm  = Normalize /. {opts} /. Options[MinimizeFA];    
    trace = DoTrace   /. {opts} /. Options[MinimizeFA];

     inv[sym_,p_] := Flatten@Position[trans[[sym]],p];
     inv[LL_List] := inv@@LL;
      
     splitpart[i_Integer] := Intersection[part[[i]],#]& /@ pred;
     split[A_List,sym_Integer,B_List] := 
     Module[ {A0},
      A0 = Intersection[A,Flatten[inv[sym,#]& /@ B]];
      {A0, Complement[A,A0]}
     ];
   
     getpivot[L_List] := 
     Module[ {pos,piv},
             pos = Flatten@Position[ L, {__} ];
             If[ pos==={},{},piv = First[pos];{piv,L[[piv,1]]}]
     ];
     
     updatenext[ss_] := 
      AppendTo[next[[ss]],
      If[ !MemberQ[next[[ss]],j] && 
           0 < Length[targ[[j,ss]]] <= Length[targ[[nop,ss]]],
           j, nop ]
      ];

(* initialize two partitions *)

     n = Size[M];
     {k,kk,KK} = GetAlphabet[M];
     alph = Alphabet[M];
     Fin   = Final[M];
     trans = Transitions[M];
     invtr = Partition[inv /@ CartesianProduct[k,n],n];
     pred  = Union /@ trans;
     nop   = 2;
     part  = {Fin,Complement[Range[n],Fin]};
     targ  = splitpart /@ {1,2};
     next  = Table[If[Length[targ[[1,i]]] <= Length[targ[[2,i]]],{1},{2}],{i,k}];
     ttrace = { {{},part} };

     (*  main loop *)

     While[ Length[part] < n,

       ppiv  = getpivot[next];
       If[ Length[ppiv]==0, Break[] ];       (* done, exit *)
       {sym,piv}   = ppiv; 
       next[[sym]] = Rest[next[[sym]]];
       cnop = nop; 

       Do[ 
	   thetarg = targ[[piv,sym]];

	   If[  !DisjointQ[ part[[j]], Flatten[ invtr[[sym,thetarg]] ] ],

	   {P1,P2} = split[ part[[j]], sym, thetarg ]; 
	   part[[j]] = P1;

	   If[ Length[P2]>0,
	       nop++;
	       AppendTo[part,P2];
	       targ[[j]] = splitpart[j];
	       AppendTo[ targ, splitpart[nop] ];
	       updatenext /@ Range[k];
	   ];
	   ];
       ,{j,cnop}];         (* end Do-j  *)

       If[ trace, AppendTo[ ttrace, {{alph[[sym]],piv},part} ]];
     ];             (* end while *)

     nn  =  Length[part];
     AssignFunction[ h, Range[n], First@First@Position[part,#]& /@ Range[n]];
     Scan[ (hh[h[#]]=#)&, Reverse@Range[n] ];
     tr  = Thread@Map[ h, Thread[trans][[hh /@ Range[nn]]], {2} ];
     Ini = h[TheInitial[M]];
     F   = Union[ h /@ Final[M] ];
     res = DFA[ nn, kk, tr, Ini, F, KK, {} ];

     If[ trace, Return[ {res, ttrace} ] ];

     Switch[ norm, 
         0, res, 
         1, ReplacePart[ res, part, -1 ],
         2, ReplacePart[ res, Q[[#]]& /@ part, -1 ]
     ]
];


Options[ModCounterDFA]={Normalize:>$defaultnormalize};

ModCounterDFA[ a_, r_Integer, n_Integer, K_:$alphabet, opts___?OptionQ ] := 
    ModCounterDFA[ a, {r}, n, K, opts ]; 

ModCounterDFA[ a_, LL_List, n_Integer, K_:$alphabet, opts___?OptionQ ] := 
Module[{A,R,p,k,alph,norm},
    norm = Normalize /. {opts} /. Options[ModCounterDFA];
    
    {k,alph} = MakeFullAlphabet[K];
    R = Range[n];
    p = First@ToIndex[a,alph];
    A = Join[ Table[R,{p-1}], {RotateLeft[R]}, Table[R,{k-p}] ];
    res = DFA[ n, AlphabetSizeS[K], A, 1, LL+1, MakeShortAlphabet[K], {} ];
    If[ norm==0,
        res, 
        ReplacePart[ res, Range[0,n-1], -1 ]
    ]
];




Options[NFA]={};

NFA[n_,k_,t_,i_,f_] := NFA[n,k,t,i,f,{},{}];


NNFAToFA[ M_NNFA, K_:$alphabet ] := 
Module[ {insert,shifttr,T},
     insert[{p_,q_}] := {p,M[[3,q]],q};
     shifttr[{p_,s_,q_}] := {p+1,s,q+1};

     T = insert /@ Join[ CartesianProduct[{0},M[[4]] ], Zwei[M] ];
     T = ToTransitions[ T, K ];

     FA[ First[M] + 1,
         AlphabetSizeS[K],
         shifttr /@ T,
         {1},
         If[ M[[6]]==0, M[[5]], Union[ M[[5]], {0} ] ] + 1,
         MakeShortAlphabet[K], {}
     ]
];
    



Options[NNFA]={};

unionNNFA[ M1_NNFA, M2_NNFA ] := 
Module[ {n=M1[[1]], I1=M1[[4]], F1=M1[[5]], I2, F2},
     I2 = M2[[4]] + n;
     F2 = M2[[5]] + n;
     NNFA[    
            n + M2[[1]],
            Union[ M1[[2]], M2[[2]] + n ],
            Join[ M1[[3]], M2[[3]] ],
            Union[ I1, I2 ],
            Union[ F1, F2 ],
            Max[ M1[[6]], M2[[6]] ] 
     ]
];
unionNNFA[ M1_NNFA, M2_NNFA, M___NNFA ] := 
     unionNNFA[ unionNNFA[ M1, M2 ], M ];
       
concatenateNNFA[ M1_NNFA, M2_NNFA ] := 
Module[ {n=M1[[1]], I1=M1[[4]], F1=M1[[5]], I2, F2},
     I2 = M2[[4]] + n;
     F2 = M2[[5]] + n;
     
     NNFA[    
	   n + M2[[1]],
	   Union[ M1[[2]], M2[[2]]+n, CartesianProduct[F1,I2] ],
	   Join[ M1[[3]], M2[[3]] ],
	   If[M1[[6]]==0, I1, Union[ I1, I2 ] ],
	   If[M2[[6]]==0, F2, Union[ F1, F2 ] ],
	   M1[[6]] M2[[6]]
     ]
];
concatenateNNFA[ M1_NNFA, M2_NNFA, M___NNFA ] := 
    concatenateNNFA[ concatenateNNFA[ M1, M2 ], M ];
       
starNNFA[ M_NNFA ] := ReplaceParts[ M, Union[ Zwei[M], CartesianProduct[M[[5]],M[[4]]] ], 2, 1, 6 ];


Options[NoFactorFA]={Normalize:>$defaultnormalize};

NoFactorFA[ MM_?FSMQ, opts___?OptionQ ] := 
Module[ {n,alph,m1,F,p,sink,flip,m2,newtrans,mm2,F0},
	M    = ToDFA[MM,opts];
	n    = Size[M];
	k    = AlphabetSize[M];
	m1   = ToFA[M,opts];
	F    = Final[M];
	p    = TheSinkDFA[M];
	sink = If[p>0,p,n+1];
	flip[{x_,a_,y_}] := 
		If[ MemberQ[F,x], {x,a,sink}, {x,a,y} ];
	m1[[1]] = n1 = If[p>0,n,n+1];
	m1[[3]] = flip /@ m1[[3]];
	m2      = m1;
	m2[[1]] = n2 = n1+1;
	newtrans = Join[ 
			CartesianProduct[{n2},Range[k],{n2}],
			CartesianProduct[{n2},Range[k],m2[[4]]],
			CartesianProduct[{sink},Range[k],{sink}]
		   ];
	m2[[3]] = Join[m2[[3]],newtrans];
	m2[[4]] = {n2};
	mm2     = ToDFA[m2,Normalize->2];
	F0      = Complement[Range[n2],F,{sink}];
	mm2[[5]] = PositionList[States[mm2],Select[States[mm2],SubsetQ[#,F0]&] ];
	IntersectionFA[ m1, MinimizeFA[mm2,opts], opts ]
];


Options[NoPrefixFA]={Normalize:>$defaultnormalize};

NoPrefixFA[ MM_?FSMQ, opts___?OptionQ ] := 
Module[ {M,tr,F},
	M  = ToFA[ToDFA[MM,opts],opts];
	tr = Transitions[M];
	F  = Final[M];
	ReplacePart[ M, Complement[ tr, Select[ tr, MemberQ[F,First[#]]& ] ], 3 ] 
];


Options[NormalizeControl]={};

NormalizeControl::off = "Normalization is turned off (level `1`).";
NormalizeControl::off = "Normalization is turned on (level `1`).";

NormalizeControl[n_:2] := 
( 
  $defaultnormalize = n; 
  If[ n=!=0, Message[NormalizeControl::off,n], Message[NormalizeControl::on,n] ] 
);


Options[NormalizeFA]={};

NormalizeFA[ M_?FSMQ ] := ReplacePart[M,{},-1];


Options[NoSuffixFA]={Normalize:>$defaultnormalize};

NoSuffixFA[ MM_?FSMQ, opts___?OptionQ ] := 
Module[ {M,tr,F},
	M  = ToFA[ToDFA[ReverseFA[MM],opts]];
	tr = Transitions[M];
	F  = Final[M];
	ReverseFA@ReplacePart[ M, Complement[ tr, Select[ tr, MemberQ[F,First[#]]& ] ], 3 ]
];


Options[NumberOfCA]={};

NumberOfCA[ w_Integer, k_Integer ] := k^(k^w);

Options[NumberOfDFA]={};

NumberOfDFA[ n_Integer, k_Integer ] := n^(k n + 1) 2^n;


NumberOfTotalisticCA[ w_Integer, k_Integer ] := k^(w(k-1)+1);

Options[NumTransitions]={};

NumTransitions[ M_DFA ] := Size[M] AlphabetSize[M];
NumTransitions[ M_FA|M_SA|M_BEFA ] := Length@Transitions[M];
NumTransitions[ M_NFA ] := Length@Transitions@ToFA[M];


Options[OrbitCA]={Boundary->Cyclic, External:>$defaultexternal};

OrbitCA[ C_CA, pat_String, t_Integer:40, opts___?OptionQ ] := 
Module[ {G},

     (*If[ External /. {opts} /. Options[OrbitCA], 
         Return[ Automata`extaut`ExtOrbitCA[C,pat,t,opts] ] ]; *)
     GlobalMapCA[ G, C, WordMap->True, SelectOptions[GlobalMapCA,opts] ];
     NestList[ G, pat, t ]
];

OrbitCA[ C_CA, pat_List, t_Integer:40, opts___?OptionQ ] := 
Module[ {G},

     If[ External /. {opts} /. Options[OrbitCA], 
         Return[ Automata`extaut`ExtOrbitCA[C,pat,t,opts] ] ]; 
     GlobalMapCA[ G, C, WordMap->False, SelectOptions[GlobalMapCA,opts] ];
     NestList[ G, pat, t ]
];


Options[ParikhVector]={};

ParikhVector[ Eps|"Eps"|Global`\[Epsilon], K_:$alphabet ] := 
     Table[0,{AlphabetSize[K]}];

ParikhVector[ w_?WordQ, K_:$alphabet ] := 
     Count[ToCharacters[w],#]& /@ MakeAlphabet[K];

ParikhVector[ L_List, K_:$alphabet ] := 
Block[ {k,alph,parikh},
     {k,alph} = MakeFullAlphabet[K];
     parikh["Eps"|Eps] = Table[0,{k}];
     parikh[x_] := Count[ToCharacters[x],#]& /@ alph;
     parikh /@ L
];





Options[PermutationSA]={};

PermutationSA[ perms_List, K_:$alphabet ] := 
Module[ {k,n},
    k  = AlphabetSize[K];
    n  = Length@First[perms];
    SA[ n, AlphabetSizeS[K], 
        Sort@FlattenOne[Thread[{Range[n],Table[#,{n}],ToList[perms[[#]]]}]& /@ Range[k]], 
        MakeShortAlphabet[K], {} ]
];




PermuteFA[ M_DFA, {pp__}|T[pp__] ] := 
Module[ {n,hh,perm,iperm},
	n = Size[M];
	perm = {pp};
	AssignFunction[ hh, Range[n], perm, Opts->Listable ];
	iperm = ToList@InverseT[T@@perm];
	res = ReplaceParts[ M, hh /@ Thread[ Thread[Transitions[M]][[iperm]] ], 3, 
		hh[ TheInitial[M] ], 4, Sort[hh /@ Final[M]], 5 ];
	ReplacePart[ res, States[M][[perm]], -1 ]
];

PermuteFA[ M_FA, perm_List ] := 
Module[ {n,hh,newtr},
	n = Size[M];
	AssignFunction[ hh, Range[n], perm ];
	newtr[{p_,a_,q_}] := { hh[p],a,hh[q] };
	res = ReplaceParts[ M, newtr /@ Transitions[M], 3, 
		Sort[hh /@ Initial[M]], 4, Sort[hh /@ Final[M]], 5 ];
	ReplacePart[ res, States[M][[perm]], -1 ]
];

PermuteFA[ M_NFA, perm_List ] := ToNFA@PermuteFA[ ToFA[M], perm ];
PermuteFA[ M_SA, perm_List ] := ToSA@PermuteFA[ ToFA[M], perm ];
		


Options[PlotComputationFA]={DoTrace->Automatic, LabelGrid->None, Full->True, Frame->True};

PlotComputationFA[ M_NFA|M_DFA|M_SA, w_?WordQ, opts___?OptionQ] := 
      PlotComputationFA[ ToFA[M], w, opts];
      
PlotComputationFA[ M_FA, w_?WordQ, opts___?OptionQ ] :=
Block[  {n,A,B,trace,full},

	 n  = Size[M];
	 
	trace = DoTrace /. {opts} /. Options[PlotComputationFA];
	full  = Full /. {opts} /. Options[PlotComputationFA];

	{A,B} = 
	Switch[ trace,
		Automatic,     {Initial[M],Final[M]},
		All,           {Range[n],Range[n]},
		{__Integer},   {trace,Range[n]},
		_,             trace
	]; 
      
	PlotTDGraph[ ComputationGraphFA[M,w], n, 
		     DoTrace->{A,B}, Full->full, FrameTicks->None, opts ]
];


Options[PolynomialToCA]={};

PolynomialToCA[ pol_, w_Integer, k_Integer:2, str_String:"x" ] := 
Block[ {ff,kk},
    kk = Abs[k];
    ff = Function[ Evaluate[SymbolList[str,w]], Mod[ pol, kk ] ];
    FunctionToCA[ ff, w, -kk ]
];



Options[postload]={};

Options[PrefixDFA]={Normalize:>$defaultnormalize};

PrefixDFA[ w_?WordQ, K_:$alphabet, opts___?OptionQ ] :=
Module[  {n,lab,k,alph,A,norm,nexti,next},
    norm = Normalize /. {opts} /. Options[PrefixDFA];
    
    {k,alph} = MakeFullAlphabet[K];
    lab = ToIndex[ w, alph ];
    n   = Length[lab];
    
    nexti[a_,i_] := If[ lab[[i]]==a, i+1, n+2 ];
    next[a_] := Join[ nexti[a,#]& /@ Range[n], {n+1,n+2} ];     
    A = next /@ Range[k];
    res = DFA[ n+2, AlphabetSizeS[K], A, 1, {n+1}, MakeShortAlphabet[K], {} ];
    If[ norm==0,
        res,
        ReplacePart[ res, WordPrefixes[w], -1 ]
    ]
];




Options[PrefixQ]={};

PrefixQ[ Eps|"Eps"|Global`\[Epsilon], _?WordQ ] = True;
PrefixQ[ u_?WordQ, v_?WordQ ] := 
    StringMatchQ[ ToString[v], StringJoin[ToString[u],"*"] ];


automata::ldend = "autoamta loaded, version: `1`.";

Format[Automata`automata`Private`X[i_]] := Subscript["X",i];

Options[PrimitiveCount]={};

Attributes[PrimitiveCount]={Listable};

PrimitiveCount[ n_Integer, k_Integer ] := 
With[ {div = Divisors[n]}, Inner[ Times, MoebiusMu /@ div, k^(n/div), Plus] ];


Options[PrimitiveQ]={};

Attributes[PrimitiveQ]={Listable};

PrimitiveQ[ Eps|"Eps"|Global`\[Epsilon] ] := True;
PrimitiveQ[ s_String|s_Symbol ] := 
	With[ {ss = ToString[s]}, Length[StringPosition[ss<>ss,ss]]==2 ];



Options[PrintCA]={};

PrintCA[C_CA] := 
(     
    Switch[ WidthCA[C],
	1,	ToRulesCA[C],
	2|3,	Partition[ First@ToRulesCA[C], AlphabetSize[C]^(WidthCA[C]-1) ],
	_,	Partition[ First@ToRulesCA[C], AlphabetSize[C]^(WidthCA[C]-2) ] 
    ] // Thread // TableForm[#,TableSpacing->{1,2}]&
);


Options[PrintFA]={Full->False, TransOnly->False};

PrintFA[ M_DFA|M_NFA, opts___?OptionQ ] := 
Block[ {n,Q,alph,k,A,i,tr,long,toQ,trans}, 
    long  = Full /. {opts} /. Options[PrintFA];
    trans = TransOnly /. {opts} /. Options[PrintFA];
     
    n  = Size[M];
    Q  = States[M];
    {k,alph} = FullAlphabet[M];
    toQ[ {x_,a_,z_} ] := {Q[[x]],alph[[a]],Q[[z]]};
    
    If[ !trans,
        Print[  "no. of states:  ", n ];
        If[ long && StructuredQ[M], Print[ "states:      ", Q ] ];
        Print[  "alphabet:       ", alph ];
        If[ long && StructuredQ[M], 
            Print[ "initial states: ", Q[[Initial[M]]] ],
            Print[ "initial states: ", Initial[M] ]
        ];
        If[ long && !IntegerQ@First[M], 
            Print[ "final states:   ", Q[[Final[M]]] ],
            Print[ "final states:   ", Final[M] ]
        ];
    ];
    
    If[ !long, 
        TableForm[ Transitions[M], 
                   TableDepth->2, TableSpacing->{0,2}, 
                   TableHeadings->{alph,Automatic} ],
    (* else *)
        tr = MatrixToTransitions[Alphabet[M],Transitions[M]];
        toQ /@ tr // MatrixForm 
    ]
];
      
PrintFA[ M_FA, opts___?OptionQ ] := 
Block[ {n,Q,alph,k,A,i,tr,long,toQ,trans}, 
    long  = Full  /. {opts} /. Options[PrintFA];
    trans = TransOnly /. {opts} /. Options[PrintFA];
     
    n  = Size[M];
    Q  = States[M];
    {k,alph} = FullAlphabet[M];
    tr = Sort@FullTransitions[M];
    toQ[ {x_,a_,z_} ] := {Q[[x]],a,Q[[z]]};
    
    If[ !trans,
        Print[  "no. of states:   ", n ];
        Print[  "no. transitions: ", Length[tr] ];
        If[ long && !IntegerQ@First[M], Print[ "states:     ", Q ] ];
        Print[  "alphabet:        ", alph ];
        If[ long && !IntegerQ@First[M], 
            Print[ "initial states:  ", Q[[Initial[M]]] ],
            Print[ "initial states:  ", Initial[M] ]
        ];
        If[ long && !IntegerQ@First[M], 
            Print[ "final states:    ", Q[[Final[M]]] ],
            Print[ "final states:    ", Final[M] ]
        ];
    ];
    
    If[ !long, 
        TableForm[ Partition[tr,$transdispwidth,$transdispwidth,1,{}], TableSpacing->{1,1} ],
        toQ /@ tr // MatrixForm
    ]
];

PrintFA[ M_SA, opts___?OptionQ ] := 
Block[ {n,Q,alph,k,A,i,tr,long,toQ,trans}, 
    long  = Full  /. {opts} /. Options[PrintFA];
    trans = TransOnly /. {opts} /. Options[PrintFA];
     
    n  = Size[M];
    Q  = States[M];
    {k,alph} = FullAlphabet[M];
    tr = Sort@FullTransitions[M];
    toQ[ {x_,a_,z_} ] := {Q[[x]],a,Q[[z]]};
    
    If[ !trans,
        Print[ "no. of states:   ", n ];
        Print[ "no. transitions: ", Length[tr] ];
        If[ long && !IntegerQ@First[M], Print[ "states:     ", Q ] ];
        Print[ "alphabet:        ", alph ];
        Print[ "initial states: -all-" ];
        Print[ "final states:   -all-" ];
    ];
    
    If[ !long, 
        TableForm[ Partition[tr,$transdispwidth,$transdispwidth,1,{}], TableSpacing->{1,1} ],
        toQ /@ tr 
    ]
];



Options[ProductFA]={Full->False, Type->"Intersection", Normalize:>$defaultnormalize};


ProductFA[M1_SA,M2_SA,opts___?OptionQ] := 
Module[ {k,cp,Tr0,T1,T2,Tr,A,n,n1,n2,Q,Q1,Q2},
     norm  = Normalize /. {opts} /. Options[SquareSA];

     {k,kk,KK} = GetAlphabet[M1];
     n1  = Size[ M1 ];
     n2  = Size[ M2 ];
     n   = n1 n2;
     cp  = CartesianProduct[ n1, n2 ];

     If[ EpsFreeQ[M2], 
         T1 = Transitions[M1], 
         T1 = Join[Transitions[M1], 
				Pairs[Range[n1],Table[0,{n1}],Range[n1]]]
     ];
     If[ EpsFreeQ[M1], 
         T2 = Transitions[M2], 
         T2 = Join[Transitions[M2], 
				Pairs[Range[n2],Table[0,{n2}],Range[n2]]]
     ];

     Tr = ProductTransitions[ T1, T2, k ];     
     Tr = DeleteCases[ Tr, {x_,0,x_} ] /. RenumberRules[cp];
     res = SA[ n, kk, Tr, KK, {} ];
     Switch[ norm, 
         0, res,
         1, ReplacePart[ res, cp, -1 ],
         2, ReplacePart[ res, {States[M1][[#[[1]]]],States[M2][[#[[2]]]]}& /@ cp, -1 ]
     ]
];

ProductFA[M1_FA,M2_FA,opts___?OptionQ] := 
Module[ {k,kk,KK,cp,Tr0,T1,T2,Tr,A,n,n1,n2,Q,Q1,Q2,rules},
     norm  = Normalize /. {opts} /. Options[SquareSA];

     {k,kk,KK} = GetAlphabet[M1];
     n1  = Size[ M1 ];
     n2  = Size[ M2 ];
     n   = n1 n2;
     cp  = CartesianProduct[ n1, n2 ];
     rules = RenumberRules[cp];

     If[ EpsFreeQ[M2], 
         T1 = Transitions[M1], 
         T1 = Join[Transitions[M1], Pairs[Range[n1],Table[0,{n1}],Range[n1]]]
     ];
     If[ EpsFreeQ[M1], 
         T2 = Transitions[M2], 
         T2 = Join[Transitions[M2], Pairs[Range[n2],Table[0,{n2}],Range[n2]]]
     ];

     Tr = ProductTransitions[ T1, T2, k ];     
     Tr = DeleteCases[ Tr, {x_,0,x_} ] /. RenumberRules[cp];
     ini = CartesianProduct[Initial[M1],Initial[M2]] /. rules;

     If[ "Intersection" === (Type /. {opts} /. Options[ProductFA]),
         fin = CartesianProduct[Final[M1],Final[M2]] /. rules,
         fin = Union[CartesianProduct[Final[M1],Range[n2]],
	             CartesianProduct[Range[n1],Final[M2]]] /. rules
     ];
     res = FA[ n, kk, Tr, ini, fin, KK, {} ];
     Switch[ norm, 
         0, res, 
         1, ReplacePart[ res, cp, -1 ],
         2, ReplacePart[ res, {States[M1][[#[[1]]]],States[M2][[#[[2]]]]}& /@ cp, -1 ] 
     ]
];

ProductFA[M1_DFA,M2_DFA,opts___?OptionQ] :=
     If[ "Intersection" === (Type /. {opts} /. Options[ProductFA]),
         productDFA[ M1, M2, False, opts ],
         productDFA[ M1, M2, True , opts ]
     ];

ProductFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
    ProductFA[ M1//ToFA, M2//ToFA, opts ];

ProductFA[ M1_?FSMQ, M2_?FSMQ, M___?FSMQ, opts___?OptionQ ] := 
    ProductFA[ ProductFA[ M1, M2, opts ], M, opts ]; 


Options[productDFA] = {Full->False,Normalize:>$defaultnormalize};

productDFA[ M1_DFA, M2_DFA, bool_, opts___?OptionQ  ] := 
Module[  { k, K, KK, n, F, Ini, Q, Q1, Q2, Tr, A, A1, A2, 
     states, newstates, next, current, norm, full, rules },
     
     norm = Normalize /. {opts} /. Options[productDFA];
     full = Full /. {opts} /. Options[unionFA];
     If[ full, Return[ fullproductDFA[M1,M2,bool,norm] ] ];
     
     {k,kk,KK} = GetAlphabet[M1];
     A1 = Thread[Transitions[M1]];
     A2 = Thread[Transitions[M2]];
     states = {{TheInitial[M1],TheInitial[M2]}};

     next[{p_,q_}] := 
      ( t0 = Thread[{A1[[p]],A2[[q]]} ];
     t  = Thread[ {Table[{p,q},{k}], Range[k], t0} ];
     Tr = Join[ Tr, t ];
     newstates = Union[ Select[t0,!MemberQ[states,#]&] ];
     states = Join[states,newstates]  );
      
     Tr = {};
     current = 0;
     While[ current < Length[states],
            P = states[[++current]];
            next[ P ]
     ];
     
     Q   = Union@FlattenOne[ Drop[#,{2}]& /@ Tr ];
     n   = Length[Q];
     rules = Thread[ Q -> Range[n] ];
     Tr  = Tr /. rules;
     A   = TransitionsToMatrix[ n, k, Tr ];
     Ini = {TheInitial[M1],TheInitial[M2]} /. rules;
     If[ bool,
         F = Select[ states, 
             (MemberQ[Final[M1],#[[1]]] || MemberQ[Final[M2],#[[2]]])& ],
         F = Select[ states, 
             (MemberQ[Final[M1],#[[1]]] && MemberQ[Final[M2],#[[2]]])& ]      
     ];
     res = DFA[ n, kk, A, Ini, Union[F /. rules], KK, {} ];
     Switch[ norm,
         0, res,
         1, ReplacePart[ res, Q, -1 ],
         2, ReplacePart[ res, {States[M1][[#[[1]]]],States[M2][[#[[2]]]]}& /@ Q, -1 ]  
     ]
];

fullproductDFA[ M1_DFA, M2_DFA, bool_, norm_ ] := 
Module[ {k,kk,KK,F,Ini,rules,CP,Tr0,T1,T2,Tr,A,n,n1,n2,Q,Q1,Q2,i,j},

     {k,kk,KK} = GetAlphabet[M1];
     n1  = Size[ M1 ];
     n2  = Size[ M2 ];
     n   = n1 n2;
     CP  = CartesianProduct[ n1, n2 ];
     rules = Thread[ CP -> Range[n] ];
     T1  = MatrixToTransitions[ k, Transitions[M1] ];
     T2  = MatrixToTransitions[ k, Transitions[M2] ];
     Tr  = ProductTransitions[ T1, T2, k ];     
     Tr  = Tr /. rules;
     A   = TransitionsToMatrix[ n, k, Tr ];
     Ini = {TheInitial[M1],TheInitial[M2]} /. rules;
     If[ bool,
         F = Join[ CartesianProduct[Range[n1],Final[M2]], 
                   CartesianProduct[Final[M1],Range[n2]] ],
         F = CartesianProduct[Final[M1],Final[M2]] 
     ];
     res = DFA[  n, kk, A, Ini, Union[F /. rules], KK, {} ];
     Switch[ norm, 
	0, res, 
	1, ReplacePart[ res, CP, -1 ],
	2, ReplacePart[ res, {States[M1][[#[[1]]]],States[M2][[#[[2]]]]}& /@ CP, -1 ]
     ]
];



Options[ProductTransitions]={Full->0};

ProductTransitions[ L1_List, L2_List, k_Integer, opts___?OptionQ ] := 
Module[ {prod,xtrans,sortr,TT,full},  
    full = Full /. {opts} /. Options[ProductTransitions];

    prod[ {{p1_,x_,q1_},{p2_,x_,q2_}} ] := { {p1,p2}, x, {q1,q2} };
    sortr[ {p_,x_,q_} ] := { Sort[p], x, Sort[q] };
    xtrans[x_] := prod /@ CartesianProduct[ Cases[L1,{_,x,_}], Cases[L2,{_,x,_}] ];
    TT = FlattenOne[xtrans /@ Range[0,k]];
    Switch[ full,
    0,	    TT,
    1,	    Union[ sortr /@ TT ],
    2,	    DeleteCases[ Union[ sortr /@ TT ], {{p_,p_},_,_} | {_,_,{q_,q_}} ]
    ]
];



Options[ProperPrefixes]={};

ProperPrefixes[W_List] := 
Module[ {WW = ToString /@ W}, 
     If[ WW==={"Eps"}, Return[{}] ];
     StringDrop[#,-1]& /@ WW // Union // WordPrefixes // Union // WordSort
];


Options[QuotientDFA]={Normalize:>$defaultnormalize};

QuotientDFA[ L_, K_:$alphabet, opts___?OptionQ ] :=
Block[ {Q,curr,n,Tr,next,f,grid,fin,k,alph,norm,B,q},
     {k,alph} = MakeFullAlphabet[K];
     norm = Normalize /. {opts} /. Options[QuotientDFA];
     Q = { WordSort[ToString /@ L] } /. ""->"Eps";
     
     next[p_Integer,a_String] :=
     ( B = WordSort[ LeftQuotient[ a, Q[[p]] ] ];
       q = Flatten[ Position[ Q, B ] ];
       If[ q=={},          (* new state found *)
           AppendTo[ Q, B ]; 
           n++;
           f[p,a] = n,     (* else: already known *)
           f[p,a] = q[[1]] 
       ];
     );
     
     curr = 0; 
     n    = 1;
     While[ n > curr++, next[curr,#]& /@ alph ];

     grid = Thread@Partition[ CartesianProduct[Range[n],alph],k];
     Tr   = Apply[f,grid,{2}];
     fin  = PositionList[Q,Cases[ Q, {___,"Eps",___}]];
     res = DFA[ Length[Q], AlphabetSizeS[K], Tr, 1, fin, 
			MakeShortAlphabet[K], {}];
     replaceStates[ norm, res, Q ]
];


Options[QuotientMachineFA]={Normalize:>$defaultnormalize};

QuotientMachineFA[ m1_FA, m2_FA, opts___?OptionQ ] :=
Module[ {k,K,n1,n2,tr,Q,FF,m,ma,II,norm},
       norm = Normalize /. {opts} /. Options[QuotientMachineFA];
    
       {k,K} = FullAlphabet[m1];
       n1 = Size[m1];
       n2 = Size[m2];
       tr = ProductTransitions[Transitions[ToFA[m1]],Transitions[ToFA[m2]],k];  
       Q  = CartesianProduct[ n1, n2 ];
       FF = CartesianProduct[ Range[n1], Final[m2] ];

       m  = ConvertToFA[FA,Q,K,tr,{1},FF,Normalize->2];
       ma = AccessibleFA[m,Normalize->2];
       II = PositionList[ States[ma],
               Select[ States[ma], MemberQ[Final[m1],#[[1]]]&] ];
       If[ norm==0, 
           SetInitialFA[ma,II] // NormalizeFA,
           SetInitialFA[ma,II]
       ]
];

QuotientMachineFA[ m1_?FSMQ, m2_?FSMQ, opts___?OptionQ ] := 
     QuotientMachineFA[ ToFA[m1], ToFA[m2], opts ];







Options[RandomDFA]={};

RandomDFA[ n_Integer, K_:$alphabet ] :=
    DFA[ n, AlphabetSizeS[K], 
         Partition[ Random[Integer,{1,n}]& /@ Range[n AlphabetSize[K]], n ], 
         Random[Integer,{1,n}], 
         FromBitVector[Table[Random[Integer],{n}]], 
         MakeShortAlphabet[K], {} ];


Options[RandomWord]={};

RandomWord[ n_Integer, K_:$alphabet ] := 
Module[ {k,alph},
     {k,alph} = MakeFullAlphabet[K];
     If[ Positive[n],
         ToWord[ Random[Integer,{1,k}]& /@ Range[n], alph ],
         ToWord[ Random[Integer,{1,k}]& /@ Range[Random[Integer,-n]], alph ]
     ]
];


Options[RankOfDFA]={};

RankOfDFA[ M_DFA ] := 
Module[ {n,k,c1,c2},
    n   = Size[M];
    k   = AlphabetSize[M];    
    
    c1 = ToBitVector[ Final[M], Reverse[Range[n]] ];
    c1 = FromDigits[ c1, 2 ];
    
    c2 = Append[ Flatten[Transitions[M]], TheInitial[M] ] - 1;
    c2 = FromDigits[ c2, n ];
    
    c2 2^n + c1
];
    


RankToDFA[ r_Integer, n_Integer, k_Integer ] := 
Module[ {c1,c2,A,F,q0},
    If[ r > NumberOfDFA[n,k], Return["Rank too big."]];
    c1 = Mod[ r, 2^n ];    
    F  = FromBitVector[ IntegerDigits[c1,2,n], Reverse[Range[n]] ];
    
    c2 = Floor[ r/2^n ];
    A  = IntegerDigits[ c2, n, n k + 1 ] + 1;
    q0 = Last[A]; 
    A  = Partition[ Drop[A,-1], n ];
    DFA[ n, k, A, q0, F, {}, {} ]
];



Options[REEpsQ]={};

REEpsQ["Eps"|Eps]  = True;
REEpsQ["Empty"|Empty] = False;
REEpsQ[w_?WordQ]   = False;
REEpsQ[REP[xx__]] := Or@@( REEpsQ /@ {xx} );
REEpsQ[RET[xx__]] := And@@( REEpsQ /@ {xx} );
REEpsQ[RES[xx__]]  = True;


REClassify["Empty"|Empty] = 0;
REClassify["Eps"|Eps]     = 1;
REClassify[w_?WordQ]      = 2;
REClassify[REP[xx__]] := Max[ REClassify /@ {xx} ];
REClassify[RET[xx__]] := 
Module[ {vals},
    vals = REClassify /@ {xx};
    If[ Min[vals]==0, 0, Max[vals] ]
];
REClassify[RES[xx_]] := If[ REClassify[xx] < 2, 2, 3 ];


(*  left quotients of rational expressions, no simplification! *)

Options[RegExpSimp]={};

Options[$regexrules]={};

$regexrules = Dispatch[{
     Times[_,x_] :> x,
     "Eps"->Eps,
     "Empty"->Empty,
     REP[x___,REP[z__],y___] :> REP[x,z,y], 
     REP[x___,Empty,y___] :> REP[x,y],
     REP[x___,u_,y___,u_,z___] :> REP[x,u,z,y],
     RET[x___,RET[z___],y___] :> RET[x,z,y], 
     RET[___,Empty,___] -> Empty,
     RET[x___,Eps,y___] :> RET[x,y],
     REP[] -> Empty,
     RET[] -> Eps,
     REP[xx_] :> xx,
     RET[xx_] :> xx,
     RES[Empty] -> Eps,
     RES[Eps] -> Eps,
     RES[RES[x_]] :> RES[x],
     REP[x___,u_,z___,RES[u_],y___] :> REP[x,z,RES[u],y],
     REP[x___,RES[u_],z___,u_,y___] :> REP[x,RES[u],z,y],
     RES[REP[x___,Eps,y___]] :> RES[REP[x,y]],
     RET[x___,REP[Eps,y__],RES[y__],z___] :> RET[x,RES[y],z] ,
     RET[x___,RES[y__],REP[Eps,y__],z___] :> RET[x,RES[y],z], 
     REP[x___,RES[y__],z___,Eps,u___] :> REP[x,RES[y],z,u],
     REP[x___,Eps,z___,RES[y__],u___] :> REP[x,RES[y],z,u],
     RET[x___,a_Symbol,b_Symbol,y___] :> RET[x,Concatenate[a,b],y],
     RET[a_String,b_String,x___] :> RET[ a<>b, x ]
}];


Options[RegularExpressionToBEFA]={};

RegularExpressionToBEFA[ exp_ ] := makeBEFA[ ToRegExp[exp] ];

Options[RegularExpressionToFA]={SizeOnly->False, EpsElim->True, Thompson->False};

RegularExpressionToFA[ exp_, K_:$alphabet, opts___?OptionQ ] := 
Module[ {size,m,eps},
     size = SizeOnly /. {opts} /. Options[RegularExpressionToFA];
     eps  = EpsElim  /. {opts} /. Options[RegularExpressionToFA];
     tomp = Thompson /. {opts} /. Options[RegularExpressionToFA];
     
     If[ size, 
         If[ tomp, 
             Return[ sizeBEFA[ ToRegExp[exp] ] ],
             Return[ sizeNNFA[ ToRegExp[exp] ] + 1 ]
     ]];
    
     If[ tomp,
         m = BEFAToFA[ RegularExpressionToBEFA[exp], K ];
         If[ eps, EpsilonEliminationFA[m], m ],
	          NNFAToFA[ RegularExpressionToNNFA[exp], K ]
     ]
];


RegularExpressionToNNFA[ exp_ ] := makeNNFA[ ToRegExp[exp] ];


Options[RemoveTransitionFA]={};

RemoveTransitionFA[ m_FA|m_SA, p_Integer, w_, q_Integer ] := 
Module[ {ww},
    ww = If[ WordQ[w], First@ToIndex[ w, Alphabet[m] ], w ];
    ReplacePart[ m, Complement[Transitions[m],{{p,ww,q}}], 3 ]];
RemoveTransitionFA[ m_FA|m_SA, {p_Integer, w_, q_Integer} ] := 
     RemoveTransitionFA[ m, p, w, q ];
RemoveTransitionFA[ m_FA|m_SA, tr:{___List} ] := 
     Last@FoldList[ RemoveTransitionFA, m, tr ];
RemoveTransitionFA[ m_DFA|m_NFA, tt__ ] := RemoveTransitionFA[ ToFA[m], tt ];  


Options[REP]={};

Options[REQ]={};

REQ[ Eps|"Eps"|Global`\[Epsilon], w_ ] := w; 
REQ[ u_?WordQ, Eps ] = Empty;
REQ[ u_?WordQ, Empty ] = Empty;
REQ[ u_?WordQ, w_?WordQ ] := LeftQuotient[u,w] /. {"Eps"->Eps };
REQ[ u_?WordQ, re_ ] := 
    Last@FoldList[ REQ[#2,#1]&, re, ToCharacters[u] ] /; WordLength[u]>1;
REQ[ aa_, REP[xx_] ] := REQ[ aa, xx ];
REQ[ aa_, RET[xx_] ] := REQ[ aa, xx ];
REQ[ aa_, REP[xx__] ] := REP@@( REQ[aa,#]& /@ {xx} );
REQ[ aa_, RET[xx_,yy__] ] := 
    If[REEpsQ[xx], 
        REP[ RET[REQ[aa,xx],yy], REQ[aa,RET[yy]] ],
             RET[REQ[aa,xx],yy]];
REQ[ aa_, RES[xx_] ] := RET[ REQ[aa,xx], RES[xx] ];




Options[RESimplify]={};

RESimplify[ exp_ ] := 
      exp /. {NonCommutativeMultiply->RET,Plus->REP} //. $regexrules;


Options[RES]={};

Options[RET]={};

Options[ReverseFA]={};

ReverseFA[ M_FA ] := 
    ReplaceParts[ M, Reverse /@ Transitions[M], 3, Final[M], 4, Initial[M], 5 ];
ReverseFA[ M_NFA|M_DFA ] := ReverseFA[ ToFA[M] ];     
ReverseFA[ M_SA ] := ReplacePart[ M, Reverse /@ Transitions[M], 3 ];
    


Options[RightShiftCA]={};

RightShiftCA[k_Integer] := FunctionToCA[  {##}[[1]] &, 3, k ];

Options[SA]={};

SA[n_,k_,t_] :=  SA[n,k,t,{},{}];


Options[SelectFA]={Normalize->1};

SelectFA[ M_FA, L_List, opts___?OptionQ ] :=
Module[ {hh,hhh,nn,Q,tr,ini,fin,norm},
    norm = Normalize /. {opts} /. Options[SelectFA];
    {k,kk,KK} = GetAlphabet[M];
    nn   = Length[L];
    AssignFunction[hh,L,Range[nn]];
    hhh[{p_,s_,q_}] := {hh[p],s,hh[q]};
    tr   = hhh /@ Select[Transitions[M], 
            (MemberQ[L,First[#]]&&MemberQ[L,Last[#]])&];
    ini  = hh /@ Intersection[ Initial[M], L  ];
    fin  = hh /@ Intersection[ Final[M], L  ];
    res  = FA[ nn, kk, tr, ini, fin, KK, {} ];
    Switch[ norm,
	0, res,
	1, ReplacePart[ res, L, -1 ], 
	2, ReplacePart[ res, States[M][[L]], -1 ] 
    ]
];

SelectFA[ M_DFA | M_NFA, L_List, opts___?OptionQ ] := 
      SelectFA[ ToFA[M], L, opts ];

SelectFA[ M_SA, L_List, opts___?OptionQ ] :=
Module[ {Q,nn,hh,hhh,tr,norm},
    norm = Normalize /. {opts} /. Options[SelectFA];
    {k,kk,KK} = GetAlphabet[M];
    nn   = Length[L];
    AssignFunction[hh,L,Range[nn]];
    hhh[{p_,s_,q_}] := {hh[p],s,hh[q]};
    tr   = hhh /@ Select[Transitions[M], 
            (MemberQ[L,First[#]]&&MemberQ[L,Last[#]])&];
    res  = SA[ nn, kk, tr, KK, {} ];
    Switch[ norm,
	0, res,
	1, ReplacePart[ res, L, -1 ], 
	2, ReplacePart[ res, States[M][[L]], -1 ] 
    ]
];




Options[SetFinalFA]={};

SetFinalFA[ m_DFA|m_FA|m_NFA, FF_List ] := ReplacePart[m,FF,5];
SetFinalFA[ m_SA, FF_List ] := ReplacePart[m//ToFA,FF,5];

SetInitialFinalFA[ m_SA|m_FA|m_NFA, II_List|II_Integer, FF_List|FF_Integer ] := 
    SetInitialFA[ SetFinalFA[m,FF], II ];
SetInitialFinalFA[ m_DFA, II_Integer, FF_List ] := 
    ReplaceParts[ m, II, 4, FF, 5 ];
SetInitialFinalFA[ m_DFA, II_List, FF_List|FF_Integer ] := 
    ReplaceParts[ m//ToFA, II, 4, FF, 5 ];

(* obsolete *)

Options[SetInitialFA]={};

SetInitialFA[ m_DFA, q_Integer ]       := ReplacePart[m,q,4];
SetInitialFA[ m_DFA, II_List ]         := ReplacePart[ m//ToFA,II,4];
SetInitialFA[ m_FA|m_NFA, II_List ]    := ReplacePart[m,II,4];
SetInitialFA[ m_FA|m_NFA, II_Integer ] := ReplacePart[m,{II},4];
SetInitialFA[ m_SA, II_List ]          := ReplacePart[ m//ToFA,II,4];
SetInitialFA[ m_SA, II_Integer ]       := ReplacePart[ m//ToFA,{II},4];


Options[SetInitialFinalFA]={};

SetInitialFinalFA[ m_SA|m_FA|m_NFA, II_List|II_Integer, FF_List|FF_Integer ] := 
    SetInitialFA[ SetFinalFA[m,FF], II ];
SetInitialFinalFA[ m_DFA, II_Integer, FF_List ] := 
    ReplaceParts[ m, II, 4, FF, 5 ];
SetInitialFinalFA[ m_DFA, II_List, FF_List|FF_Integer ] := 
    ReplaceParts[ m//ToFA, II, 4, FF, 5 ];

Options[$shortlines]={};

$shortlines = 4;

Options[ShowAcceptQFA]={};

ShowAcceptQFA[M_?FSMQ,xx_?WordQ] := 
     Pairs[ AcceptQFA[M,xx,DoTrace->True], Append[ToCharacters[xx],"-"] ];


Options[ShowAll]={};

Options[ShowEdges]={};

Options[ShrinkCA]={Full->False};

ShrinkCA[ C_CA, opts___?OptionQ ] :=
Module[ {lab,lab1,lab2,w,k,kk,dr,dl,full},
     full = Full /. {opts} /. Options[ShrinkCA];
     lab = ToLabelCA[C];
     w   = WidthCA[C];
     k   = Drei[C];
     kk  = Abs[k];
     dr  = 1;
     While[ dr <= w && Max[Length /@ Union /@ Partition[lab,kk^dr]]==1, dr++ ];
     dr--;
     lab1 = First /@ Partition[lab,kk^dr];
     dl   = w-dr;
     While[ dl >= 0 && Length@Union@Partition[lab1,kk^dl]==1, dl-- ];
     dl++;
     lab2 = First@Union@Partition[lab1,kk^dl];
     
     If[ full,
         {CA[lab2,dl,k], {w-dr-dl,dr}},
         CA[lab2,dl,k]
     ] // LabelToCodeCA
];






Options[ShuffleProductFA]={Normalize:>$defaultnormalize};

ShuffleProductFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
Module[  {MM1,MM2,n1,n2,F,Ini,rules,nn,Tr,Q,T1,T2,norm },
     norm = Normalize /. {opts} /. Options[ShuffleProductFA];

     {k,kk,KK} = GetAlphabet[M1];
     MM1 = ToFA[M1];
     MM2 = ToFA[M2];    
     n1  = Size[MM1];
     n2  = Size[MM2];
     T1  = Transitions[MM1];
     T2  = Transitions[MM2];
     Tr  = shuffleProductTransitions[n1,n2,T1,T2];    
     Q   = Union[ Flatten[ Drop[#,{2}]& /@ Tr, 1 ] ];
     rules = RenumberRules[Q];
     Tr  = Tr /. rules;
     Ini = CartesianProduct[ Initial[MM1],Initial[MM2] ] /. rules;
     F   = CartesianProduct[ Final[MM1], Final[MM2] ] /. rules;
     res = FA[ Length[Q], kk, Tr, Sort[Ini], Sort[F], KK, {} ];
     Switch[ norm,
         0, res,
         1, ReplacePart[ res, Q, -1 ],
         2, ReplacePart[ res, {States[M1][[#[[1]]]],States[M2][[#[[2]]]]}& 
/@ Q, -1 ]  
     ]
];

shuffleProductTransitions[ n1_Integer, n2_Integer, L1_List, L2_List ] := 
Module[ {prod1,prod2},  
    prod1[{x_,a_,y_}] := {{x,#},a,{y,#}}& /@ Range[n2];
    prod2[{x_,a_,y_}] := {{#,x},a,{#,y}}& /@ Range[n1];
      
    Union[ Flatten[ prod1 /@ L1, 1 ], Flatten[ prod2 /@ L2, 1 ] ]
];






Options[SinkQDFA]={};

SinkQDFA[ M_DFA ] := 
Module[ {sink},
     sink = TheSinkDFA[M];
     (sink > 0) && {sink}===Complement[Range@Size[M],Final[M]]
];






Options[SinksDFA]={};

SinksDFA[ M_DFA ] := 
        Select[ Union /@ Thread[Append[ Transitions[M], Range@Size[M]]], 
            (Length[#]==1)& ] // FlattenOne;


Options[SizeOnly]={};

Options[Size]={Full->False};

Attributes[Size]={Listable};

Size[M_?FSMQ,opts___?OptionQ]   := 
If[ Full /. {opts} /. Options[Size],
    { First[M],
	AlphabetSize[M],
	If[Head[M]===DFA,
	    First[M] AlphabetSize[M],
	    Length[Transitions[M]]
	],
	Length[Initial[M]],
	Length[Final[M]] },
    First[M]
];
Size[M__?FSMQ,opts___?OptionQ]  := Size[{M},opts];

StructuredQ[M_?FSMQ] := MinusEins[M]=!={};


Options[Some]={};

Options[SquareSA]={Full->0, Normalize:>$defaultnormalize};


SquareSA[M_SA,opts___?OptionQ] := 
Module[ {norm,full,k,kk,KK,n,n2,NN,h,newtr},
     norm = Normalize /. {opts} /. Options[SquareSA];
     full = Full /. {opts} /. Options[SquareSA];
     
     {k,kk,KK}  = GetAlphabet[M];
     n  = Size[M];
     tr = ProductTransitions[Transitions[M],Transitions[M],k,opts];

     Switch[ full,
	     0,  n2 = n^2; NN = CartesianProduct[n, n],
	     1,  n2 = n(n + 1)/2; NN = NonDecreasing[n, 2],
	     2,  n2 = n(n - 1)/2; NN = PowerSet[n, 2]
     ];

     AssignFunction[ h, NN, Range[n2] ];
     newtr[{p_,a_,q_}] := {h[p],a,h[q]};
     res = SA[ n2, kk, newtr /@ tr, KK, {} ];

     Switch[ norm, 
	     0,  res, 
	     1,  ReplacePart[ res, NN, -1 ],
	     2,  ReplacePart[ res, States[M][[#]]& /@ NN, -1 ]
     ]
];


Options[StarFA]={Normalize:>$defaultnormalize, EpsElim->True};

StarFA[ M_FA, opts___?OptionQ ] := 
Module[ {n,k,kk,KK,T1,T2,Tr,norm,eps,MM},
     norm = Normalize /. {opts} /. Options[StarFA];
     eps  = EpsElim /. {opts} /. Options[StarFA];
     
     {k,kk,KK} = GetAlphabet[M];
     n  = Size[M];
     T1 = Map[ ({1,0,#})&, Initial[M]+1 ];
     T2 = Map[ ({#,0,1})&, Final[M]+1 ];
     Tr = Join[  Map[ shiftrans[1,1,#]&, Transitions[M] ], T1, T2 ];
     res = FA[ n+1, kk, Tr, {1}, {1}, KK, {} ];
     If[ eps, res = EpsilonEliminationFA[res] ];
     Switch[ norm,
		0, res, 
        1|2, ReplacePart[ res, Join[{n+1}, States[M]], -1 ]
     ]
];

StarFA[ M_DFA, opts___?OptionQ  ] := StarFA[ ToFA[M], opts  ]; 
StarFA[ M_NFA, opts___?OptionQ  ] := StarFA[ ToFA[M], opts  ]; 
StarFA[ M_BEFA, opts___?OptionQ  ] := starBEFA[ M ]; 




Options[StateMergeDFA]={Normalize:>$defaultnormalize, DoTrace->False, Hopcroft->False};

StateMergeDFA[ M_DFA, equ_List, opts___?OptionQ ] := 
Module[ {n,nn,h,hh,A,Ini,F,norm}, 
    norm  = Normalize /. {opts} /. Options[MinimizeFA];    
    n  = Size[M];
    {k,kk,KK} = GetAlphabet[M];
    A  = Transitions[M];
    nn = Max[equ];
    AssignFunction[ h, Range[n], equ ];
    Scan[ (hh[h[#]]=#)&, Reverse[Range[n]] ];
    A   = Thread@Map[ h, Thread[A][[hh /@ Range[nn]]], {2} ];
    Ini = h[TheInitial[M]];
    F   = Union[ h /@ Final[M] ];
    res = DFA[ nn, kk, A, Ini, F, KK, {} ];        
    Switch[ norm, 
        0, res, 
        1, ReplacePart[ res, Flatten@Position[equ,#]& /@ Range[nn], -1 ],
        2, ReplacePart[ res, States[M][[Flatten@Position[equ,#]]]& /@ Range[nn], -1 ]
    ]
];




Options[States]={};

States[M_?FSMQ] := If[ MinusEins[M]=!={}, MinusEins[M],  Range[Size[M]] ];

replaceStates[ norm_Integer, M_, Q_ ] := 
    If[ norm==0, M, ReplacePart[ M, Q, -1 ] ];



Options[SubsetQFA]={External:>$defaultexternal};

SubsetQFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
    EquivalentQFA[ UnionFA[M1,M2], M2 ];






Substitute[ Equal[LS1_,RS1_], Equal[LS2_,RS2_] ] := 
     (Equal[LS1,RS1] /. {LS2 -> RS2}) //. Join[{distrib},$regexrules];
     
Substitute[ e_Equal, e1_Equal, e2__Equal ] := 
     Substitute[ Substitute[e,e1], e2 ];


Options[SubwordCounterDFA]={Normalize:>$defaultnormalize};

SubwordCounterDFA[w_?WordQ,p_Integer,K_:$alphabet,opts___?OptionQ] :=
Block[  {alph,ws,n,mask,delta,Q,W,m,norm},
     norm = Normalize /. {opts} /. Options[SubwordCounterDFA];
     alph = MakeAlphabet[K];
     ws = ToString[w];
     n  = WordLength[w];
     mask[i_] := mask[i] = ToBitVector[Union@Flatten@StringPosition[ws,i],n];    
     delta[pv_,i_] := Min[#,p+1]& /@ (pv + Drop[Prepend[pv,1] Append[mask[i],0],-1]);
     {Q,W,m} = GenerateDFA[ Table[0,{n}], delta, alph, Last[#]==p& ];
     replaceStates[ norm, m, Q ]
];

replaceStates[ norm_Integer, M_, Q_ ] := If[ norm==0, M, ReplacePart[ M, Q, -1 ] ];


Options[SubwordDFA]={Normalize:>$defaultnormalize};

SubwordDFA[ w_?WordQ, K_:$alphabet, opts___?OptionQ ] :=
Block[  {n,lab,k,alph,A,norm,nexti,next},
    norm = Normalize /. {opts} /. Options[SubwordDFA];
    
    {k,alph} = MakeFullAlphabet[K];
    lab = ToIndex[ w, alph ];
    AppendTo[lab,-1];
    n   = Length[lab];
    nexti[a_,i_] := If[ lab[[i]]==a, i+1, i ];
    next[a_] := nexti[a,#]& /@ Range[n];
     
    res = DFA[ n, AlphabetSizeS[K], next /@ Range[k], 1, {n}, 
               MakeShortAlphabet[K], {} ]; 
    If[ norm==0,
        res, 
        ReplacePart[ res, WordPrefixes[w], -1 ]
    ]
];
     



Options[SubwordModCounterDFA]={Normalize:>$defaultnormalize};

SubwordModCounterDFA[w_?WordQ,r_Integer,p_Integer,K_:$alphabet,opts___?OptionQ] :=
Block[  {alph,ws,n,mask,delta,Q,W,m,norm},
     norm = Normalize /. {opts} /. Options[SubwordCounterDFA];
     
     alph = MakeAlphabet[K];
     ws = ToString[w];
     n  = WordLength[w];
     mask[i_] := mask[i] = 
         ToBitVector[Union@Flatten@StringPosition[ws,i],n];    
     delta[pv_,i_] := 
         Mod[pv + Drop[Prepend[pv,1] Append[mask[i],0],-1],p];

     {Q,W,m} = GenerateDFA[ Table[0,{n}], delta, alph, Last[#]==r& ];

     If[ norm==0, 
         m, 
         ReplacePart[ m, Q, -1 ]
     ]
];




Options[SuffixesFA]={Normalize:>$defaultnormalize};

SuffixesFA[ w_?WordQ, K_:$alphabet, opts___?OptionQ ] :=
Module[  {n,tr,norm},
    norm = Normalize /. {opts} /. Options[SuffixesFA];
    
    {k,alph} = MakeFullAlphabet[K];
    lab = ToIndex[ w, alph ];
    n   = WordLength[w] + 1;
    tr  = Thread[ {Range[n-1], lab, Range[2,n]} ];
    res = FA[ n, AlphabetSizeS[K], tr, Range[n], {n}, MakeShortAlphabet[K], {} ];
    If[ norm==0,
        res, 
        ReplacePart[ res, WordPrefixes[w], -1 ]
    ]
];




Options[SuffixFA]={Normalize:>$defaultnormalize};

SuffixFA[ w_?WordQ, K_:$alphabet, opts___?OptionQ ] :=
Module[  {n,lab,k,alph,T1,T2,norm},
    norm = Normalize /. {opts} /. Options[SuffixFA];
    
    {k,alph} = MakeFullAlphabet[K];
    lab = ToIndex[ w, alph ];
    n   = Length[lab] + 1;
    T1  = Thread[ {Table[1,{k}],Range[k],Table[1,{k}]} ];
    T2  = Thread[ {Range[n-1],lab,Range[2,n]} ];
    res = FA[n, AlphabetSizeS[K], Join[T1,T2], {1}, {n}, MakeShortAlphabet[K], {} ];
    If[ norm==0,
        res, 
        ReplacePart[ res, WordPrefixes[w], -1 ]
    ]
];





Options[SumFA]={Normalize:>$defaultnormalize};

SumFA[ M1_SA, M2_SA, opts___?OptionQ ] := 
Module[ {k,kk,KK,n1,n2,Q1,Q2,T1,T2,norm},
     norm = Normalize /. {opts} /. Options[UnionFA];
     
     {k,kk,KK} = GetAlphabet[M1];
     n1  = Size[ M1 ];
     n2  = Size[ M2 ];
     T1  = Transitions[M1];
     T2  = shiftrans[n1,n1,#]& /@ Transitions[M2];
     res = SA[ n1+n2, kk, Join[T1,T2], KK, {} ]; 
     Switch[ norm,
        0, res, 
	1|2, ReplacePart[ res, Join[{1,#}& /@ States[M1], {2,#}& /@ States[M2]], -1 ]
     ]
];

SumFA[ M1_FA, M2_FA, opts___?OptionQ ] := 
Module[ {k,kk,KK,n1,n2,T1,T2,norm},
     norm = Normalize /. {opts} /. Options[UnionFA];
     
     {k,kk,KK} = GetAlphabet[M1];
     n1  = Size[M1];
     n2  = Size[M2];
     T1  = Transitions[M1];
     T2  = shiftrans[n1,n1,#]& /@ Transitions[M2];
     res = FA[ n1+n2, kk, Join[T1,T2], Join[Initial[M1],n1+Initial[M2]],
               Join[Final[M1],n1+Final[M2]], KK, {} ];
     Switch[ norm, 
	0, res, 
	1|2, ReplacePart[ res, Join[{1,#}& /@ States[M1], {2,#}& /@ States[M2]], -1 ]
     ]
];

SumFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
    SumFA[ M1//ToFA, M2//ToFA, opts ];

SumFA[ M1_?FSMQ, M2_?FSMQ, M___?FSMQ, opts___?OptionQ ] := 
    SumFA[ SumFA[ M1, M2, opts ], M, opts ]; 
shiftrans[ s1_Integer, s2_Integer, {x_,y_,z_} ] := {x+s1,y,z+s2};


Options[SwitchTransitionFA]={};

SwitchTransitionFA[ m_FA|m_SA, p_Integer, q_Integer ] := 
Module[ {tr,ss,sss},
    tr = Cases[Transitions[m], {p,_,q} ];
    If[ tr==={}, Return[m] ];
    ss = Zwei@First[tr]; 
    sss = If[ ss < AlphabetSize[m], ss+1, 1 ];
    ReplacePart[ m, 
		 Union[Complement[Transitions[m],{{p,ss,q}}],{{p,sss,q}}], 3 ]
];
SwitchTransitionFA[ m_FA|m_SA, {p_Integer, q_Integer} ] := 
     SwitchTransitionFA[ m, p, q ];
SwitchTransitionFA[ m_FA|m_SA, tr:{___List} ] := 
     Last@FoldList[ SwitchTransitionFA, m, tr ];
SwitchTransitionFA[ m_DFA|m_NFA, tt__ ] := SwitchTransitionFA[ ToFA[m], tt ];  




SyntacticCongruence[ gg_GEN, r_Integer ] := 
Block[ {gen,K,next,index,index0,cumindex,rules},

     index = cumindex = {OneT[First[gg]]};
     K = Zwei[gg];
     gen = Last[gg];

     next[L_List] := Sequence@@(#**gen)& /@ L;
    
     If[ NonNegative[r],    
		 index  = Nest[ next, index, r ];
		 index0 = Union[index];
		 count  = Max[index0];
		 rules  = RenumberRules[index0];
		 index  = index /. rules;
		 ToClasses[Words[r,K],index,Type->Index],
     (* else *)
		 Scan[ (cumindex = Join[cumindex,index=next[index]];)&, Range[-r] ];
		 index0 = Union[cumindex];
		 count  = Max[index0];
		 rules  = RenumberRules[index0];
		 index  = cumindex /. rules;
		 ToClasses[Flatten@Words[r,K],index,Type->Index]
     ]
];

SyntacticCongruence[ M_DFA, r_Integer ] := 
     SyntacticCongruence[ ToGeneratorsFA[M], r ];


Options[SyntacticHomomorphism]={};

Attributes[SyntacticHomomorphism]={HoldFirst};

SyntacticHomomorphism[ ff_, gen_GEN ] := 
Module[ {k,alph,gens},
     ClearAll[ff];
     Attributes[ff]={Listable};
     {k,alph} = MakeFullAlphabet[Zwei@gen];
     gens = Last@gen;
     ff[Eps|"Eps"|Global`\[Epsilon]] = OneT[First[gen]];
     Scan[ (ff[#]  = gens[[#]])&, Range[k] ];
     ff[w_] := NonCommutativeMultiply@@ff[ ToIndex[w,alph] ];
];
SyntacticHomomorphism[ ff_, M_DFA ] := 
	SyntacticHomomorphism[ ff, ToGeneratorsFA[M] ];



Options[SyntacticSG]={};

SyntacticSG[ M_DFA, opts___?OptionQ ] := 
    GenerateSG[ ToGeneratorsFA[M], opts ];




Options[TheInitial]={};

TheInitial[ M_DFA ]  := 
     If[ Head[M[[4]]]===List, M[[4,1]], M[[4]] ];


Options[TheSinkDFA]={};

TheSinkDFA[ M_DFA ] := 
Module[ {sinks,F},
     F = Final[M];
     sinks = Select[ SinksDFA[M], (!MemberQ[F,#])& ];
     If[ sinks=!={}, First[sinks], 0 ]
];


Options[Thompson]={};

Options[ToBlocks]={Boundary->Cyclic};

ToBlocks[ L_List, w_Integer, opts___?OptionQ ] := 
With[ {ww = Ceiling[w/2], bnd = Boundary /. {opts} /. Options[ToBlocks]},
    Switch[  bnd, 
        	Cyclic, Partition[L,w,1,ww],
		None,   Partition[L,w,1],
		Fixed,	Partition[L,w,1,ww,$defzero],
		_,	Partition[L,w,1,ww,bnd]
    ]
];


ToBlocks[ x_?WordQ, w_Integer, opts___?OptionQ ] := 
With[ {ww = Ceiling[w/2], L = ToCharacters[x],
      bnd = Boundary /. {opts} /. Options[ToBlocks]},
    StringJoin /@ 
    Switch[  bnd, 
        	Cyclic, Partition[L,w,1,ww],
		None,   Partition[L,w,1],
		Fixed,	Partition[L,w,1,ww,$defzerochar],
		_,	Partition[L,w,1,ww,bnd]
    ]
];

$defzero = 0;
$defzerochar = "0";




Options[ToCharacters]={};

ToCharacters[x_]   := Characters@ToString[x];


Options[ToDFA]={Full->False, Normalize:>$defaultnormalize, External:>$defaultexternal, SizeOnly->False};

ToDFA[ M_NFA, opts___?OptionQ ] :=
Module[ {current,Q,nextstate,A,nn,newT,F,FF,rules,n,k,alph,
     h,hh,next,q,full,norm,ext,size},
    
    full = Full      /. {opts} /. Options[ToDFA];
    norm = Normalize /. {opts} /. Options[ToDFA];
    size = SizeOnly  /. {opts} /. Options[ToDFA];
    ext  = External  /. {opts} /. Options[ToDFA];

    If[ full, Return[ tofullDFA[M,norm] ] ];

    If[ ext, 
        If[ size, 
            Return[ Automata`extaut`ExtToDFASize[ ToFA[M] ] ],    
            Return[ Automata`extaut`ExtToDFA[ ToFA[M], opts] ]] 
    ];
 
    {k,kk,KK} = GetAlphabet[M];
    n   = Size[M];
    F   = Final[M];
    TT  = Transitions[M];    

    nn    = 1;
    h[_]  = 0;
    hh[_] = 0;
    h[1]  = Initial[M];
    hh[h[1]] = 1;
    
    next[a_] := 
      ( q = Union[ Flatten[ TT[[ a, h[current] ]] ] ];
        nextstate = If[ hh[q]==0, h[++nn] = q; hh[q] = nn, hh[q]];
        AppendTo[ newT, {current,a,nextstate} ]; 
      );

    (* compute all accessible state sets and transitions *)
    newT    = {};
    current = 0;
    While[ current < nn,
           ++current;
           Scan[ next, Range[k] ];
    ];

    If[ size, Return[nn] ]; 

    (* compute transition matrix *)
    newT = Drei /@ Sort[newT];
    A    = Thread[Partition[ newT, k ]];
    FF   = Select[ Range[nn], (!DisjointQ[h[#],F])& ]; 
    
    res = DFA[ nn, kk, A, 1, FF, KK, {} ]; 
    Switch[ norm, 
        0, res, 
        1, ReplacePart[ res, h/@Range[nn], -1 ],
        2, ReplacePart[ res, States[M][[#]]& /@ (h/@Range[nn]), -1 ]
    ]
];


ToDFA[ M_DFA, opts___?OptionQ ] := M;
ToDFA[ M_BEFA, K_:$alphabet, opts___?OptionQ ] := ToDFA[ ToFA[M,K], opts ];
ToDFA[ M_NNFA, K_:$alphabet, opts___?OptionQ ] := ToDFA[ ToFA[M,K], opts ];

ToDFA[ M_FA|M_SA, opts___?OptionQ ] :=
Module[ {current,Q,nextstate,A,nn,newT,F,FF,rules,n,k,KK,
     h,hh,next,q,full,norm,ext,size},
    
    full = Full      /. {opts} /. Options[ToDFA];
    norm = Normalize /. {opts} /. Options[ToDFA];
    size = SizeOnly  /. {opts} /. Options[ToDFA];
    ext  = External  /. {opts} /. Options[ToDFA];

    If[ full, Return[ tofullDFA[M,norm] ] ];

    If[ ext, 
        If[ size, 
            Return[ Automata`extaut`ExtToDFASize[M] ],    
            Return[ Automata`extaut`ExtToDFA[M,opts] ]] 
    ];
    
    ToDFA[ ToNFA[M,opts], opts ]
];


tofullDFA[ M_NFA, norm_ ] :=
Module[ {n,k,kk,KK,n2,A,TT,pow,rules,next,Ini,F,FF},
    
    n   = Size[M];
    {k,kk,KK} = GetAlphabet[M];
    F   = Final[M];
    TT  = Transitions[M];
    n2  = 2^n;
    pow = PowerSet[n];
    rules = RenumberRules[pow];
     
    next[{a_,P_}] := Union[ Flatten[ TT[[ a, P ]] ] ];
    
    A   = next /@ CartesianProduct[Range[k],pow];
    A   = Partition[A,n2] /. rules;
    Ini = Initial[M] /. rules;
    FF  = Union[ Select[ pow, (!DisjointQ[F,#])& ] ] /. rules;
    res = DFA[ n2, kk, A, Ini, FF, KK, {} ];
    Switch[ norm, 
        0, res, 
        1, ReplacePart[ res, pow, -1 ],
        2, ReplacePart[ res, States[M][[#]]& /@ pow, -1 ]
    ]
];


tofullDFA[ M_FA|M_SA, norm_ ] := tofullDFA[ ToNFA[M], norm ];
tofullDFA[ M_DFA, norm_ ] := M;



Options[ToEquationsDFA]={};

ToEquationsDFA[ M_DFA ] := 
Block[ {n,alph,A,F,rightside,makeequ},
     alph = Alphabet[M];
     n = Size[M];
     A = Thread[Transitions[M]];
     F = Final[M];
     rightside[i_] := 
       If[ !MemberQ[F,i],
           Inner[ RET,alph,X /@ A[[i]],REP ],
           Insert[ Inner[RET,alph,X /@ A[[i]],REP],Eps,1]
       ];
     makeequ[i_] := Equal[ X[i], rightside[i] ];
     makeequ /@ Range[n]
];




Options[ToFA]={Normalize:>$defaultnormalize};

ToFA[ M_DFA, opts___?OptionQ ] := 
     FA@@ReplaceParts[ M, MatrixToTransitions[ Alphabet[M], Transitions[M] ], 3, 
                          Initial[M], 4 ];
      
ToFA[ M_NFA, opts___?OptionQ ] := 
Module[ {k,A,makeT,cp,tr},
     cp[ {p_Integer,x_Integer,L_List} ] := {p,x,#}& /@ L;     
     makeT[p_] := Flatten[cp /@ Thread[{Table[p,{k}],Range[k],A[[p]]}], 1];
     k  = AlphabetSize[M];
     A  = Thread@Transitions[M];
     tr = Sort@Flatten[ makeT /@ Range@Size[M], 1 ];
     FA@@ReplacePart[ M, tr, 3 ]
];


ToFA[ M_BEFA, K_:$alphabet, opts___?OptionQ ] := 
    FA[ Size[M], AlphabetSizeS[K], 
	Transitions[M] /. Flatten[{RenumberRules[MakeAlphabet[K]], "Eps"->0 }], {1}, 
	{Size[M]}, MakeShortAlphabet[K], {} ];

ToFA[ M_NNFA, K_:$alphabet, opts___?OptionQ ] := NNFAToFA[ M, K ];

ToFA[ M_SA, opts___?OptionQ] := FA@@Insert[ M, Range[Size[M]], {{4},{4}} ];

ToFA[ M_FA ] := M;

ToFA[ C_CA, opts___?OptionQ ] := ToFA[ToSA[C,opts]];


Options[ToFrontierDFA]={};


ToFrontierDFA[ m_DFA ] := 
Module[ {K,A,q0,dot,Q,W,eq},
     K  = Alphabet[m];
     A  = Transitions[m];
     q0 = TheInitial[m];
     dot[p_,a_] := A[[ PositionOne[K,a], p ]];
     {Q,W,eq}= GenerateCSM[ q0, dot, K, Equations->True ];
     { PairsToRules[eq], W[[Final[m]]] }
];


Options[ToGeneratorsFA]={};

ToGeneratorsFA[M_DFA] := 
    GEN[ Size[M], AlphabetSize[M], Apply[ T, Transitions[M], 1 ] ];

ToGeneratorsFA[m_FA|m_SA]  := 
Module[{mm,tt},
	mm = CompleteFA[m];
	tt = Last /@ Sort[ Transitions[mm], 
		(#1[[2]]<#2[[2]])||((#1[[2]]==#2[[2]])&&(#1[[1]] <= #2[[1]]))& ];
	GEN[Size[mm], AlphabetSize[m], Apply[T,Partition[tt,Size[mm]],{1}] ] 
];




Options[ToGraphFA]={Unlabeled->True, Normalize->$defaultnormalize};

ToGraphFA[ M_?FSMQ, opts___?OptionQ ] := 
Module[ {n,ed},
     n  = Size[M];
     ed = Transitions@ToFA[M];
     res = If[ Unlabeled /. {opts} /. Options[ToGraphFA],
               ed = Union[ Drop[#,{2}]& /@ ed ];
               Graph[ n, Length[ed], 1, ed, {} ],
               Graph[ n, Length[ed], 2, ed, {} ]
     ];
     If[ 0 == (Normalize /. {opts} /. Options[ToGraphFA]),
         res, 
         ReplacePart[ res, States[M], -1 ]
     ]
];



Options[ToIndex]={};

AssignFunction[ $todigal2, ToCharacterCode["ab"], Range[2] ];

ToIndex[ Eps|"Eps"|Global`\[Epsilon], ___ ] = {};
ToIndex[ x_?WordQ ] := $todigal2 /@ ToCharacterCode@ToString[x];
ToIndex[ x_?WordQ, 2|{a,b}|{"a","b"} ] := $todigal2 /@ ToCharacterCode@ToString[x];
ToIndex[ x_?WordQ, K_:$alphabet ] := 
(
        {$kk,$alph} = MakeFullAlphabet[K];
        AssignFunction[ $todig, Flatten[ToCharacterCode /@ $alph], Range[$kk] ];
        $todig /@ ToCharacterCode@ToString[x]
);
ToIndex[ x_Integer, K_ ] := ToIndex[ ToString[x], K ];


Options[ToKernelFA]={Normalize->1, External:>$defaultexternal};

ToKernelFA[ M_FA|M_NFA|M_SA, {xx__Integer}, opts___?OptionQ ] :=   
    ToKernelFA[ M, {#}& /@ {xx}, opts ];
ToKernelFA[ M_FA|M_NFA|M_SA, pp_Integer, opts___?OptionQ ] :=   
    ToKernelFA[ M, {pp}, opts ];
ToKernelFA[ M_FA|M_NFA|M_SA, opts___?OptionQ ] :=  
    ToKernelFA[ M, {#}& /@ Initial[M], opts ];
ToKernelFA[ M_NFA, {LL__List}, opts___?OptionQ ] := 
    ToKernelFA[ ToFA[M], {LL}, opts ];

ToKernelFA[ M_FA|M_SA, {LL__List}, opts___?OptionQ ] := 
Module[ {n,Q,k,KK,TT,nn,h,hh,next,newT,current,nt,mm,q,j,ff},

    If[ External /. {opts} /. Options[ToKernelFA], 
        Return[ Automata`extaut`ExtToKernelFA[ M, {LL}, opts ] ] ];
    
    {k,kk,KK} = GetAlphabet[M];
    n  = Size[M];
    TT = Transitions@ToNFA[M];
    empty = 0;
    nn    = Length[{LL}];
    AssignFunction[ h,  Range[nn], {LL} ];
    AssignFunction[ hh, {LL}, Range[nn] ];
    h[_]  = 0;
    hh[_] = 0;
    
    next[a_] :=
      ( q = Union@Flatten[ TT[[ a, h[current] ]] ];
        j = If[ hh[q]==0,
                h[++nn] = q; hh[q] = nn,
            (*else*)
                hh[q]
            ];
        AppendTo[ newT, {current,a,j} ]; );

    newT = {};
    current = 0;
    While[ current < nn,
           ++current;
           Scan[ next, Range[k] ];
    ];
     
    nt   = Thread[newT];
    newT = Thread[{First[nt],Zwei[nt],Drei[nt]}];
    QQ   = h /@ Range[nn];
    ff   = Final[M];
    res  = If[ Head[M]===SA,
               SA[ nn, kk, newT, KK, {} ], 
               FA[ nn, kk, newT, PositionList[QQ,{LL}], 
                   PositionList[QQ,Select[QQ,!DisjointQ[#,ff]&]], KK, {} ]
       ];
    
    Switch[ Normalize /. {opts} /. Options[ToKernelFA], 
       0, res, 
       1, ReplacePart[ res, QQ, -1 ],
       2, ReplacePart[ res, QQ /. Thread[ Range[n] -> States[M] ], -1 ]
     ]
];


Options[ToLabelCA]={};

ToLabelCA[ CA[r_Integer, w_Integer, K_] ] :=
Module[ {k,alph},
     {k,alph} = MakeFullAlphabet[K];
     alph[[IntegerDigits[r,k,k^w]+1]]
];
     

Options[ToMatrix]={};

Options[ToNFA]={};

ToNFA[ M_FA, opts___?OptionQ ] := 
Module[ {ptr,n,M1,tr,A},
     ptr[LL_List] := Map[ Last, Cases[LL,{#,_,_}]& /@ Range[n], {2}];
     n  = Size[M];
     M1 = EpsilonEliminationFA[M];
     tr = Transitions[M1];
     A  = ptr[Cases[tr,{_,#,_}]]& /@ Range@AlphabetSize[M];      
     NFA@@ReplaceParts[ M, A, 3, Initial[M1], 4 ]
];  

ToNFA[ M_DFA, opts___?OptionQ ] := 
     NFA@@ReplaceParts[ M, Map[{#}&,Transitions[M],{2}], 3, Initial[M], 4 ];

ToNFA[M_SA, opts___?OptionQ ] :=       
Module[ {ptr,n,tr,A},
     ptr[LL_List] := Map[ Last, Cases[LL,{#,_,_}]& /@ Range[n], {2}];
     n  = Size[M];
     M1 = EpsilonEliminationFA[M];
     tr = Transitions[M];
     A  = ptr[Cases[tr,{_,#,_}]]& /@ Range@AlphabetSize[M];    
     NFA@@Insert[ ReplacePart[ M, A, 3 ], Range[n], {{4},{4}} ]  
];  

ToNFA[ M_NFA, opts___?OptionQ ] := M;


ToPeriodicFrontierDFA[ M_DFA ] := 
Block[ {k,K,A,q0,QQ,act,act0,front,nexti,next,q,wi},
     {k,K} = FullAlphabet[M];
     A  = Transitions[M];
     q0 = TheInitial[M];
     act   = { { "Eps", q0 } };
     QQ    = act;
     front = {};
     
     nexti[{w_,p_}, i_] := 
     (  q  = A[[i,p]];
        wi = Concatenate[w,K[[i]]];
        If[ (int=Intersection[ QQ, 
             CartesianProduct[WordPrefixes[w],{q}]])=!={} ,
        AppendTo[front,{wi,First@Last[int]}],
        AppendTo[act0,{wi,q}]; ] );
     next[x_] := Scan[ nexti[x,#]&, Range[k] ];
      
     While[ act=!={},
            act0 = {};
            Scan[ next, act ];
            QQ = Union[ QQ, act0 ];
            act  = act0;
     ];
     { front /. {x_?WordQ, y_?WordQ} -> (x -> y), 
       First /@ Select[QQ,MemberQ[Final[M],Zwei[#]]&]}
];



ToPrefixFA[M_?FSMQ] := 
Module[ {m = MinimizeFA[M],p},
    If[ (p=TheSinkDFA[m]) > 0,
        SetFinalFA[ m, Complement[Range[Size[m]],{p}] ],
        AllDFA[ Alphabet[M] ]
    ]
];              


Options[ToPrefix]={};

ToPrefix[W_List,K_:$alphabet] := 
With[ {KK = MakeAlphabet[K],WW  = ToString /@ W}, 
     If[ WW==={"Eps"}, Return[KK] ];
     Complement[ Concatenate[WW,KK], WW ] // WordSort
];


Options[ToRegExp]={};

ToRegExp[exp_] := exp /. {NonCommutativeMultiply->RET,Plus->REP};

Options[ToRegularExpressionFA]={RegExpSimp->True, DoTrace->False};

ToRegularExpressionFA[ MM_?FSMQ, opts___?OptionQ ] := 
Module[  {M,k,n,tran,Ini,Fin,exp,simp,L,trace,trc},
     simp =  RegExpSimp /. {opts} /. Options[ToRegularExpressionFA];
     trace = DoTrace /. {opts} /. Options[ToRegularExpressionFA];

     trc={};
     M = ToFA[MM];
     n = Size[M];
     Ini  = Initial[ M ];
     Fin  = Final[ M ];
     tran = FullTransitions[ M ];

     (* Kleene's algorithm *)    
     L[0,p_,q_] := L[0,p,q] =
     Module[ {lab,exp},
	 lab = Zwei /@ Cases[tran,{p,_,q}];
	 If[ lab==={},
	     exp = If[p==q,Eps,Empty],
     	     exp = If[p==q,
	              REP[Eps,Sequence @@ lab ],
	              If[ Length[lab]>1,REP@@lab,lab[[1]] ]
	           ]
	 ];
	 If[ trace, AppendTo[trc,{{0,p,q},exp}] ];
	 exp
     ];     
       
     L[s_,p_,q_] := L[s,p,q] = 
     Module[ {exp},
         exp = REP[ L[s-1,p,q], RET[ L[s-1,p,s], 
RES[L[s-1,s,s]],L[s-1,s,q]] ];
         If[ simp, exp = exp //. $regexrules ];
         If[ trace, AppendTo[trc,{{s,p,q},exp}] ];
         exp
     ];

     exp = REP@@( L[n,#[[1]],#[[2]]]& /@ CartesianProduct[Ini,Fin] );
     If[ simp, exp = exp //. $regexrules ];
     If[ trace, {exp,trc}, exp ]
];




Options[ToRulesCA]={WordMap->True};

ToRulesCA[ C_CA, opts___?OptionQ ] :=
Module[ {lab,k,alph,w,B,n,L},
     L   = First[C];
     w   = WidthCA[C];
     {k,alph} = FullAlphabet[C];
     n   = k^w;
     
     If[ WordMap /. {opts} /. Options[ToRulesCA],
		lab = Reverse@Switch[ L,
			_List,       ToString /@ L, 
     		_Integer,    alph[[IntegerDigits[L,k,n]+1]]
     	   ];
		B = StringJoin@@alph[[#]]& /@ (IntegerDigits[Range[0,n-1],k,w]+1),
	(*else*)
		lab = Reverse@Switch[ L,
			_List,       ToExpression /@ L, 
     		_Integer,    IntegerDigits[L,k,n]
     	   ];
		B = IntegerDigits[Range[0,n-1],k,w]
	];
     
    Dispatch[ Thread[ B -> lab ] ]
];





Options[ToSA]={Normalize:>$defaultnormalize};

ToSA[M_FA,opts___?OptionQ] := Delete[ SA@@M, {{4},{5}} ];
ToSA[M_NFA|M_DFA,opts___?OptionQ] := Delete[ SA@@ToFA[M,opts], {{4},{5}} ];
ToSA[M_SA,opts___?OptionQ] := M;

ToSA[ C_CA, opts___?OptionQ ] :=
Module[ {n,Rn,k,K,w,lab,B1,B2,norm,tr},
     norm  = Normalize /. {opts} /. Options[ToSA];
     w     = WidthCA[C] - 1;
     {k,K} = FullAlphabet[C];
     n    = k^w;
     Rn   = Range[n];
     lab  = If[ Head[First[C]]===List,
                 PositionList[ K, First[C] ],
                 IntegerDigits[First[C],k,k^(w+1)] + 1
             ];
     B1   = Flatten@Thread@Table[Rn,{k}];
     B2   = Join@@Table[Rn,{k}];
     tr   = Pairs[B1,Reverse@lab,B2];
     res  = SA[ n, AlphabetSizeS[Drei[C]], tr, MakeShortAlphabet[Drei[C]], {} ];
     If[ norm==0,
         res,
         ReplacePart[ res, Words[w,K], -1 ]
     ]
];


ToSeries[ L_List ] := HoldForm[Release[((#[[2]] #[[1]])& /@ L)]] /. List -> Plus;



ToSuffixFA[M_?FSMQ] := 
With[ {m = MinimizeFA[M]}, 
    If[ TheSinkDFA[m] > 0,
        SetInitialFA[ m, Complement[Range[Size[m]],{p}] ],
        SetInitialFA[ m, Range[Size[m]] ]
    ]
];


Options[TotalisticRuleToCA]={};

TotalisticRuleToCA[ r_Integer, w_Integer, k_Integer ] := 
With[ {rL = Reverse@IntegerDigits[ r, k, w(k-1)+1 ]}, 
		FunctionToCA[rL[[ Plus[##]+1 ]]&, w, -k ]
];


ToTotalisticRuleCA[ ca_CA ] := 
Module[ {ff,k,w,makepat,qq,LL},
		makepat[s_Integer] := 
		(	qq = Quotient[s,k-1];
			LL = Table[k-1,{qq}];
			If[qq<w, AppendTo[LL,Mod[s,k-1]]];
			Join[ LL, Table[0,{w-1-qq}] ]
		);
		k = AlphabetSize[ca];
		w = WidthCA[ca];
		LocalMapCA[ff,ca];
		FromDigits[ Apply[ ff, makepat /@ Reverse@Range[0,w(k-1)], 1 ], k ]
];
		

Options[ToTransitions]={};

ToTransitions[ tr_List, K_:$alphabet ] := 
Module[ {k,alph},
    {k,alph} = MakeFullAlphabet[K];
    tr /. Thread[ Prepend[alph,"Eps"] -> Range[0,k] ]
];


ToWord[ str_String, ___ ] := str;
ToWord[ {}, ___ ] = "Eps";
ToWord[ x_List, K_:$alphabet ] := StringJoin @@ MakeAlphabet[K][[x]];
ToWord[ r_Integer, k_Integer ] := 
        StringJoin@@(MakeAlphabet[k][[IntegerDigits[r,k]+1]]); 

Options[$transdispwidth]={};

$transdispwidth = 20;

Options[TransferSequenceFA]={};

TransferSequenceFA[ m_?FSMQ, s_Integer, TT_List ] :=
Block[ {expand,d,Q,L,x},

    expand[{a_,q_}] := 
       If[ d[q]<0, AppendTo[Q,q]; L[q] = Concatenate[L[x],a]; d[q] = d[x]+1 ];

     Q    = {s}; 
     d[s] = 0;
     d[_] = -1;
     L[s] = "Eps";
     tr   = FullTransitions@ToFA[m];

     While[ Q =!= {},
            x = First[Q];
            Q = Rest[Q];
            expand /@  Rest /@ Cases[tr,{x,_,_}];
     ];
     L[_] = "-";
     L /@ TT
];

TransferSequenceFA[m_?FSMQ, s_Integer, t_Integer ] := 
   TransferSequenceFA[m,s,{t}]; 
TransferSequenceFA[m_?FSMQ,SS_List,TT_List] := 
   TransferSequenceFA[m, #, TT]& /@ SS;
TransferSequenceFA[m_?FSMQ] := 
   TransferSequenceFA[m, Initial[m], Final[m] ];

    
(*  LanguageFA  *)
     

Options[TransitionFunctionFA]={Full->False};

Attributes[TransitionFunctionFA]={HoldRest};

TransitionFunctionFA[ M_DFA, del_, opts___?OptionQ ] :=  
Module[ {trfct,full}, 

     full = Full /. {opts} /. Options[TransitionFunctionFA];

     ClearAll[del];
     AssignFunction[ trfct, Alphabet[M], Transitions[M]];
     
     del[p_,Eps|"Eps"|Global`\[Epsilon]]  = p;
     del[p_,w_?WordQ]  := del[p,ToCharacters[w]];

     If[ full, 
	     del[p_List,W_List]    := FoldList[ Union[Flatten[trfct[#2][[#1]]]]&, p, W ];
	     del[p_Integer,W_List] := FoldList[ trfct[#2][[#1]]&, p, W ],
	 (*else*)
	     del[p_List,W_List]    := Fold[ Union[Flatten[trfct[#2][[#1]]]]&, p, W ];
	     del[p_Integer,W_List] := Fold[ trfct[#2][[#1]]&, p, W ]
     ];
];

TransitionFunctionFA[ M_NFA, del_, opts___?OptionQ ] := 
Module[ {trfct,full}, 

     full = Full /. {opts} /. Options[TransitionFunctionFA];

     ClearAll[del];
     AssignFunction[ trfct, Alphabet[M], Transitions[M]];
     
     del[p_,Eps|"Eps"|Global`\[Epsilon]] = {p};
     del[p_,w_?WordQ]  := del[p,ToCharacters[w]];

     If[ full, 
	     del[p_List,W_List]    := FoldList[ Union@Flatten[trfct[#2][[#1]]]&, p, W ];
	     del[p_Integer,W_List] := FoldList[ Union@Flatten[trfct[#2][[#1]]]&, {p}, W ],
	 (*else*)
	     del[p_List,W_List]    := Fold[ Union@Flatten[trfct[#2][[#1]]]&, p, W ];
	     del[p_Integer,W_List] := Fold[ Union@Flatten[trfct[#2][[#1]]]&, {p}, W ]
     ]; 
];

TransitionFunctionFA[ M_FA|M_SA, d_, opts___?OptionQ ] :=
       TransitionFunctionFA[ ToNFA[M], d, opts ]; 






Options[TransitionMatrixFA]={Type->None};

Attributes[TransitionMatrixFA]={HoldRest};

TransitionMatrixFA[ M_FA, ff_, opts___?OptionQ ] :=
(
    ClearAll[ff];
    Switch[ Type /. Release[{opts}] /. Options[TransitionMatrixFA],
	None,      natTransitionMatrixFA[M,ff],
	Boolean,   booleanTransitionMatrixFA[M,ff],
	Tropical,  tropicalTransitionMatrixFA[M,ff]
    ];
);

TransitionMatrixFA[M_NFA|M_DFA|M_SA, f_, opts___?OptionQ ] := 
    TransitionMatrixFA[ ToFA[M], f, opts ];
    
natTransitionMatrixFA[ M_FA, ff_ ] :=
Module[ {k,alph,n,gen}, 

     Attributes[ff]={Listable};
     n = Size[M];
     {k,alph} = FullAlphabet[M];
     gen = Table[ 0, {k}, {n}, {n} ];
     Scan[ (gen[[ #[[2]],#[[1]],#[[3]] ]]=1)&, Transitions[M] ];
     
     ff[Eps|"Eps"|Global`\[Epsilon]]  = IdentityMatrix[n];
     ff[w_?WordQ]  := Dot@@gen[[ ToIndex[w,alph] ]];
];

booleanTransitionMatrixFA[ M_FA, ff_ ] :=
Module[ {k,alph,n,gen}, 

     Attributes[ff]={Listable};
     n = Size[M];
     {k,alph} = FullAlphabet[M];
     gen = Table[ 0, {k}, {n}, {n} ];
     Scan[ (gen[[ #[[2]],#[[1]],#[[3]] ]]=1)&, Transitions[M] ];
     
     ff[Eps|"Eps"|Global`\[Epsilon]]  = IdentityMatrix[n];
     ff[w_?WordQ]  := Sign[Dot@@gen[[ ToIndex[w,alph] ]]];
];

tropicalTransitionMatrixFA[ M_FA, ff_ ] :=
Module[ {k,n,tr,gen,alph}, 
     n = Size[M];
     {k,alph} = FullAlphabet[M];
     tr = Transitions[M];

     gen = Table[ TS[Infinity], {k}, {n}, {n} ];

     Scan[ (gen[[ #[[2]], #[[1]], #[[3]] ]]=TS[0])&, DeleteCases[tr, {_,_,n} ]];
     Scan[ (gen[[ #[[2]], #[[1]], n ]]=TS[1])&, Cases[ tr, {_,_,n} ] ];

     ff[Eps|"Eps"|Global`\[Epsilon]] = TropicalIdentityMatrix[n];
     ff[w_?WordQ] := Dot@@gen[[ ToIndex[w,alph] ]];
];





Options[TransitionsToMatrix]={};

TransitionsToMatrix[ n_Integer, K_, tr_List ] := 
Module[ {ntr},
     ntr = Drei@ToNFA[ SA[n,K,tr] ];
     If[ Union[ Length /@ FlattenOne[ntr] ]==={1}, 
         Partition[Flatten[ntr],n],
         ntr 
     ]
];



Options[Transitions]={};

Transitions[ M_BEFA ]  := Zwei[M];
Transitions[ M_TD ]    := M[[4]];
Transitions[ M_?FSMQ ] := Drei[M];


Options[TransitiveLangQFA]={External:>$defaultexternal};


TransitiveLangQFA[ m_?FSMQ, opts___?OptionQ ]:=
Module[{mm,snk,mp,gr},

        mm = MinimizeFA[m,SelectOptions[MinimizeFA,opts]];
	If[Size[mm]==1,Return[True]];
	snk = TheSinkDFA[mm];
	If[snk==0,Return[False]];
	mp = DeleteStateFA[ mm,snk];
	gr = ToGraphFA[mp];
	Not@TrueQ[ Catch[  
	    If[!SubsetQFA[ mp, 
		SetInitialFA[mp,WeaklyConnectedComponents[gr,# ]] ],
		    Throw[True]]&  /@ Final[mp]
	]]
];
     

Options[TransitiveQFA]={DoTrace->False, External:>$defaultexternal};

TransitiveQFA[M_?FSMQ,opts___?OptionQ] := 
Module[ {res},
	res = StronglyConnectedComponents[ ToGraphFA[M],
                 SelectOptions[StronglyConnectedComponents,opts] ]; 
        If[ DoTrace /. {opts} /. Options[TransitiveQFA], 
            res, 
            Length[res] == 1
        ]
];
     

Options[TransOnly]={};

Options[TrimFA]={Normalize:>$defaultnormalize};

TrimFA[M_FA,opts___?OptionQ] := 
Module[ {Q,QQ,I0,I1,F0,F1,nn,pos,hh,norm,k,kk,KK},
     norm = Normalize /. {opts} /. Options[TrimFA];
     {k,kk,KK} = GetAlphabet[M];
     I0  = Initial[M];
     F0  = Final[M];
     QQ  = VertexSet@AccCoaccGraph[ToGraphFA[M],I0,F0];
     nn  = Length[QQ];
     AssignFunction[hh,QQ,Range[nn]];
     I1  = hh /@ Intersection[I0,QQ];
     F1  = hh /@ Intersection[F0,QQ];
     tr  = Select[ Transitions[M], (MemberQ[QQ,First[#]] && MemberQ[QQ,Last[#]])& ];
     res = FA[ nn, kk, 
     		Function[ xx, { hh[xx[[1]]], xx[[2]], hh[xx[[3]]] } ] /@ tr, 
     		Sort[I1], Sort[F1], KK, {} ];
     If[ norm==0, 
         res, 
         ReplacePart[ res, QQ, -1 ]
     ]
];
TrimFA[M_SA, opts___?OptionQ] := M;
TrimFA[M_DFA,opts___?OptionQ] := TrimFA[ToFA[M,opts],opts]; 
TrimFA[M_NFA,opts___?OptionQ] := ToFA[TrimFA[ToFA[M,opts],opts],opts]; 



Options[TropicalIdentityMatrix]={};

TropicalIdentityMatrix[n_Integer] := 
With[ {row = Join[{TS[0]}, Table[TS[Infinity],{n-1}]]},
    RotateRight[row,#]& /@ Range[0,n-1] 
];





Options[Tropical]={};

Options[TS]={};

Attributes[TS]={};

Format[TS[Infinity]] := \[Infinity];
Format[TS[x_]] := x;

TS/:  TS[a_] + TS[b_]  := TS[ Min[a,b] ];
TS/:  TS[a_] * TS[b_]  := TS[ a + b ];
TS/:  _ TS[a_]         := TS[a];
TS/:  TS[a_]^k_        := TS[k a];


Options[UnionFA]={Full->False, Normalize:>$defaultnormalize};

UnionFA[ M1_?FSMQ, M2_?FSMQ, opts___?OptionQ ] := 
Which[ 
     Head[M1]===DFA && Head[M2]===DFA,   ProductFA[ M1, M2, Type->"Union", opts],
     Head[M1]===BEFA && Head[M2]===BEFA, unionBEFA[M1,M2],
     Head[M1]===NNFA && Head[M2]===NNFA, unionNNFA[M1,M2],
     True,                               SumFA[ M1, M2, opts ]
];
    
UnionFA[ M1_?FSMQ, M2_?FSMQ, M___?FSMQ, opts___?OptionQ ] := 
    UnionFA[ UnionFA[ M1, M2, opts ], M, opts ];


Options[Unlabeled]={};

Options[VerifyFA]={};

VerifyFA[xx_SA] :=
MatchQ[ xx, SA[_Integer,_Integer,{{_Integer,_Integer,_Integer}...},_List,_List] ] &&
With[ {n=xx[[1]], k = xx[[2]], t = xx[[3]]},
checkRange[ First /@ t, n ] &&
checkRange[ Zwei /@ t, k ] &&
checkRange[ Last /@ t, n ] &&
(xx[[-2]]=={} || Length[xx[[-2]]] == k ) &&
(xx[[-1]]=={} || Length[xx[[-1]]] == n ) ];

VerifyFA[xx_FA] :=
MatchQ[ xx, FA[_Integer,_Integer,{{_Integer,_Integer,_Integer}...},
{_Integer...},{_Integer...},_List,_List] ] &&
With[ {n=xx[[1]], k = xx[[2]], t = xx[[3]]},
checkRange[ First /@ t, n ] &&
checkRange[ Zwei /@ t, k ] &&
checkRange[ Last /@ t, n ] &&
checkRange[ xx[[4]], n ] &&
checkRange[ xx[[5]], n ] &&
(xx[[-2]]=={} || Length[xx[[-2]]] == k ) &&
(xx[[-1]]=={} || Length[xx[[-1]]] == n ) ];

VerifyFA[xx_DFA] :=
MatchQ[ xx, DFA[_Integer,_Integer,{{_Integer...}...},
_Integer|{_Integer},{_Integer...},_List,_List] ] &&
With[ {n=xx[[1]], k = xx[[2]], t = xx[[3]]},
checkRange[ Flatten[t], n ] &&
Dimensions[t] == {k,n} &&
checkRange[ Flatten[{xx[[4]]}], n ] &&
checkRange[ xx[[5]], n ] &&
(xx[[-2]]=={} || Length[xx[[-2]]] == k ) &&
(xx[[-1]]=={} || Length[xx[[-1]]] == n ) ];

VerifyFA[xx_NFA] :=
MatchQ[ xx, NFA[_Integer,_Integer,{{{_Integer...}...}...},
{_Integer...},{_Integer...},_List,_List] ] &&
With[ {n=xx[[1]], k = xx[[2]], t = xx[[3]]},
checkRange[ Flatten[t], n ] &&
Dimensions[t] == {k,n} &&
checkRange[ xx[[4]], n ] &&
checkRange[ xx[[5]], n ] &&
(xx[[-2]]=={} || Length[xx[[-2]]] == k ) &&
(xx[[-1]]=={} || Length[xx[[-1]]] == n ) ];





Options[WelchCA]={External:>$defaultexternal, Full->False};

WelchCA[C_CA,opts___?OptionQ] := 
Module[ {nwl,nwm,nwr},

     If[ Full /. {opts} /. Options[WelchCA], 
	 Return[ toWelchCA[C,SelectOptions[toWelchCA,opts]]] ];

     If[ External /. {opts} /. Options[WelchCA], 
         {nwl,nwr} = Automata`extaut`ExtWelchCA[C],
         {nwl,nwr} = First@toWelchCA[C,SelectOptions[toWelchCA,opts]] 
     ];

     nwm = Abs[Drei[C]]^(WidthCA[C]-1)/(nwl nwr);
     {nwl,nwm,nwr}
];


Options[toWelchCA]={Normalize->1,External:>$defaultexternal};

toWelchCA[ C_CA, opts___?OptionQ] :=
Module[ {m,ml,mr,mxr,mxl,Ql,Qr,pos,wr,wl,w,k,alph,rules},

     If[ External /. {opts} /. Options[toWelchCA], 
         Return[Automata`extaut`ExtToWelchCA[C,opts]] ];
     norm = Normalize /. {opts} /. Options[toWelchCA];

     sa  = C // ToSA;
     mr  = ToKernelFA[ sa, 1, External->False ];
     Qr  = States[mr];
     mxr = Max[ Length /@ Qr ];
     pos = PositionList[ Qr, Select[ Qr, Length[#]==mxr& ] ];
     wr  = SelectFA[mr,pos,opts];
     ml  = ToKernelFA[ sa//ReverseFA, 1, External->False ];
     Ql  = States[ml];
     mxl = Max[ Length /@ Ql ];
     pos = PositionList[ Ql, Select[ Ql, Length[#]==mxl& ] ];
     wl  = SelectFA[ml,pos,opts];

     If[  norm==0, 
          wl = wl // NormalizeFA;
          wr = wr // NormalizeFA; 
     ];
     If[ norm==2,
         {k,alph} = FullAlphabet[C];
         w  = WidthCA[C] - 1;
         rules = Thread[ Range[k^w] -> Words[w,alph] ];
         wl = ReplacePart[ wl, States[wl]/.rules, -1 ];
         wr = ReplacePart[ wr, States[wr]/.rules, -1 ];
     ];

     {{mxl,mxr},{wl,wr}}
];


Options[WidthCA]={};

WidthCA[CA[_,w_,_]] := w;


Options[WordBinomial]={DoTrace->False};

WordBinomial[ u_?WordQ, Eps|"Eps"|Global`\[Epsilon] ] := 1;
WordBinomial[ Eps|"Eps"|Global`\[Epsilon], v_?WordQ ] := 0;
WordBinomial[ u_?WordQ, v_?WordQ, opts___?OptionQ ] := 
	WordBinomial[ {u}, v, opts ];
WordBinomial[ LL_List, v_?WordQ, opts___?OptionQ ] := 
Module[ {vL,n,nexti,next,h,updateh},
    vL    = ToCharacterCode@ToString[v];
    n     = Length[vL];
    nexti[a_,i_] := If[ vL[[i]]==a, h[i]+h[i-1], h[i] ];
    next[a_] := Scan[ (h[#]=nexti[a,#])&, Reverse[Range[n]]];
    
    updateh = Function[ uu,
   		Clear[h];h[0]=1;h[_]=0;
   		Map[(next[#];h /@ Range[n])&,ToCharacterCode@ToString[uu]] ];
    
    If[ Length[LL]==1,
	    If[ DoTrace /. {opts} /. Options[WordBinomial], 
	    	updateh[First[LL]], 
	    	Last[Last[updateh[First[LL]]]] 
	    ],
	(*else - ignore trace for lists *)
		Last@Last@updateh[#]& /@ LL
	]
];



Attributes[WordConjugateQ]={Listable};

WordConjugateQ[u_?WordQ,v_?WordQ] := False /; WordLength[u]=!=WordLength[v];
WordConjugateQ[u_?WordQ,v_?WordQ] := 
	With[ {uu=ToString[u],vv=ToString[v]}, Length@StringPosition[uu<>uu,vv]>0 ];


Options[WordConjugates]={};

Attributes[WordConjugates]={Listable};

WordConjugates[Eps|"Eps"|Global`\[Epsilon]] := {"Eps"};

WordConjugates[u_?WordQ] := 
	With[ {uu = Characters@ToString[u], nn = WordLength@WordRoot[u]}, 
	Apply[StringJoin,NestList[RotateLeft,uu,nn-1],{1}]];


Options[WordFactorizations]={};

WordFactorizations[ Eps|"Eps"|Global`\[Epsilon] ] = {{"Eps","Eps"}}; 
WordFactorizations[ w_?WordQ ] := 
     Pairs[WordPrefixes[w],Reverse[WordSuffixes[w]]];
     


Options[WordFactors]={};

Attributes[WordFactors]={Listable};

WordFactors[x_?WordQ,0,opts___?OptionQ ] := {"Eps"};
		
WordFactors[x_?WordQ,k_Integer?Positive,opts___?OptionQ ] := 
Module[ {xx=Characters@ToString[x]},
	Union@Apply[ StringJoin, Partition[xx,k,1], {1} ]
];

		
WordFactors[x_?WordQ,opts___?OptionQ ] := 
Module[ {xx=Characters@ToString[x]},
	Union@Apply[ StringJoin, Partition[xx,#,1], {1} ]& /@ 
	    Range[Length[xx]] // FlattenOne // Prepend[#,"Eps"]& 
];

		



Options[WordFusion]={};

WordFusion[ u_?WordQ, v_?WordQ, r_Integer:1 ] := 
With[ {uu = ToString[u], vv = ToString[v]},
    If[ StringTake[uu,-r]===StringTake[vv,r], uu<>StringDrop[vv,r] ]
];





Options[WordLength]={};

Attributes[WordLength]={Listable};

WordLength[Eps|"Eps"|Global`\[Epsilon]]   = 0;
WordLength[x_?WordQ]   := StringLength@ToString[x];
WordLength[Eps|"Eps"|Global`\[Epsilon],_] = 0;
WordLength[x_?WordQ,a_?WordQ] := 
    Length@StringPosition[ToString[x],ToString[a]];



Options[WordMap]={};

Options[WordOrder]={};

WordOrder[ x_?WordQ, y_?WordQ ] := 
If[ x===y, 0 ,
If[WordLength[x] < WordLength[y] ||
   WordLength[x] == WordLength[y] && Order[x,y]==1, 1 , -1 ] ];


Options[WordPower]={};

Attributes[WordPower]={Listable};

WordPower[Eps|"Eps"|Global`\[Epsilon],_] := "Eps";
WordPower[_,0] := "Eps";
WordPower[ s_Symbol|s_String, k_Integer:Positive ] := 
	StringJoin@@Table[ToString[s],{k}];
    


Attributes[WordPrefixes]={Listable};


WordPrefixes[ Eps|"Eps"|Global`\[Epsilon]] = {"Eps"}; 
WordPrefixes[ w_?WordQ ] := 
With[ {ws = ToString[w]}, 
	Prepend[ StringTake[ws,#]& /@ Range@WordLength[ws], "Eps" ] 
];
WordPrefixes[L_List] := WordPrefixes /@ L // Flatten // Union // WordSort;




Options[WordReverse]={};

Attributes[WordReverse]={Listable};

WordReverse[Eps|"Eps"|Global`\[Epsilon]] = "Eps";
WordReverse[x_?WordQ] := StringReverse@ToString[x];



Options[WordRoot]={};

Attributes[WordRoot]={Listable};

WordRoot[Eps|"Eps"|Global`\[Epsilon]] := "Eps";
WordRoot[ s_String|s_Symbol ] := 
	With[ {ss = ToString[s]}, StringTake[ss,StringPosition[ss<>ss,ss][[2,1]]-1] ];



Options[WordRotate]={};

Attributes[WordRotate]={Listable};

WordRotate[Eps|"Eps"|Global`\[Epsilon],_] = "Eps";
WordRotate[x_?WordQ,n_Integer:1] := 
    StringJoin@@RotateLeft[ToCharacters@ToString[x],n];


Options[WordShuffle]={};

WordShuffle[ Eps|"Eps"|Global`\[Epsilon], v_?WordQ ] := {v};
WordShuffle[ u_?WordQ, Eps|"Eps"|Global`\[Epsilon] ] := {u};
WordShuffle[ u_?WordQ, v_?WordQ ] := 
     Apply[ StringJoin, shuffle[ToCharacters[u],ToCharacters[v]], 1 ];
WordShuffle[ L1_List, L2_List ] := 
    Union[Flatten[ Apply[ WordShuffle, CartesianProduct[L1,L2], 1 ]]];
     
shuffle[{},L_] := {L};
shuffle[L_,{}] := {L};
shuffle[L1_List,L2_List] := 
    Union[  Prepend[#,First[L1]]& /@ shuffle[Rest[L1],L2],
     Prepend[#,First[L2]]& /@ shuffle[L1,Rest[L2]]
];




Options[WordSort]={};

WordSort[{xx___List}] := Last /@ Sort[Pairs[WordLength /@ First /@ {xx}, {xx} ]];
WordSort[ L_List ] := Last /@ Sort[ Pairs[ WordLength /@ L, L ] ];


Options[WordSuffixes]={};

Attributes[WordSuffixes]={Listable};

WordSuffixes[ Eps|"Eps"|Global`\[Epsilon] ] = {"Eps"}; 
WordSuffixes[ w_?WordQ ] := 
With[ {ws = ToString[w]}, 
     Prepend[ StringTake[ws,-#]& /@ Range@WordLength[ws], "Eps" ]
];
WordSuffixes[L_List] := WordSuffixes /@ L // Flatten // Union // WordSort;


Options[Words]={};

Words[ 0, __ ] := {"Eps"};
Words[ r_Integer?Positive, K_:$alphabet ] := 
With[ { alph = MakeAlphabet[K] },
     Apply[ StringJoin, CartesianProduct@@Table[alph,{r}], 1 ]
];

Words[ r_Integer?Negative, K_:$alphabet ] := 
     Prepend[ Flatten[ Words[#,K]& /@ Range[-r] ], "Eps" ];



End[];



AcceptQFA::args = "Wrong argument(s), try AcceptQFA[M,x,opts]";
AcceptQFA[__] := $Failed /; Message[AcceptQFA::args];
AccessibleFA::args = "Wrong argument(s), try AccessibleFA[M,opts]";
AccessibleFA[__] := $Failed /; Message[AccessibleFA::args];
AddTransitionFA::args = "Wrong argument(s), try AddTransitionFA[M,p,w,q]";
AddTransitionFA[__] := $Failed /; Message[AddTransitionFA::args];
AllDFA::args = "Wrong argument(s), try AllDFA[K]";
AllDFA[__] := $Failed /; Message[AllDFA::args];
AlphabetSize::args = "Wrong argument(s), try AlphabetSize[K]";
AlphabetSize[__] := $Failed /; Message[AlphabetSize::args];
Alphabet::args = "Wrong argument(s), try Alphabet[M]";
Alphabet[__] := $Failed /; Message[Alphabet::args];
AmbiguousQFA::args = "Wrong argument(s), try AmbiguousQFA[M,opts]";
AmbiguousQFA[__] := $Failed /; Message[AmbiguousQFA::args];
Arden::args = "Wrong argument(s), try Arden[BBBBB]";
Arden[__] := $Failed /; Message[Arden::args];
BehaviorFA::args = "Wrong argument(s), try BehaviorFA[M,p,r]";
BehaviorFA[__] := $Failed /; Message[BehaviorFA::args];
BFunctionToCA::args = "Wrong argument(s), try BFunctionToCA[BBBBB]";
BFunctionToCA[__] := $Failed /; Message[BFunctionToCA::args];
BuildBEFA::args = "Wrong argument(s), try BuildBEFA[BBBBB]";
BuildBEFA[__] := $Failed /; Message[BuildBEFA::args];
BuildDFA::args = "Wrong argument(s), try BuildDFA[w1,..,wi,K]";
BuildDFA[__] := $Failed /; Message[BuildDFA::args];
BuildNNFA::args = "Wrong argument(s), try BuildNNFA[BBBBB]";
BuildNNFA[__] := $Failed /; Message[BuildNNFA::args];
BuildStarDFA::args = "Wrong argument(s), try BuildStarDFA[BBBBB]";
BuildStarDFA[__] := $Failed /; Message[BuildStarDFA::args];
CirculantSA::args = "Wrong argument(s), try CirculantSA[BBBBB]";
CirculantSA[__] := $Failed /; Message[CirculantSA::args];
ClassifyCA::args = "Wrong argument(s), try ClassifyCA[BBBBB]";
ClassifyCA[__] := $Failed /; Message[ClassifyCA::args];
CoAccessibleFA::args = "Wrong argument(s), try CoAccessibleFA[M]";
CoAccessibleFA[__] := $Failed /; Message[CoAccessibleFA::args];
CodeterministicQFA::args = "Wrong argument(s), try CodeterministicQFA[M]";
CodeterministicQFA[__] := $Failed /; Message[CodeterministicQFA::args];
ComplementFA::args = "Wrong argument(s), try ComplementFA[BBBBB]";
ComplementFA[__] := $Failed /; Message[ComplementFA::args];
CompleteFA::args = "Wrong argument(s), try CompleteFA[M]";
CompleteFA[__] := $Failed /; Message[CompleteFA::args];
CompleteQFA::args = "Wrong argument(s), try CompleteQFA[BBBBB]";
CompleteQFA[__] := $Failed /; Message[CompleteQFA::args];
ComposeCA::args = "Wrong argument(s), try ComposeCA[C1,C2]";
ComposeCA[__] := $Failed /; Message[ComposeCA::args];
ComputationFA::args = "Wrong argument(s), try ComputationFA[BBBBB]";
ComputationFA[__] := $Failed /; Message[ComputationFA::args];
ComputationGraphFA::args = "Wrong argument(s), try ComputationGraphFA[BBBBB]";
ComputationGraphFA[__] := $Failed /; Message[ComputationGraphFA::args];
ConcatenateFA::args = "Wrong argument(s), try ConcatenateFA[M1,..,Mn]";
ConcatenateFA[__] := $Failed /; Message[ConcatenateFA::args];
ConvertToFA::args = "Wrong argument(s), try ConvertToFA[BBBBB]";
ConvertToFA[__] := $Failed /; Message[ConvertToFA::args];
CounterDFA::args = "Wrong argument(s), try CounterDFA[BBBBB]";
CounterDFA[__] := $Failed /; Message[CounterDFA::args];
CoverQDFA::args = "Wrong argument(s), try CoverQDFA[M1,M2,opts]";
CoverQDFA[__] := $Failed /; Message[CoverQDFA::args];
DeBruijnEdges::args = "Wrong argument(s), try DeBruijnEdges[w,K]";
DeBruijnEdges[__] := $Failed /; Message[DeBruijnEdges::args];
DeBruijnGraph::args = "Wrong argument(s), try DeBruijnGraph[BBBBB]";
DeBruijnGraph[__] := $Failed /; Message[DeBruijnGraph::args];
DefiniteQFA::args = "Wrong argument(s), try DefiniteQFA[BBBBB]";
DefiniteQFA[__] := $Failed /; Message[DefiniteQFA::args];
DegreesFA::args = "Wrong argument(s), try DegreesFA[BBBBB]";
DegreesFA[__] := $Failed /; Message[DegreesFA::args];
DeleteStateFA::args = "Wrong argument(s), try DeleteStateFA[BBBBB]";
DeleteStateFA[__] := $Failed /; Message[DeleteStateFA::args];
DependencyCA::args = "Wrong argument(s), try DependencyCA[BBBBB]";
DependencyCA[__] := $Failed /; Message[DependencyCA::args];
DeterministicQFA::args = "Wrong argument(s), try DeterministicQFA[BBBBB]";
DeterministicQFA[__] := $Failed /; Message[DeterministicQFA::args];
EmptyDFA::args = "Wrong argument(s), try EmptyDFA[BBBBB]";
EmptyDFA[__] := $Failed /; Message[EmptyDFA::args];
EmptyQFA::args = "Wrong argument(s), try EmptyQFA[BBBBB]";
EmptyQFA[__] := $Failed /; Message[EmptyQFA::args];
EpsFreeQ::args = "Wrong argument(s), try EpsFreeQ[M]";
EpsFreeQ[__] := $Failed /; Message[EpsFreeQ::args];
EpsilonEliminationFA::args = "Wrong argument(s), try EpsilonEliminationFA[BBBBB]";
EpsilonEliminationFA[__] := $Failed /; Message[EpsilonEliminationFA::args];
EquivalentQFA::args = "Wrong argument(s), try EquivalentQFA[M1,M2]";
EquivalentQFA[__] := $Failed /; Message[EquivalentQFA::args];
EvolutionCA::args = "Wrong argument(s), try EvolutionCA[C,X,t,opts]";
EvolutionCA[__] := $Failed /; Message[EvolutionCA::args];
FactorialQFA::args = "Wrong argument(s), try FactorialQFA[M,opts]";
FactorialQFA[__] := $Failed /; Message[FactorialQFA::args];
FinalVectorFA::args = "Wrong argument(s), try FinalVectorFA[BBBBB]";
FinalVectorFA[__] := $Failed /; Message[FinalVectorFA::args];
Final::args = "Wrong argument(s), try Final[BBBBB]";
Final[__] := $Failed /; Message[Final::args];
FiniteComplementSA::args = "Wrong argument(s), try FiniteComplementSA[w,K]";
FiniteComplementSA[__] := $Failed /; Message[FiniteComplementSA::args];
FormatAutomata::args = "Wrong argument(s), try FormatAutomata[fmt]";
FormatAutomata[__] := $Failed /; Message[FormatAutomata::args];
FormatX::args = "Wrong argument(s), try FormatX[b]";
FormatX[__] := $Failed /; Message[FormatX::args];
FrontierQ::args = "Wrong argument(s), try FrontierQ[L,K]";
FrontierQ[__] := $Failed /; Message[FrontierQ::args];
FrontierToDFA::args = "Wrong argument(s), try FrontierToDFA[gamma,F]";
FrontierToDFA[__] := $Failed /; Message[FrontierToDFA::args];
FSMQ::args = "Wrong argument(s), try FSMQ[BBBBB]";
FSMQ[__] := $Failed /; Message[FSMQ::args];
FSurjectiveCA::args = "Wrong argument(s), try FSurjectiveCA[BBBBB]";
FSurjectiveCA[__] := $Failed /; Message[FSurjectiveCA::args];
FullAlphabet::args = "Wrong argument(s), try FullAlphabet[BBBBB]";
FullAlphabet[__] := $Failed /; Message[FullAlphabet::args];
FullTransitionMatrixFA::args = "Wrong argument(s), try FullTransitionMatrixFA[M,opts]";
FullTransitionMatrixFA[__] := $Failed /; Message[FullTransitionMatrixFA::args];
FullTransitions::args = "Wrong argument(s), try FullTransitions[BBBBB]";
FullTransitions[__] := $Failed /; Message[FullTransitions::args];
FunctionToCA::args = "Wrong argument(s), try FunctionToCA[BBBBB]";
FunctionToCA[__] := $Failed /; Message[FunctionToCA::args];
FunctionToDFA::args = "Wrong argument(s), try FunctionToDFA[Q,K,del,q0,F,opts]";
FunctionToDFA[__] := $Failed /; Message[FunctionToDFA::args];
FunctionToSA::args = "Wrong argument(s), try FunctionToSA[Q,K,del,opts]";
FunctionToSA[__] := $Failed /; Message[FunctionToSA::args];
GenerateDFA::args = "Wrong argument(s), try GenerateDFA[q0,dot,K,fin]";
GenerateDFA[__] := $Failed /; Message[GenerateDFA::args];
GenerateQuotients::args = "Wrong argument(s), try GenerateQuotients[BBBBB]";
GenerateQuotients[__] := $Failed /; Message[GenerateQuotients::args];
GlobalMapCA::args = "Wrong argument(s), try GlobalMapCA[BBBBB]";
GlobalMapCA[__] := $Failed /; Message[GlobalMapCA::args];
HomomorphismFA::args = "Wrong argument(s), try HomomorphismFA[M,h,K]";
HomomorphismFA[__] := $Failed /; Message[HomomorphismFA::args];
HurwitzProduct::args = "Wrong argument(s), try HurwitzProduct[BBBBB]";
HurwitzProduct[__] := $Failed /; Message[HurwitzProduct::args];
IdealBaseFA::args = "Wrong argument(s), try IdealBaseFA[M]";
IdealBaseFA[__] := $Failed /; Message[IdealBaseFA::args];
IdealQFA::args = "Wrong argument(s), try IdealQFA[M]";
IdealQFA[__] := $Failed /; Message[IdealQFA::args];
IdentityCA::args = "Wrong argument(s), try IdentityCA[BBBBB]";
IdentityCA[__] := $Failed /; Message[IdentityCA::args];
InfiniteQFA::args = "Wrong argument(s), try InfiniteQFA[BBBBB]";
InfiniteQFA[__] := $Failed /; Message[InfiniteQFA::args];
InfixFA::args = "Wrong argument(s), try InfixFA[BBBBB]";
InfixFA[__] := $Failed /; Message[InfixFA::args];
InitialVectorFA::args = "Wrong argument(s), try InitialVectorFA[BBBBB]";
InitialVectorFA[__] := $Failed /; Message[InitialVectorFA::args];
Initial::args = "Wrong argument(s), try Initial[BBBBB]";
Initial[__] := $Failed /; Message[Initial::args];
IntersectionFA::args = "Wrong argument(s), try IntersectionFA[M1,M2]";
IntersectionFA[__] := $Failed /; Message[IntersectionFA::args];
InverseCA::args = "Wrong argument(s), try InverseCA[BBBBB]";
InverseCA[__] := $Failed /; Message[InverseCA::args];
IrreducibleFA::args = "Wrong argument(s), try IrreducibleFA[L,K]";
IrreducibleFA[__] := $Failed /; Message[IrreducibleFA::args];
IsomorphicQDFA::args = "Wrong argument(s), try IsomorphicQDFA[M1,M2]";
IsomorphicQDFA[__] := $Failed /; Message[IsomorphicQDFA::args];
IterateCA::args = "Wrong argument(s), try IterateCA[BBBBB]";
IterateCA[__] := $Failed /; Message[IterateCA::args];
IthSymbolDFA::args = "Wrong argument(s), try IthSymbolDFA[BBBBB]";
IthSymbolDFA[__] := $Failed /; Message[IthSymbolDFA::args];
IthSymbolFA::args = "Wrong argument(s), try IthSymbolFA[BBBBB]";
IthSymbolFA[__] := $Failed /; Message[IthSymbolFA::args];
JoinSA::args = "Wrong argument(s), try JoinSA[M1,M2,A,opts]";
JoinSA[__] := $Failed /; Message[JoinSA::args];
LabelToCodeCA::args = "Wrong argument(s), try LabelToCodeCA[BBBBB]";
LabelToCodeCA[__] := $Failed /; Message[LabelToCodeCA::args];
LanguageFA::args = "Wrong argument(s), try LanguageFA[M,opts]";
LanguageFA[__] := $Failed /; Message[LanguageFA::args];
LanguageSort::args = "Wrong argument(s), try LanguageSort[BBBBB]";
LanguageSort[__] := $Failed /; Message[LanguageSort::args];
LanguageToSeries::args = "Wrong argument(s), try LanguageToSeries[BBBBB]";
LanguageToSeries[__] := $Failed /; Message[LanguageToSeries::args];
LeftQuotient::args = "Wrong argument(s), try LeftQuotient[BBBBB]";
LeftQuotient[__] := $Failed /; Message[LeftQuotient::args];
LeftShiftCA::args = "Wrong argument(s), try LeftShiftCA[BBBBB]";
LeftShiftCA[__] := $Failed /; Message[LeftShiftCA::args];
LengthDFA::args = "Wrong argument(s), try LengthDFA[BBBBB]";
LengthDFA[__] := $Failed /; Message[LengthDFA::args];
LocalMapCA::args = "Wrong argument(s), try LocalMapCA[f,C]";
LocalMapCA[__] := $Failed /; Message[LocalMapCA::args];
LocalUniversalFA::args = "Wrong argument(s), try LocalUniversalFA[BBBBB]";
LocalUniversalFA[__] := $Failed /; Message[LocalUniversalFA::args];
LoopAutomatonFA::args = "Wrong argument(s), try LoopAutomatonFA[BBBBB]";
LoopAutomatonFA[__] := $Failed /; Message[LoopAutomatonFA::args];
MakeHomoDFA::args = "Wrong argument(s), try MakeHomoDFA[h,M1,M2]";
MakeHomoDFA[__] := $Failed /; Message[MakeHomoDFA::args];
MakeHomomorphism::args = "Wrong argument(s), try MakeHomomorphism[f,A,B]";
MakeHomomorphism[__] := $Failed /; Message[MakeHomomorphism::args];
MakeWord::args = "Wrong argument(s), try MakeWord[a,i,b,j,...]";
MakeWord[__] := $Failed /; Message[MakeWord::args];
MatrixToTransitions::args = "Wrong argument(s), try MatrixToTransitions[BBBBB]";
MatrixToTransitions[__] := $Failed /; Message[MatrixToTransitions::args];
MinimalFischerFA::args = "Wrong argument(s), try MinimalFischerFA[M,opts]";
MinimalFischerFA[__] := $Failed /; Message[MinimalFischerFA::args];
MinimizeDFA::args = "Wrong argument(s), try MinimizeDFA[BBBBB]";
MinimizeDFA[__] := $Failed /; Message[MinimizeDFA::args];
MinimizeFA::args = "Wrong argument(s), try MinimizeFA[M,opts]";
MinimizeFA[__] := $Failed /; Message[MinimizeFA::args];
ModCounterDFA::args = "Wrong argument(s), try ModCounterDFA[BBBBB]";
ModCounterDFA[__] := $Failed /; Message[ModCounterDFA::args];
NNFAToFA::args = "Wrong argument(s), try NNFAToFA[M,K]";
NNFAToFA[__] := $Failed /; Message[NNFAToFA::args];
NoFactorFA::args = "Wrong argument(s), try NoFactorFA[M,opts]";
NoFactorFA[__] := $Failed /; Message[NoFactorFA::args];
NoPrefixFA::args = "Wrong argument(s), try NoPrefixFA[M,opts]";
NoPrefixFA[__] := $Failed /; Message[NoPrefixFA::args];
NormalizeControl::args = "Wrong argument(s), try NormalizeControl[l]";
NormalizeControl[__] := $Failed /; Message[NormalizeControl::args];
NormalizeFA::args = "Wrong argument(s), try NormalizeFA[BBBBB]";
NormalizeFA[__] := $Failed /; Message[NormalizeFA::args];
NoSuffixFA::args = "Wrong argument(s), try NoSuffixFA[M,opts]";
NoSuffixFA[__] := $Failed /; Message[NoSuffixFA::args];
NumberOfCA::args = "Wrong argument(s), try NumberOfCA[BBBBB]";
NumberOfCA[__] := $Failed /; Message[NumberOfCA::args];
NumberOfDFA::args = "Wrong argument(s), try NumberOfDFA[BBBBB]";
NumberOfDFA[__] := $Failed /; Message[NumberOfDFA::args];
NumberOfTotalisticCA::args = "Wrong argument(s), try NumberOfTotalisticCA[w,K]";
NumberOfTotalisticCA[__] := $Failed /; Message[NumberOfTotalisticCA::args];
NumTransitions::args = "Wrong argument(s), try NumTransitions[BBBBB]";
NumTransitions[__] := $Failed /; Message[NumTransitions::args];
OrbitCA::args = "Wrong argument(s), try OrbitCA[C,pat,t,opts]";
OrbitCA[__] := $Failed /; Message[OrbitCA::args];
ParikhVector::args = "Wrong argument(s), try ParikhVector[BBBBB]";
ParikhVector[__] := $Failed /; Message[ParikhVector::args];
PermutationSA::args = "Wrong argument(s), try PermutationSA[BBBBB]";
PermutationSA[__] := $Failed /; Message[PermutationSA::args];
PermuteFA::args = "Wrong argument(s), try PermuteFA[M,L]";
PermuteFA[__] := $Failed /; Message[PermuteFA::args];
PlotComputationFA::args = "Wrong argument(s), try PlotComputationFA[M,x,opts]";
PlotComputationFA[__] := $Failed /; Message[PlotComputationFA::args];
PolynomialToCA::args = "Wrong argument(s), try PolynomialToCA[BBBBB]";
PolynomialToCA[__] := $Failed /; Message[PolynomialToCA::args];
PrefixDFA::args = "Wrong argument(s), try PrefixDFA[BBBBB]";
PrefixDFA[__] := $Failed /; Message[PrefixDFA::args];
PrefixQ::args = "Wrong argument(s), try PrefixQ[BBBBB]";
PrefixQ[__] := $Failed /; Message[PrefixQ::args];
PrimitiveCount::args = "Wrong argument(s), try PrimitiveCount[BBBBB]";
PrimitiveCount[__] := $Failed /; Message[PrimitiveCount::args];
PrimitiveQ::args = "Wrong argument(s), try PrimitiveQ[BBBBB]";
PrimitiveQ[__] := $Failed /; Message[PrimitiveQ::args];
PrintCA::args = "Wrong argument(s), try PrintCA[BBBBB]";
PrintCA[__] := $Failed /; Message[PrintCA::args];
PrintFA::args = "Wrong argument(s), try PrintFA[M]";
PrintFA[__] := $Failed /; Message[PrintFA::args];
ProductFA::args = "Wrong argument(s), try ProductFA[M1,M2]";
ProductFA[__] := $Failed /; Message[ProductFA::args];
ProductTransitions::args = "Wrong argument(s), try ProductTransitions[BBBBB]";
ProductTransitions[__] := $Failed /; Message[ProductTransitions::args];
ProperPrefixes::args = "Wrong argument(s), try ProperPrefixes[BBBBB]";
ProperPrefixes[__] := $Failed /; Message[ProperPrefixes::args];
QuotientDFA::args = "Wrong argument(s), try QuotientDFA[L,K]";
QuotientDFA[__] := $Failed /; Message[QuotientDFA::args];
QuotientMachineFA::args = "Wrong argument(s), try QuotientMachineFA[BBBBB]";
QuotientMachineFA[__] := $Failed /; Message[QuotientMachineFA::args];
RandomDFA::args = "Wrong argument(s), try RandomDFA[BBBBB]";
RandomDFA[__] := $Failed /; Message[RandomDFA::args];
RandomWord::args = "Wrong argument(s), try RandomWord[BBBBB]";
RandomWord[__] := $Failed /; Message[RandomWord::args];
RankOfDFA::args = "Wrong argument(s), try RankOfDFA[BBBBB]";
RankOfDFA[__] := $Failed /; Message[RankOfDFA::args];
RankToDFA::args = "Wrong argument(s), try RankToDFA[r,n,k]";
RankToDFA[__] := $Failed /; Message[RankToDFA::args];
REEpsQ::args = "Wrong argument(s), try REEpsQ[BBBBB]";
REEpsQ[__] := $Failed /; Message[REEpsQ::args];
RegularExpressionToBEFA::args = "Wrong argument(s), try RegularExpressionToBEFA[BBBBB]";
RegularExpressionToBEFA[__] := $Failed /; Message[RegularExpressionToBEFA::args];
RegularExpressionToFA::args = "Wrong argument(s), try RegularExpressionToFA[exp,K]";
RegularExpressionToFA[__] := $Failed /; Message[RegularExpressionToFA::args];
RegularExpressionToNNFA::args = "Wrong argument(s), try RegularExpressionToNNFA[exp]";
RegularExpressionToNNFA[__] := $Failed /; Message[RegularExpressionToNNFA::args];
RemoveTransitionFA::args = "Wrong argument(s), try RemoveTransitionFA[BBBBB]";
RemoveTransitionFA[__] := $Failed /; Message[RemoveTransitionFA::args];
REQ::args = "Wrong argument(s), try REQ[BBBBB]";
REQ[__] := $Failed /; Message[REQ::args];
RESimplify::args = "Wrong argument(s), try RESimplify[BBBBB]";
RESimplify[__] := $Failed /; Message[RESimplify::args];
ReverseFA::args = "Wrong argument(s), try ReverseFA[BBBBB]";
ReverseFA[__] := $Failed /; Message[ReverseFA::args];
RightShiftCA::args = "Wrong argument(s), try RightShiftCA[k]";
RightShiftCA[__] := $Failed /; Message[RightShiftCA::args];
SelectFA::args = "Wrong argument(s), try SelectFA[BBBBB]";
SelectFA[__] := $Failed /; Message[SelectFA::args];
SetFinalFA::args = "Wrong argument(s), try SetFinalFA[BBBBB]";
SetFinalFA[__] := $Failed /; Message[SetFinalFA::args];
SetInitialFA::args = "Wrong argument(s), try SetInitialFA[BBBBB]";
SetInitialFA[__] := $Failed /; Message[SetInitialFA::args];
SetInitialFinalFA::args = "Wrong argument(s), try SetInitialFinalFA[]";
SetInitialFinalFA[__] := $Failed /; Message[SetInitialFinalFA::args];
ShowAcceptQFA::args = "Wrong argument(s), try ShowAcceptQFA[BBBBB]";
ShowAcceptQFA[__] := $Failed /; Message[ShowAcceptQFA::args];
ShrinkCA::args = "Wrong argument(s), try ShrinkCA[BBBBB]";
ShrinkCA[__] := $Failed /; Message[ShrinkCA::args];
ShuffleProductFA::args = "Wrong argument(s), try ShuffleProductFA[BBBBB]";
ShuffleProductFA[__] := $Failed /; Message[ShuffleProductFA::args];
SinkQDFA::args = "Wrong argument(s), try SinkQDFA[BBBBB]";
SinkQDFA[__] := $Failed /; Message[SinkQDFA::args];
SinksDFA::args = "Wrong argument(s), try SinksDFA[M]";
SinksDFA[__] := $Failed /; Message[SinksDFA::args];
Size::args = "Wrong argument(s), try Size[BBBBB]";
Size[__] := $Failed /; Message[Size::args];
SquareSA::args = "Wrong argument(s), try SquareSA[M]";
SquareSA[__] := $Failed /; Message[SquareSA::args];
StarFA::args = "Wrong argument(s), try StarFA[BBBBB]";
StarFA[__] := $Failed /; Message[StarFA::args];
StateMergeDFA::args = "Wrong argument(s), try StateMergeDFA[BBBBB]";
StateMergeDFA[__] := $Failed /; Message[StateMergeDFA::args];
States::args = "Wrong argument(s), try States[BBBBB]";
States[__] := $Failed /; Message[States::args];
SubsetQFA::args = "Wrong argument(s), try SubsetQFA[BBBBB]";
SubsetQFA[__] := $Failed /; Message[SubsetQFA::args];
Substitute::args = "Wrong argument(s), try Substitute[eq1,eq2]";
Substitute[__] := $Failed /; Message[Substitute::args];
SubwordCounterDFA::args = "Wrong argument(s), try SubwordCounterDFA[w,p,K,opts]";
SubwordCounterDFA[__] := $Failed /; Message[SubwordCounterDFA::args];
SubwordDFA::args = "Wrong argument(s), try SubwordDFA[BBBBB]";
SubwordDFA[__] := $Failed /; Message[SubwordDFA::args];
SubwordModCounterDFA::args = "Wrong argument(s), try SubwordModCounterDFA[BBBBB]";
SubwordModCounterDFA[__] := $Failed /; Message[SubwordModCounterDFA::args];
SuffixesFA::args = "Wrong argument(s), try SuffixesFA[BBBBB]";
SuffixesFA[__] := $Failed /; Message[SuffixesFA::args];
SuffixFA::args = "Wrong argument(s), try SuffixFA[BBBBB]";
SuffixFA[__] := $Failed /; Message[SuffixFA::args];
SumFA::args = "Wrong argument(s), try SumFA[M1,M2]";
SumFA[__] := $Failed /; Message[SumFA::args];
SwitchTransitionFA::args = "Wrong argument(s), try SwitchTransitionFA[BBBBB]";
SwitchTransitionFA[__] := $Failed /; Message[SwitchTransitionFA::args];
SyntacticCongruence::args = "Wrong argument(s), try SyntacticCongruence[M,r]";
SyntacticCongruence[__] := $Failed /; Message[SyntacticCongruence::args];
SyntacticHomomorphism::args = "Wrong argument(s), try SyntacticHomomorphism[f,M]";
SyntacticHomomorphism[__] := $Failed /; Message[SyntacticHomomorphism::args];
SyntacticSG::args = "Wrong argument(s), try SyntacticSG[BBBBB]";
SyntacticSG[__] := $Failed /; Message[SyntacticSG::args];
TheInitial::args = "Wrong argument(s), try TheInitial[BBBBB]";
TheInitial[__] := $Failed /; Message[TheInitial::args];
TheSinkDFA::args = "Wrong argument(s), try TheSinkDFA[BBBBB]";
TheSinkDFA[__] := $Failed /; Message[TheSinkDFA::args];
ToBlocks::args = "Wrong argument(s), try ToBlocks[BBBBB]";
ToBlocks[__] := $Failed /; Message[ToBlocks::args];
ToCharacters::args = "Wrong argument(s), try ToCharacters[BBBBB]";
ToCharacters[__] := $Failed /; Message[ToCharacters::args];
ToDFA::args = "Wrong argument(s), try ToDFA[BBBBB]";
ToDFA[__] := $Failed /; Message[ToDFA::args];
ToEquationsDFA::args = "Wrong argument(s), try ToEquationsDFA[BBBBB]";
ToEquationsDFA[__] := $Failed /; Message[ToEquationsDFA::args];
ToFA::args = "Wrong argument(s), try ToFA[M]";
ToFA[__] := $Failed /; Message[ToFA::args];
ToFrontierDFA::args = "Wrong argument(s), try ToFrontierDFA[M]";
ToFrontierDFA[__] := $Failed /; Message[ToFrontierDFA::args];
ToGeneratorsFA::args = "Wrong argument(s), try ToGeneratorsFA[BBBBB]";
ToGeneratorsFA[__] := $Failed /; Message[ToGeneratorsFA::args];
ToGraphFA::args = "Wrong argument(s), try ToGraphFA[BBBBB]";
ToGraphFA[__] := $Failed /; Message[ToGraphFA::args];
ToIndex::args = "Wrong argument(s), try ToIndex[BBBBB]";
ToIndex[__] := $Failed /; Message[ToIndex::args];
ToKernelFA::args = "Wrong argument(s), try ToKernelFA[M,L,opts]";
ToKernelFA[__] := $Failed /; Message[ToKernelFA::args];
ToLabelCA::args = "Wrong argument(s), try ToLabelCA[BBBBB]";
ToLabelCA[__] := $Failed /; Message[ToLabelCA::args];
ToNFA::args = "Wrong argument(s), try ToNFA[M]";
ToNFA[__] := $Failed /; Message[ToNFA::args];
ToPeriodicFrontierDFA::args = "Wrong argument(s), try ToPeriodicFrontierDFA[M]";
ToPeriodicFrontierDFA[__] := $Failed /; Message[ToPeriodicFrontierDFA::args];
ToPrefixFA::args = "Wrong argument(s), try ToPrefixFA[M]";
ToPrefixFA[__] := $Failed /; Message[ToPrefixFA::args];
ToPrefix::args = "Wrong argument(s), try ToPrefix[BBBBB]";
ToPrefix[__] := $Failed /; Message[ToPrefix::args];
ToRegExp::args = "Wrong argument(s), try ToRegExp[BBBBB]";
ToRegExp[__] := $Failed /; Message[ToRegExp::args];
ToRegularExpressionFA::args = "Wrong argument(s), try ToRegularExpressionFA[BBBBB]";
ToRegularExpressionFA[__] := $Failed /; Message[ToRegularExpressionFA::args];
ToRulesCA::args = "Wrong argument(s), try ToRulesCA[BBBBB]";
ToRulesCA[__] := $Failed /; Message[ToRulesCA::args];
ToSA::args = "Wrong argument(s), try ToSA[M]";
ToSA[__] := $Failed /; Message[ToSA::args];
ToSeries::args = "Wrong argument(s), try ToSeries[L]";
ToSeries[__] := $Failed /; Message[ToSeries::args];
ToSuffixFA::args = "Wrong argument(s), try ToSuffixFA[M]";
ToSuffixFA[__] := $Failed /; Message[ToSuffixFA::args];
TotalisticRuleToCA::args = "Wrong argument(s), try TotalisticRuleToCA[BBBBB]";
TotalisticRuleToCA[__] := $Failed /; Message[TotalisticRuleToCA::args];
ToTotalisticRuleCA::args = "Wrong argument(s), try ToTotalisticRuleCA[BBBBB]";
ToTotalisticRuleCA[__] := $Failed /; Message[ToTotalisticRuleCA::args];
ToTransitions::args = "Wrong argument(s), try ToTransitions[BBBBB]";
ToTransitions[__] := $Failed /; Message[ToTransitions::args];
ToWord::args = "Wrong argument(s), try ToWord[L,K]";
ToWord[__] := $Failed /; Message[ToWord::args];
TransferSequenceFA::args = "Wrong argument(s), try TransferSequenceFA[BBBBB]";
TransferSequenceFA[__] := $Failed /; Message[TransferSequenceFA::args];
TransitionFunctionFA::args = "Wrong argument(s), try TransitionFunctionFA[BBBBB]";
TransitionFunctionFA[__] := $Failed /; Message[TransitionFunctionFA::args];
TransitionMatrixFA::args = "Wrong argument(s), try TransitionMatrixFA[BBBBB]";
TransitionMatrixFA[__] := $Failed /; Message[TransitionMatrixFA::args];
TransitionsToMatrix::args = "Wrong argument(s), try TransitionsToMatrix[BBBBB]";
TransitionsToMatrix[__] := $Failed /; Message[TransitionsToMatrix::args];
Transitions::args = "Wrong argument(s), try Transitions[BBBBB]";
Transitions[__] := $Failed /; Message[Transitions::args];
TransitiveLangQFA::args = "Wrong argument(s), try TransitiveLangQFA[M]";
TransitiveLangQFA[__] := $Failed /; Message[TransitiveLangQFA::args];
TransitiveQFA::args = "Wrong argument(s), try TransitiveQFA[M,opts]";
TransitiveQFA[__] := $Failed /; Message[TransitiveQFA::args];
TrimFA::args = "Wrong argument(s), try TrimFA[BBBBB]";
TrimFA[__] := $Failed /; Message[TrimFA::args];
TropicalIdentityMatrix::args = "Wrong argument(s), try TropicalIdentityMatrix[BBBBB]";
TropicalIdentityMatrix[__] := $Failed /; Message[TropicalIdentityMatrix::args];
UnionFA::args = "Wrong argument(s), try UnionFA[M1,M2]";
UnionFA[__] := $Failed /; Message[UnionFA::args];
VerifyFA::args = "Wrong argument(s), try VerifyFA[BBBBB]";
VerifyFA[__] := $Failed /; Message[VerifyFA::args];
WelchCA::args = "Wrong argument(s), try WelchCA[C,opts]";
WelchCA[__] := $Failed /; Message[WelchCA::args];
WidthCA::args = "Wrong argument(s), try WidthCA[BBBBB]";
WidthCA[__] := $Failed /; Message[WidthCA::args];
WordBinomial::args = "Wrong argument(s), try WordBinomial[BBBBB]";
WordBinomial[__] := $Failed /; Message[WordBinomial::args];
WordConjugateQ::args = "Wrong argument(s), try WordConjugateQ[u,v]";
WordConjugateQ[__] := $Failed /; Message[WordConjugateQ::args];
WordConjugates::args = "Wrong argument(s), try WordConjugates[w]";
WordConjugates[__] := $Failed /; Message[WordConjugates::args];
WordFactorizations::args = "Wrong argument(s), try WordFactorizations[BBBBB]";
WordFactorizations[__] := $Failed /; Message[WordFactorizations::args];
WordFactors::args = "Wrong argument(s), try WordFactors[BBBBB]";
WordFactors[__] := $Failed /; Message[WordFactors::args];
WordFusion::args = "Wrong argument(s), try WordFusion[BBBBB]";
WordFusion[__] := $Failed /; Message[WordFusion::args];
WordLength::args = "Wrong argument(s), try WordLength[BBBBB]";
WordLength[__] := $Failed /; Message[WordLength::args];
WordOrder::args = "Wrong argument(s), try WordOrder[BBBBB]";
WordOrder[__] := $Failed /; Message[WordOrder::args];
WordPower::args = "Wrong argument(s), try WordPower[BBBBB]";
WordPower[__] := $Failed /; Message[WordPower::args];
WordPrefixes::args = "Wrong argument(s), try WordPrefixes[w]";
WordPrefixes[__] := $Failed /; Message[WordPrefixes::args];
WordReverse::args = "Wrong argument(s), try WordReverse[BBBBB]";
WordReverse[__] := $Failed /; Message[WordReverse::args];
WordRoot::args = "Wrong argument(s), try WordRoot[BBBBB]";
WordRoot[__] := $Failed /; Message[WordRoot::args];
WordRotate::args = "Wrong argument(s), try WordRotate[BBBBB]";
WordRotate[__] := $Failed /; Message[WordRotate::args];
WordShuffle::args = "Wrong argument(s), try WordShuffle[BBBBB]";
WordShuffle[__] := $Failed /; Message[WordShuffle::args];
WordSort::args = "Wrong argument(s), try WordSort[BBBBB]";
WordSort[__] := $Failed /; Message[WordSort::args];
WordSuffixes::args = "Wrong argument(s), try WordSuffixes[BBBBB]";
WordSuffixes[__] := $Failed /; Message[WordSuffixes::args];
Words::args = "Wrong argument(s), try Words[BBBBB]";
Words[__] := $Failed /; Message[Words::args];





(* options *)
Protect[Alphabetic, Boundary, Cyclic, EdgeLU, Empty, EpsElim, FinLU, Fixed, FLBound, Hopcroft, Implementation, IniLU, ListAble, MakeTrim, RegExpSimp, ShowAll, ShowEdges, SizeOnly, Some, Thompson, ToMatrix, TransOnly, Tropical, Unlabeled, WordMap];
(* headers *)
Protect[BEFA, CA, DFA, FA, NFA, NNFA, REP, RES, RET, SA, TS];
(* functionals *)
Protect[];
(* functions *)
Protect[AcceptQFA, AccessibleFA, AddTransitionFA, AllDFA, AlphabetSize, Alphabet, AmbiguousQFA, Arden, BehaviorFA, BFunctionToCA, BuildBEFA, BuildDFA, BuildNNFA, BuildStarDFA, CirculantSA, ClassifyCA, CoAccessibleFA, CodeterministicQFA, ComplementFA, CompleteFA, CompleteQFA, ComposeCA, ComputationFA, ComputationGraphFA, ConcatenateFA, ConvertToFA, CounterDFA, CoverQDFA, DeBruijnEdges, DeBruijnGraph, DefiniteQFA, DegreesFA, DeleteStateFA, DependencyCA, DeterministicQFA, EmptyDFA, EmptyQFA, EpsFreeQ, EpsilonEliminationFA, EquivalentQFA, EvolutionCA, FactorialQFA, FinalVectorFA, Final, FiniteComplementSA, FormatAutomata, FormatX, FrontierQ, FrontierToDFA, FSMQ, FSurjectiveCA, FullAlphabet, FullTransitionMatrixFA, FullTransitions, FunctionToCA, FunctionToDFA, FunctionToSA, GenerateDFA, GenerateQuotients, GlobalMapCA, HomomorphismFA, HurwitzProduct, IdealBaseFA, IdealQFA, IdentityCA, InfiniteQFA, InfixFA, InitialVectorFA, Initial, IntersectionFA, InverseCA, IrreducibleFA, IsomorphicQDFA, IterateCA, IthSymbolDFA, IthSymbolFA, JoinSA, LabelToCodeCA, LanguageFA, LanguageSort, LanguageToSeries, LeftQuotient, LeftShiftCA, LengthDFA, LocalMapCA, LocalUniversalFA, LoopAutomatonFA, MakeHomoDFA, MakeHomomorphism, MakeWord, MatrixToTransitions, MinimalFischerFA, MinimizeDFA, MinimizeFA, ModCounterDFA, NNFAToFA, NoFactorFA, NoPrefixFA, NormalizeControl, NormalizeFA, NoSuffixFA, NumberOfCA, NumberOfDFA, NumberOfTotalisticCA, NumTransitions, OrbitCA, ParikhVector, PermutationSA, PermuteFA, PlotComputationFA, PolynomialToCA, PrefixDFA, PrefixQ, PrimitiveCount, PrimitiveQ, PrintCA, PrintFA, ProductFA, ProductTransitions, ProperPrefixes, QuotientDFA, QuotientMachineFA, RandomDFA, RandomWord, RankOfDFA, RankToDFA, REEpsQ, RegularExpressionToBEFA, RegularExpressionToFA, RegularExpressionToNNFA, RemoveTransitionFA, REQ, RESimplify, ReverseFA, RightShiftCA, SelectFA, SetFinalFA, SetInitialFA, SetInitialFinalFA, ShowAcceptQFA, ShrinkCA, ShuffleProductFA, SinkQDFA, SinksDFA, Size, SquareSA, StarFA, StateMergeDFA, States, SubsetQFA, Substitute, SubwordCounterDFA, SubwordDFA, SubwordModCounterDFA, SuffixesFA, SuffixFA, SumFA, SwitchTransitionFA, SyntacticCongruence, SyntacticHomomorphism, SyntacticSG, TheInitial, TheSinkDFA, ToBlocks, ToCharacters, ToDFA, ToEquationsDFA, ToFA, ToFrontierDFA, ToGeneratorsFA, ToGraphFA, ToIndex, ToKernelFA, ToLabelCA, ToNFA, ToPeriodicFrontierDFA, ToPrefixFA, ToPrefix, ToRegExp, ToRegularExpressionFA, ToRulesCA, ToSA, ToSeries, ToSuffixFA, TotalisticRuleToCA, ToTotalisticRuleCA, ToTransitions, ToWord, TransferSequenceFA, TransitionFunctionFA, TransitionMatrixFA, TransitionsToMatrix, Transitions, TransitiveLangQFA, TransitiveQFA, TrimFA, TropicalIdentityMatrix, UnionFA, VerifyFA, WelchCA, WidthCA, WordBinomial, WordConjugateQ, WordConjugates, WordFactorizations, WordFactors, WordFusion, WordLength, WordOrder, WordPower, WordPrefixes, WordReverse, WordRoot, WordRotate, WordShuffle, WordSort, WordSuffixes, Words];

EndPackage[];


FormatAutomata[Automatic];

If[ Global`$AutomataMessages, Message[automata::ldend,$automataReleaseNumber] ];



(* package end *)

